unit epgcgi;
{
         
  /last?Abonent=xxx&Passwd=xxx

        
  /call?Abonent=xxx&Nickname=xxx&Msg=xxx

       
  /llist?Letter=xxx

      Default.htm (   -    cgi-bin)
  - 
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  HTTPApp, DBWeb, DBTables, Db, inifiles,
  util1, PCommon;

type
  TWebModule1 = class(TDataModule)
    Query1: TQuery;
    HTTPDispatcher1: TWebDispatcher;
    HTMLQueryTableProducer1: TQueryTableProducer;
    HTMLPageProducer1: TPageProducer;
    TblAbonent: TTable;
    Database1: TDatabase;
    TblCalls: TTable;
    procedure HTTPDispatcher1Actions0Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse;
      var Handled: Boolean);
    procedure HTMLPageProducer1HTMLTag(Sender: TObject; Tag: TTag;
      const TagString: String; TagParams: TStrings;
      var ReplaceText: String);
    procedure HTTPDispatcher1Actions1Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse;
      var Handled: Boolean);
    procedure DataModule1Create(Sender: TObject);
    procedure HTTPDispatcher1Actions2Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure HTTPDispatcher1Actions3Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
  private
    // ScriptName -   ,     HTML
    ScriptName: String;
    DefHCode: THCode;
    CurZone:  THCODE;
    function ParseSetValTag(var ATag: String): Boolean;
  public
    { Public declarations }
    function  CanCurAbonentReceiveMsg(const ANickName: String): Boolean;
    procedure SendMsg2Abonent(const Abonent, NewMsg: String);
    function  LoadIni: Boolean;
  end;

var
  WebModule1: TWebModule1;

implementation

{$R *.DFM}

function TWebModule1.ParseSetValTag(var ATag: String): Boolean;
var
  TagName: String;
  TagValue: String;
  CurHCode: THCode;
  LetterFAM: String[32];
begin
  Result:= False;
  if Pos('_', ATag) > 0 then begin
    // S-     VAR
    TagName:= ANSIUpperCase(GetToken(1, '_', ATag));
    // TagUp -  
    TagValue:= GetToken(2, '_', ATag);
    //   
    // HCODE
    if (Pos('HCODE',TagName) = 1) then begin
      if (TagValue<>'')
      then CurHCode:= TagValue
      else CurHCode:= 'XXX';
      ATag := '  '+ CurHCode;
      Result:= True;
    end;
    if (Pos('LETTER',TagName) = 1) then begin
      if (TagValue<>'')
      then LetterFam:= TagValue
      else LetterFam:= '';
      if IsDecimal(LetterFam)
      then LetterFam:= Chr(StrToIntDef(LetterFam, 0));
      ATag:= LetterFam;
      Result:= True;
    end;
    //
  end;
  //     
end;

procedure TWebModule1.HTTPDispatcher1Actions0Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
begin
  Response.Content := HTMLPageProducer1.Content;
end;

{  OnHTMLTag     <#..>    Replace
          
  <A HREF="epgcgi.exe/last?Abonent=XXX">"
}
procedure TWebModule1.HTMLPageProducer1HTMLTag(Sender: TObject; Tag: TTag;
  const TagString: String; TagParams: TStrings; var ReplaceText: String);
var
  S, F: String;
  TagUp: String;
  L: Integer;
  LetterFAM: String[32];
begin
  TagUp:= TagString;
  //   <#VAR_VAL>
  if ParseSetValTag(TagUp) then begin
   ReplaceText:= TagUp;
   Exit;
  end;
  //   
  if ANSICompareText(TagUp, 'ABONENTS') = 0 then begin
    S:= '';
    with TblAbonent do begin
      IndexName:= 'ICFIO';
      SetKey;
      L:= Length(LetterFAM);
      FieldByName('FAM').AsString:= LetterFAM;
      GotoNearest;
      //          
      while not EOF do begin
        F:= TblAbonent.FieldByName('FAM').AsString;
        S := S + '<A HREF="' + ScriptName + '/last?Abonent=' +
          TblAbonent.FieldByName('ABONENT').AsString + '">' +
          F + #32 +
          TblAbonent.FieldByName('IM').AsString[1] + #32 +
          TblAbonent.FieldByName('OT').AsString[1] +
          '</A><BR>';
        Next;
        if system.Copy(F, 1, L) > LetterFAM
        then Break;
      end;
    end;
    //     # <#ABONENTS>
    //      
    ReplaceText := S;
    Exit;
  end;
  //  
  ReplaceText:= '';
end;

{        
  //last?Abonent=xxx&Passwd=xxx
}
procedure TWebModule1.HTTPDispatcher1Actions1Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  AbonNo,
  Nickname,
  Passwd: String;
begin
  //      
  AbonNo:= Request.QueryFields.Values['ABONENT'];
  Passwd:= Request.QueryFields.Values['PASSWD'];
  NickName:= Request.QueryFields.Values['NICKNAME'];
  if CanCurAbonentReceiveMsg(Nickname) then begin
    //    
    TblAbonent.IndexName:= '';
    //         Request
    TblAbonent.FindKey([DefHCode, AbonNo]);
    //   
    HTMLQueryTableProducer1.Header.Clear;
    HTMLQueryTableProducer1.Header.Add('   '+ DefHCode + ' No ' + AbonNo);
    //    
    Response.Content := '<HTML>'+HTMLQueryTableProducer1.Content+'</HTML>';
  end else begin
    Response.Content := '<HTML><BODY><H2> '+AbonNo+
      ':      </H2></BODY></HTML>';
 end;
end;

{      
  /call?Abonent=xxx&Nickname=xxx&Msg=xxx
}
procedure TWebModule1.HTTPDispatcher1Actions2Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  AbonNo,
  ENickname,
  NewMsg: String;
begin
  //      
  AbonNo:= Request.QueryFields.Values['ABONENT'];
  ENickname:= Request.QueryFields.Values['NICKNAME'];
  NewMsg:= Request.QueryFields.Values['MSG'];
  //    
  TblAbonent.IndexName:= '';
  //         Request
  if TblAbonent.FindKey([DefHCode, AbonNo]) then begin
    //    ,  ,     
    if CanCurAbonentReceiveMsg(ENickname) then begin
      //   
      SendMsg2Abonent(AbonNo, NewMsg);
      Response.Content := '<HTML><BODY><H2>   ' +
        DefHCode + ' '  + AbonNo + '</H2></BODY></HTML>';
    end else begin
      //       
      Response.Content := '<HTML><BODY><H2>      </H2></BODY></HTML>';
    end;
  end else begin
    Response.Content := '<HTML><BODY><H2> '+ DefHCode +' No '+AbonNo+'  </H2></BODY></HTML>';
  end;
end;

{      
    
  /llist?Letter=xxx
}
procedure TWebModule1.HTTPDispatcher1Actions3Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  S, F: String;
  FirstLetter: String;
  L: Integer;
begin
  FirstLetter:= Request.QueryFields.Values['Letter'];
  with TblAbonent do begin
    IndexName:= 'ICFIO';
    SetKey;
    L:= Length(FirstLetter);
    FieldByName('FAM').AsString:= FirstLetter;
    GotoNearest;
    //          
    while not EOF do begin
      F:= TblAbonent.FieldByName('FAM').AsString;
      if system.Copy(F, 1, L) > FirstLetter
      then Break;
      S := S + '<A HREF="/cgi-bin/' + ScriptName + '/last?Abonent=' +
        TblAbonent.FieldByName('ABONENT').AsString + '">' +
        F + #32 +
        TblAbonent.FieldByName('IM').AsString[1] + #32 +
        TblAbonent.FieldByName('OT').AsString[1] +
        '</A><BR>';
      Next;
    end;
  end;
  Response.Content:= '<HTML><BODY>'+S+'</BODY></HTML>';
end;

{ WebModule1.OnCreate
}
procedure TWebModule1.DataModule1Create(Sender: TObject);
var
  FN: array[0..MAX_PATH- 1] of char;
begin
  // GetModuleFileName-  Win95    /0   
  // SetString-    StrPas
  SetString(ScriptName, FN, GetModuleFileName(hInstance, FN, SizeOf(FN)));
  // ScriptName     HTML
  ScriptName := ExtractFileName(ScriptName);
  // - 
  LoadIni;
  TblCalls.Open;
  TblAbonent.Open;
end;

function TWebModule1.LoadIni: Boolean;
var
  IniFile: TIniFile;
begin
  Result:= False;
  IniFile := TIniFile.Create(INI_PAGER_FILE);
  with IniFile do begin
    DefHCode:= ReadString(sectGLOBAL, iniDEFHCODE, 'SPC');
    //   login   ,  
    //    password'
    DataBase1.LoginPrompt:= ReadBool(sectGLOBAL, iniLoginPrompt, True);
    //   ?
    if ReadBool(sectGLOBAL, iniUSEALIAS, True) then begin
      DataBase1.AliasName:= ReadString(sectGLOBAL, iniALIAS, 'PAGER');
    end else begin
      //             
      // ReadString(sectGLOBAL, iniDataFolder, 'DATA\');
      Halt(1);
    end;
    //      - , 
    ReadSectionValues(sectDBParams, DataBase1.Params);
    CurZone:= ReadString(sectOPER, iniLOCALZONE, '');
  end;
  IniFile.Free;
  LoadIni:= True;
end; { LoadIni }

//         
//(  !)
function TWebModule1.CanCurAbonentReceiveMsg(const ANickname: String): Boolean;
begin
  Result:= TblAbonent.FieldByName('NICKNAME').isNull or
    (TblAbonent.FieldByName('NICKNAME').AsString = ANickname);
end;

procedure TWebModule1.SendMsg2Abonent(const Abonent, NewMsg: String);
var
  L: Integer;
  Buf: array[0..257] of char;
begin
  //   CALLS    ?
  with TblCalls do begin
    Append;
    FieldByName('HCODE').AsString:= DefHCode;
    FieldByName('ABONENT').AsString:= Abonent;
    FieldByName('UPDATER').AsInteger:= -1;
    FieldByName('UPDATED').AsDateTime:= Date;
    FieldByName('UPDTIME').AsDateTime:= Time;
    // 1 FieldByName('MSGNO').AsInteger:= 1;
    FieldByName('MSG').AsString:= NewMsg;
    //  -  
    // FieldByName('ZONE').AsString:= CurZone;
    //   
    FieldByName('OPERREM').AsString:= 'WWW';
    {    ! }
    FieldByName('SSHEDULE').AsString:= 'o';
    {   ,      
    }
    FieldByName('SDATE').Clear;
    FieldByName('SSTART').Clear;
    {   GMT }
    FieldByName('GMT').Clear;
    {        }
    FieldByName('REPEATED').Clear;
    {  ,       }
    FieldByName('SFINISH').Clear;
    FieldByName('SRPTMIN').Clear;
    //    -  
    // FieldByName('SKIND').AsString:= Copy(CBKind.Text, 1, 1);
    {       }
    FieldByName('MAILED').AsString:= 'o';
    FieldByName('DELIVERED').AsString:= 'o';
    L:= 0;
    FieldByName('WORDS').AsInteger:=
      PCountWords(L, StrPCopy(Buf, NewMsg));
    FieldByName('CHARS').AsInteger:= L;
    Post;
  end;
end;

end.
