unit Clogin;
(*##*)
(*******************************************************************
*                                                                 *
*   C  L  O  G  I  N           EPAGER's unit.                      *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   common login prompt form for all EPAGER program               *
*   Conditioonal defines: ---                                      *
*                                                                 *
*   Last Revision: Mar 19 1998                                     *
*   Last fix     : Mar 19 1998                                    *
*   Lines        : 335                                             *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Tabs, Grids, DBGrids, Mask, ExtCtrls, TabNotBk, DB,
  DBTables, sysutils, ComCtrls,
  util1, PCommon;

type
  TFormLogin = class(TForm)
    TNLog: TTabbedNotebook;
    ETabno: TEdit;
    EDept: TEdit;
    BOk: TButton;
    BCancel: TButton;
    Label1: TLabel;
    Label2: TLabel;
    EPasswd: TEdit;
    Label3: TLabel;
    Memo1: TMemo;
    ENewTabno: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    ENewDept: TEdit;
    Label6: TLabel;
    ENewPasswd1: TEdit;
    BtnNewUser: TButton;
    BtnCancelNewUser: TButton;
    Memo2: TMemo;
    BtnDeleteUser: TButton;
    ENewPasswd2: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    ECode: TEdit;
    ERegisteredCode: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Button3: TButton;
    Memo3: TMemo;
    LoginTbl: TTable;
    LUserState: TLabel;
    Image1: TImage;
    LDaysRemaining: TLabel;
    FunnyButton: TButton;
    Label11: TLabel;
    Label12: TLabel;
    ELevel: TEdit;
    UDLevel: TUpDown;
    procedure BOkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnCancelNewUserClick(Sender: TObject);
    procedure BtnNewUserClick(Sender: TObject);
    procedure TNLogChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure FormActivate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FunnyButtonClick(Sender: TObject);
  private
    { Private declarations }
    AC: Integer;
    AliasUsed: Boolean;
    TableNameVoc: String[32];
    function  Accessibility: Integer;
    procedure ClearNewFields;
  public
    { Public declarations }
  end;

var
  FormLogin: TFormLogin;

{     
  :
  True   -  
  False  -     
   :
  RUpd   -  
  RHCode - 
}
function LoginScreen(var RUpd: LongInt; var RHCode: THCODE): Boolean;
{ fill up PCommon variables:
  LIMIT     : Integer;
  WARNLIMIT : Integer;
  DATELIMIT : TDateTime;
  WARNDATELIMIT : TDateTime;
}
implementation

{$R *.DFM}

uses
  IniFiles, dialogs,
  Secure;

{ 0 .. 255 - user granted
  -999 - no user exists
  -1..-256 - invalid passwd, absolute value - rights MINUS 1
}
function TFormLogin.Accessibility: Integer;
begin
  AC:= -999;
  if (ETabNo.Text > '') then with LoginTbl do begin
    Open;
    FindNearest(['USER', EDept.Text, ETabNo.Text]);
    if (FieldByName('SUBLIST').AsString = EDept.Text) and
    (FieldByName('TEXT').AsString = ETabNo.Text)  then begin
       if FieldByName('REM').AsString = CALCPASSWD(EPasswd.Text)
       then AC:= FieldByName('CODE').AsInteger
       else AC:= -1 - FieldByName('CODE').AsInteger;
    end else begin
      { debug
      ShowMessage(FieldByName('SUBLIST').AsString);
      ShowMessage(FieldByName('TEXT').AsString);
      }
      AC:= -999;
    end;
    Close;
  end;
  Accessibility:= AC;
end;

{     
  :
  True   -  
  False  -     
   :
  RUpd   -  
  RHCode - 
}
function LoginScreen(var RUpd: LongInt; var RHCode: THCODE): Boolean;
var
  MR: Integer;
  Lic: Integer;
  IniFile: TIniFile;
  S: String;
begin
  Result:= False;
  Lic:= LicenseIsValid(S);
  case Lic of
  licWARNING:
     begin
       ShowMessage('-    .  .');
     end;
  licINVALID:
     begin
       Result:= False;
       Exit;
     end;
  end;
  IniFile := TIniFile.Create(INI_PAGER_FILE);
  with IniFile do begin
    {      INI -    }
    S:= ReadString(sectGLOBAL, iniAUTOLOGON, '');
    IniFile.Free;
    RHCode:= GetToken(1, ',',S);
    S:= GetToken(2, ',',S);
    if isDecimal(S) then begin
      try
        RUPD:= StrToInt(S);
      except
      end;
      if (RHCode = '') then begin
        {    ,   }
      end else begin
        {    ,   -    }
        LIMIT:= 0;
        {       (  ) }
        if Lic = licVALID then begin
          Result:= True;
          Exit;
        end;
      end;
    end;
    {   ,   }
  end;
  FormLogin:= TFormLogin.Create(Application);
  with FormLogin do begin
    // ECode.Text:= S;
    ETabNo.Text:= S;
    EDept.Text:= RHCode; // RUPD
    // ActiveControl:= BOk;
    MR:= ShowModal;
    if MR = mrOK then begin
      RHCode:= EDept.Text;
      RUPD:= StrToInt(ETabNo.Text);
      Result:= True;
      { RUPD:= ETabNo.Text;}
    end;
    FormLogin.Free;
  end;
end;

procedure TFormLogin.BOkClick(Sender: TObject);
var
  AC: Integer;
begin
  AC:= Accessibility;
  if AC >= 0 then begin
    ModalResult:= mrOK;
  end;
end;

procedure TFormLogin.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  DBFolder, DBAlias: String;
  i: Integer;
begin
  IniFile := TIniFile.Create(INI_PAGER_FILE);
  with IniFile do begin
    Font.Name:= ReadString(sectFONT, iniFontName, 'System');
    { }
    TNLog.TabFont.Name:= Font.Name;
    ERegisteredCode.Text:= ReadString(sectGLOBAL, iniRegistrationKey, '');
    AliasUsed:= ReadBool(sectGLOBAL, iniUSEALIAS, True);
    DBAlias:= ReadString(sectGLOBAL, iniALIAS, 'PAGER');
    DBFolder:= ReadString(sectGLOBAL, iniDataFolder, 'DATA\');
    TableNameVoc:= ReadString(sectGLOBAL, iniVOCTbl, 'VOC');
    IniFile.Free;
  end;
  with LoginTbl do begin
    Active:= False;
    if AliasUsed then begin
      DatabaseName:= DBAlias;
      TableName:= TableNameVoc;
    end else begin
      DatabaseName:= '';
      TableName:= ConCatPath(DBFolder, TableNameVoc);
    end;
  end;
  {    -
    LicenseIsValid    
  }
  ECode.Text:= Pcommon.ComputerName+',1,'+FormatDateTime('m.yyyy', Date);
  i:= Trunc(EncodeDate(2000,1,1)-Date);
  if i < 0 then begin
    Label1.Caption:= 'XXI:  ';
    i:= -i;
  end;
  LDaysRemaining.Caption:= IntToStr(I);
end;

procedure TFormLogin.  ClearNewFields;
begin
  ENewTabno.Text:= '';
  ENewDept.Text:= '';
  ENewPasswd1.Text:= '';
  ENewPasswd2.Text:= '';
end;

procedure TFormLogin.BtnCancelNewUserClick(Sender: TObject);
begin
  ClearNewFields;
end;

procedure TFormLogin.BtnNewUserClick(Sender: TObject);
var
  Passwd: String;
begin
  { }
  if ENewPasswd1.Text <> ENewPasswd2.Text then begin
    LUserState.Caption:= '  ';
    Exit;
  end;
  Passwd:= ENewPasswd1.Text;
  ETabNo.Text:= ENewTabNo.Text;
  EDept.Text:=  ENewDept.Text;
  EPasswd.Text:= '';
  if Accessibility = -999 then begin
    { new user }
    with LoginTbl do begin
      Open;
      {IndexName:= ''; }
      Append;
    end;
    LUserState.Caption:= '  ';
  end else begin
    { change passwd }
    with LoginTbl do begin
      Open;
      FindNearest(['USER', EDept.Text, ETabNo.Text]);
      Edit;
    end;
    LUserState.Caption:= ' ';
  end;
  with LoginTbl do begin
    try
    FieldByName('LIST').AsString:= 'USER';
    FieldByName('SUBLIST').AsString:= ENewDept.Text;
    FieldByName('CODE').AsInteger:= UDLevel.Position;
    FieldByName('TEXT').AsString:= ENewTabNo.Text;
    FieldByName('REM').AsString:= Passwd;
    except
      ShowMessage(',       ');
    end;
    Post;
    Close;
  end;
  ClearNewFields;
end;

procedure TFormLogin.TNLogChange(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  AllowChange:= (newtab = 0) or
    (Accessibility = ROOTID); { 0 value }
end;

procedure TFormLogin.FormActivate(Sender: TObject);
begin
  FormLogin.ActiveControl:= ETabNo;
end;

procedure TFormLogin.Button3Click(Sender: TObject);
const
  reg_WINID =  'SOFTWARE\Microsoft\Windows\CurrentVersion';
var
  S: String;
begin
  S:= GetRegString(HKEY_LOCAL_MACHINE, reg_WINID, 'RegisteredOwner', 'nobody');
  pgSetRegString('Name', S);
  S:= GetRegString(HKEY_LOCAL_MACHINE, reg_WINID, 'RegisteredOrganization', 'mib');
  pgSetRegString('Company', S);
  pgSetRegString('Grants', ECode.Text);
  pgSetRegString('Serial', ERegisteredCode.Text);
end;

procedure TFormLogin.FunnyButtonClick(Sender: TObject);
begin
  if ANSICompareText(ERegisteredCode.Text, SECRETREGISTERKEY) = 0 then begin
    // SecretButton.Caption:= GetSecure;
    ERegisteredCode.Text:= GetSecure;
  end else begin
    ModalResult:= mrCancel;
  end;
end;

end.
