/*
 SQL script transfer data from UNIPAGE to EPAGER. (c) 1998, A.Ivanov. All rights reserved.

 CAUTION! Make backup copy of EPAGER.gdb is recommended before execute script

 How to create APager database tables, refer to mkdb.sql

 1) change directory to "C:\Src\Delphi\Pager\Data" (select any other path)
 2) edit this script (change user name and password)
 3) make
 3) run this script via WISQL32 or ISQL (located in .\BIN of Interbase
*/

/* Change USER and PASSWORD clauses to appropriate values 
*/
SET NAMES WIN1251;
CONNECT DATABASE "EPager.gdb" USER "SYSDBA" PASSWORD "masterkey";
COMMIT;

CREATE TABLE SUBDAT (
  R_SUBID VARCHAR(7),
  R_CHANNEL VARCHAR(1),
  R_ZONE VARCHAR(1),
  R_TYPE VARCHAR(1),
  R_MSG VARCHAR(1),
  R_CAPCODE VARCHAR(7),
  R_FUNC VARCHAR(1),
  R_FLAGS VARCHAR(12),
  R_ACCOUNT DOUBLE PRECISION,
  R_RATE SMALLINT,
  R_SERVICE VARCHAR(16),
  R_ADD VARCHAR(24),
  R_GROUP SMALLINT,
  R_GMASTER VARCHAR(1),
  R_NOTES VARCHAR(56),
  R_SDATE DATE,
  R_MDATE DATE,
  R_CALLCNT DOUBLE PRECISION,
  R_LASTCNT DOUBLE PRECISION,
  R_SERIAL VARCHAR(16),
  R_IMAGEA VARCHAR(12),
  R_IMAGEB VARCHAR(14),
  R_IMAGEM VARCHAR(22)
) EXTERNAL "/PATH/SUBDAT.DAT";

INSERT INTO CLIENT
( R_SUBID,  R_CHANNEL,  R_ZONE,
  R_TYPE,   R_MSG,      R_CAPCODE,
  R_FUNC,   R_FLAGS,    R_ACCOUNT,
  R_RATE,   R_SERVICE,  R_ADD,
  R_GROUP,  R_GMASTER,  R_NOTES,
  R_SDATE,  R_MDATE,    R_CALLCNT,
  R_LASTCNT,R_SERIAL,   R_IMAGEA,
  R_IMAGEB, R_IMAGEM FROM SUBDAT)
SELECT 
  R_SUBID,  R_CHANNEL,  R_ZONE,
  R_TYPE,   R_MSG,      R_CAPCODE,
  R_FUNC,   R_FLAGS,    R_ACCOUNT,
  R_RATE,   R_SERVICE,  R_ADD,
  R_GROUP,  R_GMASTER,  R_NOTES,
  R_SDATE,  R_MDATE,    R_CALLCNT,
  R_LASTCNT,R_SERIAL,   R_IMAGEA,
  R_IMAGEB, R_IMAGEM FROM SUBDAT;

DROP TABLE SUBDAT;