unit ExportT;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Dialogs, ComCtrls;

type
  TFormStoreText = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    EFN: TEdit;
    BSearch: TButton;
    Label1: TLabel;
    CBQty: TCheckBox;
    RGDelimiter: TRadioGroup;
    EOtherDelimiter: TEdit;
    ProgressBar1: TProgressBar;
    LState: TLabel;
    procedure CBQtyClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BSearchClick(Sender: TObject);
  private
    { Private declarations }
    Delim: String;
  public
    { Public declarations }
  end;

var
  FormStoreText: TFormStoreText;

procedure StoreText;

implementation

uses dm, Pdict;

{$R *.DFM}

procedure TFormStoreText.CBQtyClick(Sender: TObject);
begin
  RGDelimiter.Visible:= CBQty.Checked;
  EOtherDelimiter.Visible:= CBQty.Checked;
end;

procedure TFormStoreText.OKBtnClick(Sender: TObject);
var
  T: TextFile;
begin
  {}
  with DM1 do begin
    AssignFile(T, EFn.Text);
    Rewrite(T);
    if IOResult <> 0 then begin
      ShowMessage('    '+ EFn.Text);
      Exit;
    end;
    with QDict do begin
      DisableControls;
      First;
      if CBQty.Checked then begin
        case RGDelimiter.ItemIndex of
        0: Delim:= #9;
        1: Delim:= ';';
        2: Delim:= ',';
        3: Delim:= EOtherDelimiter.Text;
        end;
        while not EOF do begin
          Writeln(T, QDict.FieldByName('PHRASE').AsString, Delim,
            QDict.FieldByName('COUNTS').AsString);
          Next;
          if (RecNo and $F)=1
          then ProgressBar1.Position:= RecNo;
        end;
      end else begin
        while not EOF do begin
          Writeln(T, QDict.FieldByName('PHRASE').AsString);
          Next;
          if (RecNo and $F)=1
          then ProgressBar1.Position:= RecNo;
        end;
      end;
      DisableControls;
    end;
    CloseFile(T);
  end;
  //  
  with FormDict do begin
    ExportDictSeparator:= Delim;
    ExportDictQty:= CBQty.Checked;
    ExportDictName:= EFN.Text;
  end;
end;

procedure TFormStoreText.FormCreate(Sender: TObject);
begin
  LState.Caption:= ' <>   ';
  ProgressBar1.Max:= DM1.QDict.RecordCount;
  ProgressBar1.Position:= 0;
  EFN.Text:= FormDict.ExportDictName;
  CBQty.Checked:= FormDict.ExportDictQty;
  //   
  Delim:= FormDict.ExportDictSeparator;
  RGDelimiter.ItemIndex:= 3;
  EOtherDelimiter.Text:= Delim;
  if Delim = #9
  then RGDelimiter.ItemIndex:= 0;
  if Delim = ';'
  then RGDelimiter.ItemIndex:= 1;
  if Delim = ','
  then RGDelimiter.ItemIndex:= 2;

  with DM1.SaveDialog1 do begin
    DefaultExt:= 'TXT';
    Filter:= ' (*.TXT)|*.TXT| |*.*';
  end;
end;

procedure TFormStoreText.BSearchClick(Sender: TObject);
begin
  with DM1.SaveDialog1 do begin
    if Execute then begin
      EFn.Text:= FileName;
    end;
  end;
end;

procedure StoreText;
begin
  FormStoreText:= TFormStoreText.Create(Application);
  FormStoreText.ShowModal;
  FormStoreText.Free;
end;

end.
