unit ImportF;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ComCtrls;

type
  TFormImportFld = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    ProgressBar1: TProgressBar;
    CBClearFirst: TCheckBox;
    BSearch: TButton;
    Label1: TLabel;
    RGCase: TRadioGroup;
    ListBox1: TListBox;
    BDelete: TButton;
    procedure BSearchClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure BDeleteClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormImportFld: TFormImportFld;

procedure ImportDB;

implementation

{$R *.DFM}
uses
  util1, Dm, TblFld, Pdict;

procedure ImportDB;
begin
  {}
  FormImportFld:= TFormImportFld.Create(Application);
  if FormImportFld.ShowModal = mrOK then begin
    FormDict.SQLAll;
  end;
  FormImportFld.Free;
  FormImportFld:= Nil;
end;

procedure TFormImportFld.BSearchClick(Sender: TObject);
begin
  {}
  TblFld.ShowTableFld;
  ListBox1.Items.Assign(FormDict.TableFieldList);
end;

procedure TFormImportFld.FormCreate(Sender: TObject);
begin
  {}
  ListBox1.Items.Assign(FormDict.TableFieldList);
end;

procedure TFormImportFld.OKBtnClick(Sender: TObject);
var
  i, r, t, fld, wl: Integer;
  ACase: Word;
  tok, S, fldname: String;
begin
  DM1.Table1.Open;
  //  
  if CBClearFirst.Checked then begin
    //
    FormDict.ETShowStatus(0, ' ..');
    Application.ProcessMessages;
    with DM1.Table1 do begin
      First;
      Edit;
      while not EOF
      do Delete;
    end;
  end;
  {  }
  for t:= 1 to ListBox1.Items.Count do begin
    DM1.Table2.Close;
    ACase:= RGCase.ItemIndex;
    DM1.Table2.TableName:= ListBox1.Items.Names[t-1];
    DM1.Table2.Open;
    R:= DM1.Table2.RecordCount;
    ProgressBar1.Max:= R;
    {  }
    fld:= 0;
    repeat
      i:= 1;
      Inc(fld);
      fldname:= GetToken(fld, ',', ListBox1.Items.Values[DM1.Table2.TableName]);
      if fldname = ''
      then break;
      while not DM1.Table2.EOF do begin
        if (i and $F) = $F then begin
          FormDict.ETShowStatus(0, IntToStr(100 * i div R) + '%');
          ProgressBar1.Position:= i;
        end;
        S:= DM1.Table2.FieldByName(fldname).AsString;
        case ACase of
          1: S:= ANSIUpperCase(S);
          2: S:= ANSILowerCase(S);
        end;
        {     }
        repeat
          tok:= PDict.GetWord(S, WL);
          if WL < 3
          then Break;
          if DM1.Table1.FindKey([Tok]) then begin
            DM1.Table1.Edit;
            DM1.Table1.FieldByName('COUNTS').AsInteger:=
              DM1.Table1.FieldByName('COUNTS').AsInteger + 1;
          end else begin
            DM1.Table1.Edit;
            try
              DM1.Table1.InsertRecord([Tok, 1]);
            except
            end;
          end;
        until False;

        DM1.Table2.Next;
        Inc(i);
      end;
    until False;
    DM1.Table2.Close;
  end;

  DM1.Table1.Close;
  {   }
  FormDict.TableFieldList.Assign(ListBox1.Items);
end;

procedure TFormImportFld.BDeleteClick(Sender: TObject);
var
  ind: Integer;
begin
  {}
  with ListBox1 do begin
    ind:= ListBox1.ItemIndex;
    if ind >= 0 then begin
      ListBox1.Items.Delete(ind);
      {   }
      FormDict.TableFieldList.Assign(Items);
    end;  
  end;  
end;

end.
