unit ImportT;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Dialogs, ComCtrls;

type
  TFormImportText = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    GroupBox1: TGroupBox;
    CBClearFirst: TCheckBox;
    Label1: TLabel;
    BSelectfile: TButton;
    CBOEM: TCheckBox;
    ListBox1: TListBox;
    BDelete: TButton;
    BClear: TButton;
    RGCase: TRadioGroup;
    RichEdit1: TRichEdit;
    procedure BSelectfileClick(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BDeleteClick(Sender: TObject);
    procedure BClearClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure CBOEMClick(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
  private
    { Private declarations }
    function CanStart: Boolean;
  public
    { Public declarations }
    procedure DeleteSelected;
  end;

var
  FormImportText: TFormImportText;

procedure ImportText;

implementation

uses dm, Pdict;

{$R *.DFM}

procedure ImportText;
begin
  {}
  FormImportText:= TFormImportText.Create(Application);
  if FormImportText.ShowModal = mrOK then begin
    FormDict.SQLAll;
  end;
  FormImportText.Free;
  FormImportText:= Nil;
end;

procedure TFormImportText.BSelectfileClick(Sender: TObject);
begin
  with DM1.OpenDialog1 do begin
    DefaultExt:= 'TXT';
    Filter:= ' (*.TXT)|*.TXT|  (*.RTF)|*.RTF| |*.*';
    if Execute then begin
      ListBox1.Items.AddStrings(Files);
    end;
  end;
  CanStart;
end;

procedure TFormImportText.DeleteSelected;
var
  i: Integer;
begin
  i:= 0;
  while i < ListBox1.Items.Count do begin
    if ListBox1.Selected[i] then begin
      ListBox1.Items.Delete(i);
    end else begin
      Inc(i);
    end;
  end;
  CanStart;
end;

procedure TFormImportText.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_DELETE
  then DeleteSelected;
end;

procedure TFormImportText.BDeleteClick(Sender: TObject);
begin
  DeleteSelected;
end;

procedure TFormImportText.BClearClick(Sender: TObject);
begin
  ListBox1.Clear;
end;

function TFormImportText.CanStart: Boolean;
var
  c: Boolean;
begin
  c:= ListBox1.Items.Count > 0;
  OKBtn.Enabled:= c;
  Result:= c;
end;

procedure TFormImportText.OKBtnClick(Sender: TObject);
var
  i: Integer;
  Fn: String;
begin
  //  
  for i:= 1 to ListBox1.Items.Count
  do ListBox1.Selected[i-1]:= False;
  DM1.Table1.Open;
  //  
  if CBClearFirst.Checked then begin
    //
    FormDict.ETShowStatus(0, ' ..');
    Application.ProcessMessages;
    with DM1.Table1 do begin
      First;
      Edit;
      while not EOF
      do Delete;
    end;
  end;
  i:= 0;
  while i < ListBox1.Items.Count do begin
    Fn:= ListBox1.Items[i];
    if FileExists(Fn) then begin
      // 
      ListBox1.Selected[i]:= True;
      RichEdit1.Lines.LoadFromFile(Fn);
      Application.ProcessMessages;
      FormDict.DoImport(RichEdit1.Lines, RGCase.ItemIndex);
    end else begin
      ShowMessage(' '+ Fn + '  .');
    end;
    Inc(i);
  end;
  DM1.Table1.Close;
end;

procedure TFormImportText.CBOEMClick(Sender: TObject);
begin
  // RichEdit1.OEMConvert:= CBOEM.Checked;
end;

procedure TFormImportText.ListBox1DblClick(Sender: TObject);
var
  i: Integer;
begin
  //     
  for i:= 1 to ListBox1.Items.Count do begin
    if ListBox1.Selected[i-1] then begin
      RichEdit1.Lines.LoadFromFile(ListBox1.Items[i-1]);
      Exit;
    end
  end;
end;



end.
