unit Pdict;
{ Employee table DLL project implementaton.
  DLL functions:
    Index Name               Description
    1     ViewEmployeeTable  View tmployee table
    2     ...
}
interface

uses
  SysUtils, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, DBCtrls, Grids, DBGrids, DB, DBTables,
  StdCtrls, Menus, DBLookup, Inifiles,Tabs, Buttons,
  ToolWin, Tabnotbk, ComCtrls,
  About, PCommon, util1;


const
  { 3 kind of search }
  SEARCHBYNAMES = 0;
  SEARCHBYID    = 1;
  SEARCHBYDATE  = 2;

  kndALL           = 0;
  kndBYCYRLETTER   = 1;
  kndBYENGLETTER   = 2;
  kndBYWORD        = 3;

  DELIMITERS = [#0..'@', '['..'`', '{'..#127];

type
  TFormDict = class(TForm)
    StatusBar1: TStatusBar;
    Panel3: TPanel;
    TabbedNotebook1: TTabbedNotebook;
    Image4: TImage;
    Button1: TButton;
    Image3: TImage;
    TabbedNotebook3: TTabbedNotebook;
    TSABCCyr: TTabSet;
    TSABCEng: TTabSet;
    Memo4: TMemo;
    TabbedNotebook2: TTabbedNotebook;
    Label2: TLabel;
    LCount: TLabel;
    Image1: TImage;
    Memo2: TMemo;
    BDelete: TButton;
    Label1: TLabel;
    Image2: TImage;
    BReset: TButton;
    Memo3: TMemo;
    DBGDict: TDBGrid;
    CBNullCount: TCheckBox;
    BCapitalize: TButton;
    BLowerize: TButton;
    Memo1: TMemo;
    Image5: TImage;
    Splitter1: TSplitter;
    TrackBar1: TTrackBar;
    EResetCount: TEdit;
    UpDown1: TUpDown;
    ToolBar1: TToolBar;
    TBSave: TToolButton;
    TBImpDB: TToolButton;
    TBImpText: TToolButton;
    ECount: TEdit;
    Image6: TImage;
    procedure Timer1Timer(Sender: TObject);
    procedure BPrintListClick(Sender: TObject);
    procedure BSaveChangesClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TSABCCyrChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure TSABCEngChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure BDeleteClick(Sender: TObject);
    procedure BResetClick(Sender: TObject);
    procedure popEditClick(Sender: TObject);
    procedure QDictAfterOpen(DataSet: TDataset);
    procedure BCapitalizeClick(Sender: TObject);
    procedure BLowerizeClick(Sender: TObject);
    procedure TBSaveClick(Sender: TObject);
    procedure TBImpDBClick(Sender: TObject);
    procedure TBImpTextClick(Sender: TObject);
  private
    { Private declarations }
    FirstTime: Boolean;
    Kind: Byte;
    AliasCyrList: TStringList;
    AllreadyRegistered: Boolean;
    QDictName: String[32];
    DICTLABELS: String[255];
    TrackSCALE: Integer;
  protected
  public
    { Public declarations }
    CurHCode  : THCODE;  { }
    CurUPDATER: Longint;  { }
    ByAlias: Boolean;
    CurAlias: String[32];
    CurDBFolder: SQLPathString;
    SQLFolder: SQLPathString;
    SQLSYSFolder: SQLPathString;
    SQLVOCFolder: SQLPathString;
    WorkPlace: SQLPathString;
    TableFieldList: TStringList;
    //       
    ExportDictName: SQLPathString;
    ExportDictQty: Boolean;
    ExportDictSeparator: String;
    procedure ETShowStatus(Level: Integer; const S: String);
    procedure SetVisualFont(AFont: TFont);
    { store changes to INI file }
    function  LoadIni: Boolean;
    procedure StoreIniChanges;
    { change alias and update all visibles }
    function AssignAlias(const AAlias: String): Boolean;
    function AssignDataFolder(const ADataFolder: String): Boolean;
    { do smth to find DLLS.
    For example, change current directory?
    }
    procedure AssignWorkPlace(const S: String);
    procedure StoreFields(const S: String);
    function  LoginUser(AHCode: THCODE;AUPDATER: LongInt): Boolean;
    procedure UpdateDisplayLabels;
    procedure FillSQLLetter(Ch: Char; Lang: Byte);
    procedure SQLAll;
    procedure SQLAllToDelete(FromZeroTO: LongInt);
    function  DoImport(AStr: TStrings; ACase: Byte): Boolean;
    procedure DisplayHint(Sender: TObject);
    procedure ShowItems;
    procedure CountChange(ACount: Integer);
  end;

var
  FormDict: TFormDict;

function  GetWord(var S: String; var WordLen: Integer): String;

implementation
uses
  clogin, dm, tblfld, ImportF, ImportT, exportT;

procedure ViewDictTable(ASessionInserted: LongInt; var AHCode: THCODE;
  AUPDATER: LongInt);
begin
  FormDict:= TFormDict.Create(Application);
  with FormDict do begin
    if LoginUser(AHCode, AUPDATER) then begin
      ShowModal;
      Hide;
    end;
    Free;
  end;
end;

{$R *.DFM}

procedure TFormDict.ETShowStatus(Level: Integer; const S: String);
begin
  with StatusBar1 do begin
    case Level of
    1:Font.Color:= clRed;
    2:Font.Color:= clBlue;
    3:Font.Color:= clYellow;
    else Font.Color:= clBlack;
    end;
    Panels[StatusBar1.Panels.Count-1].Text:= S;
  end;
  Application.ProcessMessages;  
end;

procedure TFormDict.Timer1Timer(Sender: TObject);
begin
  { turn off message after Interval 2000 ms = 2s
  }
  ETShowStatus(0, '');
end;

procedure TFormDict.BPrintListClick(Sender: TObject);
begin
  ETShowStatus(2, ' ');
end;

procedure TFormDict.SetVisualFont(AFont: TFont);
begin
  FormDict.Font:= AFont;
  TabbedNotebook1.TabFont.Name:= AFont.Name;
  TabbedNotebook2.TabFont.Name:= AFont.Name;
  TabbedNotebook3.TabFont.Name:= AFont.Name;
  // TNVis.TabFont.Name:= AFont.Name;
end;

function TFormDict.AssignAlias(const AAlias: String): Boolean;
begin
  AssignAlias:= False;
  if AAlias <> '' then with DM1,Database1 do begin
    {   }
    QDict.Active:= False;
    QDictDelete.Active:= False;
    {     }
    Connected:= False;
    AliasName:= AAlias;
    {      }
    QDict.DataBaseName:= DataBase1.DataBaseName;
    QDictDelete.DataBaseName:= DataBase1.DataBaseName;
    {    }
    Connected:= True;
  end;
  AssignAlias:= True;
end;

function TFormDict.AssignDataFolder(const ADataFolder: String): Boolean;
begin
  AssignDataFolder:= False;
  if ADataFolder <> '' then with DM1 do begin
    Database1.Connected:= False;
    Database1.AliasName:= '';
    { connect others
    }
    with QDict do begin
      Active:= False;
      DatabaseName:= '';
    end;
    with QDictDelete do begin
      Active:= False;
      DatabaseName:= '';
    end;
  end;
  AssignDataFolder:= True;
end;

procedure TFormDict.AssignWorkPlace(const S: String);
begin
  if S = '' then begin
    if DEFWORKPLACE <> '' then begin
      ChDir(DEFWORKPLACE);
    end;  
  end else ChDir(S);
end;

procedure TFormDict.StoreFields(const S: String);
begin
  {
  not implemented
  }
end;

procedure ValidateDateDelimiters(var S: String);
begin
  {     ,    ,  }
  if Length(S) = 1
  then S:= S+S;
  {        ,  }
  if Length(S) = 0
  then S:= DEFDATEDELIMITERS;
  {     (   2),   }
  System.Delete(S, 3, 255);
end;

procedure ValidatePhoneDelimiter(var S: String);
begin
  {        ,  }
  if Length(S) = 0
  then S:= DEFPHONEDELIMITER;
  {     (   1),   }
  System.Delete(S, 2, 255);
end;

function TFormDict.LoadIni: Boolean;
var
  IniFile: TIniFile;
  S: String;
begin
  LoadIni:= False;
  IniFile := TIniFile.Create(SearchIni('', INI_PAGER_FILE));
  with IniFile do with DM1 do begin
    QDict.DisableControls;
    QDictDelete.DisableControls;
    Font.Name:= ReadString(sectFONT, iniFontName, 'System');
    Font.Size:= ReadInteger(sectFONT, iniFontSize, -10);
    SetVisualFont(Font);
    {     }
    ByAlias:= ReadBool(sectGLOBAL, iniUSEALIAS, True);
    CurAlias:= ReadString(sectGLOBAL, iniALIAS, 'PAGER');
    CurDBFolder:= ReadString(sectGLOBAL, iniDataFolder, 'DATA\');
    {    }
    QDictName:= ReadString(sectDICT, iniDICTTBL, 'Dict.db');
    {       }
    ExportDictName:= ReadString(sectDICT, iniEXPORTTEXTFN, '');
    ExportDictQty:= ReadBool(sectDICT, iniEXPORTQTY, False);
    ExportDictSeparator:= WEBStyleAndControlString2ASCII(ReadString(sectDICT, iniEXPORTSEP, ''));

    WorkPlace:= ReadString(sectGLOBAL, iniDLLS, DEFWORKPLACE);
    { folders }
    AssignWorkPlace(WorkPlace);
    SQLFolder:= ReadString(sectGLOBAL, iniSQLS, 'SQL\');
    SQLSYSFolder:= ReadString(sectGLOBAL, iniSYSSQLS, 'SQL\SYS\');
    SQLVOCFolder:= ReadString(sectGLOBAL, iniVOCSQLS, 'SQL\VOC\');
    if ByAlias
    then AssignAlias(CurAlias)
    else AssignDataFolder(CurDBFolder);
    DICTLABELS:= ReadString(sectDICT, iniDICTTBLLBL, DEFDICTLABELS);
    CountChange(ReadInteger(sectDICT, iniCountWord, 10));
    // TrackBar1Change(Self);  //  QDict.Active:= True;
    QDict.EnableControls;
    ReadSectionValues(sectBUILDTABLE, TableFieldList);
  end;
  IniFile.Free;
  LoadIni:= True;
end; { LoadIni }

procedure TFormDict.StoreIniChanges;
var
  IniFile: TIniFile;
  S: String;
  i: Integer;
begin
  {   }
  StoreIniServiceList;
  IniFile := TIniFile.Create(SearchIni('', INI_PAGER_FILE));
  with IniFile do begin
    WriteString(sectFONT, iniFontName, Font.Name);
    WriteInteger(sectFONT, iniFontSize, Font.Size);
    WriteBool(sectGLOBAL, iniUSEALIAS, ByAlias);
    { it is joke
    WriteString(sectGLOBAL, iniALIAS, Database1.AliasName);
    }
    WriteString(sectGLOBAL, iniALIAS, CurAlias);
    WriteString(sectGLOBAL, iniDATAFOLDER, CurDBFolder);
    WriteString(sectGLOBAL, iniDLLS, '');
    WriteString(sectGLOBAL, iniSQLS, SQLFolder);
    WriteString(sectGLOBAL, iniSYSSQLS, SQLSYSFolder);
    WriteString(sectGLOBAL, iniVOCSQLS, SQLVOCFolder);

    {       }
    WriteString(sectDICT, iniEXPORTTEXTFN, ExportDictName);
    WriteBool(sectDICT, iniEXPORTQTY, ExportDictQty);
    WriteString(sectDICT, iniEXPORTSEP, ControlString(ExportDictSeparator));

    { firstly change fields, adn then - table must be changed }
    { StoreFields(DICTDEFAULTFIELDFILE);}
    WriteString(sectDICT, iniDICTTBLLBL, DICTLABELS);
    {    }
    try
      EraseSection(sectBUILDTABLE);
    except
      ShowMessage('   '+sectBUILDTABLE+ '   ');
    end;
    for i:= 1 to TableFieldList.Count do begin
      S:= TableFieldList.Names[i-1];
      WriteString(sectBUILDTABLE, S, TableFieldList.Values[S]);
    end;
    WriteInteger(sectDICT, iniCountWord, StrToIntDef(ECount.Text, 10));
  end;
  IniFile.Free;
end;

procedure TFormDict.BSaveChangesClick(Sender: TObject);
begin
  {}
  StoreIniChanges;
end;

function  TFormDict.LoginUser(AHCode: THCODE; AUPDATER: LongInt): Boolean;
begin
  LoginUser:= False;
  CurHCode:= AHCode;
  CurUpdater:= AUPDATER;
  LoginUser:= True;
end;

procedure TFormDict.FormActivate(Sender: TObject);
begin
  if FirstTime then begin
    LoadIni;
    FirstTime:= False;
  end;
end;

procedure TFormDict.UpdateDisplayLabels;
var
  i: Integer;
begin
  { dbgrid labels }
  with DM1 do if QDict.Active then begin
    for i:= 1 to QDict.FieldCount do begin
      QDict.Fields[i-1].DisplayLabel:= GetToken(i, ',', DictLABELS);
    end;
  end;
end;

procedure TFormDict.FormDestroy(Sender: TObject);
begin
  EraseServiceList;
  TableFieldList.Free;
end;

procedure TFormDict.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := True;
  with DM1 do if (DSQDict.State in [dsEdit]) then begin
    if MessageDlg(': c   ?', mtConfirmation,
      [mbOk, mbCancel], 0) = mrOK then begin
      CanClose := True;
      with QDict do if State = dsEdit
      then Post;
    end else begin
      CanClose := False;
    end;
  end;
end;

procedure TFormDict.FormCreate(Sender: TObject);
var
  Ch: Char;
begin
  FirstTime:= True;
  TrackScale:= 10;
  TableFieldList:= TStringList.Create;
  Application.OnHint:= DisplayHint;
  Kind:= kndALL;
  {    .  ,   }
  AliasCyrList:= TStringList.Create;

  AllreadyRegistered:= False;
  CurHCode  := 'SPC';
  CurUPDATER:= 0;
  with TSABCEng,Tabs do begin
    Clear;
    for ch:= 'A' to 'Z'
    do Add(Ch);
    TabIndex:= 0;
  end;
  with TSABCCyr,Tabs do begin
    Clear;
    for ch:= '' to ''
    do Add(Ch);
    TabIndex:= 0;
  end;
  SQLAll;
end;

procedure TFormDict.CountChange(ACount: Integer);
begin
  if (ACount < TrackScale) then begin
    //     , 
    trackscale:= trackscale div 10;
    if trackscale <= 0
    then trackscale:= 1;
    TrackBar1.Position:= ACount div trackscale;
  end else begin
    if (ACount >= TrackBar1.Max * TrackScale) then begin
      trackscale:= (ACount div 10) * 10;
      if trackscale <=0
      then trackscale:= 1;
      TrackBar1.Position:= ACount div trackscale;
      // Trunc(ln(ACount)/ln(10));
    end;
  end;
  LCount.Caption:= IntToStr(ACount);
  ECount.Text:= IntToStr(ACount);
  EResetCount.Text:= IntToStr(ACount);
  case Kind of
  kndALL     : SQLAll;
  kndBYCYRLETTER:  FillSQLLetter(Chr(TSABCCyr.TabIndex+Ord('')), kndBYCYRLETTER);
  kndBYENGLETTER:  FillSQLLetter(Chr(TSABCEng.TabIndex+Ord('A')), kndBYENGLETTER);
  kndBYWORD  :;
  end;
end;

procedure TFormDict.TrackBar1Change(Sender: TObject);
begin
  CountChange(TrackBar1.Position*TrackSCALE);
end;

procedure TFormDict.ShowItems;
begin
  StatusBar1.Panels[0].Text:=
    IntToStr(DM1.QDict.RecordCount);
end;

procedure TFormDict.SQLAll;
begin
  Kind:= kndALL;
  with DM1, QDict do begin
    Active:= False;
    ParamByName('LETTER1').AsString:= 'A';
    ParamByName('LETTER2').AsString:= '';
    {
    ParamByName('LETTER1').Clear;
    ParamByName('LETTER2').Clear;
    }
    ParamByName('COUNT1').AsInteger:= StrToIntDef(EResetCount.Text, 10);
    if CBNullCount.Checked
    then ParamByName('COUNT1').Clear;
    Active:= True;
    ShowItems;
  end;
end;

procedure TFormDict.SQLAllToDelete(FromZeroTO: LongInt);
begin
  with DM1.QDictDelete do begin
    Active:= False;
    ParamByName('COUNT1').AsInteger:= FromZeroTO;
    Active:= True;
  end;
end;

function  GetWord(var S: String; var WordLen: Integer): String;
var
  i, L, st, fin: Integer;
begin
  L:= Length(S);
  st:= 1;
  fin:= L+1;
  for i:= 1 to L do begin
    if not (S[i] in DELIMITERS) then begin
      st:= i;
      Break;
    end;
  end;
  for i:= st to L do begin
    if S[i] in DELIMITERS then begin
      fin:= i;
      Break;
    end;
  end;
  WordLen:= fin - st;
  Result:= System.Copy(S, st, WordLen);
  System.Delete(S, 1, fin);
end;

//      
function  TFormDict.DoImport(AStr: TStrings; ACase: Byte): Boolean;
var
  L, WL: Integer;
  tok, S: String;
begin
  Result:= False;
  with AStr do begin
    if Count <=0
    then Exit;
    for L:= 1 to Count do begin
      if (L and $F) = $F then begin
        ETShowStatus(0, IntToStr(100 * L div Count) + '%');
      end;
      case ACase of
        1: S:= ANSIUpperCase(Strings[L-1]);
        2: S:= ANSILowerCase(Strings[L-1]);
        else  S:= Strings[L-1];
      end;
      repeat
        tok:= GetWord(S, WL);
        if WL < 3
        then Break;
        if DM1.Table1.FindKey([Tok]) then begin
          DM1.Table1.Edit;
          DM1.Table1.FieldByName('COUNTS').AsInteger:=
            DM1.Table1.FieldByName('COUNTS').AsInteger + 1;
        end else begin
          DM1.Table1.Edit;
          try
            DM1.Table1.InsertRecord([Tok, 1]);
          except
          end;
        end;
      until False;
    end;
  end;
  SQLAll;
  Result:= True;
end;

procedure TFormDict.FillSQLLetter(Ch: Char; Lang: Byte);
begin
  Kind:= Lang;
  with DM1.QDict do begin
    Active:= False;
    ParamByName('LETTER1').AsString:= Ch;
    ParamByName('LETTER2').AsString:= Ch+'';
    ParamByName('COUNT1').AsInteger:= StrToIntDef(EResetCount.Text, 10);
    if CBNullCount.Checked
    then ParamByName('COUNT1').Clear;
    Active:= True;
    ShowItems;
  end;
end;

procedure TFormDict.TSABCCyrChange(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
var
  Letter: Char;
begin
  {}
  Letter:= Chr(NewTab+Ord(''));
  FillSQLLetter(Letter, kndBYCYRLETTER);
  AllowChange:= True;
  TabbedNotebook1.Pages[1]:= '&   '+ Letter;
end;

procedure TFormDict.TSABCEngChange(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
var
  Letter: Char;
begin
  {}
  Letter:= Chr(NewTab+Ord('A'));
  FillSQLLetter(Letter, kndBYENGLETTER);
  AllowChange:= True;
  TabbedNotebook1.Pages[1]:= '&   '+ Letter;  
end;

procedure TFormDict.TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  if NewTab = 0
  then SQLAll;
  AllowChange:= True;
end;

procedure TFormDict.Button1Click(Sender: TObject);
begin
  SQLAll;
end;

procedure TFormDict.BDeleteClick(Sender: TObject);
begin
  {}
  SQLAllToDelete(StrToIntDef(EResetCount.Text, 10));
  with DM1.QDictDelete do begin
    First;
    Edit;
    while not EOF do begin
      Delete;
    end;
    Active:= False;
  end;
  DM1.QDict.Refresh;
end;

procedure TFormDict.BResetClick(Sender: TObject);
var
  V: LongInt;
begin
  {}
  V:= StrToIntDef(EResetCount.Text, 10);;
  with DM1.QDict do begin
    DisableControls;
    Active:= True;
    First;
    while not EOF do begin
      Edit;
      FieldByName('COUNTS').AsInteger:= V;
      Next;
    end;
    EnableControls;
  end;
  DM1.QDict.Refresh;
end;

procedure TFormDict.popEditClick(Sender: TObject);
begin
  DM1.QDict.Edit;
end;

procedure TFormDict.QDictAfterOpen(DataSet: TDataset);
begin
  {}
  UpdateDisplayLabels;
end;

procedure TFormDict.BCapitalizeClick(Sender: TObject);
var
  S, SOld: String;
begin
  {}
  SOld:= '';
  SQLAllToDelete(MaxInt);
  with DM1.QDictDelete do begin
    First;
    while not EOF do begin
      try
        S:= ANSIUpperCase(FieldByName('PHRASE').AsString);
        if ANSICompareText(S, SOld) = 0 then begin
          Delete;
        end else begin
          Edit;
          FieldByName('PHRASE').AsString:= S;
          SOld:= S;
        end;
      except
      end;
      Next;
    end;
    Active:= False;
  end;
  DM1.QDict.Refresh;
end;

procedure TFormDict.BLowerizeClick(Sender: TObject);
var
  S, SOld: String;
begin
  {}
  SOld:= '';
  SQLAllToDelete(MaxInt);
  with DM1.QDictDelete do begin
    First;
    while not EOF do begin
      try
        S:= ANSILowerCase(FieldByName('PHRASE').AsString);
        if ANSICompareText(S, SOld) = 0 then begin
          Delete;
        end else begin
          Edit;
          FieldByName('PHRASE').AsString:= S;
          SOld:= S;
        end;
      except
      end;
      Next;
    end;
    Active:= False;
  end;
  DM1.QDict.Refresh;
end;

procedure TFormDict.DisplayHint(Sender: TObject);
begin
  StatusBar1.Panels[StatusBar1.Panels.Count-1].Text:= Application.Hint;
end;

procedure TFormDict.TBSaveClick(Sender: TObject);
begin
  ExportT.StoreText;
end;

procedure TFormDict.TBImpDBClick(Sender: TObject);
begin
  ImportF.ImportDB;
end;

procedure TFormDict.TBImpTextClick(Sender: TObject);
begin
  ImportT.ImportText;
end;


end.
