unit Stat;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, ComCtrls;

type
  TFormStat = class(TForm)
    OKBtn: TButton;
    Image1: TImage;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormPaint(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure DrawGraph;
  end;

var
  FormStat: TFormStat;

implementation

{$R *.DFM}
uses
  DM;

procedure TFormStat.DrawGraph;
var
  x, y, z, recs, max: Integer;
  scalex, scaley: Real;
begin
  scalex:= exp(TrackBar1.Position - TrackBar1.Max div 2);
  scaley:= exp(- TrackBar2.Position + TrackBar2.Max div 2);
  with DM1.QDict do begin
    DisableControls;
    First;
    z:= Image1.Canvas.ClipRect.Bottom;
    //       
    max:= Trunc(Image1.Canvas.ClipRect.Right / scalex);
    recs:= RecordCount;
    if recs < max
    then max:= recs;
    //  
    y:= FieldByName('COUNTS').AsInteger;
    Image1.Canvas.MoveTO(Trunc(scalex), z-Trunc(y*scaley));
    Next;
    //  
    for x:= 2 to max do begin
      y:= FieldByName('COUNTS').AsInteger;
      Image1.Canvas.LineTO(Trunc(x*scalex), z-Trunc(y*scaley));
      Next;
    end;
    EnableControls;
  end;
end;

procedure TFormStat.FormPaint(Sender: TObject);
begin
  // Image1.Canvas.Brush.
  Image1.Canvas.FillRect(Image1.Canvas.ClipRect);
  DrawGraph;
end;

procedure TFormStat.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  i: Integer;
  scalex, scaley: Real;
begin
  scalex:= exp(TrackBar1.Position - TrackBar1.Max div 2);
  scaley:= exp(- TrackBar2.Position + TrackBar2.Max div 2);
  Label2.Caption:= ' ';
  Label1.Caption:= 'No '+ IntToStr(Trunc(x/scalex));
  with Image1.Canvas do begin
    for i:= ClipRect.Top to ClipRect.Bottom do begin
      if Pixels[x, i] = clBlack then begin
        Label2.Caption:= ' : '+IntToStr(
          Trunc((Image1.Canvas.ClipRect.Bottom - y)/ Scaley)
          ) + ' ()';
        Break;
      end;
    end;
  end;
end;


end.
