unit TblFld;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls;

type
  TFormTblFld = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    LBTables: TListBox;
    LBFields: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure LBTablesClick(Sender: TObject);
    procedure LBFieldsClick(Sender: TObject);
  private
    { Private declarations }
    NewTableFieldList: TStringList;
    procedure SynchronizeTable(ToForm: Boolean);
    procedure SynchronizeField(const TableName: String; ToForm: Boolean);
  public
    { Public declarations }
  end;

var
  FormTblFld: TFormTblFld;

procedure ShowTableFld;

implementation

{$R *.DFM}
uses
  util1, Db, DM, Pdict;

procedure ShowTableFld;
begin
  FormTblFld:= TFormTblFld.Create(Application);
  if FormTblFld.ShowModal = mrOK then begin

  end;
  FormTblFld.Free;
  FormTblFld:= Nil;
end;

procedure TFormTblFld.SynchronizeTable(ToForm: Boolean);
var
  t, ind: Integer;
  tn: String;
begin
  if toForm then begin
    //  
    for t:= 1 to LBTables.Items.Count do begin
      tn:= LBTables.Items.Strings[t-1];
      LBTables.Selected[t-1]:= FormDict.TableFieldList.Values[tn] <> '';
    end;
  end else begin
    //      
    for t:= 1 to LBTables.Items.Count do begin
      tn:= LBTables.Items.Strings[t-1];
      ind:= FormDict.TableFieldList.IndexOfName(tn);
      if LBTables.Selected[t-1] then begin
        // 
        if ind < 0
        then FormDict.TableFieldList.Add(tn+'=');
      end else begin
        // 
        if ind >=0
        then FormDict.TableFieldList.Delete(ind);
      end;
    end;
  end
end;

procedure TFormTblFld.SynchronizeField(const TableName: String; ToForm: Boolean);
var
  f, ind: Integer;
  fn: String;
begin
  if toForm then begin
    //  
    for f:= 1 to LBFields.Items.Count do begin
      fn:= LBFields.Items.Strings[f-1];
      LBFields.Selected[f-1]:=
        util1.OrderInSeparatedList(fn, FormDict.TableFieldList.Values[TableName],',') > 0;
    end;
  end else begin
    //        
    FormDict.TableFieldList.Values[TableName]:= '';
    for f:= 1 to LBFields.Items.Count do begin
      fn:= LBFields.Items.Strings[f-1];
      if LBFields.Selected[f-1] then begin
        FormDict.TableFieldList.Values[TableName]:=
          FormDict.TableFieldList.Values[TableName] + fn +',';
      end;
    end;
  end;
end;

function AnySelected(LB: TCustomListBox): Boolean;
var
  i: Integer;
begin
  for i:= 1 to LB.Items.Count do begin
    if LB.Selected[i-1] then begin
      Result:= True;
      Exit;
    end;
  end;
  Result:= False;
end;

procedure TFormTblFld.LBTablesClick(Sender: TObject);
var
  t, f: Integer;
  tn: String;
begin
  {}
  t:= LBTables.ItemIndex;
  if t >=0 then begin
    tn:= LBTables.Items[t];
    DM1.Table2.TableName:= tn;

    LBFields.Clear;
    DM1.Table2.Open;
    for f:= 1 to DM1.Table2.FieldCount do begin
      LBFields.Items.Add(DM1.Table2.Fields[f-1].FieldName);
    end;
    DM1.Table2.Close;
    SynchronizeField(tn, true);
  end;
end;

procedure TFormTblFld.LBFieldsClick(Sender: TObject);
var
  t: Integer;
  tn: String;
begin
  t:= LBTables.ItemIndex;
  if t >=0 then begin
    tn:= LBTables.Items[t];
    SynchronizeField(tn, False);
    LbTables.Selected[t]:= AnySelected(LBFields);
  end;
end;

procedure TFormTblFld.FormCreate(Sender: TObject);
begin
  //  
  DM1.Database1.Session.GetTableNames(
    DM1.Database1.DatabaseName, '', False,  False, LBTables.Items);
  //  
  LBTablesClick(Self);
  //     
  SynchronizeTable(True);
end;

end.
