unit dm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Db, DBTables, ExtDlgs;

type
  TDM1 = class(TDataModule)
    Database1: TDatabase;
    QDict: TQuery;
    DSQDict: TDataSource;
    QDictDelete: TQuery;
    OpenDialog1: TOpenDialog;
    Table1: TTable;
    SaveDialog1: TSaveDialog;
    ImageList1: TImageList;
    Table2: TTable;
    PopupMenu1: TPopupMenu;
    popSortAlphabet: TMenuItem;
    popSortFreq: TMenuItem;
    MainMenu1: TMainMenu;
    MFile: TMenuItem;
    MImportText: TMenuItem;
    MImportTable: TMenuItem;
    MDel2: TMenuItem;
    MFileSave: TMenuItem;
    MDel1: TMenuItem;
    MFileExit: TMenuItem;
    MWindow: TMenuItem;
    MWindowStat: TMenuItem;
    MOptions: TMenuItem;
    MOptionsCommon: TMenuItem;
    MOptionsOrder: TMenuItem;
    MSortByAlphabet: TMenuItem;
    MSortByFreq: TMenuItem;
    MHelp: TMenuItem;
    MHelpIndex: TMenuItem;
    MDel5: TMenuItem;
    MHelpAbout: TMenuItem;
    MDel4: TMenuItem;
    procedure DataModuleFormMOptionsCommonClick(Sender: TObject);
    procedure DataModuleFormMFileExitClick(Sender: TObject);
    procedure DataModuleFormMImportTextClick(Sender: TObject);
    procedure DataModuleFormMSortByAlphabetClick(Sender: TObject);
    procedure DataModuleFormMSortByFreqClick(Sender: TObject);
    procedure DataModuleFormMFileSaveClick(Sender: TObject);
    procedure DataModuleFormMImportTableClick(Sender: TObject);
    procedure MViewStatClick(Sender: TObject);
    procedure DataModuleFormMOptionsStoreClick(Sender: TObject);
    procedure MViewExportedTextClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DM1: TDM1;

implementation

{$R *.DFM}
uses
  util1,
  OSetting, PDict, About, ImportT, ExportT, Stat, TblFld, ImportF;

procedure TDM1.DataModuleFormMOptionsCommonClick(Sender: TObject);
begin
  FormSettings:= TFormSettings.Create(Application);
  FormSettings.Font.Name:= FormDict.Font.Name;
  with FormDict do begin
    FormSettings.Set2Alias(CurAlias, CurDBFolder, ByAlias, DataBase1);
  end;
  if FormSettings.ShowModal = mrOK then begin
    if FormSettings.FontChanged then with FormDict do begin
      SetVisualFont(FormSettings.Font);
    end;
    if FormSettings.DBLocationChanged then with FormDict do begin
      ByAlias:= FormSettings.RGByAlias.Checked;
      CurAlias:= FormSettings.CBAlias.Text;
      CurDBFolder:= FormSettings.EDBFolder.Text;
      if ByAlias
      then AssignAlias(CurAlias)
      else AssignDataFolder(CurDBFolder);
    end;
  end;
  FormSettings.Free;
end;

procedure TDM1.DataModuleFormMFileExitClick(Sender: TObject);
begin
  FormDict.Close;
end;

procedure TDM1.DataModuleFormMImportTextClick(Sender: TObject);
begin
  ImportT.ImportText;
end;

procedure TDM1.DataModuleFormMSortByAlphabetClick(Sender: TObject);
begin
  (Sender as TMenuItem).Checked:= True;
  QDict.Close;
  QDict.SQL.Text:= 'select * from dict where (Phrase >= :LETTER1)'+
    ' and (Phrase <= :LETTER2) and (Counts >=:COUNT1);';
  QDict.Open;
end;

procedure TDM1.DataModuleFormMSortByFreqClick(Sender: TObject);
begin
  (Sender as TMenuItem).Checked:= True;
  QDict.Close;
  QDict.SQL.Text:= 'select * from dict where (Phrase >= :LETTER1)'+
    ' and (Phrase <= :LETTER2) and (Counts >=:COUNT1) ORDER BY COUNTS;';
  QDict.Open;
end;

procedure TDM1.DataModuleFormMFileSaveClick(Sender: TObject);
begin
  ExportT.StoreText;
end;

procedure TDM1.DataModuleFormMImportTableClick(Sender: TObject);
begin
  {}
  ImportF.ImportDB;
end;

procedure TDM1.MViewStatClick(Sender: TObject);
begin
  {}
  // FormStat:= TFormStat.Create(Application);
  FormStat.Show;
end;

procedure TDM1.DataModuleFormMOptionsStoreClick(Sender: TObject);
begin
  {}
  FormDict.StoreIniChanges;
end;

procedure TDM1.MViewExportedTextClick(Sender: TObject);
begin
  EExecuteFile(FormDict.ExportDictName);
end;

end.
