unit CDatas;
(*##*)
(*******************************************************************
*                                                                 *
*   C  D  A  T  A  S     Client, EPAGER's unit.                    *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   unvisible components for Client                               *
*   Conditional defines: ---                                       *
*                                                                 *
*   Last Revision: Mar 19 1998                                     *
*   Last fix     : Mar 19 1998                                    *
*   Lines        : 218                                             *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBTables, Db, Menus,
  util1;

type
  TDataModule1 = class(TDataModule)
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ImageList1: TImageList;
    PopupCALL: TPopupMenu;
    PopMemoSQL: TPopupMenu;
    popMSQLSave: TMenuItem;
    popCALL: TMenuItem;
    popList: TPopupMenu;

    Database1: TDatabase;
    TableClient: TTable;
    TableVisits: TTable;
    TableCalls: TTable;
    TableCAPs: TTable;
    TableServDesc: TTable;
    TablePagers: TTable;
    TableService: TTable;
    TablePayee: TTable;
    TableGroups: TTable;
    TableEmployee: TTable;
    TableCli2Emp: TTable;
    Query1: TQuery;
    QueryServ: TQuery;

    DSClient: TDataSource;
    DSVisits: TDataSource;
    DSQuery: TDataSource;
    DSCalls: TDataSource;
    DSCAPs: TDataSource;
    DSServDesc: TDataSource;
    DSServ: TDataSource;
    DSPagers: TDataSource;
    DSPayee: TDataSource;
    DSGroups: TDataSource;
    DSEmployee: TDataSource;
    DSCli2Emp: TDataSource;
    procedure popCALLClick(Sender: TObject);
    procedure TablePagersBeforeInsert(DataSet: TDataSet);
    procedure TableClientAfterScroll(DataSet: TDataSet);
    procedure popMSQLSaveClick(Sender: TObject);
    procedure DataModuleFormpopStoreListClick(Sender: TObject);
    procedure DataModule1Create(Sender: TObject);
    procedure TableClientBeforeDelete(DataSet: TDataSet);
    procedure TableClientAfterInsert(DataSet: TDataSet);
    procedure TableEmployeeAfterScroll(DataSet: TDataSet);
    procedure TableCli2EmpAfterInsert(DataSet: TDataSet);
    procedure TableVisitsAfterInsert(DataSet: TDataSet);
    procedure TableVisitsAfterEdit(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
    function MkNewAbonentNumber(st: Integer): Integer;
  end;

const
   ALLTABLES  = 11;
   ALLQUERIES = 2;
   SQLTrigger: Boolean = False;
var
  DataModule1: TDataModule1;
  Tables: array[0..ALLTABLES-1] of TTable;
  Queries: array[0..ALLQUERIES-1] of TQuery;

  function GetFIOSpec: String;

implementation

{$R *.DFM}

uses
  Client, OSetting, Visit_2, EmplForm;

function GetFIOSpec: String;
begin
  with DataModule1.TableEmployee do begin
    GetFIOSpec:=
      FieldByName('SPECIALITY').AsString + #32 +
      FieldByName('FAM').AsString + #32 +
      FieldByName('IM').AsString + #32 +
      FieldByName('OT').AsString;
  end;
end;

procedure TDataModule1.popCALLClick(Sender: TObject);
begin
  {}
  ShowMessage('   ');
  ShowMessage('    ');
end;

procedure TDataModule1.TableClientAfterScroll(DataSet: TDataSet);
begin
  FormClient.ViewNavigateAbonent;
end;

procedure TDataModule1.popMSQLSaveClick(Sender: TObject);
begin
  { save changes }
  with FormClient do begin
    MSQL.Lines.SaveToFile(ConCatPath(SQLFolder, FLBoxSQL.Items[CBSQLs.ItemIndex]));
  end;
end;

procedure TDataModule1.DataModuleFormpopStoreListClick(Sender: TObject);
var
  F: Text;
  i: Integer;
begin
  {}
  with SaveDialog1 do begin
    DefaultExt:= 'TXT';
    Filter:= ' (*.TXT)|*.TXT|  (*.*)|*.*';
    // InitialDir:= '';
    if Execute then begin
      AssignFile(F, FileName);
      Rewrite(F);
      DataModule1.Query1.DisableControls;
      DataModule1.Query1.First;
      //  
      for i:= 0 to DataModule1.Query1. FieldCount - 1 do begin
        Write(f, DataModule1.Query1.Fields[i].DisplayLabel,#9);
      end;
      Writeln(f);
      while not DataModule1.Query1.EOF do begin
        for i:= 0 to DataModule1.Query1. FieldCount - 1 do begin
          Write(f, DataModule1.Query1.Fields[i].AsString, #9);
        end;
        Writeln(f);
        DataModule1.Query1.Next;
      end;
      DataModule1.Query1.EnableControls;
      CloseFile(F);
    end;
  end;
end;

procedure TDataModule1.DataModule1Create(Sender: TObject);
begin
  Tables[0]:= TableVisits;
  Tables[1]:= TableClient;
  Tables[2]:= TableCalls;
  Tables[3]:= TablePayee;
  Tables[4]:= TableGroups;
  Tables[5]:= TableCAPs;
  Tables[6]:= TableService;
  Tables[7]:= TablePagers;
  Tables[8]:= TableServDesc;
  Tables[9]:= TableCli2Emp;
  Tables[10]:= TableEmployee;

  Queries[0]:= Query1;
  Queries[1]:= QueryServ;
end;

function TDataModule1.MkNewAbonentNumber(st: Integer): Integer;
var
  SNewNo: String;
  no: Integer;
  rec_num: Integer;
  OldState: TDataSetState;
begin
  MkNewAbonentNumber:= st;
  with TableClient do begin
    OldState:= DSClient.State;
    Rec_Num:= TableClient.RecNo;
    IndexName:= '';
    for no:= st to MaxInt do begin
      SNewNo:= IntToStr(no);
      if not FindKey([FormClient.CurHCode, SNewNo]) then begin
        MkNewAbonentNumber:= no;
        Break;
      end;
    end;
    TableClient.MoveBy(Rec_Num - TableClient.RecNo);
    if OldState in [dsEdit, dsInsert]
    then Edit;
  end;
end;

procedure TDataModule1.TablePagersBeforeInsert(DataSet: TDataSet);
begin
  if SQLTrigger
  then Exit;
  //   
  DataSet.FieldByName('CAP').AsString:= TableClient.FieldByName('CAP').AsString;
end;

procedure TDataModule1.TableClientBeforeDelete(DataSet: TDataSet);
begin
  if SQLTrigger
  then Exit;
  // Delete all records from here
  with TableGroups do begin
    First;
    while not EOF
    do Delete;
  end;
  with TablePayee do begin
    First;
    while not EOF
    do Delete;
  end;
  with TableCalls do begin
    First;
    while not EOF
    do Delete;
  end;
  with TableVisits do begin
    First;
    while not EOF
    do Delete;
  end;
  with TableService do begin
    First;
    while not EOF
    do Delete;
  end;
end;

procedure TDataModule1.TableClientAfterInsert(DataSet: TDataSet);
begin
  if SQLTrigger
  then Exit;
  with Dataset do begin
    Edit;
    { fill Abonent }
    FieldByName('HCODE').AsString:= TableClient.FieldByName('HCODE').AsString;
    FieldByName('ABONENT').AsString:= TableClient.FieldByName('ABONENT').AsString;
    { fill creator }
    FieldByName('UPDATER').AsInteger:= FormClient.CurUPDATER;
    FieldByName('UPDATED').AsDateTime:= Now;
    FieldByName('UPDTIME').AsDateTime:= Now;
    // FormClient.ViewNavigateAbonent;
    // Post;
  end;
end;

procedure TDataModule1.TableVisitsAfterInsert(DataSet: TDataSet);
begin
  if SQLTrigger
  then Exit;
  with Dataset do begin
    Edit;
    FieldByName('HCODE').AsString:= FormClient.CurHCODE;
    if FieldByName('ABONENT').IsNull then begin
      FieldByName('ABONENT').AsString:= TableClient.FieldByname('ABONENT').AsString;
    end;
    FieldByName('UPDATED').AsDateTime:= Trunc(Now);
    FieldByName('UPDTIME').AsDateTime:= Frac(Now);
    FieldByName('UPDATER').AsString:= IntToStr(FormClient.CurUPDATER);
    // FormClient.ViewNavigateAbonent;
    // Post;
  end;
end;

procedure TDataModule1.TableVisitsAfterEdit(DataSet: TDataSet);
begin
  if SQLTrigger
  then Exit;
  with Dataset do begin
    Edit;
    FieldByName('UPDATED').AsDateTime:= Now;
    FieldByName('UPDTIME').AsDateTime:= Now;
  end;
end;

procedure TDataModule1.TableCli2EmpAfterInsert(DataSet: TDataSet);
begin
  if SQLTrigger
  then Exit;
  with Dataset do begin
    Edit;
    { fill Updater }
    FieldByName('HCODE1').AsString:= TableEmployee.FieldByName('HCODE').AsString;
    FieldByName('TABNO').AsString:= TableEmployee.FieldByName('TABNO').AsString;
    { fill Abonent }
    FieldByName('HCODE').AsString:= TableClient.FieldByName('HCODE').AsString;
    FieldByName('ABONENT').AsString:= TableClient.FieldByName('ABONENT').AsString;
    { fill other fields }
    FieldByName('DEPARTMENT').AsString:= TableEmployee.FieldByName('DEPARTMENT').AsString;
    {
    FieldByName('EDATE').AsDateTime:= Trunc(Now);
    FieldByName('ETIME').AsDateTime:= Now;
    FieldByName('DURATION').AsDateTime:= FormClient.DEFAULT_DURATION;
    }
    // Post;
  end;
end;

procedure TDataModule1.TableEmployeeAfterScroll(DataSet: TDataSet);
begin
  FormEmployee.ViewNavigateEmployee;
end;

end.
