unit EmplForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DBCtrls, StdCtrls, Mask, LZodiac, LNumNam, Grids, DBGrids,
  ComCtrls;

type
  TMinSet = set of 0..59;
  THourSet = set of 0..23;

  TWorkDayArray = array [0..23] of TMinSet;

  TWorkDay = class (TObject)
  private
    FWorkHours: THourSet;
    FWorkDay: TWorkDayArray;
    procedure SetWorkHours(AHours: THourSet);
    function GetBusy1(h, m: Integer): Boolean;
    procedure SetBusy1(h, m: Integer; TurnOn: Boolean);
    function GetBusy(ABegin, AEnd: TDateTime): Boolean;
    procedure SetBusy(ABegin, AEnd: TDateTime; TurnOn: Boolean);
  public
    HoursCount: Integer;
    constructor Create;
    destructor Destroy; override;
    procedure Clear;
    property WorkHours: THourSet read FWorkHours write SetWorkHours;
    property BusyTime[ABegin, AEnd: TDateTime]: Boolean read GetBusy write SetBusy;
    property Busy[h1, m1: Integer]: Boolean read GetBusy1 write SetBusy1;
  end;

type
  TFormEmployee = class(TForm)
    GBSearch: TGroupBox;
    BSearch: TButton;
    PageControl1: TPageControl;
    TSAnkette: TTabSheet;
    ImageList1: TImageList;
    ImPhoto: TImage;
    GBAnkette: TGroupBox;
    LNation: TLabel;
    LBirth: TLabel;
    ZodiacLabel1: TZodiacLabel;
    NumericNameLabel1: TNumericNameLabel;
    DBCBNation: TDBComboBox;
    DBRGSex: TDBRadioGroup;
    EditBirth: TDBEdit;
    GBAddress: TGroupBox;
    LBuilding: TLabel;
    LStreet: TLabel;
    LCity: TLabel;
    LHPhone: TLabel;
    EditHOMEPHONE: TDBEdit;
    EditCITY: TDBEdit;
    EditSTREET: TDBEdit;
    EditBUILDING: TDBEdit;
    GBVac: TGroupBox;
    LVacFrom: TLabel;
    LVacTo: TLabel;
    LRem: TLabel;
    EditVACANCY: TDBEdit;
    EditVACANCY2: TDBEdit;
    EditREM: TDBEdit;
    DBCheckBox1: TDBCheckBox;
    GBPriem: TGroupBox;
    LBlock: TLabel;
    LOtd: TLabel;
    LRoom: TLabel;
    EditOFFICE: TDBEdit;
    DBCBDepartment: TDBComboBox;
    DBCBBlock: TDBComboBox;
    GBSpeciality: TGroupBox;
    LDolz: TLabel;
    LCat: TLabel;
    DBCBDolz: TDBComboBox;
    DBCBSpeciality: TDBComboBox;
    DBCBCateg: TDBComboBox;
    DBCBSovmest: TDBCheckBox;
    GBPhone: TGroupBox;
    LEmail: TLabel;
    LFax: TLabel;
    LPager: TLabel;
    DBCBPhone: TDBComboBox;
    EditPAGER: TDBEdit;
    EditFAX: TDBEdit;
    EditEMAIL: TDBEdit;
    DBEditPHOTO: TDBEdit;
    GBFIO: TGroupBox;
    DBText1: TDBText;
    EditFAM: TDBEdit;
    EditIM: TDBEdit;
    EditOT: TDBEdit;
    EditID: TDBEdit;
    DBNavigator: TDBNavigator;
    TSList: TTabSheet;
    DBGrid1: TDBGrid;
    TSAssignVisit: TTabSheet;
    GBDateTime: TGroupBox;
    DGMinutes: TDrawGrid;
    SGHours: TStringGrid;
    GroupBox1: TGroupBox;
    DBCBAvailable: TDBCheckBox;
    EditHOUR: TDBEdit;
    LHourFrom: TLabel;
    LHourTo: TLabel;
    EditHOUR2: TDBEdit;
    CBAvailableOnly: TCheckBox;
    CBSearch: TComboBox;
    CBSrchWhere: TComboBox;
    CBSrchCondition: TComboBox;
    TSEmployeeVisits: TTabSheet;
    DBGCli2Emp: TDBGrid;
    GroupBox2: TGroupBox;
    DateTimePicker1: TDateTimePicker;
    EPrefHour: TEdit;
    UDPrefHour: TUpDown;
    BShowSheduleTime: TButton;
    EPrefDuration: TEdit;
    UDPrefDuration: TUpDown;
    EProfMin: TEdit;
    UDPrefMin: TUpDown;
    GBAim: TGroupBox;
    CBAim: TComboBox;
    BAssign: TButton;
    CBNaprFrom: TComboBox;
    CBRemark: TComboBox;
    LNaprFrom: TLabel;
    LRemark: TLabel;
    procedure CBSearchClick(Sender: TObject);
    procedure CBSearchKeyPress(Sender: TObject; var Key: Char);
    procedure CalcZodiac(Sender: TObject);
    procedure CBSrchWhereChange(Sender: TObject);
    procedure BSearchClick(Sender: TObject);
    procedure DGMinutesDrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BShowSheduleTimeClick(Sender: TObject);
    procedure BAssignClick(Sender: TObject);
    procedure DateTimePicker1Change(Sender: TObject);
  private
    { Private declarations }
    FStartHour: Integer;
  public
    { Public declarations }
    WorkDay: TWorkDay;
    Planning: TWorkDay;
    procedure ViewNavigateEmployee;
    function FindEmployee(const Employee: String): Boolean;
    procedure InsertNewVisit;
    procedure FillBusyTable;
  end;

var
  FormEmployee: TFormEmployee;

implementation

{$R *.DFM}

uses
  util1, CDatas, client, MoreInfo;

constructor TWorkDay.Create;
begin
  //    FWorkDay: TWorkDayArray;
  inherited Create;
end;

destructor TWorkDay.Destroy;
begin
  inherited Destroy;
end;

procedure TWorkDay.Clear;
var
  i: Integer;
begin
  for i:= 0 to 23 do begin
    FWorkDay[i]:= [];
  end;
end;

procedure TWorkDay.SetWorkHours(AHours: THourSet);
var
  i: Integer;
begin
  FWorkHours:= AHours;
  HoursCount:= 0;
  for i:= 0 to 23 do begin
    if i in FWorkHours then begin
      Inc(HoursCount);
    end;
    FWorkDay[i]:= [];
  end;
end;

function TWorkDay.GetBusy1(h, m: Integer):Boolean;
begin
  GetBusy1:= (h in FWorkHours) and (m in FWorkDay[h]);
end;

procedure TWorkDay.SetBusy1(h, m: Integer; TurnOn: Boolean);
begin
  if h in FWorkHours then begin
    if TurnOn
    then FWorkDay[h]:= FWorkDay[h] + [m]
    else  FWorkDay[h]:= FWorkDay[h] - [m];
  end;
end;

function TWorkDay.GetBusy(ABegin, AEnd: TDateTime):Boolean;
var
  h, h1, h2, m1, m2: Integer;
begin
  h1:= GetHour(ABegin);   m1:= GetMin(ABegin);
  h2:= GetHour(AEnd);   m2:= GetMin(AEnd);
  GetBusy:= True;
  if h2 = h1 then begin
    if h1 in FWorkHours then begin
      if (FWorkDay[h1] * [m1..m2]) <> []
      then Exit;
    end;
  end else begin
    if h1 in FWorkHours then begin
      if (FWorkDay[h1] * [m1..59]) <> []
      then Exit;
    end;
    if h2 in FWorkHours then begin
      if (FWorkDay[h2] * [0..m2]) <> []
      then Exit;
    end;
  end;
  for h:= h1 + 1 to h2 - 1 do begin
    if h in FWorkHours then begin
      if FWorkDay[h] <> []
      then Exit;
    end;
  end;
  GetBusy:= False;
end;

procedure TWorkDay.SetBusy(ABegin, AEnd: TDateTime; TurnOn: Boolean);
var
  h, h1, h2, m1, m2: Integer;
begin
  if ABegin > AEnd
  then Exit;
  h1:= GetHour(ABegin);   h2:= GetHour(AEnd);
  m1:= GetMin(ABegin);   m2:= GetMin(AEnd);
  if h2 = h1 then begin
    if h1 in FWorkHours then begin
      if TurnOn
      then FWorkDay[h1]:= FWorkDay[h1] + [m1..m2]
      else FWorkDay[h1]:= FWorkDay[h1] - [m1..m2];
    end;
  end else begin
    if h1 in FWorkHours then begin
      if TurnOn
      then FWorkDay[h1]:= FWorkDay[h1] + [m1..59]
      else FWorkDay[h1]:= FWorkDay[h1] - [m1..59];
    end;
    if h2 in FWorkHours then begin
      if TurnOn
      then FWorkDay[h2]:= FWorkDay[h2] + [0..m2]
      else FWorkDay[h2]:= FWorkDay[h2] - [0..m2];
    end;
  end;

  for h:= h1 + 1 to h2 - 1 do begin
    if h in FWorkHours then begin
      if TurnOn
      then FWorkDay[h]:= [0..59]
      else FWorkDay[h]:= [];
    end;
  end;
end;

procedure TFormEmployee.ViewNavigateEmployee;
var
  Em: String;
begin
  with DataModule1.TableEmployee do begin
    Em:= FieldByName('TABNO').AsString;
    CBSearch.Text:= Em + #32 +
      FieldByName('FAM').AsString + #32 +
      FieldByName('IM').AsString+ #32 + FieldByName('OT').AsString;
    if MoreInfo.FormMoreInfoOnScreen then begin
      //       (  )
      FormMoreInfo.GotoAbonent('E' + Em);
    end;
    //   
    FillBusyTable;
  end;
end;

function TFormEmployee.FindEmployee(const Employee: String): Boolean;
var
  A, S, F, I, O: String;
  TurnFilterOn: Boolean;
begin
  with DataModule1.TableEmployee do begin
    Filtered:= False;
    TurnFilterOn:= False;
    Filter:= '';
    if CBAvailableOnly.Checked then begin
      S:= 'AVAILABLE = ''x''';
      TurnFilterOn:= True;
    end;
    if (CBSrchWhere.ItemIndex > 0) and (CBSrchCondition.Text <> '') then begin
      TurnFilterOn:= True;
      { 1- 2- 3- 4-}
      case CBSrchWhere.ItemIndex of
      1: A:= 'BLOCK';
      2: A:= 'DEPARTMENT';
      3: A:= 'SPECIALITY';
      4: A:= 'DOLZ';
      end;
      if S <> ''
      then S:= S + ' and ';
      Filter:= S + A + '=''' + CBSrchCondition.Text + '''';
    end;
    Filtered:= TurnFilterOn;

    A:= GetToken(1, #32, Employee);
    if isDecimal(A) then begin
      IndexName:= '';
      FindNearest([FormClient.CurHCODE, A]);
    end else begin
      F:= GetToken(1, #32, Employee);
      I:= GetToken(2, #32, Employee);
      O:= GetToken(3, #32, Employee);
      IndexName:= 'IEFIO';
      FindNearest([F, I, O]);
    end;
    ViewNavigateEmployee;
  end;
  CalcZodiac(Self);
  FindEmployee:= True;
end;

procedure TFormEmployee.InsertNewVisit;
var
  st, durate: TDateTime;
begin
  with DataModule1.TableCli2Emp do begin
    Insert;
    FieldByName('EDATE').AsDateTime:= Trunc(DateTimePicker1.Date);
    st:= UDPrefHour.Position /24 + UDPrefMin.Position /(24*60);
    durate:= UDPrefDuration.Position /(24*60);
    FieldByName('ETIME').AsDateTime:= st;
    FieldByName('DURATION').AsDateTime:= durate;
    Post;
  end;
  with DataModule1.TableVisits do begin
    Insert;
    FieldByName('EMPL').AsString:= GetFIOSpec;
    FieldByName('NAPRFROM').AsString:= CBNaprFrom.Text;
    FieldByName('REM').AsString:= CBRemark.Text;
    FieldByName('SUBJ').AsString:=
      CBAim.Text + '[: '+ DateTimeToStr(Trunc(DateTimePicker1.Date) + Frac(st)) +
        ' ('+ IntToStr(UDPrefDuration.Position) + ''')]';
    Post;
  end;
end;

procedure TFormEmployee.FillBusyTable;
var
  r, h, h1, h2, hours: Integer;
  dt: TDateTime;
begin
  // h1:= GetHour(DataModule1.TableEmployee.FieldByName('HOUR1').AsDateTime);
  // h2:= GetHour(DataModule1.TableEmployee.FieldByName('HOUR2').AsDateTime);
  DataModule1.TableCli2Emp.DisableControls;
  h1:= DataModule1.TableEmployee.FieldByName('HOUR1').AsInteger;
  FStartHour:= h1;
  h2:= DataModule1.TableEmployee.FieldByName('HOUR2').AsInteger;
  WorkDay.WorkHours:= [h1..h2];
  Planning.WorkHours:= [h1..h2];
  hours:= h2 - h1 + 1;
  if hours <= 0
  then hours:= 1;
  if hours > 10
  then hours:= 10;
  SGHours.RowCount:= hours;
  DGMinutes.RowCount:= hours;
  h:= h1;
  for r:= 0 to hours - 1 do begin
    SGHours.Cells[0, r]:= IntToStr(h);
    Inc(h);
  end;
  with DataModule1.TableCli2Emp do begin
    // IndexName:= 'ICEMPL';
    // First;
    FindKey([DataModule1.TableClient.FieldByName('HCODE').AsString,
      DataModule1.TableClient.FieldByName('ABONENT').AsString, DateTimePicker1.Date]);
    while not EOF do begin
      if Trunc(FieldByName('EDATE').AsDateTime) = Trunc(DateTimePicker1.Date) then begin
        dt:= FieldByName('ETIME').AsDateTime;
        WorkDay.BusyTime[dt, dt + Abs(Frac(FieldByName('DURATION').AsDateTime))]:= True;
      end else begin
        Break;
      end;
      Next;
    end;
  end;
  DGMinutes.Repaint;
  DataModule1.TableCli2Emp.EnableControls;
end;

{ event handlers -------------------------------}

procedure TFormEmployee.FormCreate(Sender: TObject);
begin
  WorkDay:= TWorkDay.Create;
  Planning:= TWorkDay.Create;
  DateTimePicker1.Date:= Now;
  DBGCli2Emp.Columns[DBGCli2Emp.Columns.Count-1].PickList.Assign(CBAim.Items);
end;

procedure TFormEmployee.FormDestroy(Sender: TObject);
begin
  Planning.Free;
  WorkDay.Free;
end;

procedure TFormEmployee.CBSearchClick(Sender: TObject);
begin
  {  }
  (Sender as TCombobox).Perform(CB_ShowDropDown, Ord(True), 0);
  // CalcZodiac(Self);
end;

procedure TFormEmployee.CBSearchKeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
  #13: begin
         if FindEmployee(CBSearch.Text) then with (Sender as TCombobox) do begin
           if Items.IndexOf(Text) < 0 then begin
             if Items.Count >= DropDownCount
             then Items.Delete(Items.Count-1);
             Items.Add(Text);
           end;
         end;
         Key:= #0;
       end;
  end;
end;

procedure TFormEmployee.CalcZodiac(Sender: TObject);
var
  S: String;
begin
  with DataModule1.TableEmployee do begin
    NumericNameLabel1.FullName:= EditFam.Text + #32 + EditIm.Text + #32 + EditOt.Text;
    ZodiacLabel1.CaptionDate:= FieldByName('BIRTH').AsDateTime;
    NumericNameLabel1.CaptionDate:= ZodiacLabel1.CaptionDate;
    { update ImPhoto }
    S:= ConcatPath(FormClient.PhotoFolder, DBEditPhoto.Text);
    if FileExists(S) then begin
      try
        ImPhoto.Picture.LoadFromFile(S);
      except
      end;
    end else begin
      ImageList1.GetBitmap(NumericNameLabel1.NameNumber, ImPhoto.Picture.Bitmap);
      ImPhoto.Repaint;
    end;
  end;
end;

procedure TFormEmployee.CBSrchWhereChange(Sender: TObject);
begin
{  0-   1- 2- 3- 4-}
  CBSrchCondition.Enabled:= True;
  case CBSrchWhere.ItemIndex of
  1: CBSrchCondition.Items.Assign(DBCBBlock.Items);
  2: CBSrchCondition.Items.Assign(DBCBDepartment.Items);
  3: CBSrchCondition.Items.Assign(DBCBSpeciality.Items);
  4: CBSrchCondition.Items.Assign(DBCBDolz.Items);
  else begin
    CBSrchCondition.Items.Clear;
    CBSrchCondition.Enabled:= False;
  end;
  end;
end;

procedure TFormEmployee.BSearchClick(Sender: TObject);
begin
  FindEmployee(CBSearch.Text);
end;

procedure TFormEmployee.DGMinutesDrawCell(Sender: TObject; Col,
  Row: Integer; Rect: TRect; State: TGridDrawState);
var
  Color: TColor;
begin
  if WorkDay.Busy[FStartHour+row, col]
  then Color:= clAqua
  else Color:= clWhite;
  with DGMinutes.Canvas do begin
    Brush.Color:= Color;
    FillRect(Rect);
    if Planning.Busy[FStartHour+row, col] then begin
      DGMinutes.Canvas.Moveto(Rect.Left, Rect.Top);
      DGMinutes.Canvas.Lineto(Rect.Right, Rect.Bottom);
      DGMinutes.Canvas.Moveto(Rect.Left, Rect.Bottom);
      DGMinutes.Canvas.Lineto(Rect.Right, Rect.Top);
    end;
  end;
end;

procedure TFormEmployee.BShowSheduleTimeClick(Sender: TObject);
var
  st, fin: TDateTime;
begin
  {       }
  st:= UDPrefHour.Position /24 + UDPrefMin.Position /(24*60);
  fin:= st + UDPrefDuration.Position /(24*60);
  Planning.Clear;
  Planning.BusyTime[st, fin]:= True;
  DGMinutes.Repaint;
end;

procedure TFormEmployee.BAssignClick(Sender: TObject);
begin
  InsertNewVisit;
  FillBusyTable;
end;

procedure TFormEmployee.DateTimePicker1Change(Sender: TObject);
begin
  FillBusyTable;
end;

end.
