unit MoreInfo;
(*##*)
(*******************************************************************
*                                                                 *
*   M  O  R  E  I  N  F  O     Client, EPAGER's unit.              *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   dialog (or window?) showing more information about client     *
*   Conditional defines: ---                                       *
*                                                                 *
*   Last Revision: Mar 19 1998                                     *
*   Last fix     : Mar 19 1998                                    *
*   Lines        : 218                                             *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, Grids, ExtCtrls, MPlayer;

type
  TFormMoreInfo = class(TForm)
    MediaPlayer1: TMediaPlayer;
    ListView1: TListView;
    PopupMenu1: TPopupMenu;
    popAdd: TMenuItem;
    popStore: TMenuItem;
    popLoad: TMenuItem;
    popD1: TMenuItem;
    SGProperties: TStringGrid;
    popDelete: TMenuItem;
    ImageList1: TImageList;
    popD2: TMenuItem;
    popShowProperties: TMenuItem;
    Splitter1: TSplitter;
    popEdit: TMenuItem;
    popEditVoice: TMenuItem;
    popD3: TMenuItem;
    popAddURL: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure popAddClick(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure popLoadClick(Sender: TObject);
    procedure popStoreClick(Sender: TObject);
    procedure SGPropertiesExit(Sender: TObject);
    procedure popDeleteClick(Sender: TObject);
    procedure SGPropertiesDblClick(Sender: TObject);
    procedure popShowPropertiesClick(Sender: TObject);
    procedure popEditClick(Sender: TObject);
    procedure popShowDocumentClick(Sender: TObject);
    procedure ListViewInsertDelete(Sender: TObject; Item: TListItem);
    procedure ListView1Edited(Sender: TObject; Item: TListItem;
      var S: String);
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure popAddURLClick(Sender: TObject);
  private
    { Private declarations }
    FModified: Boolean;
    function ChooseDocument(var AFN: String): Boolean;
    function ChooseURL(var AFN: String): Boolean;
  public
    { Public declarations }
    function  LoadList(const AFN: String): Boolean;
    procedure StoreList(const AFN: String);
    procedure ClearList;
    procedure UpdateProperties(AStore: Boolean);
    function GotoAbonent(const Abonent: string): Boolean;
  end;

var
  FormMoreInfo: TFormMoreInfo;

const
  //      
  FormMoreInfoOnScreen: Boolean = False;
  //  formClient.loadini    !
  DocumentFolder: String[65] = '';
  //  DataModule1.TableClientAfterScroll    
  //   gotoAbonent
  DocumentListFN: String[65] = '';

implementation

uses
  util1, pcommon, CDatas;

{$R *.DFM}

procedure TFormMoreInfo.FormCreate(Sender: TObject);
begin
  FModified:= False;
  FormMoreInfoOnScreen:= True;
  GotoAbonent(DataModule1.TableClient.FieldByName('ABONENT').AsString);
  SGProperties.Cells[0, 0]:= '';
  SGProperties.Cells[1, 0]:= '';
  SGProperties.Cells[2, 0]:= '';
  // ListView1.FullExpand;
end;

procedure TFormMoreInfo.FormDestroy(Sender: TObject);
begin
  MoreInfo.FormMoreInfoOnScreen:= False;
end;

procedure TFormMoreInfo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Free;
end;

function TFormMoreInfo.ChooseDocument(var AFN: String): Boolean;
begin
  with DataModule1.OpenDialog1 do begin
    InitialDir:= DocumentFolder;
    FileName:= ExtractFileName(AFN);
    DefaultExt:= 'TXT';
    Filter:= '(*.TXT;*.DOC)|*.TXT;*.DOC|(*.JPG;*.GIF;*.BMP)|*.JPG;*.GIF;*.BMP| (*.WAV;*.MIDI)|*.WAV;*.MID;*.MID|  (*.*)|*.*';
    FilterIndex:= 1;
    Title:= '  ';
    if Execute then begin
      AFN:= FileName;
      Result:= True;
    end else begin
      Result:= False;
    end;
  end;
end;

function TFormMoreInfo.ChooseURL(var AFN: String): Boolean;
begin
  AFN:= 'xxx@yyy.ru';
  ShowMessage('   url  ,  Ctrl+P');
  Result:= True;
end;

{   := , ,  }
procedure TFormMoreInfo.popAddClick(Sender: TObject);
var
  L: TListItem;
  S: String;
begin
  S:= '';
  if ChooseDocument(S) then begin
    L:= ListView1.Items.Add;
    L.Caption:= '  '+DateToStr(Date);
    L.SubItems.Add('');
    L.SubItems.Add(S);
    L.SubItems.Add(DateToStr(Date));
  end;
end;

procedure TFormMoreInfo.ListView1Click(Sender: TObject);
begin
  { := , ,  }
  with ListView1 do begin
    if (Selected <> Nil) and ( Selected.SubItems.Count >= 3) and
      (Selected.SubItems[1]<> '')
    then begin
      UpdateProperties(False);
    end;
  end;
end;

{   }
function TFormMoreInfo. LoadList(const AFn: String): Boolean;
var
  T: TextFile;
  S: String;
  i, j: Integer;
  L: TListItem;
begin
  Result:= False;
  ClearList;
  if FileExists (AFN) then begin
    Caption:= ' : ' + ExtractFileName(DocumentListFN);
    AssignFile(T, AFN);
    Reset(T);
    i:= 0;
    while not EOF(T) do begin
      Readln(T, S);
      L:= ListView1.Items.Add;
      L.Caption:= GetToken(1, '<P>', S);
      for j:= 0 to 2 do begin
        L.SubItems.Add(GetToken(j + 2, '<P>', S));
      end;
      if L.SubItems[1] = '' then begin
        Inc(i);
        if i > MAXEMPTYVOICES then begin
          ShowMessage('      ');
          Break;
        end;
      end;
    end;
    CloseFile(T);
    Result:= True;
  end else begin
    Caption:= ' ';
  end;
  FModified:= False;
end;

procedure TFormMoreInfo.popLoadClick(Sender: TObject);
var
  S: String;
  L: TListItem;
begin
  {   }
  with DataModule1.OpenDialog1 do begin
    // InitialDir:= VoiceFolder;
    DefaultExt:= 'TXT';
    FileName:= DocumentListFN;
    InitialDir:= DocumentFolder;
    Filter:= '(*.TXT)|*.TXT|  (*.*)|*.*';
    FilterIndex:= 1;
    Title:= ' ';
    if Execute then begin
      if LoadList(FileName) then begin
        DocumentListFN:= ExtractFileName(FileName);
        // DocumentFolder:= ExtractFilePath(FileName); // dont!
      end;
    end;
  end;
end;

{   }
procedure TFormMoreInfo.StoreList(const AFn: String);
var
  i, j: Integer;
  T: TextFile;
begin
  if AFn = ''
  then Exit;
  //  -   ,   
  if ListView1.Items.Count =  0 then begin
    if FileExists(AFn) then begin
      DeleteFile(AFn);
    end;
    Exit;
  end;
  AssignFile(T, AFN);
  Rewrite(T);
  for i:= 0 to ListView1.Items.Count - 1 do begin
    Write(T, ListView1.Items[i].Caption +'<P>');
    for j:= 0 to ListView1.Items[i].Subitems.Count-1 do begin
      Write(T, ListView1.Items[i].SubItems[j]+'<P>');
    end;
    Writeln(T);
  end;
  CloseFile(T);
end;

{       }
procedure TFormMoreInfo.ClearList;
begin
  ListView1.Items.Clear;
  SGProperties.Rows[1].Clear;
  SGProperties.Enabled:= False;
end;

procedure TFormMoreInfo.popStoreClick(Sender: TObject);
begin
  {   }
    {   := , ,  }
  with DataModule1.SaveDialog1 do begin
    // InitialDir:= VoiceFolder;
    DefaultExt:= 'TXT';
    FileName:= DocumentListFN;
    InitialDir:= DocumentFolder;
    Filter:= '(*.TXT)|*.TXT|  (*.*)|*.*';
    FilterIndex:= 1;
    Title:= ' ';
    if Execute then begin
      DocumentListFN:= ExtractFileName(FileName);
      // DocumentFolder:= ExtractFilePath(FileName); // dont!
      StoreList(ConCatPath(DocumentFolder, DocumentListFN));
    end;
  end;
end;

procedure TFormMoreInfo.SGPropertiesExit(Sender: TObject);
begin
  UpdateProperties(True);
end;

procedure TFormMoreInfo.UpdateProperties(AStore: Boolean);
var
  i: Integer;
begin
  with ListView1, SGProperties do begin
    if AStore then begin
      if Selected <> Nil then begin
        Selected.SubItems.Clear;
        for i:=  0 to 2 do begin
          Selected.SubItems.Add(Cells[i, 1]);
        end;
      end;
    end else begin
      if (Selected <> Nil) and (Selected.SubItems.Count >= 3) then begin
        //       
        SGProperties.Enabled:= True;
        for i:=  0 to 2 do begin
          Cells[i, 1]:= Selected.SubItems[i];
        end;
      end;
    end;
  end;
end;

procedure TFormMoreInfo.popDeleteClick(Sender: TObject);
begin
  if ListView1.Selected = Nil
  then Exit;
  ListView1.Items.Delete(ListView1.Selected.Index);
  SGProperties.Rows[1].Clear;
  SGProperties.Enabled:= False;
end;

{      }
procedure TFormMoreInfo.SGPropertiesDblClick(Sender: TObject);
var
  S: String;
begin
  S:= '';
  if (SGProperties.Selection.Left = 1) and (ListView1.Selected<> Nil)
    and (ListView1.Selected.SubItems.Count>=3) and ChooseDocument(S) then begin
    ListView1.Selected.SubItems[1]:= S;
  end;  
end;

procedure TFormMoreInfo.popShowPropertiesClick(Sender: TObject);
begin
  popShowProperties.Checked:= not popShowProperties.Checked;
  SGProperties.Visible:= popShowProperties.Checked;
end;

procedure TFormMoreInfo.popEditClick(Sender: TObject);
begin
  {   }
  StoreList(ConCatPath(DocumentFolder, DocumentListFN));
  //  
  ClearList;
  //     
  EExecuteFile(ConCatPath(DocumentFolder, DocumentListFN));
end;

procedure TFormMoreInfo.popShowDocumentClick(Sender: TObject);
var
  S: String;
begin
  {   }
  if (ListView1.Selected <> Nil) and (ListView1.Selected.SubItems.Count >= 3) then begin
    S:= ListView1.Selected.SubItems[1];
    if S <> '' then begin
      EExecuteFile(S);
    end;
  end;
end;

//   DataModule1.TableClientAfterScroll    
//  
function TFormMoreInfo.GotoAbonent(const Abonent: string): Boolean;
var
  ListExists: Boolean;
begin
  if FModified then begin
    StoreList(DocumentListFN);
  end;
  DocumentListFN:= ConCatPath(DocumentFolder, Abonent+'.txt');
  // Loadlist        ,     
  ListExists:= LoadList(DocumentListFN);
  if ListExists then begin
  end else begin
  end;
  Result:= ListExists;
end;

procedure TFormMoreInfo.ListViewInsertDelete(Sender: TObject; Item: TListItem);
begin
  FModified:= True;
end;

procedure TFormMoreInfo.ListView1Edited(Sender: TObject; Item: TListItem; var S: String);
begin
  FModified:= True;
end;

procedure TFormMoreInfo.ListView1Change(Sender: TObject; Item: TListItem; Change: TItemChange);
begin
  FModified:= True;
end;

procedure TFormMoreInfo.popAddURLClick(Sender: TObject);
var
  L: TListItem;
  S: String;
begin
  S:= '';
  if ChooseURL(S) then begin
    L:= ListView1.Items.Add;
    L.Caption:= '  '+DateToStr(Date);
    L.SubItems.Add('');
    L.SubItems.Add(S);
    L.SubItems.Add(DateToStr(Date));
  end;
end;

end.
