unit RelsEdit;
(*##*)
(*******************************************************************
*                                                                 *
*   R  E  L  S  E  D  I  T    Client, EPAGER's unit.               *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   dialog edit services in list form                             *
*   Conditional defines: ---                                       *
*                                                                 *
*   Last Revision: Mar 19 1998                                     *
*   Last fix     : Mar 19 1998                                    *
*   Lines        : 46                                              *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, Grids, DBGrids, DBCtrls, ComCtrls, ToolWin, Db,
  DBTables;

type
  TFormEditRelsList = class(TForm)
    GBAbonent: TGroupBox;
    LF: TLabel;
    LHCode: TLabel;
    LAbonent: TLabel;
    GBControls: TGroupBox;
    DBNavigator1: TDBNavigator;
    OKBtn: TButton;
    Splitter1: TSplitter;
    ToolBar2: TToolBar;
    BSubRel: TToolButton;
    BAddRel: TToolButton;
    TableRels: TTable;
    TableRelClient: TTable;
    DSTableRelClient: TDataSource;
    DSRels: TDataSource;
    TableClient1: TTable;
    DSClient1: TDataSource;
    DBGClient: TDBGrid;
    LI: TLabel;
    LO: TLabel;
    GBLeft: TGroupBox;
    DBGRelClient: TDBGrid;
    DBGRel: TDBGrid;
    BGoto: TButton;
    TBAdd: TToolButton;
    procedure BAddRelClick(Sender: TObject);
    procedure BSubRelClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure BGotoClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormEditRelsList: TFormEditRelsList;

implementation

uses CDatas, Client;

{$R *.DFM}

procedure TFormEditRelsList.BAddRelClick(Sender: TObject);
begin
  if DataModule1.TableClient.IsEmpty
  then Exit;
  try
    if TableRels.State = dsEDIT
    then TableRels.Post;
  except
  end;  
  TableRels.Append;
  TableRels.FieldByName('HCODE1').AsString:= LHCode.Caption;
  TableRels.FieldByName('ABONENT1').AsString:= LAbonent.Caption;
  TableRels.FieldByName('HCODE2').AsString:= TableClient1.FieldByName('HCODE').AsString;
  TableRels.FieldByName('ABONENT2').AsString:= TableClient1.FieldByName('ABONENT').AsString;
  TableRels.Append;
  TableRels.FieldByName('HCODE2').AsString:= LHCode.Caption;
  TableRels.FieldByName('ABONENT2').AsString:= LAbonent.Caption;
  TableRels.FieldByName('HCODE1').AsString:= TableClient1.FieldByName('HCODE').AsString;
  TableRels.FieldByName('ABONENT1').AsString:= TableClient1.FieldByName('ABONENT').AsString;
  TableRels.Post;
end;

procedure TFormEditRelsList.BSubRelClick(Sender: TObject);
begin
  if TableRels.IsEmpty
  then Exit;
  TableRels.Delete;
end;

procedure TFormEditRelsList.FormActivate(Sender: TObject);
begin
  LHCode.Caption:= DataModule1.TableClient.FieldByName('HCODE').AsString;
  LAbonent.Caption:= DataModule1.TableClient.FieldByName('ABONENT').AsString;
  LF.Caption:= DataModule1.TableClient.FieldByName('FAM').AsString;
  LI.Caption:= DataModule1.TableClient.FieldByName('IM').AsString;
  LO.Caption:= DataModule1.TableClient.FieldByName('OT').AsString;
  TableClient1.Active:= True;
  TableClient1.FindNearest([LF.Caption,LI.Caption, LO.Caption]);
  TableRels.Active:= True;
  TableRelClient.Active:= True;
end;

procedure TFormEditRelsList.FormDeactivate(Sender: TObject);
begin
  TableClient1.Active:= False;
  TableRels.Active:= False;
  TableRelClient.Active:= False;
end;

procedure TFormEditRelsList.BGotoClick(Sender: TObject);
begin
  {}
  with DataModule1.TableClient do begin
    IndexName:= '';
    FindKey([TableRels.FieldByName('HCODE2').AsString,
      TableRels.FieldByName('ABONENT2').AsString]);
    FormClient.ViewNavigateAbonent;
  end;
end;

procedure TFormEditRelsList.TBAddClick(Sender: TObject);
begin
  TableClient1.Append;
end;

end.
