unit Group;
(*##*)
(*******************************************************************
*                                                                 *
*   G  R  O  U  P              EPAGER's unit.                      *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   Part of Operator project (part of EPager)                     *
*   Conditioonal defines: ---                                      *
*                                                                 *
*   Last Revision: Apr 15 1998                                     *
*   Last fix     : Apr 15 1998                                    *
*   Lines        : 123                                             *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

interface

uses Windows, Dialogs, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Db, Buttons, Grids, DBGrids, Menus, ExtCtrls;

type
  TFormGroups = class(TForm)
    DBGGroupAbonent: TDBGrid;
    Splitter1: TSplitter;
    DBGGroups: TDBGrid;
    PopMenu1: TPopupMenu;
    MEditEnabled: TMenuItem;
    N1: TMenuItem;
    MGroupNew: TMenuItem;
    MGroupDelete: TMenuItem;
    Panel1: TPanel;
    procedure SetButtons;
    procedure DBGGroupsCellClick(Column: TColumn);
    procedure MEditEnabledClick(Sender: TObject);
    procedure DBGGroupAbonentCellClick(Column: TColumn);
    procedure MGroupNewClick(Sender: TObject);
    procedure MGroupDeleteClick(Sender: TObject);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    oldx,
    oldy: Integer;
  public
    { Public declarations }
  end;

var
  FormGroups: TFormGroups;

implementation

uses Oper, DModule, PCommon;

{$R *.DFM}

procedure TFormGroups.SetButtons;
begin
  {}
end;

procedure TFormGroups.DBGGroupsCellClick(Column: TColumn);
var
  S: String;
begin
  {
  if Key = VK_RETURN
  then
  }
  S:= DataModule1.TableGrpDesc.FieldByName('GROUPID').AsString;
  {   CurHCode    S  -  4 }
  FormOper.FindCustomer(PREF_GRP+S);
  {  }
  FormOper.CustomerSelected;
end;

procedure TFormGroups.DBGGroupAbonentCellClick(Column: TColumn);
var
  S: String;
begin
  S:= DataModule1.TableGroups.FieldByName('ABONENT').AsString;
  {   CurHCode    S  }
  FormOper.FindCustomer(S);
  {  }
  FormOper.CustomerSelected;
end;

procedure TFormGroups.MEditEnabledClick(Sender: TObject);
begin
  DBGGroups.ReadOnly:= not DBGGroups.ReadOnly;
  DBGGroupAbonent.ReadOnly:= DBGGroups.ReadOnly;
  MEditEnabled.Checked:= not DBGGroups.ReadOnly;
end;
     
procedure TFormGroups.MGroupNewClick(Sender: TObject);
begin
  {     }
  with DataModule1 do begin
    if (DSGrpDesc.State in [dsEdit])
    then TableGrpDesc.Post;
    TableGrpDesc.Append;
    {    ? }
    // TableGroups.FieldByName('GROUPID').AsInteger:= ;
  end;
end;

procedure TFormGroups.MGroupDeleteClick(Sender: TObject);
begin
  if FormOper.UserCan('DEL-GROUP') then begin
    if MessageDlg('  (   )?', mtConfirmation,
       [mbOk, mbCancel], 0) = mrOK then begin
       {    }
      with DataModule1 do begin
        if (DSGrpDesc.State in [dsEdit])
        then TableGrpDesc.Post;
        TableGrpDesc.Delete;
      end;
    end;
  end;
end;

procedure TFormGroups.Panel1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  {}
 if FormOper.MViewHotAreas.Checked then begin
    if (MouseMoveDir(x, y, oldx, oldy) and 8) = 8
    then Hide;
  end;
end;

procedure TFormGroups.FormActivate(Sender: TObject);
begin
  oldx:= 0;
  oldy:= 0;
end;

end.
