unit OpSets;
(*##*)
(*******************************************************************
*                                                                 *
*   O  P  S  E  T  S           EPAGER's unit.                      *
*                                                                 *
*   Copyright (c) 1998, ..           *
*                                                                 *
*   Conditioonal defines: ---                                      *
*                                                                 *
*   Last Revision: Apr 15 1998                                     *
*   Last fix     : Apr 15 1998                                    *
*   Lines        : 1641                                            *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)
interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ComCtrls, Dialogs, ExtPage;

type
  TFormOperSettings = class(TForm)
    ExtPageControl1: TExtPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Image1: TImage;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    CBTimerDelay: TCheckBox;
    ETimerDelay: TEdit;
    UDTimerDelay: TUpDown;
    GBVoices: TGroupBox;
    Label2: TLabel;
    CBSound: TCheckBox;
    ESound: TEdit;
    UDSound: TUpDown;
    ESoundFN: TEdit;
    TabSheet3: TTabSheet;
    GBtapi: TGroupBox;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    CBtapiLog: TCheckBox;
    CBtapiStatus: TCheckBox;
    EAnswerOnRing: TEdit;
    UDAnswerOnRing: TUpDown;
    EMaxAttempts: TEdit;
    UDMaxAttempts: TUpDown;
    ERetryWait: TEdit;
    UDRetryWait: TUpDown;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    EDevice: TEdit;
    CBtapiUse: TCheckBox;
    CBSoundUse: TCheckBox;
    Panel1: TPanel;
    OKBtn: TButton;
    CancelBtn: TButton;
    SBConfig: TSpeedButton;
    EDialPrefix: TEdit;
    Label9: TLabel;
    TabSheet4: TTabSheet;
    GBAttachFolder: TGroupBox;
    EAttachFolder: TEdit;
    Memo4: TMemo;
    procedure OKBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CBTimerDelayClick(Sender: TObject);
    procedure CBSoundUseClick(Sender: TObject);
    procedure ESoundFNDblClick(Sender: TObject);
    procedure CBtapiUseClick(Sender: TObject);
    procedure EDeviceDblClick(Sender: TObject);
    procedure SBConfigClick(Sender: TObject);
    procedure EAttachFolderDblClick(Sender: TObject);
  private
    { Private declarations }
    procedure FillFields(AToForm: Boolean);
  public
    { Public declarations }

  end;

var
  FormOperSettings: TFormOperSettings;

implementation
{$R *.DFM}
uses
  util1, DModule, Voices, opTapi, Oper;

procedure TFormOperSettings.FillFields(AToForm: Boolean);
begin
  with DataModule1 do begin
    if AToForm then begin
      {  "" }
      CBTimerDelay.Checked:= Timer1.Enabled;
      Timer1.Enabled:= False; //   
      UDTimerDelay.Position:= MaxFrom2(Timer1.Interval  div 1000, 1);
      {  "" }
      CBSound.Checked:= Voices.VoiceActive;
      CBSound.Checked:= Voices. VoicesInMemory;
      UDSound.Position:= Voices. VoicesMaxInMemory;
      ESoundFN.Text:= ConcatPath(VoiceFolder, VoiceListFN);
      {  "" }
      cbTapiUse.Checked:= optapi.useTapi;
      EDialPrefix.Text:= optapi.DialPrefix;
      EDevice.Text:= tapidev.SelectedDevice;
      CBtapiLog.Checked:= tapidev.TapiLog <> Nil;
      CBtapiStatus.Checked:= tapidev.StatusDisplay <> Nil;
      UDAnswerOnRing.Position:= tapidev.AnswerOnRing;
      UDMaxAttempts.Position:= tapidev.MaxAttempts;
      UDRetryWait.Position:= tapidev.RetryWait;
      EAttachFolder.Text:= FormOper.AttachFolder;
      //     
      CBTimerDelayClick(Self);
      CBSoundUseClick(Self);
      CBtapiUseClick(Self);
    end else begin
      {  "" }
      Timer1.Enabled:= CBTimerDelay.Checked; //   
      Timer1.Interval:= UDTimerDelay.Position * 1000;
      {  "" }
      if CBSoundUse.Checked and (not FileExists(ESoundFN.Text)) then begin
        ShowMessage('    '+ ESoundFN.Text +
         ' -         ');
      end;
      Voices.VoiceActive:= CBSound.Checked;
      Voices. VoicesInMemory:= CBSound.Checked;
      Voices. VoicesMaxInMemory:= UDSound.Position;
      VoiceListFN:= ExtractFileName(ESoundFN.Text);
      VoiceFolder:= ExtractFilePath(ESoundFN.Text);
      {  "" }
      optapi.useTapi:= cbTapiUse.Checked;
      optapi.DialPrefix:= EDialPrefix.Text;
      tapidev.SelectedDevice:= EDevice.Text;
      if CBtapiLog.Checked
      then tapidev.TapiLog:= tapiLog
      else tapidev.TapiLog:= Nil;
      if CBtapiStatus.Checked
      then tapidev.StatusDisplay:= tapiStatus
      else tapidev.StatusDisplay:= Nil;
      tapidev.AnswerOnRing:= UDAnswerOnRing.Position;
      tapidev.MaxAttempts:= UDMaxAttempts.Position;
      tapidev.RetryWait:= UDRetryWait.Position;
      FormOper.AttachFolder:= EAttachFolder.Text;
    end;
  end;
end;

procedure TFormOperSettings.OKBtnClick(Sender: TObject);
begin
  FillFields(False);
  FormOper.GBPhone.Visible:= optapi.useTapi;
end;

procedure TFormOperSettings.FormCreate(Sender: TObject);
begin
  GBtapi.Caption:= 'TAPI : '+IntToStr(Hi(DataModule1.tapidev.APIVersion)+1)+
  '.'+IntToStr(Lo(DataModule1.tapidev.APIVersion));
  FillFields(True);
end;

procedure TFormOperSettings.CBTimerDelayClick(Sender: TObject);
var
  Enabled: Boolean;
begin
  Enabled:= CBTimerDelay.Checked;
  UDTimerDelay.Enabled:= Enabled;
  ETimerDelay.Enabled:= Enabled;
end;

procedure TFormOperSettings.CBSoundUseClick(Sender: TObject);
var
  Enabled: Boolean;
begin
  Enabled:= CBSoundUse.Checked;
  GBVoices.Visible:= Enabled;
  {
  CBSound.Enabled:= Enabled;
  UDSound.Enabled:= Enabled;
  ESound.Enabled:= Enabled;
  ESoundFN.Enabled:= Enabled;
  }
end;

procedure TFormOperSettings.ESoundFNDblClick(Sender: TObject);
begin
  with DataModule1.OpenDialog1 do begin
    // InitialDir:= VoiceFolder;
    DefaultExt:= 'TXT';
    Filter:= '  (*.TXT)|*.TXT|  (*.*)|*.*';
    FilterIndex:= 1;
    Title:= '    ';
    if Execute then begin
      ESoundFN.Text:= FileName;
    end;
  end;
end;

procedure TFormOperSettings.CBtapiUseClick(Sender: TObject);
begin
  {    ,  tapi   }
  GBtapi.Visible:= CBtapiUSE.Checked;
  if CBtapiUSE.Checked then begin
    {
    CBtapiLog.Enabled:= True;
    CBtapiStatus.Enabled:= True;
    EAnswerOnRing.Enabled:= True;
    UDAnswerOnRing.Enabled:= True;
    EMaxAttempts.Enabled:= True;
    UDMaxAttempts.Enabled:= True;
    ERetryWait.Enabled:= True;
    UDRetryWait.Enabled:= True;
    }
  end else begin
    {
    CBtapiLog.Enabled:= True;
    CBtapiStatus.Enabled:= True;
    EAnswerOnRing.Enabled:= True;
    UDAnswerOnRing.Enabled:= True;
    EMaxAttempts.Enabled:= True;
    UDMaxAttempts.Enabled:= True;
    ERetryWait.Enabled:= True;
    UDRetryWait.Enabled:= True;
    }
  end;
end;

procedure TFormOperSettings.EDeviceDblClick(Sender: TObject);
begin
  {}
  DataModule1.tapidev.SelectDevice;
  EDevice.Text:= DataModule1.tapidev.SelectedDevice;
end;

procedure TFormOperSettings.SBConfigClick(Sender: TObject);
begin
  {}
  if DataModule1.tapidev.SelectedDevice <> ''
  then DataModule1.tapidev.ShowConfigDialog;
end;

procedure TFormOperSettings.EAttachFolderDblClick(Sender: TObject);
begin
  with DataModule1.OpenDialog1 do begin
    InitialDir:= EAttachFolder.Text;
    DefaultExt:= 'TXT';
    Filter:= '  (*.*)|*.*';
    FilterIndex:= 1;
    Title:= '    ';
    if Execute then begin
      EAttachFolder.Text:= ExtractFilePath(FileName);
    end;
  end;
end;

end.
