unit Oper;
(*##*)
(*******************************************************************
*                                                                 *
*   O  P  E  R                 EPAGER's unit.                      *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   Main unit for operator project                                *
*   Conditioonal defines: ---                                      *
*                                                                 *
*   Last Revision: Apr 15 1998                                     *
*   Last fix     : Apr 15 1998                                    *
*   Lines        : 1641                                            *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)
interface

uses
  SysUtils, Windows, WinTypes, WinProcs, Messages, Classes,
  Graphics, Controls, Forms, Dialogs, ExtCtrls, Grids,
  DB, DBCtrls, DBGrids, DBTables, DBLookup,
  StdCtrls, Mask, TabNotBk, FileCtrl, Menus, Inifiles,
  DDEMan, ShellAPI,
  Tabs, Buttons,  PCommon, util1, About,
  pagexlat, typist, ComCtrls, ToolWin, ExtPage;

const
  MaxAttachFiles = 7 - 1; //       "+"
  DEFMsgListViewLimit = 20; {    XX ,      }
  { 3 kind of search }
  SEARCHBYNAMES = 0;
  SEARCHBYID    = 1;
  SEARCHBYDATE  = 2;

  PREF_GRP      = '+';
  PREF_ORG      = '/';
  PREF_NICK     = '.';

  kndALL           = 0;
  kndBYCYRLETTER   = 1;
  kndBYENGLETTER   = 2;
  kndBYWORD        = 3;

type
  TFormOper = class(TForm)
    MainMenu1: TMainMenu;
    MMFile: TMenuItem;
    MMFileDelimiter1: TMenuItem;
    MMFileExit: TMenuItem;
    MMOptions: TMenuItem;
    MMOptionsDlg: TMenuItem;
    MMHelp: TMenuItem;
    MMHelpIndex: TMenuItem;
    MMsg: TMenuItem;
    MMsgSend2List: TMenuItem;
    MMsgDelimiter1: TMenuItem;
    MMsgSendByFile: TMenuItem;
    MMsgSend2Abonent: TMenuItem;
    StatusBar1: TStatusBar;
    CoolBar1: TCoolBar;
    CBAbonent: TComboBox;
    ToolBar1: TToolBar;
    TBViewAbonentList: TToolButton;
    TBViewMsgList: TToolButton;
    TBViewGroupList: TToolButton;
    TBViewVoiceList: TToolButton;
    TBSend: TToolButton;
    CBZone: TComboBox;
    ESubj: TEdit;
    CBKind: TComboBox;
    CBPageCP: TComboBox;
    N1: TMenuItem;
    MOptionsLoadAll: TMenuItem;
    GroupBox1: TGroupBox;
    TSToday: TExtTabControl;
    Panel2: TPanel;
    TabSetMessages: TExtTabControl;
    DateEdit1: TDateTimePicker;
    MOptionsDictionary: TMenuItem;
    MOptionsSave: TMenuItem;
    MMessage: TMemo;
    LBDict: TListBox;
    MView: TMenuItem;
    MViewShowDict: TMenuItem;
    MViewShowDictNO: TMenuItem;
    MViewShowDictIfExists: TMenuItem;
    MViewShowDictTimeout: TMenuItem;
    MViewShowDictAllways: TMenuItem;
    PopupMenu1: TPopupMenu;
    popMsgCount: TMenuItem;
    MOptionsOper: TMenuItem;
    MMViewDelimiter1: TMenuItem;
    MViewAbonentList: TMenuItem;
    MViewGroupList: TMenuItem;
    MViewMsgList: TMenuItem;
    MViewVoiceList: TMenuItem;
    TSAttach: TExtTabControl;
    popMenuAttach: TPopupMenu;
    popAttachSub: TMenuItem;
    popAttachClear: TMenuItem;
    N2: TMenuItem;
    MOptionsCopyLink: TMenuItem;
    Panel1: TPanel;
    GroupBox2: TGroupBox;
    RGSheduleNo: TRadioButton;
    RGSheduleYes: TRadioButton;
    Notebook2: TNotebook;
    Label4: TLabel;
    CBLocalTime: TCheckBox;
    DESend: TDateTimePicker;
    MEStart: TDateTimePicker;
    RGAlone: TGroupBox;
    Notebook1: TNotebook;
    Label7: TLabel;
    Label6: TLabel;
    MEFinish: TDateTimePicker;
    MEInterval: TDateTimePicker;
    RGRepeatNo: TRadioButton;
    RGRepeatYes: TRadioButton;
    GBPhone: TGroupBox;
    SBPhoneCall: TSpeedButton;
    MEPhone: TMaskEdit;
    MViewHotAreas: TMenuItem;
    MMViewDelimiter2: TMenuItem;
    MViewOnTop: TMenuItem;
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure MMOptionsDlgClick(Sender: TObject);
    procedure MMFileExitClick(Sender: TObject);
    procedure BSendRepeatedlyClick(Sender: TObject);
    procedure MEFinishChange(Sender: TObject);
    procedure MEStartChange(Sender: TObject);
    procedure MEIntervalChange(Sender: TObject);
    procedure ComboBoxEnter(Sender: TObject);
    procedure CBAbonentKeyPress(Sender: TObject; var Key: Char);
    procedure RGAloneClick(Sender: TObject);
    procedure TSTodayChange(Sender: TObject);
    procedure DateEdit1Change(Sender: TObject);
    procedure TabSetMessagesChange(Sender: TObject);
    procedure MMessageKeyPress(Sender: TObject; var Key: Char);
    procedure CBAbonentClick(Sender: TObject);
    procedure MMessageChange(Sender: TObject);
    procedure TBViewAbonentListClick(Sender: TObject);
    procedure TBViewMsgListClick(Sender: TObject);
    procedure TBViewGroupListClick(Sender: TObject);
    procedure TBSendClick(Sender: TObject);
    procedure RGSheduleClick(Sender: TObject);
    procedure DESendAcceptDate(Sender: TObject; var Date: TDateTime;
      var Action: Boolean);
    procedure DateEdit1DblClick(Sender: TObject);
    procedure DESendDblClick(Sender: TObject);
    procedure MEStartDblClick(Sender: TObject);
    procedure CBAbonentKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MOptionsDictionaryClick(Sender: TObject);
    procedure MOptionsSaveClick(Sender: TObject);
    procedure MMessageKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MMessageClick(Sender: TObject);
    procedure MViewShowDictClick(Sender: TObject);
    procedure MViewShowDictionaryClick(Sender: TObject);
    procedure popMsgCountClick(Sender: TObject);
    procedure MOptionsOperClick(Sender: TObject);
    procedure TBViewVoiceListClick(Sender: TObject);
    procedure SBPhoneCallClick(Sender: TObject);
    procedure TSAttachMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure popAttachAddClick(Sender: TObject);
    procedure popAttachClearClick(Sender: TObject);
    procedure MOptionsCopyLinkClick(Sender: TObject);
    procedure MViewHotAreasClick(Sender: TObject);
    procedure StatusBar1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TBViewAbonentListMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure TBViewGroupListMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure MViewOnTopClick(Sender: TObject);
  private
    { Private declarations }
    FirstTime,        //SecondEnter
    AllreadyRegistered,
    UseDict: Boolean;
    FShowKind,
    cploadedCount,    //   codepage
    MsgListViewLimit: Word;
    TmStart,
    TmFinish,
    TmInterval: TDateTime;
    Repeats,
    CurMsgWords,
    CurMsgChars: LongInt;
    {    }
    TodayMessageCount: Integer;
    PagerCodeDefs: PPagerCPs;   // . 
    HaveTalk: Boolean;
    procedure SetDictionary(const APath: String);
    function  FullFIO: String;
    procedure FillTime2Current;
    procedure FillDBCB(const SQLFN: String; List: TStrings; const ACaption: String);
    procedure UpdateDBCBs;
    function  GotoCall(ADate: TDateTime; No: LongInt): Boolean;
    procedure FillCall;
    function  CheckMsg: Boolean;
    procedure SendMsg;
    procedure CalcMemoWords;
    procedure ShowOperatorInfo(const AZone, AHCode: THCode; AUPDATER: Integer);
    procedure ShowCustomerInfo;
    procedure CountRepeats;
    function  UserLevel: Word;
    procedure DiffDays(adateofs: Integer);
    procedure UpdateCursorPos;
    procedure SetShowDictKind(AKind: Word);
    function  GetShowDictKind: Word;
    procedure UpdateAttachList;
    function  AddFN2Attaches(const AFN: String): Boolean;
  protected
    procedure wmDropFiles(var Msg: TMessage); message WM_DropFiles;
  public
    { Public declarations }
    SearchCategory: Byte;
    Use_Alias: Boolean;
    Sheduled: Boolean;
    Repeatadly: Boolean;
    AliasName: String[32];
    DatabaseFolder: String[32];
    CurZone,
    CurHCode  : THCODE;  { }
    CurAbonent: String[32];
    CurGroup: String[32];
    OperateDay: TDateTime;
    CurUPDATER: Longint;  { }
    SQLFolder,
    SQLSYSFolder,
    SQLVOCFolder,
    WorkPlace,
    DictFolder: SQLPathString;
    AttachFolder: SQLPathString;
    OperLabels: String[255];
    ClientLabels: String[255];
    CALLSLABELS: String[255];
    GroupsLABELS: String[255];
    GrpDescLABELS: String[255];
    procedure ETShowStatus(Level: Integer; const S: String);
    function  LoadIni: Boolean;
    procedure StoreIni;
    { change alias and update all visibles }
    function  AssignAlias(const AAlias: String): Boolean;
    function  AssignDataFolder(const ADataFolder: String): Boolean;
    procedure ChangeDataBaseAliasOrFolder;
    { do smth to find DLLS.
    For example, change current directory?
    }
    procedure AssignWorkPlace(const S: String);
    procedure StoreFields(const S: String);
    function  LoginUser(AHCode: THCODE;AUPDATER: LongInt): Boolean;
    // function  ValidateLicense: Integer;
    procedure DisplayHint(Sender: TObject);
    procedure UpdateDisplayLabels;
    function  MsgQty(ADate: TDateTime): Word;
    procedure SetDate(NewDate: TDateTime);
    procedure ActivateTables;
    function  FindCustomer(const Srch: String): Boolean;
    procedure CustomerSelected;
    function  UserCan(const Operation: string): Boolean;
    function  CPVerifyKey(var Key: Char): Boolean;
    function  CPVerifyEnteredText(var LineNo, CharNo: Integer): Boolean;
    property  ShowDictKind: Word read GetShowDictKind write SetShowDictKind;
    procedure SetDictStyle;
    procedure ShowIsSent(AKind: Word);
  end;

var
  FormOper: TFormOper;

implementation
uses
  clogin, OSetting, DModule, AbMsgLst, ViewAbon, Group, OpSets,
  Voices, optapi;

function GetFirstWord(const S: String): String;
var
  st: Boolean;
  SS: String;
  i: Integer;
begin
  st:= True;
  SS:= '';
  for i:= 1 to Length(S) do begin
    if st then begin
      if S[i] <= #32
      then Continue;
      SS:= S[i];
      st:= False;
    end else begin
      if S[i] <= #32
      then Break;
      SS:= SS+S[i];
    end;
  end;
  Result:= SS;
end;

procedure ViewOperForm(ASessionInserted: LongInt; var AHCode: THCODE;
  AUPDATER: LongInt);
begin
  FormOper:= TFormOper.Create(Application);
  with FormOper do begin
    if LoginUser(AHCode, AUPDATER) then begin
      ShowModal;
      Hide;
    end;
    Free;
  end;
end;

{$R *.DFM}

procedure TFormOper.ETShowStatus(Level: Integer; const S: String);
begin
  with StatusBar1 do begin
    case Level of
    1:Font.Color:= clRed;
    2:Font.Color:= clBlue;
    3:Font.Color:= clYellow;
    else Font.Color:= clBlack;
    end;
    Panels[Panels.Count-1].Text:= S;
  end;
end;

function TFormOper.AssignAlias(const AAlias: String): Boolean;
begin
  AssignAlias:= False;
  if AAlias <> '' then with DataModule1, DataBase1 do begin
    {   -       }
    TableClient.Active:= False;
    TableCalls.Active:= False;
    TableGroups.Active:= False;
    TableGrpDesc.Active:= False;
    TablePagers.Active:= False;
    TableModels.Active:= False;
    QDict.Active:= False;
    {     }
    Connected:= False;
    AliasName:= AAlias;
    {      }
    {   -    dbOper }
    
    QDict.DataBaseName:= DataModule1.DataBase1.DataBaseName;
    TableClient.DataBaseName:= DataModule1.DataBase1.DataBaseName;
    TableCalls.DataBaseName:= DataModule1.DataBase1.DataBaseName;
    TableGroups.DataBaseName:= DataModule1.DataBase1.DataBaseName;
    TableGrpDesc.DataBaseName:= DataModule1.DataBase1.DataBaseName;
    TablePagers.DataBaseName:= DataModule1.DataBase1.DataBaseName;
    TableModels.DataBaseName:= DataModule1.DataBase1.DataBaseName;
    {    }
    Connected:= True;
  end;
  Result:= True;
end;

function TFormOper.AssignDataFolder(const ADataFolder: String): Boolean;
begin
  AssignDataFolder:= False;
  if ADataFolder <> '' then with DataModule1 do begin
    DataBase1.Connected:= False;
    DataBase1.AliasName:= '';
    { connect others
    }
    with QDict do begin
      Active:= False;
      DatabaseName:= '';
    end;
    with TableClient do begin
      Active:= False;
      DatabaseName:= '';
    end;
    with TableCalls do begin
      Active:= False;
      DatabaseName:= '';
    end;
    with TableGroups do begin
      Active:= False;
      DatabaseName:= '';
    end;
    with TableGrpDesc do begin
      Active:= False;
      DatabaseName:= '';
    end;
    with TablePagers do begin
      Active:= False;
      DatabaseName:= '';
    end;
    with TableModels do begin
      Active:= False;
      DatabaseName:= '';
    end;
  end;
  AssignDataFolder:= True;
end;

procedure TFormOper.ChangeDataBaseAliasOrFolder;
begin
  if Use_Alias then begin
    AssignAlias(AliasName);
  end else begin
    AssignDataFolder(DatabaseFolder);
  end;
end;

procedure TFormOper.AssignWorkPlace(const S: String);
begin
  if S = '' then begin
    if DEFWORKPLACE <> ''
    then ChDir(DEFWORKPLACE);
  end else begin
    ChDir(S);
  end;
end;

procedure TFormOper.StoreFields(const S: String);
begin
end;

procedure ValidateDateDelimiters(var S: String);
begin
  {     ,    ,  }
  if Length(S) = 1
  then S:= S+S;
  {        ,  }
  if Length(S) = 0
  then S:= DEFDATEDELIMITERS;
  {     (   2),   }
  System.Delete(S, 3, 255);
end;

procedure ValidatePhoneDelimiter(var S: String);
begin
  {        ,  }
  if Length(S) = 0
  then S:= DEFPHONEDELIMITER;
  {     (   1),   }
  System.Delete(S, 2, 255);
end;

procedure TFormOper.ActivateTables;
begin
  with DataModule1 do begin
    QDict.DisableControls;
    TableClient.DisableControls;
    TableCalls.DisableControls;
    TableGroups.DisableControls;
    TableGrpDesc.DisableControls;
    TablePagers.DisableControls;
    TableModels.DisableControls;
//  QDict.Active:= True;
    TableClient.Active:= True;
    TableCalls.Active:= True;
    TableGroups.Active:= True;
    TableGrpDesc.Active:= True;
    TablePagers.Active:= True;
    TableModels.Active:= True;
    { labels }
    UpdateDisplayLabels;
    UpdateDBCBs;

    QDict.EnableControls;
    TableClient.EnableControls;
    TableCalls.EnableControls;
    TableGroups.EnableControls;
    TableGrpDesc.EnableControls;
    TablePagers.EnableControls;
    TableModels.EnableControls;
  end;
end;

function TFormOper.LoadIni: Boolean;
var
  IniFile: TIniFile;
  S: ShortString;
begin
  LoadIni:= False;
  IniFile:= TIniFile.Create(SearchIni('', INI_PAGER_FILE));
  with IniFile do begin
    Font.Name:= ReadString(sectFONT, iniFontName, 'System');
    TabSetMessages.Font.Name:= Font.Name;
//    TNVis.TabFont.Name:= Font.Name;
    Font.Size:= ReadInteger(sectFONT, iniFontSize, -10);
    {     }
    Use_Alias:= ReadBool(sectGLOBAL, iniUSEALIAS, True);
    AliasName:= ReadString(sectGLOBAL, iniALIAS, 'PAGER');
    DatabaseFolder:= ReadString(sectGLOBAL, iniDataFolder, 'DATA\');
    WorkPlace:= ReadString(sectGLOBAL, iniDLLS, DEFWORKPLACE);
    {      - ,  }
    ReadSectionValues(sectDBParams, DataModule1.DataBase1.Params);
    DataModule1.DataBase1.LoginPrompt:= ReadBool(sectGLOBAL, iniLoginPrompt, True);
    { folders }
    AssignWorkPlace(WorkPlace);
    SQLFolder:= ReadString(sectGLOBAL, iniSQLS, 'SQL\');
    SQLSYSFolder:= ReadString(sectGLOBAL, iniSYSSQLS, 'SQL\SYS\');
    SQLVOCFolder:= ReadString(sectGLOBAL, iniVOCSQLS, 'SQL\VOC\');
    ChangeDataBaseAliasOrFolder;
    {}
    CurZone:= ReadString(sectOPER, iniLOCALZONE, '');
    CBZone.Text:= CurZone;
    CBKind.Text:= ReadString(sectOPER, iniDEFAULTPRIORITY, '');
    { LABELS }
    OperLabels:= ReadString(sectOPER, iniOPERTBLLBL, DEFOperLABELS);
    CLIENTLABELS:= ReadString(sectCLIENTS, iniCLIENTLABELS, DEFCLILABELS);
    CallsLABELS:= ReadString(sectCALLS, iniCALLSLABELS, DEFCALLABELS);
    GroupsLABELS:= ReadString(sectGRP, iniGRPLABELS, DEFGRPLABELS);
    GrpDescLABELS:= ReadString(sectGRPDESC, iniGRPDESCLABELS, DEFGRPDESCLABELS);

    { load dictionary
    }
    DictFolder:= ReadString(sectGLOBAL, iniDICTFolder, DEFDICTFolder);
    SetDictionary(ReadString(sectGLOBAL, iniDICTFN, ''));
    ShowDictKind:= ReadInteger(sectGLOBAL, iniDICTViewStyle, 0);
    SetDictStyle;
    { load pager cp definitions
    }
    S:= ReadString(sectPagerDefs, iniDEFPAGERCPFILE, DEFPAGERCPFILE);
    MOptionsLoadAll.Checked:= ReadBool(sectPagerDefs, iniLOADALLDEFS, False);
    { PagerCodeDefs = Nil (FormCreate) }
    cploadedCount:= LoadECC(S, MOptionsLoadAll.Checked, PagerCodeDefs, CBPageCP.Items);
    if cploadedCount <=0 then begin
      ShowMessage('    '+ S);
    end;
    {}
    ActivateTables;
    {  }
    DataModule1.Timer1.Interval:= 1000 * ReadInteger(sectOPER, iniTimerDelay, 5);
    DataModule1.Timer1.Enabled:= ReadBool(sectOPER, iniUseTimer, False);
    {  }
    Voices.VoiceActive:= ReadBool(sectOPER, iniVoiceActive,  False);
    Voices.VoicesInMemory:= ReadBool(sectOPER, iniVoicesInMemory, False);
    Voices.VoicesMaxInMemory:= ReadInteger(sectOPER, iniVoicesMaxInMemory, 5);
    Voices.VoiceListFN:= ReadString(sectOPER, iniVoiceListFN, '');
    Voices.VoiceFolder:= ReadString(sectOPER, iniVoiceFolder, DEFVoiceFolder);
    { tapi }
    with DataModule1 do begin
      optapi.useTapi:= ReadBool(sectOPER, iniUseTapi, False);
      optapi.DialPrefix:= ReadString(sectOPER, iniDialPrefix, 'P');
      GBPhone.Visible:= optapi.useTapi;
      tapidev.SelectedDevice:= ReadString(sectOPER, iniTapiDevice, '');
      if ReadBool(sectOPER, iniTapiLog,  False)
      then tapidev.TapiLog:= tapiLog
      else tapidev.TapiLog:= Nil;
      if ReadBool(sectOPER, iniStatusDisplay,  False)
      then tapidev.StatusDisplay:= tapiStatus
      else tapidev.StatusDisplay:= Nil;
      tapidev.AnswerOnRing:= ReadInteger(sectOPER, iniAnswerOnRing, 2);
      tapidev.MaxAttempts:=  ReadInteger(sectOPER, iniMaxAttempts, 3);
      tapidev.RetryWait:= ReadInteger(sectOPER, iniRetryWait, 5);
    end;
    {   }
    AttachFolder:= ReadString(sectOPER, iniAttachFolder, '');
  end;
  IniFile.Free;
  LoadIni:= True;
end; { LoadIni }

procedure TFormOper.StoreIni;
var
  IniFile: TIniFile;
begin
  IniFile := TIniFile.Create(SearchIni('', INI_PAGER_FILE));
  with IniFile do begin
    WriteString(sectFONT, iniFontName, Font.Name);
    { store dictionary
    }
    WriteString(sectGLOBAL, iniDICTFN, GetNameFromMenu(MOptionsDictionary));
    WriteString(sectGLOBAL, iniDICTFolder, DictFolder);
    WriteInteger(sectGLOBAL, iniDICTViewStyle, ShowDictKind);
    {  }
    WriteBool(sectOPER, iniUseTimer, DataModule1.Timer1.Enabled);
    WriteInteger(sectOPER, iniTimerDelay, DataModule1.Timer1.Interval div 1000);
    {  }
    WriteBool(sectOPER, iniVoiceActive, Voices.VoiceActive);
    WriteBool(sectOPER, iniVoicesInMemory, Voices.VoicesInMemory);
    WriteInteger(sectOPER, iniVoicesMaxInMemory, Voices.VoicesMaxInMemory);
    WriteString(sectOPER, iniVoiceListFN, Voices.VoiceListFN);
    WriteString(sectOPER, iniVoiceFolder, Voices.VoiceFolder);
    { tapi }
    with DataModule1 do begin
      WriteBool(sectOPER, iniuseTapi,  optapi.useTapi);
      WriteString(sectOPER, iniDialPrefix, optapi.DialPrefix);
      WriteString(sectOPER, iniTapiDevice, tapidev.SelectedDevice);
      WriteBool(sectOPER, iniTapiLog,  tapidev.TapiLog <> Nil);
      WriteBool(sectOPER, iniStatusDisplay, tapidev.StatusDisplay <> Nil);
      WriteInteger(sectOPER, iniAnswerOnRing, tapidev.AnswerOnRing);
      WriteInteger(sectOPER, iniMaxAttempts, tapidev.MaxAttempts);
      WriteInteger(sectOPER, iniRetryWait, tapidev.RetryWait);
    end;
    {   }
    WriteString(sectOPER, iniAttachFolder, AttachFolder);
  end;
  IniFile.Free;
end; { StoreIni }

function  TFormOper.LoginUser(AHCode: THCODE; AUPDATER: LongInt): Boolean;
begin
  CurHCode:= AHCode;
  CurUpdater:= AUPDATER;
  LoginUser:= True;
end;

procedure TFormOper.ShowOperatorInfo(const AZone, AHCode: THCode; AUPDATER: Integer);
begin
  with StatusBar1 do begin
    {      }
    Panels[0].Text:= AZone + '-' + AHCode + ':' + IntToStr(AUPDATER);
  end;
end;

procedure TFormOper.FormDestroy(Sender: TObject);
begin
  //    drag'n'drop 
  DragAcceptFiles(Handle, False);
  EraseServiceList;
end;

procedure TFormOper.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := True;
  with DataModule1 do begin
    if (DSDict.State in [dsEdit]) then begin
      if MessageDlg(': c   ?', mtConfirmation,
        [mbOk, mbCancel], 0) = mrOK then begin
        CanClose := True;
        with QDict do if State = dsEdit
        then Post;
      end else begin
        CanClose := False;
      end;
    end;
  end;
end;

procedure TFormOper.DisplayHint(Sender: TObject);
begin
  with StatusBar1
  do Panels[Panels.Count-1].Text:= Application.Hint;
end;

procedure TFormOper.ShowCustomerInfo;
begin
  with DataModule1, TableClient do begin
    if SearchCategory = 4 then begin
      //   
      //     
      CBAbonent.Text:= PREF_GRP+TableGrpDesc.FieldByName('GROUPID').AsString+#32+
        TableGrpDesc.FieldByName('DESCRIPTION').AsString;
      // CoolBar1.Bands[1].Text:= '';
      //   
      ETShowStatus(0, ': '+TableGrpDesc.FieldByName('NICKNAME').AsString+
        ' :'+ TableGrpDesc.FieldByName('PASSWD').AsString);
      with StatusBar1
      do Panels[Panels.Count-1].Text:= '';
      //    ,  
      MEPhone.Text:= '';
      MEPhone.Hint:= '';
    end else begin
      //  
      CBAbonent.Text:=  FieldByName('ABONENT').AsString+#32+ FullFIO;
      //    ,  
      MEPhone.Text:=  FieldByName('PHONET').AsString;
      //  ,  
      if MEPhone.Text = ''
      then MEPhone.Text:=  FieldByName('PHONE').AsString;
      MEPhone.Hint:= '  '+DateToStr(Date);
      // CoolBar1.Bands[1].Text:= '';
      //   
      ETShowStatus(0, ': '+TableClient.FieldByName('NICKNAME').AsString+
        ' :'+ TableClient.FieldByName('PASSWD').AsString);
      with StatusBar1
      do Panels[Panels.Count-1].Text:= FullFIO;
    end;
    // DDE
    itemAbonent.Text:= CBAbonent.Text;
    {    ,       }
    {    }
    MsgQty(OperateDay);
   end;
end;

procedure TFormOper.FormCreate(Sender: TObject);
begin
  FirstTime:= True;
  SearchCategory:= 1;
  Application.OnHint:= DisplayHint;
  // pointer MUST be nil before first load
  PagerCodeDefs:= Nil;
  AllreadyRegistered:= False;
  CurHCode  := 'SPC';
  CurUPDATER:= 0;
  {         }
  DESend.Date:= Date;
  TmStart:= 0;
  TmFinish:= 0;
  TmInterval:= 0;
  // SecondEnter:= False;
  Repeats:= 0;
  MsgListViewLimit:= DEFMsgListViewLimit;
  UpdateCursorPos;
  HaveTalk:= False;
  //   drag'n'drop
  DragAcceptFiles(Handle, True);
end;

procedure TFormOper.UpdateAttachList;
var
  i: Integer;
begin
  with TSAttach do begin
    Tabs.Clear;
    Tabs.Add('+'); //  0- " "
    for i:= 1 to TSAttach.TabHints.Count - 1 do begin
      Tabs.Add(ExtractFileName(TabHints[i]));
    end;
    TabIndex:= 0;
  end;
end;

//  False         
//   ,        
//    - ,   
function TFormOper.AddFN2Attaches(const AFN: String): Boolean;
var
  S: String;
begin
  Result:= False;  //     url
  if (AFN = '')    // or (not FileExists(AFN) -     ,
  then Exit;
  if TSAttach.TabHints.Count >= MaxAttachFiles then begin
    TSAttach.TabHints.Delete(1); // 0-  "+"
  end else begin
    Result:= True;
  end;
  //    
  S:= ExtractRelativePath(AttachFolder, AFn);
  if TSAttach.TabHints.IndexOf(S) < 0
  then TSAttach.TabHints.Add(S);
  UpdateAttachList;
end;

procedure TFormOper.TSAttachMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  ind: Integer;
  S: String;
begin
  {}
  ind:= (Sender as TTabControl).TabIndex;
  if (ind = 0) then begin
    //   
    with DataModule1.OpenDialog1 do begin
      InitialDir:= AttachFolder;
      DefaultExt:= 'TXT';
      Filter:= ' (*.TXT)|*.TXT| HTML|*.HTM;*.HTML|  (*.*)|*.*';
      FilterIndex:= 1;
      Title:= '  ';
      if Execute then begin
        AddFN2Attaches(FileName);
      end;
    end;
  end else begin
    //   
    S:= ExpandRelativePath(AttachFolder, TSAttach.TabHints[ind]);
    if FileExists(S) then begin
      try
        MMessage.Lines.LoadFromFile(S);
        S:= MMessage.Text;
        //   ,  
        if ANSICompareText(ExtractFileExt(TSAttach.TabHints[ind]), '.HTM') >=0 then begin
          //  
          ReplaceTag(S, '<', '>', #0, KeepLinkCallBack);
        end;
        DeleteControlsStrCRLF2Space(S);
        MMessage.Text:= S;
      except
        ShowMessage('    '+TSAttach.TabHints[ind]);
      end;
    end else begin
      ETShowStatus(0, '   ()');
    end;
  end;
end;

procedure TFormOper.wmDropFiles(var Msg: TMessage);
var
  FN: array[0..255] of Char;
  f, files: Integer;
begin
//    win32 -  /0    /0/0-   -   .
//        -1    
  files:= DragQueryFile(THandle(Msg.WParam), -1, FN, SizeOf(FN));
//TSAttach.TabHints.Clear;
  for f:= 1 to files do begin
    DragQueryFile(THandle(Msg.WParam), f-1, FN, SizeOf(FN));
    AddFN2Attaches(StrPas(FN));
  end;
  DragFinish(THandle(Msg.WParam));
end;

procedure TFormOper.MMOptionsDlgClick(Sender: TObject);
begin
  FormSettings:= TFormSettings.Create(Application);
  FormSettings.Font.Name:= Font.Name;
  FormSettings.Set2Alias(AliasName, DataBaseFolder, Use_Alias, DataModule1.DataBase1);
  if FormSettings.ShowModal = mrOK then begin
    if FormSettings.FontChanged then begin
      Font:= FormSettings.Font;
      TabSetMessages.Font.Name:= Font.Name;
//      TNVis.TabFont.Name:= Font.Name;
    end;
    if FormSettings.DBLocationChanged then begin
      Use_Alias:= FormSettings.RGByAlias.Checked;
      AliasName:= FormSettings.CBAlias.Text;
      DataBaseFolder:= FormSettings.EDBFolder.Text;
      ChangeDataBaseAliasOrFolder;
      ActivateTables;
    end;
  end;
  FormSettings.Free;
end;

procedure TFormOper.MOptionsOperClick(Sender: TObject);
begin
  FormOperSettings:= TFormOperSettings.Create(Application);
  FormOperSettings.Font.Name:= Font.Name;
  if FormOperSettings.ShowModal = mrOK then begin
  
  end;
  FormOperSettings.Free;
end;

procedure TFormOper.MOptionsDictionaryClick(Sender: TObject);
begin
  with DataModule1.OpenDialog1 do begin
    InitialDir:= DictFolder;
    DefaultExt:= 'TXT';
    Filter:= '   (*.TXT)|*.TXT| MS Word 6(*.DIC)|*.DIC|  (*.*)|*.*';
    FilterIndex:= 1;
    Title:= ' 1  ';
    if Execute then begin
      SetDictionary(FileName);
    end;
  end;
end;

procedure TFormOper.MOptionsSaveClick(Sender: TObject);
begin
  StoreIni;
end;

procedure TFormOper.MMFileExitClick(Sender: TObject);
begin
  Close;
end;

procedure TFormOper.BSendRepeatedlyClick(Sender: TObject);
begin
end;

{         
  
}
procedure TFormOper.FillTime2Current;
var
  DT: TDateTime;
begin
  DT:= Date+Time;
  {  ,     }
  DESend.Date:= Trunc(DT);
  {      }
  RoundTime(DT, 0, 5);
  MEStart.Time:= DT;
  IncTime(DT, 1, 0);
  MEFinish.Time:= DT;
  MEInterval.Time:= EncodeTime(0, 15, 0, 0);
end;

procedure TFormOper.MEFinishChange(Sender: TObject);
begin
  TmFinish:= Frac(MEFinish.Time) + Trunc(DESend.Date);
  CountRepeats;
end;

procedure TFormOper.MEStartChange(Sender: TObject);
begin
  TmStart:= Frac(MEStart.Time) + Trunc(DESend.Date);
  CountRepeats;
end;

procedure TFormOper.CountRepeats;
begin
  if Abs(TmInterval) < 1/(24*60*60) then begin //  1 
    //  
    Repeats:= 0;
    RGRepeatNo.Checked:= True;
    Repeatadly:= False;
  end else begin
    //    24 
    if TMFinish < TMStart
    then Repeats:= Trunc((1 + TMFinish - TMStart) / TmInterval)
    else Repeats:= Trunc((TMFinish - TMStart) / TmInterval);
    // METimes.Text:= IntToStr(Repeats);
    RGRepeatYes.Caption:= '&'+IntToStr(Repeats)+' ';
    RGRepeatYes.Checked:= True;
    Repeatadly:= True;
  end;
end;

procedure TFormOper.MEIntervalChange(Sender: TObject);
begin
  TmInterval:= Frac(MEInterval.Time);
  if TmInterval <= 0
  then TmInterval:= 5;
  CountRepeats;
end;

procedure TFormOper.ComboBoxEnter(Sender: TObject);
begin
  {  }
  (Sender as TCombobox).Perform(CB_ShowDropDown, Ord(True), 0);
end;

{ 
  1 -    [CurHCode,No]
  2 -  
  3 -   
  4 - 
  5 -  
}
function WhatIndex2Use(const Srch: String): Integer;
var
  FirstWord: String;
  ch: Char;
begin
  Result:= 1;
  if Length(Srch) = 0
  then Exit;
  FirstWord:= GetFirstWord(Srch);
  ch:= Upcase(FirstWord[1]);
  if isDecimal(FirstWord) then begin
    Result:= 1;            //  
  end else begin
    case ch of
      PREF_ORG : Result:= 3; // / -   
      PREF_GRP : Result:= 4; // + -  
      PREF_NICK: Result:= 5; // . -  
      else       Result:= 2; //  
    end;
  end;
end;

{ Cat: 0 -  
  1 -    [CurHCode,No]
  2 -  
  3 -   
  4 - 
  5 -  
      -         
      -       
}
function TFormOper.FindCustomer(const Srch: String): Boolean;
var
  // V: LongInt;
  FirstWord: String;
begin
  Result:= False;
  FirstWord:= GetFirstWord(Srch);
  if FirstWord = ''
  then Exit;
  with DataModule1, TableClient do begin
    SearchCategory:= WhatIndex2Use(FirstWord);
    case SearchCategory of
      1: begin
           try
             // V:= StrToInt(FirstWord);
             IndexName:= '';
             SetKey;
             FieldByName('HCODE').AsString:= CurHCode;
             FieldByName('ABONENT').AsString := FirstWord;
             if GotoKey then begin
             end else begin
               ETShowStatus(1,'       .');
             end;
           except
             ETShowStatus(1,'    .');
           end;
         end;
      2: begin
           try
             IndexName:= 'ICFIO';
             SetKey;
             FieldByName('FAM').AsString:= GetToken(1, #32, FirstWord);
             FieldByName('IM').AsString := GetToken(2, #32, FirstWord);
             FieldByName('OT').AsString := GetToken(3, #32, FirstWord);
             GotoNearest;
           except
             ETShowStatus(1,'    .');
           end;
         end;
      3: begin
           try
             IndexName:= 'ICORG';
             SetKey;
             FieldByName('ORGNAME').AsString:= Copy(GetToken(1, #32, FirstWord), 2, 255);
             FieldByName('ORGNO').AsString := GetToken(2, #32, FirstWord);
             GotoNearest;
           except
             ETShowStatus(1,'    .');
           end;
         end;
      4: begin
           {    }
           try
             // V:= StrToInt(FirstWord);
             TableGrpDesc.IndexName:= '';
             TableGrpDesc.SetKey;
             TableGrpDesc.FieldByName('GROUPID').AsString:= FirstWord;
             if TableGrpDesc.GotoKey then begin
               {     }
               // V:= StrToInt(FirstWord);
               IndexName:= '';
               SetKey;
               FieldByName('HCODE').AsString:= CurHCode;
               FieldByName('ABONENT').AsString := TableGrpDesc.FieldByName('GRPADMIN').AsString;
               if GotoKey then begin
               end else begin
                 ETShowStatus(1,'        .');
               end;
             end else begin
               ETShowStatus(1,'    .');
             end;
           except
             ETShowStatus(1,'    .');
           end;
         end;
      5: begin
           {   }
           ShowMessage('   ')
         end;
      else begin
      end;
    end;
    // ShowCustomerInfo;
  end;
  Result:= True;
end;

procedure TFormOper.CBAbonentKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  with DataModule1 do begin
    case Key of
    VK_DOWN: begin
           if SearchCategory = 4 then begin
             TableGrpDesc.Next;
           end else begin
             TableClient.Next;
           end;
           ShowCustomerInfo;
         end;
    VK_UP: begin
           if SearchCategory = 4 then begin
             TableGrpDesc.Prior;
           end else begin
             TableClient.Prior;
           end;
           ShowCustomerInfo;
         end;
    end;
  end;
end;

procedure TFormOper.CBAbonentKeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
  #13, #32: begin
         FindCustomer(CBAbonent.Text);
         CustomerSelected;
         SetDate(Date);
         Key:= #0;
       end;
  end;
end;

procedure TFormOper.RGAloneClick(Sender: TObject);
begin
  case RGRepeatNo.Checked of
  True: begin
       NoteBook1.ActivePage:= 'Alone';
       Repeatadly:= False;
     end;
  False: begin
       NoteBook1.ActivePage:= 'Repeats';
       if not Repeatadly then begin
         Repeatadly:= True;
       end;
     end;
  end;
  FillTime2Current;
end;

procedure TFormOper.RGSheduleClick(Sender: TObject);
begin
  case RGSheduleNo.Checked of
  True: begin
       NoteBook2.ActivePage:= 'Immediately';
       Sheduled:= False;
     end;
  False: begin
       NoteBook2.ActivePage:= 'Sheduled';
       Sheduled:= True;
     end;
  end;
end;

procedure TFormOper.FillDBCB(const SQLFN: String; List: TStrings; const ACaption: String);
var
  UsedFolder: SQLPathString;
begin
  UsedFolder:= SQLSYSFolder;
  with DataModule1, QDict do begin
    Close;
    SQL.LoadFromFile(ConcatPath(UsedFolder, SQLFN));
    if Use_Alias then begin
    end else begin
      { ChDir(EDBFolder.Text);
              -    SQL
      }
      {
      ChDir(WorkPlace);
      }
    end;
    Open;
    with List do begin
      Clear;
      while not EOF do begin
        Add(Fields[0].AsString);
        Next;
      end;
    end;
  end;
  if AboutBox <> Nil then begin
    AboutBox.LLoading.Caption:= ' : '+ ACaption;
  end else begin
    with StatusBar1
    do Panels[Panels.Count-1].Text:= ' : '+ ACaption;
  end;
  Application.ProcessMessages;
end;

procedure TFormOper.UpdateDBCBs;
begin
  try
    FillDBCB(SQLZONES, CBZone.Items, ' ');
    {    0..9? }
    FillDBCB(SQLKINDS, CBKind.Items, ' ');
  except
    ShowMessage('      .');
  end;
end;

procedure TFormOper.UpdateDisplayLabels;
var
  i: Integer;
begin
  with DataModule1 do begin
    { dbgrid labels }
    with TableClient do begin
      if Active then begin
        for i:= 1 to FieldCount do begin
          Fields[i-1].DisplayLabel:= GetToken(i, ',', CLIENTLABELS);
        end;
      end;
    end;
    with TableCalls do begin
      if Active then begin
        for i:= 1 to FieldCount do begin
          Fields[i-1].DisplayLabel:= GetToken(i, ',', CALLSLABELS);
        end;
      end;
    end;
    with TableGroups do begin
      if Active then begin
        for i:= 1 to FieldCount do begin
          Fields[i-1].DisplayLabel:= GetToken(i, ',', GROUPSLABELS);
        end;
      end;
    end;
    with TableGrpDesc do begin
      if Active then begin
        for i:= 1 to FieldCount do begin
          Fields[i-1].DisplayLabel:= GetToken(i, ',', GRPDescLABELS);
        end;
      end;
    end;
    {
    with TableModels do begin
      if Active then begin
        for i:= 1 to FieldCount do begin
          Fields[i-1].DisplayLabel:= GetToken(i, ',', ModelsLABELS);
        end;
      end;
    end;

    with TablePagers do begin
      if Active then begin
        for i:= 1 to FieldCount do begin
          Fields[i-1].DisplayLabel:= GetToken(i, ',', PagersLABELS);
        end;
      end;
    end;
    with TableOper do begin
      if Active then begin
        for i:= 1 to FieldCount do begin
          Fields[i-1].DisplayLabel:= GetToken(i, ',', OPERLABELS);
        end;
      end;
    end;
    }
  end;
end;

{       }
function TFormOper.FullFIO: String;
begin
  with DataModule1, TableClient do begin
    Result:=
      FieldByName('FAM').AsString + #32 +
      FieldByName('IM').AsString + #32 +
      FieldByName('OT').AsString + ','#32 +
      FieldByName('BUSINESS').AsString;
  end;
end;

{   ,    SearchCategory
}
procedure TFormOper.CustomerSelected;
begin
  with DataModule1 do begin
    if SearchCategory = 4 then begin
      CurGroup:= TableGrpDesc.FieldByName('GROUPID').AsString;
      {   - GATE   
      }
      CBPageCP.ItemIndex:= -1;
    end else begin
      CurAbonent:= TableClient.FieldByName('ABONENT').AsString;
      {    }
      CBPageCP.ItemIndex:= CBPageCP.Items.IndexOf(
        DataModule1.TableModels.FieldByName('CHARSET').AsString);
    end;
  end;
  ShowCustomerInfo;
end;

function  TFormOper.MsgQty(ADate: TDateTime): Word;
var
  Count: LongInt;
  CurDate: TDateTime;
  Lbl: String;
begin
  Count:= 0;
  with DataModule1 do begin
    TSAttach.TabHints.Text:= '+';
    UpdateAttachList;
    with TabSetMessages,Tabs do begin
      Clear;
      Add('&');
      TabIndex:= 0;
    end;
    with TableCalls do begin
      DisableControls;
      {
      IndexName:= 'IUPD';
      }
      SetKey;
      FieldByName('HCODE').AsString:= CurHCode;
      FieldByName('ABONENT').AsString:= CurAbonent;
      FieldByName('UPDATED').AsDateTime:= ADate;
      GotoNearest;

      CurDate:= Trunc(FieldByName('UPDATED').AsDateTime);
      TodayMessageCount:= 0;
      while not EOF do begin
        Inc(Count);
        if CurDate = Trunc(FieldByName('UPDATED').AsDateTime) then begin
          Inc(TodayMessageCount);
        end else begin
          TodayMessageCount:= 1;
          CurDate:= Trunc(FieldByName('UPDATED').AsDateTime);
        end;
        CurDate:= FieldByName('UPDATED').AsDateTime;
        if Trunc(FieldByName('UPDATED').AsDateTime - ADate) = 0 then begin
          {      }
          Lbl:= '&'+IntToStr(TodayMessageCount);
        end else begin
          {    -    }
          Lbl:= FormatDateTime('ddddd &', CurDate) + IntToStr(TodayMessageCount);
          {      XX  }
          if (Count > MsgListViewLimit) then begin
            Break;
          end;
        end;
        TabSetMessages.Tabs.Add(Lbl);
        Next;
      end;
      EnableControls;
    end;
  end;
  MMessage.Clear;
  Result:= Count;
end;

procedure TFormOper.SetDate(NewDate: TDateTime);
begin
  OperateDay:= NewDate;
  DateEdit1.Date:= NewDate;
  TSToday.TabIndex:= CyrDayOfWeek(DateEdit1.Date);
  DiffDays(Trunc(NewDate-Date));
  {         FormCreate }
  if not FirstTime
  then MsgQty(OperateDay);
end;

procedure TFormOper.TSTodayChange(Sender: TObject);
var
  dateofs: Integer;
begin
  // TTabControl su - 6 mo - 0
  dateofs:= (Sender as TTabControl).TabIndex - CyrDayOfWeek(Date);
  if dateofs > 0
  then Dec(dateofs, 7);
  SetDate(Date+dateofs);
end;

procedure TFormOper.DateEdit1Change(Sender: TObject);
begin
  SetDate(DateEdit1.Date);
end;

procedure TFormOper.DateEdit1DblClick(Sender: TObject);
begin
  SetDate(Date);
end;

{      NO
   No <= 0      False
}
function TFormOper.GotoCall(ADate: TDateTime; No: LongInt): Boolean;
var
  Count: LongInt;
begin
  Result:= False;
  if No <=0
  then Exit;
  Count:= 0;
  with DataModule1, TableCalls do begin
    DisableControls;
    {
    IndexName:= 'IUPD';
    }
    SetKey;
    FieldByName('HCODE').AsString:= CurHCode;
    FieldByName('ABONENT').AsString:= CurAbonent;
    FieldByName('UPDATED').AsDateTime:= ADate;
    GotoNearest;
    while not EOF do begin
      Inc(Count);
      if Count = No
      then begin
        Result:= True;
        Break;
      end;
      Next;
    end;
    EnableControls;
  end;
end;

{ ,    
  AKind: 0 -    
         1 -  
         2 -  
         3 -     
}
procedure TFormOper.ShowIsSent(AKind: Word);
var
  ch: Char;
  s: String;
  kind: Word;
begin
  //     ,   
  TabSetMessages.TabActiveColor:= clSilver;
  with DataModule1, TableCalls do begin
    // 'x' - , b( )-   ( ) o- 
    if AKind = 0 then begin
      try
        S:= FieldByName('DELIVERED').AsString;
      except
        S:= '';
      end;
      if Length(S) > 0
      then ch:= s[1]
      else ch:= #32;
      case ch of
      'X', 'x': kind:= 1;
      #32,'O', 'o': kind:= 2;
      else  kind:= 3; //  
      end;
    end else begin
      kind:= akind and $3;
    end;
    {   TabSetMessages}
    with TabSetMessages do begin
      case kind of
      1:begin
          TabActiveColor:= clGreen;
        end;
      2:begin
          TabActiveColor:= $004080FF;
        end;
      3:begin
          TabActiveColor:= clYellow;
        end;
      end;
      // Repaint;
    end;
  end;
end;

procedure TFormOper.FillCall;
var
  p: array[0..255] of Char;
  MsgSheduled: Boolean;
  TimeLong: TDateTime;
begin
  {  memo }
  with DataModule1, TableCalls do begin
    StrPLCopy(p, FieldByName('MSG').AsString, SizeOf(p));
    MMessage.Lines.SetText(p);
    CBZone.Text:= FieldByName('ZONE').AsString;
    CBLocalTime.Checked:= FieldByName('GMT').AsString = 'x';
    // METimes.Text:= IntToStr(Repeats);
    ESubj.Text:= FieldByName('SUBJ').AsString;
    CBKind.Text:= FieldByName('SKIND').AsString;
    TSAttach.TabHints.CommaText:= '"+",'+FieldByName('ATTACH').AsString;
    UpdateAttachList;
    if FieldByName('ZONE').IsNull or (FieldByName('ZONE').AsString = CurZone) then begin
      {   }
      if FieldByName('DELIVERED').IsNull or (FieldByName('DELIVERED').AsString = 'o')
      then ETShowStatus(1, '   ')
      else ETShowStatus(1, ' .');
    end else begin
      {   }
      if FieldByName('MAILED').IsNull or (FieldByName('MAILED').AsString = 'o')
      then ETShowStatus(1, '      ')
      else ETShowStatus(1, '    .');
    end;
    //   CountRepeats
    Repeatadly:= FieldByName('SREPEAT').AsString = 'x';
    MsgSheduled:= FieldByName('SSHEDULE').AsString = 'x';

    //      
    if MsgSheduled then begin
      TimeLong:= FieldByName('SFINISH').AsDateTime-
        FieldByName('SSTART').AsDateTime;
    end else begin
      if Repeatadly then begin
      TimeLong:= Frac(FieldByName('SFINISH').AsDateTime)-
        Frac(FieldByName('UPDATED').AsDateTime);
      end else TimeLong:= 0;
    end;
    //    24 
    if TimeLong < 0
    then TimeLong:= TimeLong + 1;

    TMStart:= Date+Time;
    TMFinish:= Date + Time + TimeLong;
    TMInterval:= 0; SetMin(TmInterval, FieldByName('SRPTMIN').AsInteger);

    DESend.Date:= TMStart;
    MEStart.Time:= TMStart;
    MEFinish.Time:= TMFinish;
    MEInterval.Time:= TMInterval;
    CountRepeats;
    RGSheduleYes.Checked:= MsgSheduled;
  end;
  Application.ProcessMessages;
end;

//  hint
procedure TFormOper.DiffDays(adateofs: Integer);
begin
  case adateofs of
  1..6, -14..-7: begin
        TSToday.Hint:= '  ';
        end;
  0   : begin
        TSToday.Hint:= '';
        end;
  -1  : begin
        TSToday.Hint:= '';
        end;
  -2  : begin
        TSToday.Hint:= '';
        end;
  -4..-3: begin
        TSToday.Hint:= IntToStr(Abs(adateofs)) + '  ';
        end;
  -6..-5: begin
        TSToday.Hint:= IntToStr(Abs(adateofs)) + '  ';
        end;
    else TSToday.Hint:= FormatDateTime('dddd, mmmm d', DateEdit1.Date);    
  end;
end;

{      }
function  TFormOper.CheckMsg: Boolean;
begin
  Result:= True;
end;

{      }
procedure TFormOper.SendMsg;
var
  s: String;
begin
  repeat
    Application.ProcessMessages;
    //      
  until DataModule1.DBBusy = 0;
  //  ,     
  Inc(DataModule1.DBBusy);
  {  memo }
  try
    with DataModule1, TableCalls do begin
      Append;
      FieldByName('HCODE').AsString:= CurHCode;
      FieldByName('ABONENT').AsString:= CurAbonent;
      FieldByName('UPDATER').AsInteger:= CurUPDATER;
      FieldByName('UPDATED').AsDateTime:= Date;
      FieldByName('UPDTIME').AsDateTime:= Time;
      FieldByName('MSGNO').AsInteger:= TodayMessageCount;
      FieldByName('MSG').AsString:= StrPas(MMessage.Lines.GetText);
      FieldByName('CHARS').AsInteger:= CurMsgChars;
      FieldByName('WORDS').AsInteger:= CurMsgWords;
      FieldByName('ZONE').AsString:= CBZone.Text;
      FieldByName('SUBJ').AsString:= ESubj.Text;
      S:= TSAttach.TabHints.CommaText;
      S:= Copy(S, Pos(',', s)+1, 64);
      FieldByName('ATTACH').AsString:= S;
      //  ShowMessage('  -  attach      1 ');
      {     ,    -  }
      if RGSheduleYes.Checked then begin
        FieldByName('SSHEDULE').AsString:= 'x';
        {   ,    
        }
        FieldByName('SDATE').AsDateTime:= DESend.Date;
        FieldByName('SSTART').AsDateTime:= TMStart;
        {  GMT = x -    
        o -    (      )
        }
        if CBLocalTime.Checked
        then FieldByName('GMT').AsString:= 'x'
        else FieldByName('GMT').AsString:= 'o';
      end else begin
        FieldByName('SSHEDULE').AsString:= 'o';
        {   ,      
        }
        FieldByName('SDATE').Clear;
        FieldByName('SSTART').Clear;
        {   GMT }
        FieldByName('GMT').Clear;
      end;
      if Repeatadly then begin
        {      }
        FieldByName('SFINISH').AsDateTime:= TMFinish;
        FieldByName('SRPTMIN').AsInteger:= GetMin(TMInterval);
        {   -  }
        FieldByName('REPEATED').AsInteger:= 0;
        FieldByName('SREPEAT').AsString:= 'x';
      end else begin
        {        }
        FieldByName('REPEATED').Clear;
        {  ,       }
        FieldByName('SFINISH').Clear;
        FieldByName('SRPTMIN').Clear;
        FieldByName('SREPEAT').AsString:= 'o';
      end;
      {    - (aplhanumeric ascending)
            ()   
      }
      FieldByName('SKIND').AsString:= Copy(CBKind.Text, 1, 1);
      {       }
      FieldByName('MAILED').AsString:= 'o';
      FieldByName('DELIVERED').AsString:= 'o';
      Post;
    end;
  finally
    Dec(DataModule1.DBBusy);
  end;
end;

procedure TFormOper.TabSetMessagesChange(Sender: TObject);
begin
  if GotoCall(OperateDay, (Sender as TTabControl).TabIndex) then begin
    FillCall;
    ShowIsSent(0)
  end else begin
    {    0      
       
    }
    FillTime2Current;
    ShowIsSent(2);
  end;
end;

procedure TFormOper.CalcMemoWords;
begin
  {     }
{  Chars:= MMessage.GetTextLen;}
  CurMsgChars:= 0;
  CurMsgWords:= PCountWords(CurMsgChars, MMessage.Lines.GetText);
  {   / }
  with StatusBar1 do begin
    Panels[1].Text:= ':'+IntToStr(CurMsgWords) + ' :'+ IntToStr(CurMsgChars);
  end;
end;

{        
      
  True- Ok
  False -        ( XLAT 
                )
}
function TFormOper.CPVerifyKey(var Key: Char): Boolean;
begin
  {       
         XLAT ,   
      
  }
  if (CBPageCP.ItemIndex < 0) or (CBPageCP.ItemIndex >= cploadedCount) then begin
    Result:= True;
    Exit;
  end;
  with PagerCodeDefs^[CBPageCP.ItemIndex] do begin
    if Byte(Key) in InUse then begin
      Result:= True;
    end else begin
      Result:= False;
    end;
  end;
end;

{  MMessage memo     
   d LineNo  CharNo    
}
function  TFormOper.CPVerifyEnteredText(var LineNo, CharNo: Integer): Boolean;
var
  r, c: Integer;
  S: String;
begin
  {}
  if (CBPageCP.ItemIndex < 0) or (CBPageCP.ItemIndex >= cploadedCount) then begin
    Result:= True;
    Exit;
  end;
  for r:= 1 to MMessage.Lines.Count do begin
    for c:= 1 to Length(MMessage.Lines[r-1]) do begin
      S:= MMessage.Lines[r-1];
      if not (Byte(MMessage.Lines[r-1][c]) in PagerCodeDefs^[CBPageCP.ItemIndex].InUse)
      then begin
        LineNo:= r;
        CharNo:= c;
        Result:= False;
        Exit;
      end;
    end;
  end;
  Result:= True;
end;

procedure TFormOper.CBAbonentClick(Sender: TObject);
begin
  {    }
  // SelectCustomer;
end;

procedure TFormOper.FormActivate(Sender: TObject);
begin
  if FirstTime then begin
    { debug -  }
    DataModule1.DataBase1.Connected:= False;
    Repeatadly:= False;
    Sheduled:= False;
    LoadIni;
    ShowOperatorInfo(CurZone, CurHCode, CurUPDATER);
    {  -     (    memo) }
    CalcMemoWords;
    SetDate(Date);
    //         
    CustomerSelected;
    FirstTime:= False;
  end;
end;

procedure ShowAdditionalForm(AForm: TForm);
begin
  with AForm do begin
    if Screen.Height < 600 then begin
      //  
      Top:= FormOper.Top + FormOper.Notebook2.Top;
      Left:= FormOper.Left + 2;
    end else begin
      if Screen.Height < 600 then begin
        //  
        Top:= FormOper.Top + FormOper.Height;
        Left:= FormOper.Left + 2;
      end else begin
        //  
        Top:= FormOper.Top + FormOper.Height;
        Left:= FormOper.Left + 2;
      end
    end;
    Show;
  end;
end;

procedure TFormOper.TBViewAbonentListClick(Sender: TObject);
begin
  ShowAdditionalForm(FormAbonents);
end;

procedure TFormOper.TBViewMsgListClick(Sender: TObject);
begin
  ShowAdditionalForm(FormClientMessages);
end;

procedure TFormOper.TBViewVoiceListClick(Sender: TObject);
begin
  if Voices.FormVoicesOnScreen then begin
    FormVoices.Free;
  end else begin
    FormVoices:= TFormVoices.Create(Application);
    FormVoices.Font.Name:= Font.Name;
    FormVoices.Show;
  end;
end;

procedure TFormOper.TBViewGroupListClick(Sender: TObject);
begin
  ShowAdditionalForm(FormGroups);
end;

procedure TFormOper.TBSendClick(Sender: TObject);
begin
  if TabsetMessages.TabIndex <> 0 then begin
    if Application.MessageBox
      (' ?', ' ', MB_YesNo) = idNo then begin
      Exit;
    end;
  end;
  if CheckMsg then begin
    SendMsg;
    if Repeatadly then begin
  //    Sheduled:= False;
      {     }
      FillTime2Current; //   -   
    end;
    MsgQty(OperateDay);
  end;
end;

{      CurUpdater
  0- 
}
function  TFormOper.UserLevel: Word;
begin
  Result:= 0;
end;

function  TFormOper.UserCan(const Operation: string): Boolean;
var
  Level: Word;
begin
  {     CurUpdater }
  // Level:=
  UserLevel;
  // 'DEL-GROUP' -  
  Result:= True;
end;

procedure TFormOper.DESendAcceptDate(Sender: TObject; var Date: TDateTime;
  var Action: Boolean);
begin
  if Repeatadly
  then CountRepeats;
end;

procedure TFormOper.DESendDblClick(Sender: TObject);
begin
  //      
  DESend.Date:= Date;
end;

procedure TFormOper.MEStartDblClick(Sender: TObject);
begin
  //      
  MEStart.Time:= Time;
  MEStartChange(Self);
end;

procedure TFormOper.SetDictionary(const APath: String);
begin
  UseDict:= False;
  if APath <> '' then begin
    if FileExists(APath) then begin
      LBDict.Items.LoadFromFile(APath);
      UseDict:= True;
      SetNameInMenu(MOptionsDictionary, '&', APath);
    end else begin
      LBDict.Clear;
      SetNameInMenu(MOptionsDictionary, '&', ' ');
    end;
  end;
end;

procedure TFormOper.MMessageChange(Sender: TObject);
begin
  CalcMemoWords;
  UpdateCursorPos;
end;

procedure TFormOper.MMessageKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ind: Integer;
  x, y: Integer;
  line, Ins: String;
begin
  case Key of
  VK_RETURN:begin
             ind:= LBDict.ItemIndex;
             if ind >=0 then begin
               ins:= LBDict.Items[ind];
               if usedict and (ind >= 0) then begin
                 // line:= GetRichPos(MMessage, y, x);
                 line:= GetMemoPos(MMessage, y, x);
                 InsertWord(Ins, Line, x);
                 MMessage.Lines[y]:= Line;
               end;
             end;
           end;
  VK_DOWN: begin
           LBDict.ItemIndex:= LBDict.ItemIndex + 1;
           Key:= 0;
           end;
  VK_UP:   begin
           LBDict.ItemIndex:= LBDict.ItemIndex - 1;
           Key:= 0;
           end;
  VK_LEFT, VK_RIGHT: begin
           UpdateCursorPos;
           end;
  else;
  end;
end;

procedure TFormOper.MMessageKeyPress(Sender: TObject; var Key: Char);
var
  L, C: Integer;
begin
  if Key = #13 then begin
    Key:= #0;
    Exit;
  end;
  {     }
  TabSetMessages.TabIndex:= 0;
  {        
  }
  if CPVerifyEnteredText(L, C) then begin
    //  OK
    ETShowStatus(0, '');
  end else begin
    //    
    ETShowStatus(0, IntToStr(c) + '    '+IntToStr(L)+'    ');
  end;
end;

procedure TFormOper.UpdateCursorPos;
var
  S: String;
  len: Integer;
  xy: TPoint;
begin
//ETShowStatus(0, IntToStr(x)+':'+IntToStr(y));
  S:= GetMemoPos(MMessage, xy.y, xy.x);
  StatusBar1.Panels[2].Text:= Format('%3d:%3d', [xy.Y+1, xy.X]);
  if usedict and (FShowKind <> 0) then begin
    S:= GetLineWord(S, xy.x, len);
    GetSelCharXY(MMessage, xy.x, xy.y);
    xy:= FormOper.ScreenToClient(MMessage.ClientToScreen(xy));
    xy.x:= MaxFrom2(xy.x, FormOper.Width - LBDict.Width - 64); // scrollbar
    LBDict.Left:= xy.x;
    LBDict.Top:= xy.y+2*Abs(LBDict.Font.Height);
    if FShowKind = 1 then begin
      //     
      LBDict.ItemIndex:= FindExactStartSortedStrings(LBDict.Items, S);
      LBDict.Visible:= LBDict.ItemIndex >= 0;
    end else begin
      LBDict.ItemIndex:= FindSortedStrings(LBDict.Items, S);
      if FShowKind = 2 then begin
        //  - 
      end else begin
        // 
        //   
      end;
    end;
  end;
end;

{
procedure TFormOper.UpdateCursorPos;
var
  S: String;
  start: Integer;
  i, x, y, len: Integer;
begin
  S:= GetMemoPos(MMessage, y, x);
  StatusBar1.Panels[2].Text:= Format('%3d:%3d', [Y+1, X]);
  S:= GetLineWord(S, x, len);
  if (LBDict.ItemIndex = -1) or (ANSICompareText(LBDict.Items[LBDict.ItemIndex], S) > 0)
  then start:= 1
  else start:= LBDict.ItemIndex;
  if UseDict then begin
    for i:= start to LBDict.Items.Count do begin
      if ANSICompareText(LBDict.Items[i-1], S) >=0 then begin
        LBDict.ItemIndex:= i-1;
        Break;
      end;
    end;
  end;
end;
}


procedure TFormOper.MMessageClick(Sender: TObject);
begin
  UpdateCursorPos;
end;

procedure TFormOper.MViewShowDictClick(Sender: TObject);
begin
  (Sender as TMenuItem).Checked:= True;
  SetDictStyle;
end;

// ShowDictKind property methods
procedure TFormOper.SetShowDictKind(AKind: Word);
begin
  MViewShowDictNo.Checked:= AKind = 0;
  MViewShowDictIfExists.Checked:= AKind = 1;
  MViewShowDictTimeout.Checked:= AKind = 2;
  MViewShowDictAllways.Checked:= AKind = 3;
  FShowKind:= AKind;
end;

function  TFormOper.GetShowDictKind: Word;
var
  k: Integer;
begin
  {}
  k:= 0;
  if MViewShowDictIfExists.Checked
  then k:= 1 else
    if MViewShowDictTimeout.Checked
    then k:= 2 else
      if MViewShowDictAllways.Checked
      then k:= 3;
  FShowKind:= k;
  Result:= k;
end;

procedure TFormOper.SetDictStyle;
begin
  LBDict.Visible:= False;
  case ShowDictKind of //        FShowKind
  0: begin //   
     end;
  1: begin //  
       //     UpdateCursorPos
     end;
  2: begin //  - 
       //  ,   
     end;
  3: begin // 
       LBDict.Visible:= True;
     end;
  end;
end;

procedure TFormOper.MViewShowDictionaryClick(Sender: TObject);
begin
  if usedict then begin
    MViewShowDictNo.Enabled:= True;
    MViewShowDictIfExists.Enabled:= True;
    MViewShowDictTimeout.Enabled:= True;
    MViewShowDictAllways.Enabled:= True;
  end else begin
    MViewShowDictNo.Enabled:= False;
    MViewShowDictIfExists.Enabled:= False;
    MViewShowDictTimeout.Enabled:= False;
    MViewShowDictAllways.Enabled:= False;
  end;
end;

procedure TFormOper.popMsgCountClick(Sender: TObject);
begin
  {    }
  MsgQty(OperateDay);
end;

procedure TFormOper.SBPhoneCallClick(Sender: TObject);
begin
  with datamodule1.tapidev do begin
    if HaveTalk then begin
      CancelCall;
      HaveTalk:= False;
    end else begin
      Dial(optapi.DialPrefix+MEPhone.Text);
      HaveTalk:= True;
    end;
  end;
end;

procedure TFormOper.popAttachAddClick(Sender: TObject);
var
  ind: Integer;
begin
  ind:= TSAttach.TabIndex;
  if ind > 0 then begin
    TSAttach.TabHints.Delete(ind);
    UpdateAttachList;
  end;
end;

procedure TFormOper.popAttachClearClick(Sender: TObject);
begin
  TSAttach.TabHints.Clear;
  UpdateAttachList;
end;

procedure TFormOper.MOptionsCopyLinkClick(Sender: TObject);
begin
  {        DDE }
  Datamodule1.itemAbonent.CopyToClipboard;
end;

procedure TFormOper.MViewHotAreasClick(Sender: TObject);
begin
  {}
  MViewHotAreas.Checked:= not MViewHotAreas.Checked;
end;

procedure TFormOper.StatusBar1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  { debug  StatusBar1.Panels[0].Text:= IntToStr(X)+ ':' + IntToStr(Y); }
  //  
  if MViewHotAreas.Checked then with FormClientMessages do begin
    Top:= FormOper.BoundsRect.Bottom - Height;
    Left:= FormOper.Left;
    Show;
  end;
end;

procedure TFormOper.TBViewAbonentListMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if MViewHotAreas.Checked then with FormAbonents do begin
    // Top:= FormOper.BoundsRect.Bottom - Height;
    Top:= FormOper.Top + GroupBox1.Top + 32;
    Left:= FormOper.Left;
    Show;
  end;
end;

procedure TFormOper.TBViewGroupListMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if MViewHotAreas.Checked then with FormGroups do begin
    // Top:= FormOper.BoundsRect.Bottom - Height;
    Top:= FormOper.Top + GroupBox1.Top + 64;
    Left:= FormOper.Left;
    Show;
  end;
end;

procedure TFormOper.MViewOnTopClick(Sender: TObject);
begin
  MViewOnTop.Checked:= not MViewOnTop.Checked;
  if MViewOnTop.Checked then begin
    FormGroups.FormStyle:= fsStayOnTop;
    FormClientMessages.FormStyle:= fsStayOnTop;
    // FormVoices.FormStyle:= fsStayOnTop;   
    FormAbonents.FormStyle:= fsStayOnTop;
  end else begin
    FormGroups.FormStyle:= fsNormal;
    FormClientMessages.FormStyle:= fsNormal;
    // FormVoices.FormStyle:= fsNormal;
    FormAbonents.FormStyle:= fsNormal;
  end;
end;

end.
