unit Cycles;
(*##*)
(*******************************************************************
*                                                                 *
*   C  Y  C  L  E  S           EPAGER's unit.                      *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   DDE server- dynamically open DDE channel to EQ    processor   *
*   Conditional defines: ---                                       *
*                                                                 *
*   Last Revision: Mar 19 1998                                     *
*   Last fix     : Mar 19 1998                                    *
*   Lines        : 1166                                            *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, IniFiles,
  pcommon, tap, util1, Grids, ExtCtrls, EDdeMan, Menus;

const
  iniCyclesDefSect  = 'CyclesDefs';
  iniSheduleSect    = 'Shedule';
  iniWAIT           = 'Wait';    //     
  iniTimeOut        = 'TimeOut';
  iniDDEServer      = 'DDEServer';
  iniITEMSSect      = 'DDEServerItems'; //    Topic=Item,Value
  //   Status,  OnExecuteMacro
  mst_ready       = 0; //    
  mst_waitconfirm = 1; //  
  mst_sent        = 2; //  
  mst_failed      = 3; //   

type
  //    DLL 
  FADLLProc = array [0..1] of TFarProc;
  TADLLProc = ^FADLLProc;

  RCycle = record
    Enabled: Boolean;    //   
    // Kind   : Char;    // +  P- ,  (T)- TAP 
    // Cycles:  Word;    //  
    Module:  String32;   //     ()
    Name  :  String32;   //  
    Serv  : String32;    //  
    Func: Word;          // (    DLL)
    Param: String32;     //  
    Started: Boolean;    //    
    MsgID: LongInt;      //   
    Status: Byte;        //  -  OnExecuteMacro
    SOk: String32;       //  "   "
    SFail: String32;     //  " "
  end;
  PCycle  = ^RCycle;
  FCycles = array[0..99] of RCycle; // 99  -   
  TCycles = record
    Started: Boolean;     //   
    ModuleCount: Word;    //  
    // CurModule: Word;   //    (0..)
    CurCycle: Word;       //     (0..)
    WaitSec: Word;
    TimeOutSec: Word;
    Cycles: ^FCycles;
    TopicItems: TStringList;
    DDEServerName: String32;
  end;

  TFormCycles = class(TForm)
    Memo1: TMemo;
    StatusBar1: TStatusBar;
    pmItems: TPopupMenu;
    pmItemAdd: TMenuItem;
    pmItemSub: TMenuItem;
    pmTopics: TPopupMenu;
    pmAddTopic: TMenuItem;
    pmDeleteTopic: TMenuItem;
    PanelControls: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    EInterval: TEdit;
    UDInterval: TUpDown;
    EServerName: TEdit;
    PanelButtons: TPanel;
    BtnOK: TButton;
    BtnCancel: TButton;
    BStart: TButton;
    BStop: TButton;
    BCopyBuffer: TButton;
    BTest: TButton;
    ETimeOut: TEdit;
    UDTimeOut: TUpDown;
    Label3: TLabel;
    PanelElements: TPanel;
    SGElements: TStringGrid;
    Splitter1: TSplitter;
    HeaderControl2: THeaderControl;
    PanelNavigate: TPanel;
    Splitter3: TSplitter;
    LVCycles: TListView;
    PanelCycle: TPanel;
    Splitter2: TSplitter;
    SGCycle: TStringGrid;
    pmExe: TPopupMenu;
    pmAddExe: TMenuItem;
    pmOptsExe: TMenuItem;
    procedure BStartClick(Sender: TObject);
    procedure BStopClick(Sender: TObject);
    procedure BCopyBufferClick(Sender: TObject);
    procedure BTestClick(Sender: TObject);
    procedure pmItemAddClick(Sender: TObject);
    procedure pmItemSubClick(Sender: TObject);
    procedure pmAddTopicClick(Sender: TObject);
    procedure pmDeleteTopicClick(Sender: TObject);
    procedure SGElementsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure HeaderControl2SectionResize(HeaderControl: THeaderControl;
      Section: THeaderSection);
    procedure LVCyclesClick(Sender: TObject);
    procedure LVCyclesKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LVCyclesEdited(Sender: TObject; Item: TListItem;
      var S: String);
    procedure pmAddExeClick(Sender: TObject);
    procedure EIntervalChange(Sender: TObject);
    procedure pmOptsExeClick(Sender: TObject);
    procedure EServerNameChange(Sender: TObject);
//    procedure EDdeServerConvExecuteMacro(Sender: TObject; Msg: TStrings);
  private
    { Private declarations }
    oldcycle: Integer;
  public
    procedure FillCycle(var ACycles: TCycles; no: Integer; AReturn, AFillOther: Boolean);
    procedure FillCycles(var ACycles: TCycles);
    procedure ViewElementsSG(const ATopic: String);
  end;

var
  FormCycles: TFormCycles;
  //        DlgCycles
  PCurModuleCycles: ^TCycles;
{  .
    ACycles ( Nil, ).     
  
    True   
    False  
}
function  CreateCyclesStruct(ACount: Word; var ACycles: TCycles): Boolean;

{  .
    No (0,..)  
}
procedure DeleteItemFromCycles(No: Word; var ACycles: TCycles);

procedure FreeCyclesStruct(var ACycles: TCycles);

{  .
  ACycles      Nil.
     ACycles <> Nil,   
  
  True-   (  )
  ACycles
}
function CyclesLoadIni(var ACycles: TCycles): Boolean;

{  . Cycles.Cycles    
  
  True-  
}
function CyclesStoreIni(ACycles: TCycles): Boolean;

{    .
  ACycles.Cycles     Nil.
  
  True   -   
  ACycles-  
}
function DlgCycles(var ACycles: TCycles; AStore: Boolean): Boolean;

{  ,    ACycles
  AOwner   - -    DDE
  ACycles  - 
  AFarProcs-    DLL
  AServ    -    DDE
  AItem1   -    DDE
   True-     
             False-        
    ACycles   Started  True  False
}
function StartDDE_DLL(AOwner: TComponent;
  var ACycles: TCycles;         // 
  var AFarProcs: TADLLProc;     //    DLL
  var AServ: TAEDDEServConv;    //    DDE
  var AItem1: TAEDDEServItem;   //    DDE
  AExecuteMacro: TMacroEvent
): Boolean;

function StopDDE_DLL(var ACycles: TCycles; var AFarProcs: TADLLProc;
  var AServ: TAEDDEServConv; var AItem1: TAEDDEServItem): Boolean;

//  

//    (item)   (topic')
function  ItemsOnTopic(ACycles: TCycles; const ATopic: String): Integer;
//      Nm-  item    Vl-  item ( )
function TopicGetItemNVal(ACycles: TCycles; const ATopic: String; No: Integer;
  var Nm, Vl: String): Boolean;

//    
//   .   ,  Nil
function GetCycle(ACycles: TCycles; const ATopic: String): PCycle;
//       ATopic- topic, Nm-    item ()
//  True,   , False-     
function GetTopicItemVal (ACycles: TCycles; No: Integer;
  var ATopic, Nm, Vl: String): Boolean;
//      No item
function TopicSetItemNVal(ACycles: TCycles; const ATopic: String;
  No: Integer; const Nm, Vl: String): Boolean;
//    item
procedure TopicAddItemNVal(ACycles: TCycles; const ATopic: String);
//  item no
function TopicDeleteItemNVal(ACycles: TCycles; const ATopic: String; No: Integer): Boolean;
//      " "  
function CompTopicRet(ACycles: TCycles; const ATopic: String; const ARet: String): Integer;

//     
procedure SetCycleStatuses(ACycles: TCycles; AStatus: Byte);

implementation

uses DModule, EQ;

{$R *.DFM}

{ ViewElementsSG         ATopic
    SGElements.    ,     
   "" 
}
procedure TFormCycles.ViewElementsSG(const ATopic: String);
var
  i, r: Integer;
  SItem, SValue, SOk, SFail: String;
begin
  with SGElements do begin
    // r-   (item)   (topic')
    r:= ItemsOnTopic(PCurModuleCycles^, ATopic);
    if r = 0 then begin
      //   
      RowCount:= 1;
      Rows[0].Clear;
      //    popupmenu    
      //     "" 
      //SGElements.Enabled:= False;
      SGElements.Color:= clInactiveBorder;
    end else begin
      //   
      SGElements.Color:= clWindow;
      //SGElements.Enabled:= True;
      RowCount:= r;
      //    item, value
      for i:=  0 to r - 1 do begin
        //      item = i
        TopicGetItemNVal(PCurModuleCycles^, ATopic, i, SItem, SValue);
        // 
        Cells[0, i]:= SItem;
        Cells[1, i]:= SValue;
        Cells[2, i]:= SOk;
        Cells[3, i]:= SFail;
      end;
    end;
  end;
end;

{      
}
procedure   TFormCycles.FillCycles(var ACycles: TCycles);
var
  no: Integer;
  li: TListItem;
begin
  {    SGCycles
    1      2      3   4  5
      No  Ok Fail
  }
  with LVCycles do begin
    //      
    EServerName.Text:= ACycles.DDEServerName;
    UDInterval.Position:= ACycles.WaitSec;
    UDTimeOut.Position:=  ACycles.TimeOutSec;
    // ACycles.ModuleCount -      
    LVCycles.Items.Clear;
    SGCycle.Cells[0, 0]:= '';
    SGCycle.Cells[1, 0]:= '';
    SGCycle.Cells[0, 1]:= '';
    SGCycle.Cells[0, 2]:= '';
    SGCycle.Cells[0, 3]:= 'No';
    SGCycle.Cells[0, 4]:= '""';
    SGCycle.Cells[0, 5]:= '""';
    SGCycle.Cells[0, 6]:= '()';
    for no:= 0 to ACycles.ModuleCount - 1 do begin
      li:= LVCycles.Items.Add;
      li.SubItems.Add('?');
      FillCycle(ACycles, no, False, no=0);
    end;
  end;
end;

procedure   TFormCycles.FillCycle(var ACycles: TCycles; no: Integer;
  AReturn, AFillOther: Boolean);
var
  li: TListItem;
  TopicN: String;
  i: Integer;
begin
  {    SGCycles
    1      2      3   4  5
      No  Ok Fail
  }
  with LVCycles do if (no < LVCycles.Items.Count) and (no >=0) then begin
    li:= LVCycles.Items.Item[no];
    TopicN:= ACycles.Cycles^[LI.Index].Serv;
    if AReturn then begin
      //      
      // SGElements
      //   item,  stringgrid row    <1,  item
      for i:= 1 to ItemsOnTopic(ACycles, TopicN) do begin
        //      i-1 item
        TopicSetItemNVal(ACycles, TopicN, i-1,
          SGElements.Cells[0, i-1], SGElements.Cells[1, i-1]);
      end;
      // TListView
      for i:= 0 to LVCycles.Items.Count-1 do begin
        ACycles.Cycles^[i].Enabled:= LVCycles.Items.Item[i].Checked;
      end;
      // : ACycles.Cycles^[no].Enabled:= li.Checked;
      // .    Checkbox -      
      //   (OnChange).      OnExit
      ACycles.Cycles^[no].Name:=  li.Caption;
      // SGCycle
      ACycles.Cycles^[no].Module:= SGCycle.Cells[1, 1];
      ACycles.Cycles^[no].Serv:=  SGCycle.Cells[1, 2];
      ACycles.Cycles^[no].Func:= StrToIntDef(SGCycle.Cells[1, 3], 1);
      ACycles.Cycles^[no].SOk:=  SGCycle.Cells[1, 4];
      ACycles.Cycles^[no].SFail:= SGCycle.Cells[1, 5];
      ACycles.Cycles^[no].Param:= SGCycle.Cells[1, 6];
    end else begin
      //      
      // TListView
      li.Caption:= ACycles.Cycles^[no].Name;
      li.Checked:= ACycles.Cycles^[no].Enabled;
      if (Pos('.EXE', AnsiUpperCase(ACycles.Cycles^[no].Module))>0)
      then li.SubItems[0]:= 'DDE '
      else li.SubItems[0]:= ' ';
      if AFillOther then begin
        //    
        // SGElements
        ViewElementsSG(TopicN);
        // SGCycle
        SGCycle.Cells[1, 1]:= ACycles.Cycles^[no].Module;
        SGCycle.Cells[1, 2]:= ACycles.Cycles^[no].Serv;
        SGCycle.Cells[1, 3]:= IntToStr(ACycles.Cycles^[no].Func);
        SGCycle.Cells[1, 4]:= ACycles.Cycles^[no].SOk;
        SGCycle.Cells[1, 5]:= ACycles.Cycles^[no].SFail;
        SGCycle.Cells[1, 6]:= ACycles.Cycles^[no].Param;
      end;
    end;
  end;
end;

{  .
    ACycles ( Nil, )
   ACount = 0,      
  
    True   
    False  
}
function CreateCyclesStruct(ACount: Word; var ACycles: TCycles): Boolean;
var
  MS: Integer;
  ANewOne: Boolean;
begin
  Result:= False;
  ANewOne:= ACycles.Cycles = Nil;
  //  0    
  if ACount > 0
  then ACycles.ModuleCount:= ACount;
  //      
  if ACycles.ModuleCount = 0
  then Exit;
  //   
  MS:= ACycles.ModuleCount * SizeOf(FCycles);
  //   item
  if ANewOne then begin
    ACycles.TopicItems:= TStringList.Create;
    ACycles.TopicItems.Duplicates:= dupAccept;
  end else begin
    // if ACycles.TopicItems <> Nil
    // then ACycles.TopicItems.Clear;
  end;
  //       
  //   (    ) 
  ReAllocMem(ACycles.Cycles, MS);
  Result:= ACycles.Cycles <> Nil;
end;

{  .
    No (0,..)  
}
procedure DeleteItemFromCycles(No: Word; var ACycles: TCycles);
begin
  if (ACycles.ModuleCount > 0) and (ACycles.Cycles <> Nil) then begin
    {   no (no+1,..  ACycles.ModuleCount-1 ) 
          }
    System.Move(ACycles.Cycles^[no+1], ACycles.Cycles^[no],
      (ACycles.ModuleCount-no) *SizeOf(FCycles));
    {     
    }
    CreateCyclesStruct(ACycles.ModuleCount-1, ACycles);
  end;
end;

procedure FreeCyclesStruct(var ACycles: TCycles);
begin
  //       DLL, 
  //  TFarProc, DDEServConv  DDEServItem?
  if (ACycles.ModuleCount > 0) and (ACycles.Cycles <> Nil) then begin
    if ACycles.TopicItems <> Nil
    then ACycles.TopicItems.Free;
    if ACycles.Cycles <> Nil
    then Freemem(ACycles.Cycles);
    ACycles.ModuleCount:= 0;
    //  
    ACycles.TopicItems:= Nil;
    ACycles.Cycles:= Nil;
  end;
end;

{  .
  ACycles      Nil.
     ACycles <> Nil,   
  
  True-   (  )
  ACycles
   
    ,    
}
function CyclesLoadIni(var ACycles: TCycles): Boolean;
var
  Ini: TIniFile;
  L: Integer;
  CyclesDefList: TStringList;
  S, ValueStr: String;
  i, b: Integer;
begin
  Result:= False;
  Ini:= TIniFile.Create(iniPagerOPTINIFN);
  CyclesDefList:= TStringList.Create;
  with ACycles, Ini do begin
    DDEServerName:= ReadString(iniSheduleSect, iniDDEServer, 'EGATE');
    if ddemgr <> nil
    then ddemgr.AppName:= DDEServerName;
    WaitSec:= ReadInteger(iniSheduleSect, iniWait, 1);
    TimeOutSec:= ReadInteger(iniSheduleSect, iniTimeOut, 30);
    ReadSectionValues(iniCyclesDefSect, CyclesDefList);
    //    -   
    ModuleCount:= CyclesDefList.Count;
    // 0- -     ACycles
    CreateCyclesStruct(0, ACycles);
    //    (0..)
    //      < ModuleCount
    // CurModule:= 0;
    //     (0..)
    //    
    CurCycle:= 0;
    Started:= False;

    //  Topic=Item,Value
    ReadSectionValues(iniITEMSSect, ACycles.TopicItems);
    {   0001Item,.. }
    for i:=  1 to ACycles.TopicItems.Count do begin
      S:= System.Copy(ACycles.TopicItems.Strings[i-1], 1, 4);
      {      4  }
      if Length(S) >= 4 then begin
        {    ,    }
        if isHexaDecimal(S) then begin
          S:= ACycles.TopicItems.Strings[i-1];
          System.Delete(S, 1, 4);
          ACycles.TopicItems.Strings[i-1]:= S;
        end;
      end;
    end;
    //  
    for i:= 1 to ModuleCount do begin
      {   }
      S:= GetToken(1, '=', CyclesDefList.Strings[i-1]);
      ACycles.Cycles^[i-1].Name:= Copy(S, 1, 32);
      b:= Pos('=', CyclesDefList.Strings[i-1]);
      if b > 0 then begin
        ValueStr:= System.Copy(CyclesDefList.Strings[i-1], b+1, Length(CyclesDefList.Strings[i-1])-b);
      end else begin
        // ?!!
        ValueStr:= CyclesDefList.Strings[i-1];
      end;
//           1          2        3          4
// =<>,<>,< DDE>,<No >, "", ""
      with ACycles.Cycles^[i-1] do begin
        {  }
        S:= GetToken(1, ',', ValueStr);
        b:= StrToIntDef(S, 0);
        ACycles.Cycles^[i-1].Enabled:= b = 1;
        {  }
        S:= GetToken(2, ',', ValueStr);
        Module:= Copy(S, 1, 32);
        {  }
        S:= GetToken(3, ',', ValueStr);
        Serv:= Copy(S, 1, 32);
        { No  -  }
        S:= GetToken(4, ',', ValueStr);
        b:= StrToIntDef(S, 1);
        Func:= b;
        { SOk    ""}
        SOk:= GetToken(5, ',', ValueStr);
        { SFail  ""}
        SFail:= GetToken(6, ',', ValueStr);
        { Param  }
        Param:= GetToken(7, ',', ValueStr);
        {   ,     }
        Started:= False;
      end;
    end;
  end;
  CyclesDefList.Free;
  Ini.Free;
  // True    1  
  Result:= ACycles.ModuleCount > 0;
end;

{  . ACycles    
  
  True-  
}
function CyclesStoreIni(ACycles: TCycles): Boolean;
var
  Ini: TIniFile;
  L: Integer;
  CyclesDefList: TStringList;
  S: String;
  i, b: Integer;
begin
  Result:= False;
  Ini:= TIniFile.Create(iniPagerOPTINIFN);
  CyclesDefList:= TStringList.Create;
  with ACycles, Ini do begin
    //   
    WriteString(iniSheduleSect, iniDDEServer, DDEServerName);
    WriteInteger(iniSheduleSect, iniWait, WaitSec);
    WriteInteger(iniSheduleSect, iniTimeOut, TimeOutSec);
    //  Topic=Item,Value
    EraseSection(iniITEMSSect);
    for i:= 1 to ACycles.TopicItems.Count do begin
      //   Topic=Item,Value
      WriteString(iniITEMSSect,
        //    
        IntToHex(i, 4)+
        GetToken(1, '=', ACycles.TopicItems[i-1]),
        GetToken(2,  '=', ACycles.TopicItems[i-1]));
    end;
    //    -   
    //           1          2        3          4
    // =<>,<>,< DDE>,<No >, "", "", ()
     EraseSection(iniCyclesDefSect);
    for i:= 1 to ModuleCount do begin
      {  }
      if ACycles.Cycles^[i-1].Enabled
      then S:= '1,'
      else S:= '0,';
      {  }
      S:= S + ACycles.Cycles^[i-1].Module + ',';
      {  }
      S:= S + ACycles.Cycles^[i-1].Serv + ',';
      { No  -  }
      S:= S + IntToStr(ACycles.Cycles^[i-1].Func) + ',';
      { SOk    ""}
      S:= S + ACycles.Cycles^[i-1].SOk + ',';
      { SFail  ""}
      S:= S + ACycles.Cycles^[i-1].SFail + ',';
      { SFail  ""}
      S:= S + ACycles.Cycles^[i-1].Param;
      WriteString(iniCyclesDefSect, ACycles.Cycles^[i-1].Name, S);
    end;
  end;
  CyclesDefList.Free;
  Ini.Free;
  // True    1  
  Result:= ACycles.ModuleCount > 0;
end;

{    .
  ACycles     Nil.
  AStore - True -   INI  
  
  True   -   
  ACycles-  
}
function DlgCycles(var ACycles: TCycles; AStore: Boolean): Boolean;
begin
  Result:= False;
  FormCycles:= TFormCycles.Create(Application);
  //        DlgCycles
  //        
  PCurModuleCycles:= @ACycles;
  FormCycles.FillCycles(ACycles);
  with FormCycles do begin
    {   }
    { FormActivate  controls   New.. }
    if ShowModal = mrOK then begin
      {          }
      //      
      Result:= True;
    end;
  end;
  FormCycles.Free;
  //        
  if AStore
  then CyclesStoreIni(ACycles);
end;

//    (item)   (topic')
function ItemsOnTopic(ACycles: TCycles; const ATopic: String): Integer;
var
  i: Integer;
  Found: Integer;
  S: String;
begin
  Found:= 0;
  for i:= 1 to ACycles.TopicItems.Count do begin
    S:= GetToken(1,'=', ACycles.TopicItems.Strings[i-1]);
    if ANSICompareText(S, ATopic) = 0
    then Inc(Found);
  end;
  Result:= Found;
end;

//    
//   .   ,  Nil
function GetCycle(ACycles: TCycles; const ATopic: String): PCycle;
var
  i: Integer;
begin
  Result:= Nil;
  for i:= 1 to ACycles.ModuleCount do begin
    if ANSICompareText(ATopic, ACycles.Cycles^[i-1].Serv) = 0 then begin
      Result:= @(ACycles.Cycles^[i-1]);
      Exit;
    end;
  end;
end;

//      " "  
// -1  
// 0- OK
// 1- Fail
// >1   ( )
function CompTopicRet(ACycles: TCycles; const ATopic: String; const ARet: String): Integer;
var
  i: Integer;
  Found: Integer;
begin
  Found:= -1;
  // URet:= ANSIUpperCase(ARet);
  for i:= 1 to ACycles.ModuleCount do begin
    if ANSICompareText(ATopic, ACycles.Cycles^[i-1].Serv) = 0 then begin
      Found:= 2;
      if Pos(ACycles.Cycles^[i-1].SOk, ARet) > 0
      then Found:= 0 else begin
        if Pos(ACycles.Cycles^[i-1].SFail, ARet) > 0
        then Found:= 1;
      end;
      Break;
    end;
  end;
  Result:= Found;
end;

{ TopicGetItemNVal
   
    Nm-  item
    Vl-  item ( )
  
    True - item    
    False- item      Nm  Vl  ''
}
function TopicGetItemNVal(ACycles: TCycles; const ATopic: String; No: Integer;
  var Nm, Vl: String): Boolean;
var
  i: Integer;
  Found: Integer;
  S: String;
begin
  Result:= False;
  Found:= 0;
  Nm:= '';
  Vl:= '';
  for i:= 1 to ACycles.TopicItems.Count do begin
    S:= GetToken(1,'=', ACycles.TopicItems.Strings[i-1]);
    if ANSICompareText(S, ATopic) = 0 then begin
      if Found = No then begin
        S:= GetToken(2,'=', ACycles.TopicItems.Strings[i-1]);
        Nm:= GetToken(1,',', S);
        Vl:= GetToken(2,',', S);
//        ASOk:= GetToken(3,',', S);
//        ASFail:= GetToken(4,',', S);
        Result:= True;
        Exit;
      end;
      Inc(Found);
    end;
  end;
end;

//       ATopic- topic, Nm-    item ()
//  True,   , False-     
function GetTopicItemVal (ACycles: TCycles; No: Integer;
  var ATopic, Nm, Vl: String): Boolean;
var
  S: String;
begin
  Result:= False;
  ATopic:= '';
  Nm:= '';
  Vl:= '';
//  ASOk:= '';
//  ASFail:= '';
  if No >= ACycles.TopicItems.Count
  then Exit;
  ATopic:= GetToken(1,'=', ACycles.TopicItems.Strings[no]);
  S:= GetToken(2,'=', ACycles.TopicItems.Strings[no]);
  Nm:= GetToken(1,',', S);
  Vl:= GetToken(2,',', S);
//  ASOk:= GetToken(3,',', S);
//  ASFail:= GetToken(4,',', S);
  Result:= ACycles.Cycles^[no].Enabled;
end;

{      No item
  
    True - item    
    False- item    
}
function TopicSetItemNVal(ACycles: TCycles; const ATopic: String; No: Integer;
  const Nm, Vl: String): Boolean;
var
  i: Integer;
  Found: Integer;
  S: String;
begin
  Result:= False;
  Found:= 0;
  for i:= 1 to ACycles.TopicItems.Count do begin
    S:= GetToken(1,'=', ACycles.TopicItems.Strings[i-1]);
    if ANSICompareText(S, ATopic) = 0 then begin
      if Found = No then begin
        ACycles.TopicItems.Strings[i-1]:= ATopic+'='+Nm+','+Vl;
        Result:= True;
        Exit;
      end;
      Inc(Found);
    end;
  end;
end;

{    item
}
procedure TopicAddItemNVal(ACycles: TCycles; const ATopic: String);
begin
  ACycles.TopicItems.Add(ATopic+'=');
end;

{  item no
  
    True - item    
    False- item      Nm  Vl  ''
}
function  TopicDeleteItemNVal(ACycles: TCycles; const ATopic: String; No: Integer): Boolean;
var
  i: Integer;
  Found: Integer;
  S: String;
begin
  Result:= False;
  Found:= 0;
  for i:= 1 to ACycles.TopicItems.Count do begin
    S:= GetToken(1,'=', ACycles.TopicItems.Strings[i-1]);
    if ANSICompareText(S, ATopic) = 0 then begin
      if Found = No then begin
        ACycles.TopicItems.Delete(i-1);
        Result:= True;
        Exit;
      end;
      Inc(Found);
    end;
  end;
end;

//     
procedure SetCycleStatuses(ACycles: TCycles; AStatus: Byte);
var
  curm: Integer;
begin
  for curm:= 1 to ACycles.ModuleCount do begin
     ACycles.Cycles^[curm-1].Status:= AStatus;
  end;
end;

{  -   DDE  DLL  ACycles
}
function   CountDDE_DLLServices(ACycles: TCycles): Word;
var
  i: Word;
  c: Integer;
begin
  with ACycles do begin
    c:= 0;
    for i:= 1 to ModuleCount do begin
      if (ACycles.Cycles^[i-1].Module <> '')
        // and (ACycles.Cycles^[i-1].Serv <> '') -   DLL  
        and ACycles.Cycles^[i-1].Enabled
      then Inc(c);
    end;
  end;
  Result:= c;
end;

{
procedure TFormCycles.EDdeServerConvExecuteMacro(Sender: TObject; Msg: TStrings);
begin
  ShowMessage(': '+(Sender as TEDDEServerConv).Topic +':'+ Msg.Text);
  case CompTopicRet(PCurModuleCycles^, (Sender as TEDDEServerConv).Topic,Msg.Text) of
  0: ShowMessage(' OK');
  1: ShowMessage(' Fail');;
  2: ShowMessage('');;
  end;
end;
}

{  ,    ACycles.
//     1 
   True-     
             False-         (   0)
    ACycles   Started  True  False
}
function StartDDE_DLL(AOwner: TComponent;
  var ACycles: TCycles;         // 
  var AFarProcs: TADLLProc;     //    DLL
  var AServ: TAEDDEServConv;    //    DDE
  var AItem1: TAEDDEServItem;   //    DDE
  AExecuteMacro: TMacroEvent
): Boolean;
var
  DDECount: Word;
  curTopic, Sz: Integer;
  Nm, Vl, SOk, SFail,
  CurTopicName: String;
  CurTopicItems: Integer; //  item   topic'
  curitemno: Integer;
  loadedItems: Integer;
  buf: array[0..32] of Char;
  DLLHandle: Integer;
begin
  PCurModuleCycles:= @ACycles;
  Result:= False;
  DDECount:= CountDDE_DLLServices(ACycles);
  if DDECount = 0
  then Exit;
  //    
  StopDDE_DLL(ACycles, AFarProcs, AServ, AItem1);
  //   

  // ddeMgr := TEDdeMgr.Create(Application);
  //   DDE
  DDEMgr.AppName:= ACycles.DDEServerName;
  { /      Conv   Item }
  Sz:= SizeOf(TEDDEServerConv) * ACycles.ModuleCount;
  // ----------------------bug----------------------
  //     
  ReAllocMem(AServ, Sz);
  // TopicItems.Count-  item (  )
  Sz:= SizeOf(TEDDEServerItem) * ACycles.TopicItems.Count;
  ReAllocMem(AItem1, Sz);
  //   DLL
  Sz:= SizeOf(TFarProc) * ACycles.ModuleCount;
  ReAllocMem(AFarProcs, Sz);
  //   item
  loadedItems:= 0;
  {      }
  for curTopic:= 1 to ACycles.ModuleCount do begin
    CurTopicName:= ACycles.Cycles^[curTopic-1].Serv;
    CurTopicItems:= ItemsOnTopic(PCurModuleCycles^, CurTopicName);
    //    
    AServ^[curTopic-1]:= Nil;
    AFarProcs^[curTopic-1]:= Nil;
    //     AServ  AFarproc    Nil,   Nil
    //  ,  ,    
    //    -     ?  ,   
    if ACycles.Cycles^[curTopic-1].Enabled and (ACycles.Cycles^[curTopic-1].Module <> '') then begin
      {   EXE ,    ,  DDE , }
      if (Pos('.EXE', AnsiUpperCase( ACycles.Cycles^[curTopic-1].Module))>0)
        and (CurTopicName <> '')
        then  begin
        //   DDE  
        {   DDE-  (.EXE)  DDE }
        //   DDEServConv,    TComponent ( Self)
        AServ^[curTopic-1]:= TEDDEServerConv.Create(AOwner);
        //  
        AServ^[curTopic-1].Topic:= CurTopicName;
        AServ^[curTopic-1].OnExecuteMacro:= AExecuteMacro;
        { item ------------- }
        for curitemno:= 1 to CurTopicItems do begin
          TopicGetItemNVal(PCurModuleCycles^, CurTopicName, curitemno-1, Nm, Vl);
          //  DDEServItem,    TComponent ( Self)
          AItem1^[loadedItems]:= TEDDEServerItem.Create(AOwner);
          AItem1^[loadedItems].Item:= Nm;
// ------------------------------ debug
//        AItem1^[loadedItems].Text:= '';
          //   Fmt,     -  RO
          // AItem1^[loadedItems].Fmt:= CF_TEXT;
          //   Item  Conv
          //         DDE
          AItem1^[loadedItems].ServerConv:= AServ^[curTopic-1];
          PCurModuleCycles^.Cycles^[loadedItems].Status:= mst_ready;
          Inc(loadedItems);
        end;
      end else begin
        //     DLL?            
        if (Pos('.DLL', AnsiUpperCase(ACycles.Cycles^[curTopic-1].Module))>0)
          and ((CurTopicName <> '') or (ACycles.Cycles^[curTopic-1].Func <> 0))
          then  begin
          DLLHandle:= LoadLibrary(StrPCopy(buf, ACycles.Cycles^[curTopic-1].Module));
          if DLLHandle = 0 then begin
            ShowMessage('   '+
              ACycles.Cycles^[curTopic-1].Module + '  ');
            Exit;
          end else begin
            // GetProcAddress      (   =0 (   /0))
            if CurTopicName <> ''
            then AfarProcs^[curTopic-1]:= GetProcAddress(DLLHandle, Buf)
            else AfarProcs^[curTopic-1]:= GetProcAddress(DLLHandle, PChar(ACycles.Cycles^[curTopic-1].Func));
            if AFarProcs^[curTopic-1] = Nil then begin
              ShowMessage('   '+
                ACycles.Cycles^[curTopic-1].Module + '    '+
                CurTopicName +
                '('+IntToStr(ACycles.Cycles^[curTopic-1].Func)+')');
              FreeLibrary(DLLHandle);
            end;
          end;
        end;
      end;
    end;
  end;
  //    item
  for curitemno:= loadedItems to ACycles.TopicItems.Count -1 do begin
    AItem1^[curitemno]:= Nil;
  end;
  //    (0..)
  // ACycles.CurModule:= 0;
  //    
  ACycles.CurCycle:= 0;
  ACycles.Started:= True;
  Result:= True;
end;

function StopDDE_DLL(var ACycles: TCycles; var AFarProcs: TADLLProc;
  var AServ: TAEDDEServConv; var AItem1: TAEDDEServItem): Boolean;
label
  just;
var
  DDECount: Word;
  i: Integer;
  // Sz: Integer;
begin
  Result:= False;
  if (AFarProcs = Nil) or (AServ = Nil) or (AItem1 = Nil)
  then begin
    //    ,     
    Result:= True;
    Exit;
  end;
  // ddemgr.Free;
  // goto just;
  {     ,   }
  DDECount:= CountDDE_DLLServices(ACycles);
  if DDECount = 0
  then Exit;
  //   item 
  if AItem1 <> Nil then begin
    for i:= 1 to ACycles.TopicItems.Count do begin
      if AItem1^[i-1] <> Nil then begin
        AItem1^[i-1].Free;
        AItem1^[i-1]:= Nil;
      end;
    end;
  end;
  for i:= 1 to ACycles.ModuleCount do begin
    //   
    if (ACycles.Cycles^[i-1].Module <> '') // and ACycles.Cycles^[i-1].Enabled then
    then begin
      if (AServ <> Nil) and (AServ^[i-1] <> Nil) then begin
        //  DDEServConv
        AServ^[i-1].Free;
        AServ^[i-1]:= Nil;
      end else begin
        if AFarProcs^[i-1] <> Nil then begin
          //   DLL,  handler    
          //  Windows  
        end;
      end;
    end;
  end;
  {     Conv   Item }
  // Sz:= SizeOf(TEDDEServerConv) * ACycles.ModuleCount;
  // Sz:= SizeOf(TEDDEServerItem) * ACycles.TopicItems.Count;
just:
  ReAllocMem(AItem1, 0);
  AItem1:= Nil;
  ReAllocMem(AServ, 0);
  AServ:= Nil;
  ReAllocMem(AFarProcs, 0);
  AFarProcs:= Nil;
  //  ,    DDE EDDEMan.ddemgr
  //    (0..)
  // ACycles.CurModule:= 0;
  //    
  ACycles.CurCycle:= 0;
  ACycles.Started:= False;
  Result:= True;
end;

procedure TFormCycles.BStartClick(Sender: TObject);
begin
  // TComponent
  FormQueue.CyclesStarted:= True;
  if FormQueue.CyclesStarted then begin
    ShowMessage(' : '+IntToStr(CountDDE_DLLServices(PCurModuleCycles^)));
  end else begin
    ShowMessage('    : '+IntToStr(CountDDE_DLLServices(PCurModuleCycles^))+',    ');
  end;
  LVCycles.Enabled:= False;
  SGElements.Enabled:= False;
  BStart.Enabled:= False;
  BStop.Enabled:= True;
  BTest.Enabled:= True;
  BCopyBuffer.Enabled:= True;
end;

procedure TFormCycles.BStopClick(Sender: TObject);
begin
  with FormQueue do
  if (TAPDll = Nil) or (Serv = Nil) or (Item1 = Nil) then begin
    //   
  end else begin
    if MessageDlg('   TAP   Enter', mtConfirmation,
        [mbOk, mbCancel], 0) = mrOK then begin
      FormQueue.CyclesStarted:= False;
      if not FormQueue.CyclesStarted
      then ShowMessage(' ');
    end;
  end;
  LVCycles.Enabled:= True;
  SGElements.Enabled:= True;
  BStart.Enabled:= True;
  BStop.Enabled:= False;
  BTest.Enabled:= False;
  BCopyBuffer.Enabled:= False;
end;

procedure TFormCycles.BCopyBufferClick(Sender: TObject);
var
  i: Integer;
begin
  {          }
  {           }
  for i:= 1 to PCurModuleCycles^.ModuleCount do begin
    //   
    if (PCurModuleCycles^.Cycles^[i-1].Module <> '')
      and (PCurModuleCycles^.Cycles^[i-1].Serv <> '')
      and PCurModuleCycles^.Cycles^[i-1].Enabled then  begin
      FormQueue.Item1^[i-1].CopyToClipboard;
      {  user       }
      ShowMessage('  '+PCurModuleCycles^.Cycles^[i-1].Module+
      ' ( '+PCurModuleCycles^.Cycles^[i-1].Serv+')  ,   Enter' )
    end;
  end;
end;

procedure TFormCycles.BTestClick(Sender: TObject);
var
  i, j: Integer;
  ATopic, Nm, Vl, ASOk, ASFail:String;
begin
  // FormQueue.NextMessage;
  {     / item }
  j:= 0;
  for i:= 0 to PCurModuleCycles^.TopicItems.Count - 1 do begin
    //      Nm-  item    Vl-  item ( )
    if GetTopicItemVal(FormQueue.GateCycles, i, ATopic, Nm, Vl) then begin
      //    &#xxx  
      Vl:= WEBStyleString2ASCII(Vl);
      //     
      Util1.ReplaceTag(Vl, '<', '>', #0, EQ.ParsedTag);
      if Vl <> '' then begin
        // 
        if FormQueue.Item1^[j] <> Nil
        then FormQueue.Item1^[j].Text:= Vl;
        // ShowMessage('    '+ ATopic+','+Nm, +  ': "'+Vl+'"');
        StatusBar1.Panels[StatusBar1.Panels.Count-1].Text:= ChangeChars(#9,#32, Vl);
        Inc(j);
      end;
    end;
  end;
end;
{
 if (PCurModuleCycles^.Cycles^[i-1].Module <> '')
      and (PCurModuleCycles^.Cycles^[i-1].Serv <> '')
      and PCurModuleCycles^.Cycles^[i-1].Enabled
}

procedure TFormCycles.pmItemAddClick(Sender: TObject);
var
  TopicN: String;
var
  LI: TListItem;
begin
  LI:= LVCycles.ItemFocused;
  if LI <> Nil then begin
    TopicN:= PCurModuleCycles^.Cycles^[LI.Index].Serv;
    TopicAddItemNVal(PCurModuleCycles^, TopicN);
    ViewElementsSG(TopicN);
  end;
end;

procedure TFormCycles.pmAddTopicClick(Sender: TObject);
var
  LI: TListItem;
begin
  //      PCurModuleCycles
  if CreateCyclesStruct(PCurModuleCycles^.ModuleCount+1, PCurModuleCycles^) then begin
    // LI:= LVCycles.Items.Add;
    //   ( )
    FormCycles.FillCycles(PCurModuleCycles^);
  end;
  {    DLL }
  // p:= LoadMSG2TERMDLLProc(FileName, HTapDLL);
end;

procedure TFormCycles.pmDeleteTopicClick(Sender: TObject);
var
  LI: TListItem;
begin
  LI:= LVCycles.ItemFocused;
  if LI <> Nil then begin
    //      PCurModuleCycles
    DeleteItemFromCycles(LI.Index, PCurModuleCycles^);
    //   ( )
    FormCycles.FillCycles(PCurModuleCycles^);
  end;
end;

procedure TFormCycles.pmItemSubClick(Sender: TObject);
var
  TopicN: String;
  LI: TListItem;
begin
  LI:= LVCycles.ItemFocused;
  if LI <> Nil then begin
    TopicN:= PCurModuleCycles^.Cycles^[LI.Index].Serv;
    if MessageDlg('   '+ TopicN +'  ' +
        SGElements.Cells[0,SGElements.Selection.Top], mtConfirmation, [mbOk, mbCancel], 0) = mrOK then begin
        TopicDeleteItemNVal(PCurModuleCycles^, TopicN, SGElements.Selection.Top);
      ViewElementsSG(TopicN);
    end;
  end;
end;

procedure TFormCycles.SGElementsClick(Sender: TObject);
var
  S: String;
begin
  //    statusbar
  S:= WEBStyleString2ASCII(SGElements.Cells[1, SGElements.Selection.Top]);
  Util1.ReplaceTag(S, '<', '>', #0, EQ.ParsedTag);
  //    tab    
  StatusBar1.Panels[StatusBar1.Panels.Count-1].Text:= ChangeChars(#9,#32, S);
end;

procedure TFormCycles.FormCreate(Sender: TObject);
begin
  //       
  BStopClick(Self);
  //      
  oldcycle:= 0;
end;

procedure TFormCycles.HeaderControl2SectionResize(
  HeaderControl: THeaderControl; Section: THeaderSection);
var
  i: Integer;
begin
  for i:= 1 to HeaderControl.Sections.Count do begin
    SGElements.ColWidths[i-1]:= HeaderControl.Sections[i-1].Width;
  end;
end;

procedure TFormCycles.LVCyclesClick(Sender: TObject);
var
  ind: Integer;
  LI: TListItem;
begin
  LI:= LVCycles.ItemFocused;
  if LI <> Nil then begin
    ind:= LI.Index;
    //     ,      
    FillCycle(PCurModuleCycles^, oldcycle, True, True);
    //     
    FillCycle(PCurModuleCycles^, ind, False, True);
    oldcycle:= ind;
   end;
end;

procedure TFormCycles.LVCyclesEdited(Sender: TObject; Item: TListItem;
  var S: String);
begin
  {}
  PCurModuleCycles^.Cycles^[Item.Index].Name:= S;
end;

procedure TFormCycles.LVCyclesKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  LVCyclesClick(Self);
end;

procedure TFormCycles.pmAddExeClick(Sender: TObject);
begin
  with DataModule1.OpenDialog1 do begin
    Filter:= ' (.EXE)|*.exe|  (.DLL)|*.dll| |*.*';
    FilterIndex:= 1;
    DefaultExt:= 'exe';
    if Execute then begin
      FileName:= ExtractFileName(FileName);
      SGCycle.Cells[1, 1]:= FileName;
      //????
    end;
  end;
end;

procedure TFormCycles.EIntervalChange(Sender: TObject);
begin
  PCurModuleCycles^.WaitSec:= UDInterval.Position;
  PCurModuleCycles^.TimeOutSec:= UDTimeOut.Position;
end;

procedure TFormCycles.pmOptsExeClick(Sender: TObject);
begin
  ShowMessage('       .    .');
end;

procedure TFormCycles.EServerNameChange(Sender: TObject);
begin
  PCurModuleCycles^.DDEServerName:= EServerName.Text;
end;

end.

{ callid        msgid   capcode         }
{10001291	102162	100040091110	"ASASASS"	10.03.98	17	55
}

