unit OQueue;
(*##*)
(*******************************************************************
*                                                                 *
*   O  Q  U  E  U  E           EPAGER's unit.                      *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   Messages queue options form                                   *
*   Conditioonal defines: ---                                      *
*                                                                 *
*   Last Revision: Mar 19 1998                                     *
*   Last fix     : Mar 19 1998                                    *
*   Lines        : 221                                             *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ToolWin, IniFiles,
  PCommon, ExtCtrls;

type
  TMsgQueuePars = record
    QueueID: String[1];
    FailListLimit: Integer;
    DefaultPrior: Byte;       { 32 - 96; 48, 53, 57 }
    NNoLowPriorityMsg: Byte;
    PriorDecreaseAfterFail: Boolean;
    NoNewMsgWhileFull: Boolean;
    WarningAfterFail: Boolean;
    NoLowPriorityMsg: Boolean;
    NPriorDecreaseAfterFail: Word;
    NWarningAfterFail: Word;
    NNoNewMsgWhileFull: Word;
  end;

  {      
  }
  TFailList = TStringList;
  { ID       = ddd           ,ddd [,]
          -        
         
      
  }
const
  iniQUEUESect              = 'Queue';
  iniQueueID                = 'QueueID';
  iniDefaultPrior           = 'DefaultPriority';
  iniFailListLimit          = 'FailsLimit';
  iniPriorDecreaseAfterFail = 'DoPriorityDecrease';
  iniNoNewMsgWhileFull      = 'NoNewIfFull';
  iniWarningAfterFail       = 'DoWarningAfterFail';
  iniNoLowPriorityMsg       = 'DisableLowPriorMsgs';
  iniNPriorDecreaseAfterFail= 'PriorityDecreaseAfter';
  iniNWarningAfterFail      = 'WarningAfter';
  iniNNoNewMsgWhileFull     = 'Full';
  iniNNoLowPriorityMsg      = 'NoServicePriority';

type
  TFormOptsQueue = class(TForm)
    EDefaultPrior: TEdit;
    UDDefaultPrior: TUpDown;
    Label1: TLabel;
    EPriorDecreaseAfterFail: TEdit;
    UDPriorDecreaseAfterFail: TUpDown;
    CBPriorDecreaseAfterFail: TCheckBox;
    Label3: TLabel;
    CBWarningAfterFail: TCheckBox;
    EWarningAfterFail: TEdit;
    Label4: TLabel;
    UDWarningAfterFail: TUpDown;
    CBNoNewMsgWhileFull: TCheckBox;
    ENoNewMsgWhileFull: TEdit;
    UDNoNewMsgWhileFull: TUpDown;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    CBNoLowPriorityMsg: TCheckBox;
    ENoLowPriorityMsg: TEdit;
    UDNoLowPriorityMsg: TUpDown;
    Label5: TLabel;
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    EFailListLimit: TEdit;
    Label6: TLabel;
    UDFailListLimit: TUpDown;
    Label7: TLabel;
    Bevel1: TBevel;
    EQueueID: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    // True  -       
    // False -       
    procedure SyncView(AToScreen: Boolean);
  end;

var
  MsgQueuePars: TMsgQueuePars;
  FormOptsQueue: TFormOptsQueue;

procedure LoadIniMsgQueuePars;
procedure StoreIniMsgQueuePars;

implementation

uses DModule;

{$R *.DFM}

procedure LoadIniMsgQueuePars;
var
  Ini: TIniFile;
begin
  Ini:= TIniFile.Create(INI_PAGER_FILE);
  with Ini, MsgQueuePars do begin
    QueueID:= ReadString(iniQUEUESect, iniQueueID, 'b');
    PriorDecreaseAfterFail:= ReadBool(iniQUEUESect, iniPriorDecreaseAfterFail, False);
    NoNewMsgWhileFull:= ReadBool(iniQUEUESect, iniNoNewMsgWhileFull, False);
    WarningAfterFail:= ReadBool(iniQUEUESect, iniWarningAfterFail, False);
    NoLowPriorityMsg:= ReadBool(iniQUEUESect, iniNoLowPriorityMsg, False);

    FailListLimit:= ReadInteger(iniQUEUESect, iniFailListLimit, 128);
    if FailListLimit = 0
    then FailListLimit:= 1;
    { +32    32, 53 = "5" }
    DefaultPrior:= ReadInteger(iniQUEUESect, iniDefaultPrior, 53);
    //  :     
    NPriorDecreaseAfterFail:= ReadInteger(iniQUEUESect, iniNPriorDecreaseAfterFail, 1);
    if NPriorDecreaseAfterFail = 0
    then NPriorDecreaseAfterFail:= 1; //    -      
    //                   10 
    NWarningAfterFail:= ReadInteger(iniQUEUESect, iniNWarningAfterFail, 10);
    if NWarningAfterFail = 0
    then NWarningAfterFail:= 1;  //    -      
    //                      25 
    NNoNewMsgWhileFull:= ReadInteger(iniQUEUESect, iniNNoNewMsgWhileFull, 25);
    if NNoNewMsgWhileFull = 0
    then NNoNewMsgWhileFull:= 1;
    //                     "z"
    NNoLowPriorityMsg:= ReadInteger(iniQUEUESect, iniNNoLowPriorityMsg, 58);
    // 
    if DefaultPrior > 63
    then DefaultPrior:= 63;
    if NNoLowPriorityMsg > 63
    then NNoLowPriorityMsg:= 63;
   end;
  Ini.Free;
end;

procedure StoreIniMsgQueuePars;
var
  Ini: TIniFile;
begin
  Ini:= TIniFile.Create(INI_PAGER_FILE);
  with Ini, MsgQueuePars do begin
    WriteString(iniQUEUESect, iniQueueID, QueueID);
    WriteInteger(iniQUEUESect, iniFailListLimit, FailListLimit);
    // 
    if DefaultPrior > 63
    then DefaultPrior:= 63;
    if NNoLowPriorityMsg > 63
    then NNoLowPriorityMsg:= 63;
    WriteBool(iniQUEUESect, iniPriorDecreaseAfterFail, PriorDecreaseAfterFail);
    WriteBool(iniQUEUESect, iniNoNewMsgWhileFull, NoNewMsgWhileFull);
    WriteBool(iniQUEUESect, iniWarningAfterFail, WarningAfterFail);
    WriteBool(iniQUEUESect, iniNoLowPriorityMsg, NoLowPriorityMsg);
    WriteInteger(iniQUEUESect, iniDefaultPrior, DefaultPrior);
    WriteInteger(iniQUEUESect, iniNPriorDecreaseAfterFail, NPriorDecreaseAfterFail);
    WriteInteger(iniQUEUESect, iniNWarningAfterFail, NWarningAfterFail);
    WriteInteger(iniQUEUESect, iniNNoNewMsgWhileFull, NNoNewMsgWhileFull);
    WriteInteger(iniQUEUESect, iniNNoLowPriorityMsg, NNoLowPriorityMsg);
  end;
  Ini.Free;
end;

//       
procedure TFormOptsQueue.SyncView(AToScreen: Boolean);
begin
  with MsgQueuePars do begin
    // 
    if DefaultPrior > 63
    then DefaultPrior:= 63;
    if NNoLowPriorityMsg > 63
    then NNoLowPriorityMsg:= 63;
    {     }
    if AToScreen then begin
      EQueueID.Text:= QueueID;
      UDFailListLimit.Position:= FailListLimit;
      UDDefaultPrior.Position:= DefaultPrior;
      CBPriorDecreaseAfterFail.Checked:= PriorDecreaseAfterFail;
      UDPriorDecreaseAfterFail.Position:= NPriorDecreaseAfterFail;
      CBWarningAfterFail.Checked:= WarningAfterFail;
      UDWarningAfterFail.Position:= NWarningAfterFail;
      CBNoNewMsgWhileFull.Checked:= NoNewMsgWhileFull;
      UDNoNewMsgWhileFull.Position:= NNoNewMsgWhileFull;
      CBNoLowPriorityMsg.Checked:= NoLowPriorityMsg;
      UDNoLowPriorityMsg.Position:= NNoLowPriorityMsg;
    end else begin
      QueueID:= Copy(EQueueID.Text, 1, SizeOf(QueueID)-1);
      FailListLimit:= UDFailListLimit.Position;
      DefaultPrior:= UDDefaultPrior.Position;
      PriorDecreaseAfterFail:= CBPriorDecreaseAfterFail.Checked;
      NPriorDecreaseAfterFail:= UDPriorDecreaseAfterFail.Position;
      WarningAfterFail:= CBWarningAfterFail.Checked;
      NWarningAfterFail:= UDWarningAfterFail.Position;
      NoNewMsgWhileFull:= CBNoNewMsgWhileFull.Checked;
      NNoNewMsgWhileFull:= UDNoNewMsgWhileFull.Position;
      NoLowPriorityMsg:= CBNoLowPriorityMsg.Checked;
      NNoLowPriorityMsg:= StrToIntDef(ENoLowPriorityMsg.Text, 58);
      NNoLowPriorityMsg:= UDNoLowPriorityMsg.Position;
    end;
  end;
end;

procedure TFormOptsQueue.Button1Click(Sender: TObject);
begin
  //       
  SyncView(False);
  StoreIniMsgQueuePars;
end;

procedure TFormOptsQueue.FormCreate(Sender: TObject);
begin
  //       
  SyncView(True);
end;



end.
