unit EQ;
(*##*)
(*******************************************************************
*                                                                 *
*   E  Q                       EPAGER's unit.                      *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   Messages queue processor                                      *
*   Conditioonal defines: ---                                      *
*                                                                 *
*    : GateDDEStep-> NextMessage-> PrepareTAPMessage->  *
*     PrepareMessageByRule-> SendTAPMessage                       *
*                                                                  *
*                                                                 *
*   Last Revision: Mar 19 1998                                     *
*   Last fix     : Mar 19 1998                                    *
*   Lines        : 1869                                            *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

{   
   QueryCalls.Unidirectional = True   BDE  
             (  Table)
}
interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, DBCtrls, Grids, DBGrids, DB, DBTables,
  StdCtrls, Mask, TabNotBk, FileCtrl, Menus, DBLookup, Inifiles,
  Tabs, Buttons,  Gauges, Spin,
  PCommon, util1, About, Calendar, ComCtrls, ToolWin,
  cpcoll, tap, conopts, pagopts, EDDEMan, Cycles;

const
  DEFMsgListViewLimit = 20; {    XX ,      }
  { 3 kind of search }
  SEARCHBYNAMES = 0;
  SEARCHBYID    = 1;
  SEARCHBYDATE  = 2;

  kndALL           = 0;
  kndBYCYRLETTER   = 1;
  kndBYENGLETTER   = 2;
  kndBYWORD        = 3;

{      MarkMessageAs(AState: Char);
}
  ch_SENT       = 'x';
  ch_BUSY: Char = 'b';
  ch_READY      = 'o';

type
  TFormQueue = class(TForm)
    MainMenu1: TMainMenu;
    MFile: TMenuItem;
    MMFileDelimiter1: TMenuItem;
    MFileExit: TMenuItem;
    MOptions: TMenuItem;
    MOptionsDlg: TMenuItem;
    MHelp: TMenuItem;
    MHelpIndex: TMenuItem;
    MMsg: TMenuItem;
    MMsgSend2List: TMenuItem;
    MMsgSend2Group: TMenuItem;
    MMsgDelimiter1: TMenuItem;
    MMsgSendByFile: TMenuItem;
    MMsgSend2Abonent: TMenuItem;
    StatusBar1: TStatusBar;
    TNVis: TTabbedNotebook;
    CoolBar1: TCoolBar;
    CBZone: TComboBox;
    ToolBar1: TToolBar;
    TBStart: TToolButton;
    TVCycles: TToolButton;
    CBRule: TComboBox;
    DBGrid1: TDBGrid;
    MProtocol: TMemo;
    DBGrid2: TDBGrid;
    MFileLoadPagerDef: TMenuItem;
    MOptionsLoadAll: TMenuItem;
    CBPageCP: TComboBox;
    Memo1: TMemo;
    DBGrid4: TDBGrid;
    MOptionsLoad: TMenuItem;
    MOptionsStore: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    MHelpAbout: TMenuItem;
    MOptionsStartStop: TMenuItem;
    MOptionsStartCycles: TMenuItem;
    MOptionsExtModuleEdit: TMenuItem;
    N4: TMenuItem;
    MOptionsQueue: TMenuItem;
    DBGClient: TDBGrid;
    DBGGroups: TDBGrid;
    DBGGrpDesc: TDBGrid;
    LBFails: TListBox;  //   
    Label1: TLabel;
    MOptionsStopCycles: TMenuItem;
    TBQueueOptions: TToolButton;
    Panel1: TPanel;
    BClearFails: TButton;
    BSaveFiscal: TButton;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure MOptionsDlgClick(Sender: TObject);
    procedure MFileExitClick(Sender: TObject);
    procedure ComboBoxEnter(Sender: TObject);
    procedure CBZoneChange(Sender: TObject);
    procedure BSaveFiscalClick(Sender: TObject);
    procedure MFileLoadPagerDefClick(Sender: TObject);
    procedure MOptionsLoadAllClick(Sender: TObject);
    procedure MOptionsLoadClick(Sender: TObject);
    procedure MOptionsStoreClick(Sender: TObject);
    procedure TBNoSendClick(Sender: TObject);
    procedure MOptionsStartCyclesClick(Sender: TObject);
    procedure MOptionsExtModuleEditClick(Sender: TObject);
    procedure MOptionsQueueClick(Sender: TObject);
    procedure MOptionsStopCyclesClick(Sender: TObject);
    procedure TNVisChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    // ,  
    procedure EDdeServerConvExecuteMacro(Sender: TObject; Msg: TStrings);
    procedure TBStartClick(Sender: TObject);
    procedure BClearFailsClick(Sender: TObject);
  private
    { Private declarations }
    FirstTime,
    SecondEnter,
    AllreadyRegistered,
    FHasMsg: Boolean;
    MsgListViewLimit: Word;
    TmStart,
    TmFinish,
    TmInterval: TDateTime;
    Repeats,
    CurMsgWords,
    CurMsgChars,
    FiscalReportViewLen: LongInt;
    {   TAP }
    {  COM  }
    ConnectPars: TConnectPars;
    CurMsgStr: String;
    DefaultRule: String;
    Rules: TStringList;
    FCyclesStarted: Boolean;
    { serve property }
    procedure SetCyclesStarted(ACyclesStarted: Boolean);
    { other }
    procedure FillDBCB(const SQLFN: String; List: TStrings; const ACaption: String);
    procedure UpdateDBCBs;
    function  FindCustomer(Cat: Integer; const Srch: String): Boolean;
    function  GotoCall(ADate: TDateTime; No: LongInt): Boolean;
    procedure ShowOperatorInfo(const AZones: String; AHCode: THCode; AUPDATER: Integer);
    procedure ShowAbonentInfo(const Ab: String);
    procedure FlushProtocol;
    procedure FailedMessageSentSuccess;
    function  ProcessFailedMessage: Boolean;
    function  SendTAPMessage(const p: String): Integer; //    NextMessage
    procedure SendNULLTAPMessage;
    function  MarkMessageAs(AState: Char): Boolean;
    procedure UpdateList(AComplete: Boolean);
    function  IsCallGroup: Word;
    function  FirstMessageReady2Send: Boolean;
    function  GetCurRule: String ;
    // function  LoadMSG2TERMDLLProc(const AExternalTAPModuleName: String; var ADLLHandle: Integer): TFarProc;
    function  GetCurrentPriority: Integer;
    procedure SetCurrentPriority(APrior: Integer);
    // codepage, capcode  AMsgNo   CurCPxlatIndex, CurCAP  CurMsgNo
    function  PrepareMessageByRule(const rule: String): String;
  protected
    { 0..63 }
    property  CurrentPriority: Integer read GetCurrentPriority write SetCurrentPriority;
  public
    { Public declarations }
    Use_Alias,
    RptSheduled: Boolean;
    AliasName,
    DatabaseFolder: String32;
    ZonesInServiceList,
    CurHCode  : THCODE;  { }
    ZonesInServiceListCount: Word; //  0,     ZonesInServiceList 
    CurAbonent: String32;
    OperateDay: TDateTime;
    CurUPDATER: Longint;  { }
    CurCAP: String;
    CurMsgNo: Integer;
    CurCPxlatIndex: Integer;
    CurInfoChannel: Integer;
    CurZone2Send: THCODE;
    curCallGroupKind: Integer;
    SQLFolder: SQLPathString;
    SQLSYSFolder: SQLPathString;
    SQLVOCFolder: SQLPathString;
    FiscalProtocolFolder: SQLPathString;
    WorkPlace: SQLPathString;
    OperLabels: String[255];
    ClientLabels: String[255];
    CALLSLABELS: String[255];
    GroupsLABELS: String[255];
    GrpDescLABELS: String[255];
    cploadedCount: Word; //   codepage
    PagerCodeDefs: PCPDefinitions;
    {  TAP     }
    // HTapDLL: Integer;
    // TapDLLProc: TFarProc;
    // ExternalTAPModuleType: Char;
    // ExternalTAPModuleName: SQLPathString;
    GateCycles: TCycles;
    TAPDLL: TADLLProc;
    Serv: TAEDDEServConv;
    Item1: TAEDDEServItem;
    CurMsgLimit: Integer;
    CurTAPPar: TTerminalPar;
    StepCount: LongInt;
    property  CyclesStarted: Boolean read FCyclesStarted write SetCyclesStarted;
    property  NextMessageReady: Boolean read FHasMsg;
    function  isTime2Send: Boolean;  //    
    procedure ETShowStatus(Level: Integer; const S: String);
    procedure FiscalReport(const S: String);
    function  LoadIni: Boolean;
    function  StoreIni: Boolean;
    { change alias and update all visibles }
    function AssignAlias(const AAlias: String): Boolean;
    function AssignDataFolder(const ADataFolder: String): Boolean;
    procedure ChangeDataBaseAliasOrFolder;
    { do smth to find DLLS.
    For example, change current directory?
    }
    procedure AssignWorkPlace(const S: String);
    procedure StoreFields(const S: String);
    function  LoginUser(AHCode: THCODE;AUPDATER: LongInt): Boolean;
    procedure DisplayHint(Sender: TObject);
    procedure UpdateDisplayLabels;
    procedure ActivateTables;
    procedure PrepareTAPMessage(const Rule: String; var p: String);
    function  NextMessage: Boolean;  //   FHasMsg
    procedure LinkClient2CallsOrGroups(A2Calls: Boolean);
    procedure WarningOperator(AOper: Integer; S: String);
    function  IsInZoneList(const AZone: String): Boolean;
    function  AllTopicsResponded: Boolean;
  end;

var
  FormQueue: TFormQueue;

{ callback   Cycles    (  )
}
function ParsedTag(Tag: String): String;

{ callback      ( )
}
function ParsedTagNULL(Tag: String): String;

{    DModule.DataModule1.Timer1Timer      
   False -     
  True-  
}
function GateDDEStep: Boolean;

implementation

{$R *.DFM}

uses
  clogin, OSetting, DModule, OQueue;

{      GateDDEStep }
const
  GateStepENTERED: Word = 0;

{    DModule.DataModule1.Timer1Timer      
            GateDDEStep
}
function GateDDEStepCallBack: Boolean; far;
begin
  Result:= False;
  Inc(FormQueue.StepCount);
  // ..
  with DataModule1.ImageList2 do begin
    GetIcon(FormQueue.StepCount and (Count-1), Application.Icon);
    FormQueue.Icon.Assign(Application.Icon);
  end;
  if FormQueue.NextMessageReady
  then Application.Title:= ' ..'
  else Application.Title:= '..';
  // ..
  //   
  if GateStepENTERED > 0
  then Exit;
  //  ,      ,     , 
  // if (not Started) or (ModuleCount<=0) // or (CurModule >= ModuleCount) or (CurModule <0)
  Result:= GateDDEStep;
end;

//  function StopCycle: Boolean; function StartCycle: Boolean;  CyclesStarted

{      FormQueue }
function StartCycle: Boolean;
begin
  Result:= False;
  DModule.TimerIdle:= Nil;
  with FormQueue do begin
    if GateCycles.Started then begin
      //  
      Result:= True;
      Exit;
    end;
    // EDdeServerConvExecuteMacro-       
    if Cycles.StartDDE_DLL(FormQueue, GateCycles, TAPDLL, Serv, Item1,
      EDdeServerConvExecuteMacro) then begin
      if MessageDlg('() DDE ().  .', mtConfirmation,
        [mbOk, mbCancel], 0) = mrOK then begin
        //   
        FormQueue.NextMessage;
        //  
        DataModule1.Timer1.Interval:= GateCycles.WaitSec * 1000;
        StepCount:= 0;
        DModule.TimerIdle:= GateDDEStepCallBack;
        Result:= True;
      end;
    end;
  end;
end;

function StopCycle: Boolean;
begin
  with FormQueue do begin
    if not GateCycles.Started then begin //
      //  
      Result:= True;
      Exit;
    end;
    //    DDE
    // 4  98    ?
    // EDDEMan.NoResponse:= True;
    DModule.TimerIdle:= Nil; //    
    if MessageDlg(' ', mtConfirmation,
      [mbOk], 0) = mrOK then begin
      Result:= Cycles.StopDDE_DLL(GateCycles, TAPDLL, Serv, Item1);
    end;
  end;
end;

procedure TFormQueue.SetCyclesStarted(ACyclesStarted: Boolean);
begin
  if ACyclesStarted then begin
    //    NextMessage -> SendTAPMessage
    FCyclesStarted:= True;
    FCyclesStarted:= StartCycle;
  end else begin
    FCyclesStarted:= not StopCycle;
  end;
  MOptionsStartCycles.Checked:= FCyclesStarted;
  MOptionsStopCycles.Checked:= not FCyclesStarted;
end;

procedure ViewOperForm(ASessionInserted: LongInt; var AHCode: THCODE;
  AUPDATER: LongInt);
begin
  FormQueue:= TFormQueue.Create(Application);
  with FormQueue do begin
    if LoginUser(AHCode, AUPDATER) then begin
      ShowModal;
      Hide;
    end;
    Free;
  end;
end;

procedure TFormQueue.ETShowStatus(Level: Integer; const S: String);
begin
  with StatusBar1 do begin
    case Level of
    1:Font.Color:= clRed;
    2:Font.Color:= clBlue;
    3:Font.Color:= clYellow;
    else Font.Color:= clBlack;
    end;
    Panels[Panels.Count-1].Text:= S;
  end;
end;

function TFormQueue.AssignAlias(const AAlias: String): Boolean;
begin
  AssignAlias:= False;
  if AAlias <> '' then with DataModule1, DataBase1 do begin
    {   -       }

    TableClient.Active:= False;
    TableModels.Active:= False;
    TablePagers.Active:= False;        
    TableCalls.Active:= False;
    TableGroups.Active:= False;
    TableGrpDesc.Active:= False;

    QDict.Active:= False;
    {     }
    Connected:= False;
    AliasName:= AAlias;
    {      }
    {   -    dbOper }

    QDict.DataBaseName:= DataModule1.DataBase1.DataBaseName;
    TableClient.DataBaseName:= DataModule1.DataBase1.DataBaseName;
    TableModels.DataBaseName:= DataModule1.DataBase1.DataBaseName;
    TablePagers.DataBaseName:= DataModule1.DataBase1.DataBaseName;
    TableCalls.DataBaseName:= DataModule1.DataBase1.DataBaseName;
    TableGroups.DataBaseName:= DataModule1.DataBase1.DataBaseName;
    TableGrpDesc.DataBaseName:= DataModule1.DataBase1.DataBaseName;
    {    }
    Connected:= True;
  end;
  AssignAlias:= True;
end;

function TFormQueue.AssignDataFolder(const ADataFolder: String): Boolean;
begin
  AssignDataFolder:= False;
  if ADataFolder <> '' then with DataModule1 do begin
    DataBase1.Connected:= False;
    DataBase1.AliasName:= '';
    { connect others
    }
    with QDict do begin
      Active:= False;
      DatabaseName:= '';
    end;
    with TableClient do begin
      Active:= False;
      DatabaseName:= '';
    end;
    with TableModels do begin
      Active:= False;
      DatabaseName:= '';
    end;
    with TablePagers do begin
      Active:= False;
      DatabaseName:= '';
    end;
    with TableCalls do begin
      Active:= False;
      DatabaseName:= '';
    end;
    with TableGroups do begin
      Active:= False;
      DatabaseName:= '';
    end;
    with TableGrpDesc do begin
      Active:= False;
      DatabaseName:= '';
    end;
  end;
  AssignDataFolder:= True;
end;

procedure TFormQueue.ChangeDataBaseAliasOrFolder;
begin
  if Use_Alias then begin
    AssignAlias(AliasName);
  end else begin
    AssignDataFolder(DatabaseFolder);
  end;
end;

procedure TFormQueue.AssignWorkPlace(const S: String);
begin
  if S = '' then begin
    if DEFWORKPLACE <> ''
    then ChDir(DEFWORKPLACE);
  end else begin
    ChDir(S);
  end;
end;

procedure TFormQueue.StoreFields(const S: String);
begin
end;

procedure ValidateDateDelimiters(var S: String);
begin
  {     ,    ,  }
  if Length(S) = 1
  then S:= S+S;
  {        ,  }
  if Length(S) = 0
  then S:= DEFDATEDELIMITERS;
  {     (   2),   }
  System.Delete(S, 3, 255);
end;

procedure ValidatePhoneDelimiter(var S: String);
begin
  {        ,  }
  if Length(S) = 0
  then S:= DEFPHONEDELIMITER;
  {     (   1),   }
  System.Delete(S, 2, 255);
end;

procedure TFormQueue.ActivateTables;
begin
  with DataModule1 do begin
    QDict.DisableControls;
    TableClient.DisableControls;
    TableModels.DisableControls;;
    TablePagers.DisableControls;;
    TableCalls.DisableControls;
    TableGroups.DisableControls;
    TableGrpDesc.DisableControls;
//  QDict.Active:= True;
    TableClient.Active:= True;
    TableModels.Active:= True;
    TablePagers.Active:= True;
    TableCalls.Active:= True;
    TableGroups.Active:= True;
    TableGrpDesc.Active:= True;
    { labels }
    UpdateDisplayLabels;
    UpdateDBCBs;
    QDict.EnableControls;
    TableClient.EnableControls;
    TableModels.EnableControls;
    TablePagers.EnableControls;
    TableCalls.EnableControls;
    TableGroups.EnableControls;
    TableGrpDesc.EnableControls;
  end;
end;

{ called from FormActivate just 1 (first) time
}
function TFormQueue.LoadIni: Boolean;
var
  IniFile: TIniFile;
  S: ShortString;
begin
  Result:= False;
  IniFile := TIniFile.Create(SearchIni('', INI_PAGER_FILE));
  with IniFile do begin
    Font.Name:= ReadString(sectFONT, iniFontName, 'System');
//    TabSetMessages.Font.Name:= Font.Name;
    TNVis.TabFont.Name:= Font.Name;
    Font.Size:= ReadInteger(sectFONT, iniFontSize, -10);
    {     }
    Use_Alias:= ReadBool(sectGLOBAL, iniUSEALIAS, True);
    AliasName:= ReadString(sectGLOBAL, iniALIAS, 'PAGER');
    DatabaseFolder:= ReadString(sectGLOBAL, iniDataFolder, 'DATA\');
    WorkPlace:= ReadString(sectGLOBAL, iniDLLS, DEFWORKPLACE);
    //    
    FiscalProtocolFolder:= ReadString(sectGLOBAL, iniFISCAL, DEFFISCALPLACE);
    //     
    FiscalReportViewLen:= ReadInteger(sectGLOBAL, iniFiscalLines, 1000);
    {      - ,  }
    ReadSectionValues(sectDBParams, DataModule1.DataBase1.Params);
    DataModule1.DataBase1.LoginPrompt:= ReadBool(sectGLOBAL, iniLoginPrompt, True);
    { folders }
    AssignWorkPlace(WorkPlace);
    SQLFolder:= ReadString(sectGLOBAL, iniSQLS, 'SQL\');
    SQLSYSFolder:= ReadString(sectGLOBAL, iniSYSSQLS, 'SQL\SYS\');
    SQLVOCFolder:= ReadString(sectGLOBAL, iniVOCSQLS, 'SQL\VOC\');
    ChangeDataBaseAliasOrFolder;
    {}
    //      
    ZonesInServiceList:= ReadString(sectGATE, iniSERVICEZONES, '*');
    //   0,   
    ZonesInServiceListCount:= Length(ZonesInServiceList);
    //   *..,  
    if (ZonesInServiceListCount > 0) and (ZonesInServiceList[1]='*')
    then begin
      ZonesInServiceList:= '*';
      ZonesInServiceListCount:= 0;
    end;
    //  ,      ("x")
//  CBKind.Text:= ReadString(sectOPER, iniDEFAULTPRIORITY, '');
    { LABELS }
    OperLabels:= ReadString(sectOPER, iniOPERTBLLBL, DEFOperLABELS);
    CLIENTLABELS:= ReadString(sectCLIENTS, iniCLIENTLABELS, DEFCLILABELS);
    CallsLABELS:= ReadString(sectCALLS, iniCALLSLABELS, DEFCALLABELS);
    GroupsLABELS:= ReadString(sectGRP, iniGRPLABELS, DEFGRPLABELS);
    GrpDescLABELS:= ReadString(sectGRPDESC, iniGRPDESCLABELS, DEFGRPDESCLABELS);
    { load default rule
    }
    DefaultRule:= ReadString(iniTAPSECTION, iniDEFAULTRULE, '');
    { load pager cp definitions
    }
    S:= ReadString(sectPagerDefs, iniDEFPAGERCPFILE, DEFPAGERCPFILE);
    MOptionsLoadAll.Checked:= ReadBool(sectPagerDefs, iniLOADALLDEFS, False);
    cploadedCount:= LoadECC(S, MOptionsLoadAll.Checked, PagerCodeDefs, CBPageCP.Items);
    if cploadedCount <=0 then begin
      ShowMessage('    '+ S);
    end;
    { activate all views }
    ActivateTables;
    {     ComboBox }
    { because style = list }
    CBZone.ItemIndex:= CBZone.Items.IndexOf(ZonesInServiceList);
    //   
    Cycles.CyclesLoadIni(GateCycles);
    //
    {    TAP  -    }
    CyclesStarted:= ReadBool(iniTAPSECTION, iniCyclesStarted, False);
    // ExternalTAPModuleName -   
    // ExternalTAPModuleName:= ReadString(iniTAPSECTION, iniExtModuleName, '');
    //  HTapDLL
    // LoadMSG2TERMDLLProc(ExternalTAPModuleName, HTapDLL);
  end;
  IniFile.Free;
  {     TAP }
  //
  {    COM  }
  //
  {     TAP }
  TAPRuleLoadIni(CBRule.Items, Rules);
  CBRule.ItemIndex:= CBRule.Items.IndexOf(DefaultRule);
  {     }
  LoadIniMsgQueuePars;
  Result:= True;
end; { LoadIni }

function TFormQueue.StoreIni: Boolean;
var
  IniFile: TIniFile;
begin
  Result:= False;
  IniFile := TIniFile.Create(SearchIni('', INI_PAGER_FILE));
  with IniFile do begin
    WriteBool(iniTAPSECTION, iniCyclesStarted, CyclesStarted);
  end;
  IniFile.Free;
  //     TAP
  //
  Result:= True;
end;

function  TFormQueue.LoginUser(AHCode: THCODE; AUPDATER: LongInt): Boolean;
begin
  LoginUser:= False;
  CurHCode:= AHCode;
  CurUpdater:= AUPDATER;
  LoginUser:= True;
end;

procedure TFormQueue.ShowOperatorInfo(const AZones: String; AHCode: THCode; AUPDATER: Integer);
begin
  with StatusBar1 do begin
    {      }
    if pos(',', AZones)> 0 //   ,  
    then Panels[0].Text:= System.Copy(AZones, 1, 5) + '..-' + AHCode + ':' + IntToStr(AUPDATER)
    else Panels[0].Text:= AZones + '-' + AHCode + ':' + IntToStr(AUPDATER);
  end;
end;

procedure TFormQueue.FormDestroy(Sender: TObject);
begin
  EraseServiceList;
  FreeCyclesStruct(GateCycles);
  Rules.Free;
end;

procedure TFormQueue.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := True;
  with DataModule1 do begin
    if (DSDict.State in [dsEdit]) then begin
      if MessageDlg(': c   ?', mtConfirmation,
        [mbOk, mbCancel], 0) = mrOK then begin
        CanClose := True;
        with QDict do if State = dsEdit
        then Post;
      end else begin
        CanClose := False;
      end;
    end;
  end;
end;

procedure TFormQueue.DisplayHint(Sender: TObject);
begin
  with StatusBar1
  do Panels[Panels.Count-1].Text:= Application.Hint;
end;

procedure TFormQueue.ShowAbonentInfo(const Ab: String);
begin
  with StatusBar1
  do Panels[Panels.Count-1].Text:= Ab;
end;

procedure TFormQueue.FormCreate(Sender: TObject);
var
  Ch: Char;
begin
  FirstTime:= True;
  // pointer MUST be nil before first load
  PagerCodeDefs:= Nil;
  Application.OnHint:= DisplayHint;
  AllreadyRegistered:= False;
  CurHCode  := 'SPC';
  CurUPDATER:= 0;
  {         }
  TmStart:= 0;
  TmFinish:= 0;
  TmInterval:= 0;
  SecondEnter:= False;
  Repeats:= 0;
  cploadedCount:= 0;
  MsgListViewLimit:= DEFMsgListViewLimit;
  Rules:= TStringList.Create;
end;

procedure TFormQueue.MOptionsDlgClick(Sender: TObject);
begin
  FormSettings:= TFormSettings.Create(Application);
  FormSettings.Font.Name:= Font.Name;
  FormSettings.Set2Alias(AliasName, DataBaseFolder, Use_Alias, DataModule1.DataBase1);
  if FormSettings.ShowModal = mrOK then begin
    if FormSettings.FontChanged then begin
      Font:= FormSettings.Font;
//      TabSetMessages.Font.Name:= Font.Name;
      TNVis.TabFont.Name:= Font.Name;
    end;
    if FormSettings.DBLocationChanged then begin
      Use_Alias:= FormSettings.RGByAlias.Checked;
      AliasName:= FormSettings.CBAlias.Text;
      DataBaseFolder:= FormSettings.EDBFolder.Text;
      ChangeDataBaseAliasOrFolder;
      ActivateTables;
    end;
  end;
  FormSettings.Free;
end;

procedure TFormQueue.MFileExitClick(Sender: TObject);
begin
  Close;
end;

procedure TFormQueue.ComboBoxEnter(Sender: TObject);
begin
  {  }
  (Sender as TCombobox).Perform(CB_ShowDropDown, Ord(True), 0);
end;

{ Cat: 0 -  
       1 -    [CurHCode,No]
       2 -  
       3 -   
}
function TFormQueue.FindCustomer(Cat: Integer; const Srch: String): Boolean;
var
  V: LongInt;
begin
  with DataModule1, TableClient do begin
    case Cat of
      1: begin
           try
             V:= StrToInt(Srch);
             IndexName:= '';
             SetKey;
             FieldByName('HCODE').AsString:= CurHCode;
             FieldByName('ABONENT').AsString := Srch;
             if GotoKey then begin
             end else begin
               ETShowStatus(1,'       .');
             end;
           except
             ETShowStatus(1,'    .');
           end;
         end;
      2: begin
           try
             IndexName:= 'ICFIO';
             SetKey;
             FieldByName('FAM').AsString:= GetToken(1, #32, Srch);
             FieldByName('IM').AsString := GetToken(2, #32, Srch);
             FieldByName('OT').AsString := GetToken(3, #32, Srch);
             GotoNearest;
           except
             ETShowStatus(1,'    .');
           end;
         end;
      3: begin
           try
             IndexName:= 'ICORG';
             SetKey;
             FieldByName('ORGNAME').AsString:= Copy(GetToken(1, #32, Srch), 2, 255);
             FieldByName('ORGNO').AsString := GetToken(2, #32, Srch);
             GotoNearest;
           except
             ETShowStatus(1,'    .');
           end;
         end;
      else begin
      end;
    end;
  end;
  Result:= True;
end;

procedure TFormQueue.FillDBCB(const SQLFN: String; List: TStrings; const ACaption: String);
var
  UsedFolder: SQLPathString;
begin
  UsedFolder:= SQLSYSFolder;
  with DataModule1, QDict do begin
    Close;
    SQL.LoadFromFile(ConcatPath(UsedFolder, SQLFN));
    if Use_Alias then begin
    end else begin
      { ChDir(EDBFolder.Text);
              -    SQL
      }
      {
      ChDir(WorkPlace);
      }
    end;
    Open;
    with List do begin
      Clear;
      while not EOF do begin
        Add(Fields[0].AsString);
        Next;
      end;
    end;
  end;
  if AboutBox <> Nil then begin
    AboutBox.LLoading.Caption:= ' : '+ ACaption;
  end else begin
    with StatusBar1
    do Panels[Panels.Count-1].Text:= ' : '+ ACaption;
  end;
  Application.ProcessMessages;
end;

procedure TFormQueue.UpdateDBCBs;
begin
  try
    FillDBCB(SQLZONES, CBZone.Items, ' ');
    //   
    CBZone.Items.Add('*');
    {    0..9? }
//    FillDBCB(SQLKINDS, CBKind.Items, ' ');
  except
    ShowMessage('      .');
  end;
end;

procedure TFormQueue.UpdateDisplayLabels;
var
  i: Integer;
begin
  with DataModule1 do begin
    { dbgrid labels }
    with TableClient do begin
      if Active then begin
        for i:= 1 to FieldCount do begin
          Fields[i-1].DisplayLabel:= GetToken(i, ',', CLIENTLABELS);
        end;
      end;
    end;
    with TableCalls do begin
      if Active then begin
        for i:= 1 to FieldCount do begin
          Fields[i-1].DisplayLabel:= GetToken(i, ',', CALLSLABELS);
        end;
      end;
    end;
    with TableGroups do begin
      if Active then begin
        for i:= 1 to FieldCount do begin
          Fields[i-1].DisplayLabel:= GetToken(i, ',', GROUPSLABELS);
        end;
      end;
    end;
    with TableGrpDesc do begin
      if Active then begin
        for i:= 1 to FieldCount do begin
          Fields[i-1].DisplayLabel:= GetToken(i, ',', GRPDescLABELS);
        end;
      end;
    end;
    {
    with TableOper do begin
      if Active then begin
        for i:= 1 to FieldCount do begin
          Fields[i-1].DisplayLabel:= GetToken(i, ',', OPERLABELS);
        end;
      end;
    end;
    }
  end;
end;

{      }
function TFormQueue.GotoCall(ADate: TDateTime; No: LongInt): Boolean;
var
  Count: LongInt;
begin
  Result:= False;
  Count:= 0;
  with DataModule1, TableCalls do begin
    DisableControls;
    IndexName:= 'IUPD';
    FieldByName('HCODE').AsString:= CurHCode;
    FieldByName('ABONENT').AsString:= CurAbonent;
    FieldByName('UPDATED').AsDateTime:= ADate;
    while not EOF do begin
      Inc(Count);
      if Count = No
      then begin
        Result:= True;
        Break;
      end;
      Next;
    end;
    IndexName:= 'ITIME';
    EnableControls;
  end;
end;

procedure TFormQueue.FormActivate(Sender: TObject);
begin
  if FirstTime then begin
    { debug -  }
    DataModule1.DataBase1.Connected:= False;
    RptSheduled:= False;
    LoadIni;
    ShowOperatorInfo(ZonesInServiceList, CurHCode, CurUPDATER);
    {  -     (    memo) }
    FirstTime:= False;
  end;
end;

procedure TFormQueue.FlushProtocol;
var
  FN: SQLPathString;
begin
  with MProtocol, Lines do begin
    FN:= ConCatPath(FiscalProtocolFolder, FormatDateTime('yymmddhh', Date+Time));
    SaveToFile(FN);
    Clear;
    Add('    :' + FN);
  end;
end;

procedure TFormQueue.FiscalReport(const S: String);
begin
  ETShowStatus(1, S);
  //   memo    
  with MProtocol, Lines do begin
    if Lines.Count > FiscalReportViewLen then begin
      FlushProtocol;
    end;
    Add(S);
  end;
end;

procedure TFormQueue.CBZoneChange(Sender: TObject);
begin
  ZonesInServiceList:= CBZone.Text;
  ZonesInServiceListCount:= Length(ZonesInServiceList);
  //   *..,  
  if (ZonesInServiceListCount > 0) and (ZonesInServiceList[1]='*') then begin
    ZonesInServiceListCount:= 0;
  end;
  FiscalReport('  : '+ ZonesInServiceList);
  //  query: DataModule1.TableCalls.Active:= False; DataModule1.TableCalls.Active:= True;
  //  
  DataModule1.TableCalls.Refresh;
end;

procedure TFormQueue.BSaveFiscalClick(Sender: TObject);
begin
  { }
  FlushProtocol;
end;

procedure TFormQueue.MFileLoadPagerDefClick(Sender: TObject);
begin
  with DataModule1.OpenDialog1 do begin
    Filter:= ' |*.epc| |*.*';
    FilterIndex:= 1;
    DefaultExt:= 'epc';
    if Execute then begin
      if PagerCodeDefs <> Nil then begin
        //   
        Freemem(PagerCodeDefs);
        // make sure anyway
        PagerCodeDefs:= Nil;
      end;
      cploadedCount:= LoadECC(FileName, MOptionsLoadAll.Checked, PagerCodeDefs, CBPageCP.Items);
      if cploadedCount <=0 then begin
        ShowMessage('       '+ FileName);
      end;
    end;
  end;
end;

procedure TFormQueue.MOptionsLoadAllClick(Sender: TObject);
begin
  MOptionsLoadAll.Checked:= not MOptionsLoadAll.Checked;
end;

procedure TFormQueue.MOptionsLoadClick(Sender: TObject);
begin
  {}
end;

procedure TFormQueue.MOptionsStoreClick(Sender: TObject);
begin
  StoreIni;
end;

procedure XlatPChar(var XLATTbl; var p: String);
var
  i, L: Integer;
begin
  L:= Length(p);
  if L <=0
  then Exit;
  for i:= 1 to L do begin
    p[i]:= util1.CA(XLATTbl)[Byte(p[i])];
    //   -    ,   -  
    if p[i] = #0
    then p[i]:= #32;
  end;
  //      ?
end;

{      (  '<'  '>')
   : *  .
  * - 
  . -  
  <*CAP>,<*MSG>,<*TIME>,<*NO> - CAP :12, :d.mm,  h:mm,  : 8
  <date>: d.mm  <*DATE>: dd.mm.yy
  <*CH>,<*Z>   , 
  <*Y_xxx>-    CALLS,  Y:
  C_ - CALLS  D_ - GRPDESC G_ - GROUPS
  A_ - CLIENT P_ - PAGERS  T_ - MODELS
  xxx-      ( - 0)
  <*MNO> <*hh> <*mm> -  :6, :2  :2
  <*HCODE> <*OPER>-    
  <*F>,<*I>,<*O> ,  . ,   -   ()
  <*T> <*CR>, <*LF> = #9, #10, #13
}
function ParsedTag(Tag: String): String;
label
  translit;
var
  no, L: Integer;
  needtranliterate: Boolean;
  clower: Boolean; //    ?
  tagu: String;    // tag   
  Rs: String;
begin
  Result:= '';
  L:= Length(tag);
  if (L <= 1) or (not (tag[1] in ['*', '.']))
  then Exit;
  needtranliterate:= tag[1] = '*';
  System.Delete(tag, 1, 1);
  Dec(L);
  tagu:= ANSIUpperCase(tag);
  clower:= tagu[1] <> tag[1];
  if tagu = 'MSG' then begin
    Rs:= DataModule1.TableCalls.FieldByName('MSG').AsString;
    goto translit;
  end;
  if tagu = 'CAP' then begin
    Rs:= FormQueue.CurCAP;
    goto translit;
  end;
  if tagu = 'CH' then begin
    Rs:= IntToStr(FormQueue.CurInfoChannel);
    goto translit;
  end;
  if tagu = 'Z' then begin
    Rs:= FormQueue.CurZone2Send;
    goto translit;
  end;
  if tagu = 'DATE' then begin
    if clower
    then Rs:= FormatDateTime('d/m',Date)
    else Rs:= FormatDateTime('dd/mm/yy',Date);
    goto translit;
  end;
  if tagu = 'TIME' then begin
    Rs:= FormatDateTime('h:nn',Time);
    goto translit;
  end;
  if tagu = 'HH' then begin
    Rs:= FormatDateTime('hh',Time);
    goto translit;
  end;
  if tagu = 'MM' then begin
    Rs:= FormatDateTime('nn',Time);
    goto translit;
  end;
  if tagu = 'CR' then begin
    Rs:= #13;
    goto translit;
  end;
  if tagu = 'LF' then begin
    Rs:= #10;
    goto translit;
  end;
  if tagu = 'T' then begin
    Rs:= #9;
    goto translit;
  end;
  if tagu = 'NUL' then begin
    Rs:= #0;
    goto translit;
  end;
  if tagu = 'HCODE' then begin
    Rs:= DataModule1.TableCalls.FieldByName('HCODE').AsString;
    goto translit;
  end;
  if tagu = 'OPER' then begin
    Rs:= DataModule1.TableCalls.FieldByName('UPDATER').AsString;
    goto translit;
  end;
  if tagu = 'NO' then begin
    Rs:= LeadZero(DataModule1.TableCalls.FieldByName('ABONENT').AsString, 8);
    goto translit;
  end;
  if tagu = 'MNO' then begin
    // Rs:= LeadZero(DataModule1.TableCalls.FieldByName('ID').AsString, 6);
    Rs:= LeadZero(IntToStr(FormQueue.CurMsgNo), 6);
    goto translit;
  end;
  if (tagu = 'F') or (tagu = 'I') or (tagu = 'O') then begin
    case tagu[1] of
    'F': Rs:= DataModule1.TableClient.FieldByName('FAM').AsString;
    'I': Rs:= DataModule1.TableClient.FieldByName('IM').AsString;
    'O': Rs:= DataModule1.TableClient.FieldByName('OT').AsString;
    end;
    //    (  - )
    if clower and (Length(Rs)>1) then begin
      //   
      Rs:= Rs[1];
    end;
    goto translit;
  end;
  {            }
  if (L > 2) and (tagu[2] = '_') and
    (tagu[1] in ['A','C','D','G','P','T']) then begin
    {    C_
    C_ - CALLS  D_ - GRPDESC G_ - GROUPS
    A_ - CLIENT P_ - PAGERS  T_ - MODELS }
    {   ,     }
    Rs:= Copy(tagu, 3, L - 3 + 1);
    if isDecimal(Rs) then begin
      no:= StrToIntDef(Rs, 0);
      case tagu[1] of
      'C': Rs:= DataModule1.TableCalls.Fields[no].AsString;
      'D': Rs:= DataModule1.TableGrpDesc.Fields[no].AsString;
      'G': Rs:= DataModule1.TableGroups.Fields[no].AsString;
      'A': Rs:= DataModule1.TableClient.Fields[no].AsString;
      'P': Rs:= DataModule1.TablePagers.Fields[no].AsString;
      'T': Rs:= DataModule1.TableModels.Fields[no].AsString;
      end;
    end else begin
      case tagu[1] of
      'C': Rs:= DataModule1.TableCalls.FieldByName(Rs).AsString;
      'D': Rs:= DataModule1.TableGrpDesc.FieldByName(Rs).AsString;
      'G': Rs:= DataModule1.TableGroups.FieldByName(Rs).AsString;
      'A': Rs:= DataModule1.TableClient.FieldByName(Rs).AsString;
      'P': Rs:= DataModule1.TablePagers.FieldByName(Rs).AsString;
      'T': Rs:= DataModule1.TableModels.FieldByName(Rs).AsString;
      end;
    end;
    goto translit;
  end;
translit:
  {         }
  if needtranliterate and (FormQueue.CurCPxlatIndex >=0) and
    (FormQueue.CurCPxlatIndex < FormQueue.cploadedCount) then begin
    {      }
    XlatPChar(FormQueue.PagerCodeDefs^[FormQueue.CurCPxlatIndex].XLAT, Rs);
  end;
  Result:= Rs;
end;

{ callback ParsedTagNULL      ( )
       
}
function ParsedTagNULL(Tag: String): String;
label
  translit;
var
  no, L: Integer;
  needtranliterate: Boolean;
  clower: Boolean; //    ?
  tagu: String;    // tag   
  Rs: String;
begin
  Result:= '';
  L:= Length(tag);
  if (L <= 1) or (not (tag[1] in ['*', '.']))
  then Exit;
  needtranliterate:= tag[1] = '*';
  System.Delete(tag, 1, 1);
  Dec(L);
  tagu:= ANSIUpperCase(tag);
  clower:= tagu[1] <> tag[1];
  if tagu = 'CR' then begin
    Rs:= #13;
    goto translit;
  end;
  if tagu = 'LF' then begin
    Rs:= #10;
    goto translit;
  end;
  if tagu = 'T' then begin
    Rs:= #9;
    goto translit;
  end;
  if tagu = 'NUL' then begin
    Rs:= #0;
    goto translit;
  end;
translit:
  {         }
  if needtranliterate and (FormQueue.CurCPxlatIndex >=0) and
    (FormQueue.CurCPxlatIndex < FormQueue.cploadedCount) then begin
    {      }
    XlatPChar(FormQueue.PagerCodeDefs^[FormQueue.CurCPxlatIndex].XLAT, Rs);
  end;
  Result:= Rs;
end;

{ capcode  AMsgNo   CurCAP  CurMsgNo
}
function TFormQueue.PrepareMessageByRule(const rule: String): String;
var
  fa, im, ot: String;
  S, SS: String;
  i: Integer;
  MsgList,
  BlockList,
  KindList: TList;
  Rs: String;
begin
  MsgList:= TList.Create;
  BlockList:= TList.Create;
  KindList:= TList.Create;
  {---------------------------------------------}
  if Rule = '' then begin
    S:= DataModule1.TableCalls.FieldByName('MSG').AsString;
    if (CurCPxlatIndex >=0) and (CurCPxlatIndex < cploadedCount) then begin
      XlatPChar(PagerCodeDefs^[CurCPxlatIndex].XLAT, S);
    end;
    S:= ValidateCAP(CurCAP) + #13 + S;
  end else begin
    //     : &#xxx;
    S:= WEBStyleString2ASCII(Rule);
    ReplaceTag(S, '<', '>', #0, ParsedTag);
  end;
  {---------------------------------------------}
  TransactionFillMessages(S, CurTAPPar, CurMsgLimit, MsgList);
  TransactionFillBlocks(S, MsgList, CurTAPPar.tapBlockLen, BlockList, KindList);
  Rs:= '';
  for i:= 1 to BlockList.Count do begin
    SS:= GenerateMessageBlock(CurMsgNo, i-1, S, CurTAPPar, MsgList, BlockList, KindList);
    Rs:= Rs + SS;
  end;
  MsgList.Free;
  BlockList.Free;
  KindList.Free;
  Result:= Rs;
end;

{         
  0-       ARpt = <0
}
function CalcPlanningMsgRpts(AStart, ARpt: TDateTime): Integer;
var
  tm: TDateTime;
  R: Integer;
begin
  tm:= Date + Time - AStart;
  if (tm < 0) or (ARpt <= 0) then R:= 0 else begin
    try
      R:= Trunc(tm / ARpt) + 1;
    except
      R:= 0;
    end;
  end;
  Result:= R;
end;

{ 
  True  -       ,
       -   
  False -      
      False
}
function TFormQueue.isTime2Send: Boolean;
var
  RptSent,
  PlanningMsgRpts: Integer;
  Date2Send, Time2Send, Time2Stop, RepeatInterval: TDateTime;
begin
  try
    with DataModule1.TableCalls do begin
      if FieldByName('SSHEDULE').AsString[1] in ['X','x'] then begin
        {   ,    ,  -     }
        {     }
        if FieldByName('REPEATED').IsNull
        then RptSent:= 0 //  ,   
        else RptSent:= FieldByName('REPEATED').AsInteger;
        {         }
        Date2Send:= Trunc(FieldByName('SDATE').AsDateTime);
        Time2Send:= Frac(FieldByName('SSTART').AsDateTime);
        RepeatInterval:= FieldByName('SRPTMIN').AsInteger/DAYINMINUTES;
        PlanningMsgRpts:= CalcPlanningMsgRpts(Date2Send + Time2Send, RepeatInterval);
        Result:= RptSent < PlanningMsgRpts;
      end else begin
        {       -    }
        {  -   ? }
        Result:= not FieldByName('ABONENT').IsNull;
      end;
    end;
  except
  end;
end;

{   
  AComplete  - True -  
             - False -    (   )
}
procedure TFormQueue.UpdateList(AComplete: Boolean);
begin
  try
    with DataModule1.TableCalls do begin
      DisableControls;
      if AComplete then begin
        // for QueryCalls: // Close; Open;
        First;
      end;
      Refresh;
      EnableControls;
    end;
  except
    //   ?
  end;
end;

{
  
  0-   
  1-   c  cap-    
  2-     
      0
}
function  TFormQueue.IsCallGroup: Word;
begin
  Result:= 0;
  try
    with DataModule1, TableCalls do begin
      if FieldByName('CALLGRP').AsString = 'x' then begin
        if (TableGrpDesc.FieldByName('GCAP').isNull) or (not IsDecimal(TableGrpDesc.FieldByName('GCAP').AsString)) then begin
          {     cap-  }
          Result:= 2;
          CurInfoChannel:= 0;
        end else begin
          {    cap-  /   }
          Result:= 1;
          CurInfoChannel:= DataModule1.TableGRPDesc.FieldByName('GCHAN').AsInteger;
        end;
      end;
    end;
  except
  end;
end;

{        ,   
  (          )
   False   
   -    False
}
function TFormQueue.FirstMessageReady2Send: Boolean;
begin
  Result:= False;
  try
    with DataModule1.TableCalls do begin
  //          
      //if not FindFirst
      //then Exit;
      if DataModule1.DSCalls.State in [dsEdit]
      then Post;
      First;
      while not EOF do begin
        if isTime2Send then begin  //   
          //     DDE
          EDDEMan.NoResponse:= False;
          Result:= True;
          Exit;
        end;
        // if not FindNext  //    
        // then Exit;
        Next;
      end;
    end;
  except
    //      False
  end;
end;

{   
       255 
}
function TFormQueue.GetCurRule: String ;
begin
  Result:= Rules.Values[CBRule.Text];
  {
var
  p, L: Integer;
begin
  Result:= '';
  if (CBRule.ItemIndex < Rules.Count) and (CBRule.ItemIndex >= 0) then begin
    L:= Length(Rules[CBRule.ItemIndex]);
    p:= Pos('=', Rules[CBRule.ItemIndex]);
    if p > 0 then begin
      Inc(p);
      Dec(L, p);
      if L > 0
      then Result:= Copy(Rules[CBRule.ItemIndex], p, 255);
    end else Result:= Rules[CBRule.ItemIndex];
  end;
  }
end;

{
  :
  p -    (wo)
  :
  p-  TAP ,      
}
procedure TFormQueue.PrepareTAPMessage(const Rule: String; var p: String);
begin
  //           
  curCallGroupKind:= IsCallGroup;
  //       TableClient         
  //     CAP   
  {  capcode      12 ,    ! }
  {  0-     1-   c  cap-    
     2-     
  }
  case curCallGroupKind of
  0, 2: begin
          CurCAP:= ValidateCAP(DataModule1.TableClient.FieldByName('CAP').AsString);
          CurInfoChannel:= 0;
        end;
  1:    begin
          CurCAP:= ValidateCAP(DataModule1.TableGrpDesc.FieldByName('GCAP').AsString);
          CurInfoChannel:= DataModule1.TableGrpDesc.FieldByName('GCHAN').AsInteger;
        end;
  end;
  {    capcode    }
  // ....    ....
  {      CHARSET }
  CurCPxlatIndex:= CBPageCP.Items.IndexOf(DataModule1.TableModels.FieldByName('CHARSET').AsString);
  {    }
  CBPageCP.ItemIndex:= CurCPxlatIndex;
  {   }
  CurMsgNo:= DataModule1.TableCalls.FieldByName('MSGNO').AsInteger;
  { curCallGroupKind        }
  {   }
  CurZone2Send:= DataModule1.TableCalls.FieldByName('ZONE').AsString;
  {    :
  <CAP>,<DATE>,<TIME>,<NO>,<F>,<I>,<O>- CAP , , ,    
  capcode  AMsgNo   CurCAP  CurMsgNo
  }
  p:= PrepareMessageByRule(Rule);
  {   }
  Memo1.Text:= p;
end;

{  PrepareTAPMessage -> PrepareMessageByRule
  :
  True -  
  False-   (   )
}
function  TFormQueue.NextMessage: Boolean;
begin
  Result:= False;
  FHasMsg:= False;
  {          }
  try
    if FirstMessageReady2Send and MarkMessageAs(ch_BUSY) then begin
      //       1  
      curCallGroupKind:= IsCallGroup;
      case curCallGroupKind of
      0,1: begin
           // 0 -   
           // 1 -      cap-    
           LinkClient2CallsOrGroups(curCallGroupKind=0);
           PrepareTAPMessage(GetCurRule, CurMsgStr);
           SendTAPMessage(CurMsgStr);
           // ShowMessage('    ');
         end;
      2: begin
           //    (     )
           LinkClient2CallsOrGroups(False);
           with DataModule1.TableGroups do begin
             DataModule1.TableGroups.FindFirst;
             {  cap-    }
             while not DataModule1.TableGroups.EOF do begin
               PrepareTAPMessage(GetCurRule, CurMsgStr);
               SendTAPMessage(CurMsgStr);
               ETShowStatus(1, '    '+DataModule1.TableGroups.FieldByName('ABONENT').AsString);
               // ShowMessage('  ');
               if not DataModule1.TableGroups.FindNext
               then Break;
             end;
           end;
         end;
      end; { case }
      FHasMsg:= True;
      Result:= True;
    end else begin
      //    ,    : UpdateList(True);
    end;
  except
  end;  
end;

function TFormQueue.GetCurrentPriority: Integer;
var
  s: String;
  Pr: Integer;
begin
  try
    s:= DataModule1.TableCalls.FieldByName('SKIND').AsString;
  except
    FiscalReport('     (SKIND),     '+IntToStr(OQueue.MsgQueuePars.DefaultPrior));
  end;
  if Length(s) = 0
  then Pr:= OQueue.MsgQueuePars.DefaultPrior
  else Pr:= Ord(S[1])-32;
 //    
  if Pr < 0
  then Pr:= 0 else begin
    if Pr > 63
    then Pr:= 63;
  end;
  Result:= Pr;
end;

{   "dataset is RO" -     QueryCALLS
}
procedure TFormQueue.SetCurrentPriority(APrior: Integer);
var
  s: String;
  Pr: Integer;
begin
  //    
  if APrior < 0
  then APrior:= 0 else begin
    if APrior > 63
    then APrior:= 63;
  end;
  S:= Chr(APrior+32);
  with DataModule1.TableCalls do begin
    try
      if not (DataModule1.DSCalls.State in [dsEdit])
      then Edit;
      FieldByName('SKIND').AsString:= s;
    except
      FiscalReport('  (SKIND)   ');
    end;
  end;
end;

{       
   ,    
}
procedure TFormQueue.FailedMessageSentSuccess;
var
  IDStr: String;
  p: Integer;
begin
  with OQueue.MsgQueuePars do begin
    try
      //     
      IDStr:= IntToStr(DataModule1.TableCalls.FieldByName('ID').AsInteger);
      p:= LBFails.Items.IndexOfName(IDStr);
    except
      Exit;
    end;
    if p >= 0 then begin
      // 
      LBFails.Items.Delete(p);
    end;
  end;
end;

{ ,     p,    
   -      
}
function TFormQueue.ProcessFailedMessage: Boolean;
var
  S, IDStr: String;
  OperTabNo: Integer;
  Fails: Integer;
begin
  Result:= False;
  with OQueue.MsgQueuePars do begin
    try
      //    
      IDStr:= IntToStr(DataModule1.TableCalls.FieldByName('ID').AsInteger);
      OperTabNo:= DataModule1.TableCalls.FieldByName('UPDATER').AsInteger;
      S:= LBFails.Items.Values[IDStr];
    except
      Exit;
    end;
    //   
    if S = '' then begin
      //       
      if LBFails.Items.Count > FailListLimit then begin
        // ,    
        FiscalReport('  :'+IntToStr(LBFails.Items.Count));
        Exit;
      end else begin
        //    
        LBFails.Items.Add(IDStr+'=');
      end;
    end;
    Fails:= StrToIntDef(GetToken(1, ',' ,S), 0);
    //  
    Inc(Fails);

    if PriorDecreaseAfterFail then begin
      //   (0-  , 63- )
      // NPriorDecreaseAfterFail     
      if (Fails mod NPriorDecreaseAfterFail) = 0 then begin
        CurrentPriority:= CurrentPriority + 1;
        //  QueryCalls
        // Inc(FailPrior);
        //  -      
        //      
        MarkMessageAs(ch_READY);
      end;
    end;
    //  
    if WarningAfterFail then begin
      //  
      if (Fails mod NWarningAfterFail) = 0
      then WarningOperator(OperTabNo,
        ' ('+IDStr+')    '+ IntToStr(Fails)+ ' : "'+
        DataModule1.TableCalls.FieldByName('MSG').AsString+'"');
    end;
    //   
    LBFails.Items.Values[IDStr]:= IntToStr(Fails)+','+IntToStr(CurrentPriority);
    Result:= True;
  end;
end;

{ :
   0 -    
   1 -   ,   (,  )
   2 -  :
              ,    
}
function TFormQueue.SendTAPMessage(const p: String): Integer;
var
  i, j: Integer;
  Topic, Nm, Vl, ASOk, ASFail:String;
begin
  Result:= 2;
  if CyclesStarted then begin
    {   }
    {     / item }
    j:= 0;
    for i:= 0 to GateCycles.ModuleCount - 1 do begin
      GateCycles.Cycles^[i].Status:= mst_waitconfirm;
    end;
    for i:= 0 to GateCycles.TopicItems.Count - 1 do begin
      //      Nm-  item    Vl-  item ( )
      if GetTopicItemVal(GateCycles, i, Topic, Nm, Vl) then begin
        //    &#xxx  
        Vl:= WEBStyleString2ASCII(Vl);
        //     
        Util1.ReplaceTag(Vl, '<', '>', #0, ParsedTag);
        if Vl <> '' then begin
          // 
          if Item1^[j] <> Nil
          then Item1^[j].Text:= Vl;
          // StatusBar1.Panels[StatusBar1.Panels.Count-1].Text:= ChangeChars(#9,#32, Vl);
          Inc(j);
        end; { if }
      end; { if }
    end; { for }
  end else begin
    // Success:= Send2InternalTAPDeviceDriver(p);
  end; { if }
  Result:= 0;
end;

//   -   DDE
// (   -   callback ParsedTagNULL)
procedure TFormQueue.SendNULLTAPMessage;
var
  i, j: Integer;
  Topic, Nm, Vl:String;
begin
  //      
  if CyclesStarted then begin
    for i:= 1 to GateCycles.ModuleCount do begin
      //   
      GateCycles.Cycles^[i-1].Status:= mst_ready;
    end;

    for i:= 0 to GateCycles.TopicItems.Count - 1 do begin
      //      Nm-  item    Vl-  item ( )
      if GetTopicItemVal(GateCycles, i, Topic, Nm, Vl) then begin
        //    &#xxx  
        Vl:= WEBStyleString2ASCII(Vl);
        //     
        Util1.ReplaceTag(Vl, '<', '>', #0, ParsedTag);
        if Vl <> '' then begin
          // 
          if Item1^[j] <> Nil
          then Item1^[j].Text:= Vl;
        end;
      end;  
    end;
  end;
end;

{   
  -   ( SREPEAT <> 'x'   SREPEAT >    )
  -     SREPEAT  
    True
     ( )  False
}
function  TFormQueue.MarkMessageAs(AState: Char): Boolean;
var
  RptSent: Integer;
  Time2Stop: TDateTime;
begin
  {}
  try
    with DataModule1.TableCalls do begin
      if not (DataModule1.DSCalls.State in [dsEdit])
      then Edit;
      if AState in ['X', 'x'] then begin
        //          
        if FieldByName('SREPEAT').AsString = 'x' then begin
          {   }
          {           }
          Time2Stop:= Frac(FieldByName('SFINISH').AsDateTime);
          {     }
          if FieldByName('REPEATED').IsNull
          then RptSent:= 0 //  ,   
          else RptSent:= FieldByName('REPEATED').AsInteger;
          {    ,      ,  }
          if Time > Time2Stop then begin
            FieldByName('DELIVERED').AsString:= 'x';
          end;
          {    }
          FieldByName('REPEATED').AsInteger:= RptSent+1;
        end else begin
          {   -     }
          FieldByName('DELIVERED').AsString:= 'x';
        end;
      end else begin
        FieldByName('DELIVERED').AsString:= AState;
      end;
    end;
    Result:= True;
  except
    Result:= False;
  end;
end;

{   TableClient       Client  Group
}
procedure TFormQueue.LinkClient2CallsOrGroups(A2Calls: Boolean);
begin
  {}
  with DataModule1,TableClient do begin
    if A2Calls then begin
      if MasterSource <> DSCalls then begin
        {    }
        DBGGroups.Visible:= False;
        DBGGrpDesc.Visible:= False;
        {}
        Active:= False;
        MasterSource:= DSCalls;
//        IndexName:= '';
//        MasterFields:= 'HCODE;ABONENT';
//        IndexFielNames:= 'HCODE;ABONENT';
        Active:= True;
      end;
    end else begin
      if MasterSource <> DSGroups then begin
        {    }
        DBGGroups.Visible:= True;
        DBGGrpDesc.Visible:= True;
        {}
        Active:= False;
        MasterSource:= DSGroups;
//        IndexName:= '';
//        MasterFields:= 'HCODE;ABONENT';
//        IndexFielNames:= 'HCODE;ABONENT';
        Active:= True;
      end;
    end;
  end;
end;

procedure TFormQueue.TBNoSendClick(Sender: TObject);
begin
  DataModule1.TableCalls.Active:= False;
end;

procedure TFormQueue.MOptionsStopCyclesClick(Sender: TObject);
begin
  //    
  FormQueue.CyclesStarted:= False;
end;

procedure TFormQueue.MOptionsStartCyclesClick(Sender: TObject);
begin
  //    
  FormQueue.CyclesStarted:= True;
end;

{
function  TFormQueue.LoadMSG2TERMDLLProc(const AExternalTAPModuleName: String; var ADLLHandle: Integer): TFarProc;
var
  buf: array[0..127] of Char;
  ch: String[1];
begin
  Result:= Nil;
  ch:= System.Copy(ExtractFileExt(AExternalTAPModuleName), 2, 1);
  ExternalTAPModuleType:= #0;
  if Length(ch) = 1
  then ExternalTAPModuleType:= Upcase(ch[1]);
  ExternalTAPModuleName:= AExternalTAPModuleName;
  case ExternalTAPModuleType of
  'D':begin
        ADLLHandle:= LoadLibrary(StrPCopy(buf, AExternalTAPModuleName));
        if ADLLHandle = 0 then begin
          ShowMessage(' '+ AExternalTAPModuleName + '     ');
          Exit;
        end else begin
          TapDLLProc:= GetProcAddress(ADLLHandle, 'MSG2TERM');
          if TapDLLProc = Nil then begin
            ShowMessage('   '+ AExternalTAPModuleName +
            '    MSG2TERM');
            FreeLibrary(ADLLHandle);
            Exit;
          end;
          Result:= TapDLLProc;
        end;
      end;
  'E':begin
        ShowMessage(' '+ AExternalTAPModuleName + '    ');
      end;
  end;
end;
}

procedure TFormQueue.MOptionsExtModuleEditClick(Sender: TObject);
begin
  {    .
    AStore - True -   INI  
  }
  if DlgCycles(GateCycles, True) then begin
    //   
    FiscalReport('   ');
  end;
end;

procedure TFormQueue.MOptionsQueueClick(Sender: TObject);
begin
  {}
  FormOptsQueue:= TFormOptsQueue.Create(Application);
  FormOptsQueue.Font.Name:= Font.Name;
  if FormOptsQueue.ShowModal = mrOK then begin
    {}
  end;
  FormOptsQueue.Free;
end;

{      AOper
   S
}
procedure TFormQueue.WarningOperator(AOper: Integer; S: String);
begin
  //   ,    
  FiscalReport('   '+ IntToStr(AOper)+':'+S);
  //   
end;

{ 
  False - 
  True  -     ZonesInServiceList
}
function  TFormQueue.IsInZoneList(const AZone: String): Boolean;
var
  p: Integer;
  f: Integer;
begin
  //     
  // p:= Pos(ANSIUpperCase(AZone), ANSIUpperCase(ZonesInServiceList));
  if ZonesInServiceListCount = 0 then begin
    Result:= True;
    Exit;
  end;
  p:= Pos(AZone, ZonesInServiceList);
  //        ","
  //   ,     ZonesInServiceList
  f:= p + Length(AZone);
  Result:= (p = 1) or (ZonesInServiceList[p-1]=',') and
    ((f < ZonesInServiceListCount) or (ZonesInServiceList[f]=','));
end;

procedure TFormQueue.TNVisChange(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  //
  UpdateDisplayLabels;
end;

//    ,  True
//     (  )     True
function TFormQueue.AllTopicsResponded: Boolean;
var
  curm: Integer;
begin
  with GateCycles do begin
    for Curm:= 0 to ModuleCount -1 do begin
      // ,    (   ,   )
      if (Cycles^[CurM].SOk = '') or (not Cycles^[CurM].Enabled) or
        (Cycles^[CurM].Status in [mst_sent, mst_failed]) then begin
        //       
      end else begin
        //    ()    ,
        Result:= False;
        //   
        Exit;
      end;
    end;
  end;
  Result:= True;
end;

procedure TFormQueue.EDdeServerConvExecuteMacro(Sender: TObject; Msg: TStrings);
var
  rc: PCycle;
begin
  //     
  rc:= GetCycle(GateCycles, (Sender as TEDDEServerConv).Topic);
  if rc = Nil
  then Exit; //     (    Cycle ?)
  //    DDE
  // -        ?----------------------------
  // EDDEMan.NoResponse:= True;
  case cycles.CompTopicRet(GateCycles, (Sender as TEDDEServerConv).Topic,Msg.Text) of
  0: begin
       //      
       rc^.Status:= mst_sent;
     end;
  1: begin
       rc^.Status:= mst_failed;
       //     -  ,  
       FormQueue.ProcessFailedMessage; //   
       //       
       //     
       //              
     end;
   end;
  // ShowMessage(': '+(Sender as TEDDEServerConv).Topic +':'+ Msg.Text);
end;

{    DModule.DataModule1.Timer1Timer      
   False -     
  True-  
      ,     
  (     CALLS)
}
function GateDDEStep: Boolean;

{    }
function DoNextMessage: Boolean;
begin
  with FormQueue, GateCycles do begin
    CurCycle:= 0;
    SetCycleStatuses(FormQueue.GateCycles, mst_ready);
    // FormQueue.UpdateList(True);
    Result:= NextMessage;
  end;
end;

begin
  Result:= False;
  Inc(GateStepENTERED);  //   
  try                    //    
    with FormQueue.GateCycles do begin
      if FormQueue.NextMessageReady then begin
        //    
        Inc(CurCycle, WaitSec);
        //     ?
        if CurCycle >= TimeOutSec then begin
          //   
          // 
          FormQueue.FiscalReport('-       DDE.');
          //      
          //     NextMessage     
          FormQueue.ProcessFailedMessage;
          //       
          DoNextMessage;
          //  ,     ,  :  FormQueue.UpdateList(True);
        end else begin
          //  
          //     ,  
          if FormQueue.AllTopicsResponded then begin
            //     (   1 )   
            // ..  
            FormQueue.FailedMessageSentSuccess; //    ,   .
            //  (     )
            FormQueue.MarkMessageAs(ch_SENT);
            //   ..
            DoNextMessage;
          end; { if }
        end; { if }
      end else begin
        DoNextMessage;
      end; { if FMsgHas }
    end;
  except
  end;
  Dec(GateStepENTERED);
  Result:= True;
end;

procedure TFormQueue.TBStartClick(Sender: TObject);
begin
  CyclesStarted:= not CyclesStarted;
  if CyclesStarted then begin
    TBStart.ImageIndex:= 0;
  end else begin
    TBStart.ImageIndex:= 1;
  end;
end;


procedure TFormQueue.BClearFailsClick(Sender: TObject);
begin
  LBFails.Items.Clear;
end;



end.
