unit MSCommLib;

{ Microsoft Comm Control 5.0 }
{ Version 1.1 }

interface

uses Windows, ActiveX, Classes, Graphics, OleCtrls, StdVCL;

const
  LIBID_MSCommLib: TGUID = '{648A5603-2C6E-101B-82B6-000000000014}';

const

{ MS Comm Control Handshake Constants }

{ HandshakingConstants }

  NoHandshaking = 0;
  XonXoff = 1;
  RtsCts = 2;
  XonXoffAndRtsCts = 3;

{ MS Comm Control Handshake Constants }

{ HandshakeConstants }

  comNone = 0;
  comXOnXoff = 1;
  comRTS = 2;
  comRTSXOnXOff = 3;

{ Error Constants }

{ ErrorConstants }

  comInvalidPropertyValue = 380;
  comGetNotSupported = 394;
  comSetNotSupported = 383;
  comPortInvalid = 8002;
  comPortAlreadyOpen = 8005;
  comPortOpen = 8000;
  comNoOpen = 8012;
  comSetCommStateFailed = 8015;
  comPortNotOpen = 8018;
  comReadError = 8020;
  comDCBError = 8021;
  comBreak = 1001;
  comCTSTO = 1002;
  comDSRTO = 1003;
  comFrame = 1004;
  comOverrun = 1006;
  comCDTO = 1007;
  comRxOver = 1008;
  comRxParity = 1009;
  comTxFull = 1010;
  comDCB = 1011;

{ Error constants. }

{ CommEventConstants }

  comEventBreak = 1001;
  comEventCTSTO = 1002;
  comEventDSRTO = 1003;
  comEventFrame = 1004;
  comEventOverrun = 1006;
  comEventCDTO = 1007;
  comEventRxOver = 1008;
  comEventRxParity = 1009;
  comEventTxFull = 1010;
  comEventDCB = 1011;

{ OnComm constants. }

{ OnCommConstants }

  comEvSend = 1;
  comEvReceive = 2;
  comEvCTS = 3;
  comEvDSR = 4;
  comEvCD = 5;
  comEvRing = 6;
  comEvEOF = 7;

{ InputMode Constants }

{ InputModeConstants }

  comInputModeText = 0;
  comInputModeBinary = 1;

const

{ Component class GUIDs }
  Class_MSComm: TGUID = '{648A5600-2C6E-101B-82B6-000000000014}';

type

{ Forward declarations }
  IMSComm = interface;
  DMSComm = dispinterface;
  DMSCommEvents = dispinterface;

  HandshakingConstants = TOleEnum;
  HandshakeConstants = TOleEnum;
  ErrorConstants = TOleEnum;
  CommEventConstants = TOleEnum;
  OnCommConstants = TOleEnum;
  InputModeConstants = TOleEnum;

{ Dispatch interface for Microsoft Comm Control }

  IMSComm = interface(IDispatch)
    ['{E6E17E90-DF38-11CF-8E74-00A0C90F26F8}']
    function Get_CDHolding: WordBool; safecall;
    procedure Set_CDHolding(Value: WordBool); safecall;
    function Get_CDTimeout: Integer; safecall;
    procedure Set_CDTimeout(Value: Integer); safecall;
    function Get_CommID: Integer; safecall;
    procedure Set_CommID(Value: Integer); safecall;
    function Get_CommPort: Smallint; safecall;
    procedure Set_CommPort(Value: Smallint); safecall;
    function Get__CommPort: Smallint; safecall;
    procedure Set__CommPort(Value: Smallint); safecall;
    function Get_CTSHolding: WordBool; safecall;
    procedure Set_CTSHolding(Value: WordBool); safecall;
    function Get_CTSTimeout: Integer; safecall;
    procedure Set_CTSTimeout(Value: Integer); safecall;
    function Get_DSRHolding: WordBool; safecall;
    procedure Set_DSRHolding(Value: WordBool); safecall;
    function Get_DSRTimeout: Integer; safecall;
    procedure Set_DSRTimeout(Value: Integer); safecall;
    function Get_DTREnable: WordBool; safecall;
    procedure Set_DTREnable(Value: WordBool); safecall;
    function Get_Handshaking: HandshakeConstants; safecall;
    procedure Set_Handshaking(Value: HandshakeConstants); safecall;
    function Get_InBufferSize: Smallint; safecall;
    procedure Set_InBufferSize(Value: Smallint); safecall;
    function Get_InBufferCount: Smallint; safecall;
    procedure Set_InBufferCount(Value: Smallint); safecall;
    function Get_Break: WordBool; safecall;
    procedure Set_Break(Value: WordBool); safecall;
    function Get_InputLen: Smallint; safecall;
    procedure Set_InputLen(Value: Smallint); safecall;
    function Get_Interval: Integer; safecall;
    procedure Set_Interval(Value: Integer); safecall;
    function Get_NullDiscard: WordBool; safecall;
    procedure Set_NullDiscard(Value: WordBool); safecall;
    function Get_OutBufferSize: Smallint; safecall;
    procedure Set_OutBufferSize(Value: Smallint); safecall;
    function Get_OutBufferCount: Smallint; safecall;
    procedure Set_OutBufferCount(Value: Smallint); safecall;
    function Get_ParityReplace: WideString; safecall;
    procedure Set_ParityReplace(const Value: WideString); safecall;
    function Get_PortOpen: WordBool; safecall;
    procedure Set_PortOpen(Value: WordBool); safecall;
    function Get_RThreshold: Smallint; safecall;
    procedure Set_RThreshold(Value: Smallint); safecall;
    function Get_RTSEnable: WordBool; safecall;
    procedure Set_RTSEnable(Value: WordBool); safecall;
    function Get_Settings: WideString; safecall;
    procedure Set_Settings(const Value: WideString); safecall;
    function Get_SThreshold: Smallint; safecall;
    procedure Set_SThreshold(Value: Smallint); safecall;
    function Get_Output: OleVariant; safecall;
    procedure Set_Output(Value: OleVariant); safecall;
    function Get_Input: OleVariant; safecall;
    procedure Set_Input(Value: OleVariant); safecall;
    function Get_CommEvent: Smallint; safecall;
    procedure Set_CommEvent(Value: Smallint); safecall;
    function Get_EOFEnable: WordBool; safecall;
    procedure Set_EOFEnable(Value: WordBool); safecall;
    function Get_InputMode: InputModeConstants; safecall;
    procedure Set_InputMode(Value: InputModeConstants); safecall;
    procedure AboutBox; safecall;
    property CDHolding: WordBool read Get_CDHolding write Set_CDHolding;
    property CDTimeout: Integer read Get_CDTimeout write Set_CDTimeout;
    property CommID: Integer read Get_CommID write Set_CommID;
    property CommPort: Smallint read Get_CommPort write Set_CommPort;
    property _CommPort: Smallint read Get__CommPort write Set__CommPort;
    property CTSHolding: WordBool read Get_CTSHolding write Set_CTSHolding;
    property CTSTimeout: Integer read Get_CTSTimeout write Set_CTSTimeout;
    property DSRHolding: WordBool read Get_DSRHolding write Set_DSRHolding;
    property DSRTimeout: Integer read Get_DSRTimeout write Set_DSRTimeout;
    property DTREnable: WordBool read Get_DTREnable write Set_DTREnable;
    property Handshaking: HandshakeConstants read Get_Handshaking write Set_Handshaking;
    property InBufferSize: Smallint read Get_InBufferSize write Set_InBufferSize;
    property InBufferCount: Smallint read Get_InBufferCount write Set_InBufferCount;
    property Break: WordBool read Get_Break write Set_Break;
    property InputLen: Smallint read Get_InputLen write Set_InputLen;
    property Interval: Integer read Get_Interval write Set_Interval;
    property NullDiscard: WordBool read Get_NullDiscard write Set_NullDiscard;
    property OutBufferSize: Smallint read Get_OutBufferSize write Set_OutBufferSize;
    property OutBufferCount: Smallint read Get_OutBufferCount write Set_OutBufferCount;
    property ParityReplace: WideString read Get_ParityReplace write Set_ParityReplace;
    property PortOpen: WordBool read Get_PortOpen write Set_PortOpen;
    property RThreshold: Smallint read Get_RThreshold write Set_RThreshold;
    property RTSEnable: WordBool read Get_RTSEnable write Set_RTSEnable;
    property Settings: WideString read Get_Settings write Set_Settings;
    property SThreshold: Smallint read Get_SThreshold write Set_SThreshold;
    property Output: OleVariant read Get_Output write Set_Output;
    property Input: OleVariant read Get_Input write Set_Input;
    property CommEvent: Smallint read Get_CommEvent write Set_CommEvent;
    property EOFEnable: WordBool read Get_EOFEnable write Set_EOFEnable;
    property InputMode: InputModeConstants read Get_InputMode write Set_InputMode;
  end;

{ DispInterface declaration for Dual Interface IMSComm }

  DMSComm = dispinterface
    ['{E6E17E90-DF38-11CF-8E74-00A0C90F26F8}']
    property CDHolding: WordBool dispid 1;
    property CDTimeout: Integer dispid 2;
    property CommID: Integer dispid 3;
    property CommPort: Smallint dispid 4;
    property _CommPort: Smallint dispid 0;
    property CTSHolding: WordBool dispid 5;
    property CTSTimeout: Integer dispid 6;
    property DSRHolding: WordBool dispid 7;
    property DSRTimeout: Integer dispid 8;
    property DTREnable: WordBool dispid 9;
    property Handshaking: HandshakeConstants dispid 10;
    property InBufferSize: Smallint dispid 11;
    property InBufferCount: Smallint dispid 12;
    property Break: WordBool dispid 13;
    property InputLen: Smallint dispid 14;
    property Interval: Integer dispid 15;
    property NullDiscard: WordBool dispid 16;
    property OutBufferSize: Smallint dispid 17;
    property OutBufferCount: Smallint dispid 18;
    property ParityReplace: WideString dispid 19;
    property PortOpen: WordBool dispid 20;
    property RThreshold: Smallint dispid 21;
    property RTSEnable: WordBool dispid 22;
    property Settings: WideString dispid 23;
    property SThreshold: Smallint dispid 24;
    property Output: OleVariant dispid 25;
    property Input: OleVariant dispid 26;
    property CommEvent: Smallint dispid 27;
    property EOFEnable: WordBool dispid 28;
    property InputMode: InputModeConstants dispid 29;
    procedure AboutBox; dispid -552;
  end;

{ Event interface for MSComm Control }

  DMSCommEvents = dispinterface
    ['{648A5602-2C6E-101B-82B6-000000000014}']
    procedure OnComm; dispid 1;
  end;

{ Microsoft Comm Control 5.0 }

  TMSComm = class(TOleControl)
  private
    FOnComm: TNotifyEvent;
    FIntf: IMSComm;
  protected
    procedure InitControlData; override;
    procedure InitControlInterface(const Obj: IUnknown); override;
  public
    procedure AboutBox;
    property ControlInterface: IMSComm read FIntf;
    property CDTimeout: Integer index 2 read GetIntegerProp write SetIntegerProp;
    property _CommPort: Smallint index 0 read GetSmallintProp write SetSmallintProp;
    property CTSTimeout: Integer index 6 read GetIntegerProp write SetIntegerProp;
    property DSRTimeout: Integer index 8 read GetIntegerProp write SetIntegerProp;
    property Interval: Integer index 15 read GetIntegerProp write SetIntegerProp;
  published
    property CDHolding: WordBool index 1 read GetWordBoolProp write SetWordBoolProp stored False;
    property CommID: Integer index 3 read GetIntegerProp write SetIntegerProp stored False;
    property CommPort: Smallint index 4 read GetSmallintProp write SetSmallintProp stored False;
    property CTSHolding: WordBool index 5 read GetWordBoolProp write SetWordBoolProp stored False;
    property DSRHolding: WordBool index 7 read GetWordBoolProp write SetWordBoolProp stored False;
    property DTREnable: WordBool index 9 read GetWordBoolProp write SetWordBoolProp stored False;
    property Handshaking: HandshakeConstants index 10 read GetTOleEnumProp write SetTOleEnumProp stored False;
    property InBufferSize: Smallint index 11 read GetSmallintProp write SetSmallintProp stored False;
    property InBufferCount: Smallint index 12 read GetSmallintProp write SetSmallintProp stored False;
    property Break: WordBool index 13 read GetWordBoolProp write SetWordBoolProp stored False;
    property InputLen: Smallint index 14 read GetSmallintProp write SetSmallintProp stored False;
    property NullDiscard: WordBool index 16 read GetWordBoolProp write SetWordBoolProp stored False;
    property OutBufferSize: Smallint index 17 read GetSmallintProp write SetSmallintProp stored False;
    property OutBufferCount: Smallint index 18 read GetSmallintProp write SetSmallintProp stored False;
    property ParityReplace: WideString index 19 read GetWideStringProp write SetWideStringProp stored False;
    property PortOpen: WordBool index 20 read GetWordBoolProp write SetWordBoolProp stored False;
    property RThreshold: Smallint index 21 read GetSmallintProp write SetSmallintProp stored False;
    property RTSEnable: WordBool index 22 read GetWordBoolProp write SetWordBoolProp stored False;
    property Settings: WideString index 23 read GetWideStringProp write SetWideStringProp stored False;
    property SThreshold: Smallint index 24 read GetSmallintProp write SetSmallintProp stored False;
    // olevariant, getolevariant
    property Output: Variant index 25 read GetVariantProp write SetVariantProp stored False;
    // olevariant, getolevariant
    property Input: Variant index 26 read GetVariantProp write SetVariantProp stored False;
    property CommEvent: Smallint index 27 read GetSmallintProp write SetSmallintProp stored False;
    property EOFEnable: WordBool index 28 read GetWordBoolProp write SetWordBoolProp stored False;
    property InputMode: InputModeConstants index 29 read GetTOleEnumProp write SetTOleEnumProp stored False;
    property OnComm: TNotifyEvent read FOnComm write FOnComm;
  end;

procedure Register;

implementation

uses ComObj;

procedure TMSComm.InitControlData;
const
  CEventDispIDs: array[0..0] of Integer = (
    $00000001);
  CControlData: TControlData = (
    ClassID: '{648A5600-2C6E-101B-82B6-000000000014}';
    EventIID: '{648A5602-2C6E-101B-82B6-000000000014}';
    EventCount: 1;
    EventDispIDs: @CEventDispIDs;
    LicenseKey: nil;
    Flags: $00000000;
    Version: 300;
    FontCount: 0;
    FontIDs: nil);
begin
  ControlData := @CControlData;
end;

procedure TMSComm.InitControlInterface(const Obj: IUnknown);
begin
  FIntf := Obj as IMSComm;
end;

procedure TMSComm.AboutBox;
begin
  ControlInterface.AboutBox;
end;

procedure Register;
begin
  RegisterComponents('Ensen', [TMSComm]);
  RegisterNonActiveX([TMSComm]);
end;

end.
