unit Pcommon;
(*##*)
(*******************************************************************
*                                                                 *
*   P  C  O  M  M  O  N        EPAGER's unit.                      *
*                                                                 *
*   Copyright (c) 1998, ..           *
*   common EPAGER init declartes global variables and constants   *
*   Conditional defines:                                           *
*                                                                 *
*   Last Revision: Mar 19 1998                                     *
*   Last fix     : Mar 19 1998                                    *
*   Lines        : 628                                             *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

{ DLL functions declaration
  global variable declarations
}
interface
uses
  classes, inifiles, Dialogs, db, dbTables, DBGrids,
  util1;

type
  SQLPathString = String[64];
  THCODE = String[12];
const
  VERRELEASE = '1.0';
  VERSION = '1998 '+VERRELEASE+' ( Windows 95  NT)';
  REGISTRYKEY = 'SOFTWARE\Ensen\Pager\'+ VERRELEASE;
  DEF_LIMIT_YEAR = 1999; {  1  1999 }
  { DDE }
  PAGER_DDEITEMNAME1 = 'TAPStr';
  FieldNameList: TStringList = Nil;
  SECRETREGISTERKEY = 'ENSEN';
  COPYRIGHT: String[26] = 'Copyright(c)1998,A.Ivanov';
  DDE_FIELD_DELIMITER = #9;
  DEFDATEDELIMITERS = '..';
  DEFPHONEDELIMITER = '-';
  ROOTID = 0;
  { VisFieldName
    0 - visitor
    1 - visits
    2 - employee
    3 - hospitals
    7 - messages
    8 - (visitor) index
  }
  FLDCLI = '0';
  FLDVSS = '1';
  FLDEMP = '2';
  FLDCAL = '3';
  MSGSTR = '7';
  INDCLI = '8';
  INDVSS = '9';
  INDEMP = 'A';
  INDCAL = 'B';

  DEFWORKPLACE   = '';
  DEFFISCALPLACE = '';
  DEFDICTFolder  = 'Dic';
  ABOUTPICTURE     = 'Logo.BMP';
  ABOUTCLIPICTURE  = 'LogoCli.BMP';
  ABOUTGATEPICTURE = 'LogoGate.bmp';
  ABOUTDICTPICTURE = 'LogoDict.bmp';
  ABOUTOPERPICTURE = 'LogoOper.bmp';
  { time }
  DAYINSECS   = 86400;
  DAYINMINUTES= 1440;
  TIMECONV = DAYINSECS div 6;
  VACANCYDAYS = 45; { days }
  { fields definition files - reserved, no used }
  EMPDEFAULTFIELDFILE = 'Emp.fld';
  CLIDEFAULTFIELDFILE = 'Cli.fld';
  DICTDEFAULTFIELDFILE= 'Dic.fld';
  DEFCLILABELS = ',,,,No,,,, ,,,,,No,,,'+
    '*,,,,,*,,,,,,,,,,*,,,'+
    ',,,No,,,,No,,*';
  DEFVSSLABELS      = ',No,*,,,,,.,,.,, ,';
  DEFEMPLABELS      = ',,,,,(),,,,,'+
    ',,,,,,,,m,,,'+
    ',,,,,,,,,,';
  DEFCALLABELS      = ',,,,,';
  DEFHSPLABELS      = ',,,,,';
  DEFEMPSHORTLABELS = ',,,.';
  DEFDICTLABELS     = ',';
  DEFOPERLABELS     = ',';
  { ini }
  INI_PAGER_FILE = 'EPAGER.INI'; { put into Windows folder }
  { INI file sections
  }
  { global section }
  sectGLOBAL       = 'Common';
  iniUSEALIAS      = 'UseAlias';
  iniSQLTRIGGER    = 'SQLTriggers';
  iniALIAS         = 'BDEAlias';
  iniDATAFOLDER    = 'DataFolder';
  iniDriverName    = 'DriverName';
  iniDLLS          = 'DLLFolder';
  iniPHOTOS        = 'PHOTOSFolder';
  iniFISCAL        = 'FiscalReportFolder';
  iniFiscalLines   = 'FiscalReportLines';
  iniSQLS          = 'SQLFolder';
  iniSYSSQLS       = 'SQLSYSFolder';
  iniVOCSQLS       = 'SQLVOCFolder';
  iniAUTOSEXDETECT = 'AutoSexDetect';
  iniDATEDELIMITERS= 'DateDelimiters';
  iniPHONEDELIMITER= 'PhoneDelimiter';
  iniRegistrationKey= 'Key';
  iniVOCTbl        = 'VocTable';
  iniAUTOLOGON     = 'Debugging';  { =SPC,0 }
  iniLoginPrompt   = 'ManualLogin';
  iniDEFHCODE      = 'DefaultHCode';
  iniDICTFN        = 'Dictionary';
  iniDICTFolder    = 'DictionaryFolder';
  iniDICTViewStyle = 'DictionaryStyle';
  { aliases }
  sectALIASESCYR   = 'AliasListCyr';
  { Clients section }
  sectCLIENTS      = 'Clients';
  iniCLILTBL       = 'ClientTable';
  iniCLIENTLABELS  = 'ClientTableLabels';
  iniUseVOCCLI     = 'UseVocabulary';
  iniUseVOCEMP     = 'UseVocabulary';
  iniDOCUMENTFOLDER= 'DocumentFolder';
  DEFDOCUMENTFOLDER= 'DOCS\';
  { visits detailed table }
  sectVISITS       = 'Visits';
  iniVISITSTBL     = 'VisitsTable';
  iniVISITSLABELS  = 'VisitsTableLabels';
  { calls detailed table }
  sectCALLS        = 'Calls';
  iniCALLSTBL      = 'CallsTable';
  iniCALLSLABELS   = 'CallsTableLabels';
  { payee detailed table }
  sectPayee        = 'Payee';
  iniPayeeTBL      = 'PayeeTable';
  iniPayeeLABELS   = 'PayeeTableLabels';
  { groups detailed table }
  sectGROUPS       = 'Groups';
  iniGroupsTBL     = 'GroupsTable';
  iniGroupsLABELS  = 'GroupsTableLabels';

  { Dictionary }
  sectDICT         = 'Dictionary';
  iniDICTTBL       = 'DictionaryTable';
  iniEXPORTTEXTFN  = 'ExportText';
  iniEXPORTQTY     = 'ExportQty';
  iniEXPORTSEP     = 'ExportSeparator';
  iniDICTTBLLBL    = 'DictionaryTableLabels';
  { Dictionary build list }
  sectBUILDTABLE   = 'ScanTables'; //  
  iniCountWord     = 'OftenWord';

  { CAP }
  sectCAPS         = 'PagerCAPs';
  iniCAPsTBL       = 'PagerCAPsTable';
  { SERVD }
  sectSERV         = 'Service';
  iniSERVTBL       = 'ServiceTable';
  { SERVDESC }
  sectSERVDESC     = 'ServiceDesc';
  iniSERVDESCTBL   = 'ServiceDescTable';
  { Groups }
  sectGRP          = 'Groups';
  iniGRPTable      = 'GroupsTable';
  iniGRPLABELS     = 'GroupsLabels';
  DEFGRPLABELS     = '';
  { Pagers }
  sectPAGER        = 'Pagers';
  iniPAGERSTBL     = 'PAgerTable';
  { GrpDesc }
  sectGRPDESC      = 'GroupsDescription';
  iniGRPDescTBL    = 'GroupsDescTable';
  iniGRPDESCLABELS = 'GroupsDescLabels';
  DEFGRPDESCLABELS = '';
  { operator section }
  sectOPER         = 'Operator';
  iniOPERTBL       = 'MessagesTable';
  iniOPERTBLLBL    = 'MessagesTableLabels';
  iniLOCALZONE     = 'LocalZone';
  iniDEFAULTPRIORITY='DefaultPriority';
  {  }
  iniUseTimer      = 'TimerRefresh';
  iniTimerDelay    = 'TimerSecs';
  {  }
  iniVoiceActive   = 'VoiceActive';
  iniVoicesInMemory= 'VoicesInMemory';
  iniVoicesMaxInMemory= 'VoicesMaxInMemory';
  iniVoiceListFN   = 'VoiceListFN';
  iniVoiceFolder   = 'VoiceFolder';
  iniusetapi       = 'UseTapi';
  iniDialPrefix    = 'DialPrefix';
  iniTapiDevice    = 'TapiDevice';
  iniTapiLog       = 'TapiLog';
  iniStatusDisplay = 'StatusDisplay';
  iniAnswerOnRing  = 'AnswerOnRing';
  iniMaxAttempts   = 'MaxAttempts';
  iniRetryWait     = 'RetryWait';
  {   }
  iniAttachFolder  = 'AttachFolder'; 
  DEFVOICEFOLDER   = 'Voices';
  MAXEMPTYVOICES   = 3; //   3   
  { pager's codepages definition file section }
  sectPagerDefs    = 'PagerCodePageDef';
  iniDEFPAGERCPFILE= 'CPDefFile';
  iniLOADALLDEFS   = 'CPLoadAll';  
  DEFPAGERCPFILE   = 'epgdefs.epc';

  { fonts section }
  sectFont     = 'Font';
  iniFontName  = 'Name';
  iniFontSize  = 'Size';
  { Employee section }
  sectEMPLOYEE = 'Employee';
  iniEMPLTBL   = 'EmployeeTable';
  iniEMPLABELS = 'EmployeeTableLabels';
  iniDefaultPhoto = 'EmployeeDefaultPhoto';
  iniEMPSHORTLABELS='EmployeeShortTableLabels';
  { Cli2Emp section }
  sectCLI2EMP    = 'Cli2Emp';
  iniCLI2EMPTBL  = 'Cli2EmpTable';
  { Database parameters section
  USERNAME=SYSDBA
  PASSWORD=masterkey
  }
  sectDBParams    = 'DataBaseParams';
  { fields }
  sectTableFields='TableFields';
  { utility section }
  sectUTILS        = 'Utility';
  iniEXPORTFN      = 'LastExportFileName';
  iniDEFAULTFOLDER = 'DefaultExportFolder';
  iniDEFAULTALIAS  = 'DefaultAlias';
  { TAP2NULL section }
  sectTAP_NULL       = 'TAP_NULL';
  iniNULLEXE         = 'Exe';
  iniNULLSERV        = 'Service';
  iniNULLTOPIC       = 'Topic';
  iniNULLITEM1       = 'Item1';
  iniNULLITEM2       = 'Item2';
  { Gate section }
  sectGATE           = 'Gate';
  iniSERVICEZONES    = 'Zones';
  { file name constants
  }
  { employee }
  SQLSPECIALITY  = 'spec.SQL';
  SQLDOLZ        = 'dolz.SQL';
  SQLCATEG       = 'categ.SQL';
  SQLBLOCK       = 'block.SQL';
  SQLDEPARTMENT  = 'depart.SQL';
  SQLPHONE       = 'phone.SQL';
  SQLNATION      = 'nation.SQL';
  SQLSUBJ1       = 'subj1.SQL';
  SQLSUBJ2       = 'subj2.SQL';
  { clients }
  SQLSERVICE     = 'Service.SQL';
  SQLBUSINESS    = 'Business.SQL';
  SQLVENTURES    = 'Ventures.SQL';
  SQLMODEL       = 'Models.SQL';
  SQLMANUF       = 'Resell.SQL';
  SQLDEFECT      = 'Defec.SQL';
  SQLINFOCHANNELS= 'InfoChan.SQL';
  SQLEMPL        = 'Empl.SQL';
  SQLCITY        = 'City.SQL';
  SQLBILL        = 'Bill.SQL';
  SQLDOC         = 'Doc.SQL';
  { operator }
  SQLZONES     = 'Zones.SQL';
  SQLKINDS     = 'Kinds.SQL';
  { LicenseIsValid values }
  licVALID   = 0;
  licWARNING = 1;
  licINVALID = 2;
  { license }
var
  LIMIT     : LongInt;
  WARNLIMIT : LongInt;
  DATELIMIT : TDateTime;
  WARNDATELIMIT : TDateTime;
  //      
  ComputerName: String[32];

{$IFNDEF DLLTEST}
{$IFDEF DLLSTATIC }
procedure ViewVisitorTable(ASessionInserted: LongInt; var AHCode: THCODE;
  AUPDATER: LongInt);
procedure ViewEmployeeTable;
{$ENDIF}
{$ENDIF}
procedure SelectAlias(var A_ALIAS: String);

function LastChar(const S: ShortString): Char;
function HideColon(S: String): String;
{ calculate password string }
function CALCPASSWD(S: Shortstring): ShortString;
{ validate license
}
function LicenseIsValid(var UserGrant: String): Integer;
{ verifykeys in login form
}
function CreateServiceList: Boolean;
procedure StoreIniServiceList;
procedure MkNewTableFieldsList;
procedure EraseServiceList;
{ cat:
  0 - client
  1 - visits
  2 - employee
  3 - hospitals
  8 - (visitor) index
  No:  
}
function TblFieldName(const CatNo: String): String;
//  capcode  12    
function ValidateCAP(const CAPCode:String): String;

//     
function pgGetRegString(const APar, DefVal: String): String;
procedure pgSetRegString(const APar, AValue: String);

//      ,   
//       
{      8
       |
  4 <- 0 -> 1
       |
       2
}
function MouseMoveDir(x, y: Integer; var oldx, oldy: Integer): Integer;

// PrintDBGrid
//  TDBGrid
function PrintDBGrid(AGrid: TDBGrid): Boolean;

implementation
uses
  WinTypes, SysUtils, Registry, Printers,
  Secure;

{ DLL functions declaration
  Make sure that PATH environment variable include path to all DLLs
  It's easy, just put that DLLs into folder WINDOWS
}
{$IFNDEF DLLTEST}
{$IFDEF DLLSTATIC }
procedure ViewVisitorTable; external 'VISITOR1' name 'VIEWVISITORTABLE';
procedure ViewEmployeeTable; external 'EMPLOY1' name 'VIEWEMPLOYEETABLE';
{$ENDIF}
{$ENDIF}
{ DLL function. Not in use. 19.11.97
procedure SelectAlias(var A_ALIAS: String); external 'ALIASP' name 'SELECTALIAS';
}
{ return #0 if nothing }
function LastChar(const S: ShortString): Char;
begin
  LastChar:= S[Byte(S[0])];
end;

{ select alias from list
}
procedure SelectAlias(var A_ALIAS: String);
begin
end;

{ calculate password string }
function CALCPASSWD(S: Shortstring): ShortString;
var
  SS: ShortString;
begin
  SS:= S;
  {}
  CALCPASSWD:= SS;
end;

function HideColon(S: String): String;
var
  SS: String;
  i: Integer;
begin
  SS:= S;
  for i:=  1 to Length(SS) do begin
    if SS[i] = ':'
    then SS[i]:= '|';
  end;
  HideColon:= SS;
end;

{ :
  0-  1-    2-  
  UserGrant      
}
function LicenseIsValid(var UserGrant: String): Integer;
var
  Access: Boolean;
  valid: Integer;
  today: TDateTime;
  TryCode: String;
  LicensedDate: String;
  VisitNumber: Integer;
begin
  VisitNumber:= 1;
  ComputerName:= Util1.GetRegString(HKEY_LOCAL_MACHINE,'System\CurrentControlSet\control\ComputerName\ComputerName',
    'ComputerName', '');
  {  , ,    :
    mmmmmm,11111,M.YYYY
       ?
  }
  UserGrant:= pgGetRegString('Grants', 'unknownPC,1,1.1999');
  if ComputerName <> GetToken(1, ',', UserGrant) then begin
    //    -  !
    access:= False;
  end else begin
    Secure.SetMachine_Id(UserGrant);
    //  S/N
    TryCode:= pgGetRegString('Serial', 'TRIAL');
    if TryCode <> '' then begin
      access:= Secure.IsValidPasswd(TryCode);
    end else begin
      access:= False;
    end;
  end;
  //
  LicensedDate:= GetToken(3, ',', UserGrant);
  if access  then begin
    { 1- OK }
    LIMIT     := -1;
    { other is not valid }
    LIMIT     := MaxLongInt;
    WARNLIMIT := MaxLongInt;
    DATELIMIT := Date + 10;
    WARNDATELIMIT:= Date + 10;
    Result:= licVALID;
    Exit;
  end else begin
    { 0- failed }
    //  trial 
    LIMIT:= 10000;
    WARNLIMIT := 0;
    // DATELIMIT := EncodeDate(DEF_LIMIT_YEAR,1,1);
    DATELIMIT := EncodeDate(StrToIntDef(GetToken(2, '.', LicensedDate), 1999),
      StrToIntDef(GetToken(1, '.', LicensedDate), 1),1);

    WARNDATELIMIT:= 0;
  end;
  // ------------------------------------
  if VisitNumber > LIMIT then begin
    Valid:= licINVALID;
  end else begin
    if VisitNumber > WARNLIMIT then begin
      Valid:= licWARNING;
    end else begin
      Today:= Date;
      if Today > DATELIMIT then begin
        Valid:= licINVALID;
      end else begin
        if Today > WARNDATELIMIT then begin
          Valid:= licWARNING;
        end else begin
          Valid:= licVALID;
        end;
      end;
    end;
  end;
  Result:= Valid;
end;

function CreateServiceList: Boolean;
var
  IniFile: TIniFile;
  Loaded: Boolean;
begin
  CreateServiceList:= False;
  IniFile:= TIniFile.Create(INI_PAGER_FILE);
  {   }
  FieldNameList:= TStringList.Create;
  with IniFile do begin
    ReadSectionValues(sectTableFields, FieldNameList);
  end;
  Loaded:= FieldNameList.Count > 0;
  {DEBUG-------------------------------------------------------------------}
  { Loaded:= False;}
  {DEBUG-------------------------------------------------------------------}
  if not Loaded then begin
    {           }
    MkNewTableFieldsList;
  end;
  IniFile.Free;
  CreateServiceList:= True;
end;

procedure StoreIniServiceList;
begin
  StoreListIni(INI_PAGER_FILE, sectTableFields, FieldNameList);
end;

procedure MkNewTableFieldsList;
var
  T: TTable;

procedure AddTF(const TblPrefix, TN: String);
var
  i: Integer;
begin
  T.TableName:= TN;
  T.Active:= True;
  for i:= 1 to T.FieldCount
  do FieldNameList.Add(TblPrefix+IntToStr(i)+'='+T.Fields[i-1].FieldName);
  T.Active:= False;
end;

begin
  if FieldNameList = Nil
  then Exit;
  T:= TTable.Create(Nil);
  T.DatabaseName:= 'PAGER';
  FieldNameList.Clear;
  try
    AddTF(FLDCLI, 'CLIENT');
    AddTF(FLDVSS, 'VISITS');
{    AddTF(FLDEMP, 'EMPLOYEE');}
    AddTF(FLDCAL, 'CALLS');
  except
    ShowMessage('        ');
  end;
  T.Free;
end;

procedure EraseServiceList;
begin
  if FieldNameList <> Nil
  then FieldNameList.Free;
  FieldNameList:= Nil;
end;

{ cat:
  0 - visitor
  1 - visits
  2 - employee
  3 - hospitals
  8 - (visitor) index
}

function TblFieldName(const CatNo: String): String;
begin
  if FieldNameList = Nil then begin
    TblFieldName:= '';
  end else begin
    TblFieldName:= FieldNameList.Values[CatNo];
  end;
end;

//  capcode  12    
function ValidateCAP(const CAPCode: String): String;
var
  S: String;
  i, L: Integer;
begin
  //  
  S:= CAPCode;
  SaveDecimalDigitsOnly(S);
  L:= Length(S);
  //  ,   
  if L > 12
  then System.Delete(S, 1, L-12)
  else begin
    //   ,   
    for i:= L to 11
    do S:= '0' + S;
  end;
  Result:= S;
end;

function pgGetRegString(const APar, DefVal: String): String;
begin
  Result:= GetRegString(HKEY_LOCAL_MACHINE, REGISTRYKEY, APar, DefVal);
end;

procedure pgSetRegString(const APar, AValue: String);
begin
  SetRegString(HKEY_LOCAL_MACHINE, REGISTRYKEY, APar, AValue);
end;

{ HKEY_LOCAL_MACHINE
  System\CurrentControlSet\control\ComputerName\ComputerName
}

function MouseMoveDir(x, y: Integer; var oldx, oldy: Integer): Integer;
var
  r: Integer;
begin
  r:= 0;
  if x<>oldx then begin
    if x > oldx
    then R:= 1
    else R:= 4;
  end;
  if y<>oldy then begin
    if y > oldy
    then R:= R + 2
    else R:= R + 8;
  end;
  oldx:= x;
  oldy:= y;
  Result:= r;
end;

// PrintDBGrid
function PrintDBGrid(AGrid: TDBGrid): Boolean;
var
  F: Text;
  i: Integer;
begin
  Result:= True;
  Printers.AssignPrn(F);
  Rewrite(F);
  AGrid.DataSource.DataSet.First;
  while not AGrid.DataSource.DataSet.EOF do begin
    for i:= 0 to AGrid.DataSource.DataSet.FieldCount - 1 do begin
      Write(f, AGrid.DataSource.DataSet.Fields[i].AsString:32);
    end;
    Writeln(f);
    AGrid.DataSource.DataSet.Next;
  end;
  CloseFile(F);
end;

end.
