unit PagOpts;
(*##*)
(*******************************************************************
*                                                                 *
*   P  A  G  O  P  T  S   Pager option set dialog                  *
*                         Part of EPager                          *
*                                                                  *
*                                                                 *
*   Copyright (c) 1998, A.Ivanov. All rights reserved.             *
*   Delphi 2, 3 only (uses huge strings)                          *
*   Conditional defines: ASYNC H+                                  *
*   define MSCOMM if wants MSComm component                       *
*   Last Revision: Mar 19 1998                                     *
*   Last fix     : Mar 19 1998                                    *
*   Lines        : 485                                             *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Spin, Mask,
  util1, tap;

const
  iniALLOWCONTROLS   = 'AllowControls';
  iniBLOCKTRM_ETB_US = 'BlockTerminator_ETBOrUS';
  iniALLOWCR         = 'AllowCRInMessage';
  iniNO_CR_AFTER_MSG = 'NoCRAfterMessage';
  iniFORCETRUNCLONG  = 'ForceTruncateLongMessage';
  iniFORCE1BLOCK     = 'Force1BlockOnly';
  iniNOTRANSLATION   = 'SendWOTranslate';
  iniRING            = 'ForceRingOrQuiet';
  iniUseNO           = 'NumerateMessages';
  iniNUMERIC         = 'NumerateStyle';
  iniALLOWSUBMSG     = 'AllowNumerateSubMsg';
  iniSUBMSGNUMERATE  = 'SubMessagesNumStyle';
  iniSUBMSGTOTAL     = 'SubMsgQtyIndicate';
  iniTAPBLOCKLEN     = 'TAPBlockLen';
  iniFirstMsg        = 'FirstNumber'; // ?!!
  iniTAPBLOCKMAX     = 'TAPBlocksMax';
  iniCRC8Bit         = 'CRC8BitCalculation';
  iniTAPRULESect     = 'TAPFieldRule';

type
  TFormPagerOptions = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    RGNumerateDigits: TRadioGroup;
    RGNumerateSubMsg: TRadioGroup;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox6: TCheckBox;
    CBNoNumerate: TCheckBox;
    CBShowParts: TCheckBox;
    CheckBox5: TCheckBox;
    CB8BitCRC: TCheckBox;
    TSLengths: TTabSheet;
    Label2: TLabel;
    Label4: TLabel;
    Panel1: TPanel;
    BOk: TButton;
    BCancel: TButton;
    Image1: TImage;
    Image3: TImage;
    UDFirstNum: TUpDown;
    MEFirstNum: TMaskEdit;
    TSCRC: TTabSheet;
    UDBlockLen: TUpDown;
    EBlockLen: TEdit;
    Label5: TLabel;
    GroupBox2: TGroupBox;
    EBlocksMax: TEdit;
    UDBlocksMax: TUpDown;
    RBNoMaxBlockLimit: TRadioButton;
    RBMaxBlockLimit: TRadioButton;
    procedure BOkClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure RGNumerateSubMsgClick(Sender: TObject);
    procedure CBShowPartsClick(Sender: TObject);
    procedure CBMsgLenKeyPress(Sender: TObject; var Key: Char);
    procedure RBMaxBlockLimitClick(Sender: TObject);
    procedure CBNoNumerateClick(Sender: TObject);
  private
    { Private declarations }
  public
    { -- Public declarations -- }
    { returned values }
    NewTerminalPars: TTerminalPar;
   { -- returned values -- }
    procedure FillFields(AReturn: Boolean);
    procedure StoreIni;
    procedure LoadIni;
  end;

var
  FormPagerOptions: TFormPagerOptions;

{ fill up:
    NewFormatStyle: FormatStyleSet;
    NewNumerateStyle: NumerateStyleSet;
    NewBlockLen: Integer;
    NewBlocksMax: Integer;
    NewFirstMsgNo: Integer;
  if return = true then fill up (return):
    AFormatStyle, ANumerateStyle, ABlockLen, ABlocksMax, AMsgNo
}
function FormPagerOptionsDlg(var ATerminalPars: TTerminalPar): Boolean;

{  ASection = ''    iniTAPSECTION ([TAP])
         
   
}
function  PagLoadIni(const ASection: String; var ATerminalPars: TTerminalPar): Boolean;
function  PagStoreIni(const ASection: String; const ATerminalPars: TTerminalPar): Boolean;
function  IniTapSectionQty: Integer;
procedure SetIniTapSectionQty(ANew: Integer);

  {    }
function TAPRuleLoadIni(BannerList, RulesList: TStrings): Boolean;

implementation

{$R *.DFM}
uses
  IniFiles;

procedure TFormPagerOptions. FillFields(AReturn: Boolean);
begin
  with NewTerminalPars do if AReturn then begin
    {       }
    stlFormat:= [];
    if CheckBox1.Checked
    then Include(stlFormat, fmtpgALLOWCONTROLS);
    case RadioGroup1.ItemIndex of
    0:Include(stlFormat, fmtpgBLOCKTRM_ETB);
    1:Include(stlFormat, fmtpgBLOCKTRM_US);
    end;
    if CheckBox2.Checked then Include(stlFormat, fmtpgALLOWCR);
    if CheckBox3.Checked then Include(stlFormat, fmtpgNO_CR_AFTER_MSG);
    if CheckBox4.Checked then Include(stlFormat, fmtpgFORCETRUNCLONG);
    if CheckBox5.Checked then Include(stlFormat, fmtpgFORCE1BLOCK);
    if CheckBox6.Checked then Include(stlFormat, fmtpgNOTRANSLATION);
    case RadioGroup2.ItemIndex of
    1:Include(stlFormat, fmtpgRING);
    2:Include(stlFormat, fmtpgNORING);
    end;
    {----------------------   ---------------------}
    stlNumerate:= [];
    tapFirstMsgNo:= StrToIntDef(MeFirstNum.Text, 1);
    if CBNoNumerate.Checked
    then Include(stlNumerate, numpgNO);
    case RGNumerateDigits.ItemIndex of
    0:Include(stlNumerate, numpgNUMERIC);
    1:Include(stlNumerate, numpgALPHANUMERIC);
    2:Include(stlNumerate, numpgALPHA);
    3:Include(stlNumerate, numpgHEX);
    end;
    case RGNumerateSubMsg.ItemIndex of
    1:begin
      Include(stlNumerate, numpgALLOWSUBMSG);
      Include(stlNumerate, numpgSUBMSGDOTTED);
      end;
    2:begin
      Include(stlNumerate, numpgALLOWSUBMSG);
      Include(stlNumerate, numpgSUBMSG_AS_MSG);
      end;
    end;
    if CBShowParts.Checked
    then Include(stlNumerate, numpgSUBMSGTOTAL);

    {----------------------   ---------------------}
    if RBNoMaxBlockLimit.Checked
    then tapLimitBlocks:= UNLIMITEDBLOCKS
    else tapLimitBlocks:= StrToIntDef(EBlocksMax.Text, UNLIMITEDBLOCKS);
    //RBMaxBlockLimitClick(Self);

    tapBlockLen:= StrToIntDef(EBlockLen.Text, DEFBLOCKLIMITMSG);

    {----------------------   ---------------------}
    if CB8BitCRC.Checked
    then Include(stlFormat, fmtpgCRC8bit);
   end else begin
    {          }
    CheckBox1.Checked:= fmtpgALLOWCONTROLS in stlFormat;
    RadioGroup1.ItemIndex:= 0;
    if fmtpgBLOCKTRM_ETB in stlFormat then RadioGroup1.ItemIndex:= 0;
    if fmtpgBLOCKTRM_US  in stlFormat then RadioGroup1.ItemIndex:= 1;
    CheckBox2.Checked:= fmtpgALLOWCR in stlFormat;
    CheckBox3.Checked:= fmtpgNO_CR_AFTER_MSG in stlFormat;
    CheckBox4.Checked:= fmtpgFORCETRUNCLONG in stlFormat;
    CheckBox5.Checked:= fmtpgFORCE1BLOCK in stlFormat;
    CheckBox6.Checked:= fmtpgNOTRANSLATION in stlFormat;
    RadioGroup2.ItemIndex:= 0;
    if fmtpgRING in stlFormat then RadioGroup2.ItemIndex:= 1;
    if fmtpgNORING in stlFormat then RadioGroup2.ItemIndex:= 2;
    {----------------------   ---------------------}
    UDFirstNum.Position:= tapFirstMsgNo;
    CBNoNumerate.Checked:= numpgNO in stlNumerate;
    if numpgNUMERIC in stlNumerate then RGNumerateDigits.ItemIndex:=0;
    if numpgALPHANUMERIC in stlNumerate then RGNumerateDigits.ItemIndex:=1;
    if numpgALPHA in stlNumerate then RGNumerateDigits.ItemIndex:=2;
    if numpgHEX in stlNumerate then RGNumerateDigits.ItemIndex:=3;
    RGNumerateSubMsg.ItemIndex:=0;
    if numpgALLOWSUBMSG in stlNumerate then begin
      if numpgSUBMSGDOTTED in stlNumerate then RGNumerateSubMsg.ItemIndex:=1;
      if numpgSUBMSG_AS_MSG in stlNumerate then RGNumerateSubMsg.ItemIndex:=2;
    end;
    CBShowParts.Checked:= numpgSUBMSGTOTAL in stlNumerate;

    {----------------------   ---------------------}
    UDBlocksMax.Position:= tapLimitBlocks;
    if tapLimitBlocks = UNLIMITEDBLOCKS
    then RBNoMaxBlockLimit.Checked:= True
    else RBMaxBlockLimit.Checked:= True;
    //RBMaxBlockLimitClick(Self);
    UDBlockLen.Position:= tapBlockLen;
    {----------------------   ---------------------}
    CB8BitCRC.Checked:= fmtpgCRC8bit in stlFormat;
  end;
end;

procedure TFormPagerOptions.BOkClick(Sender: TObject);
begin
  FillFields(True);
end;

procedure TFormPagerOptions.FormActivate(Sender: TObject);
begin
  FillFields(False);
end;

function PagStoreIni(const ASection: String; const ATerminalPars: TTerminalPar): Boolean;
var
  Ini: TIniFile;
  L: Integer;
  SectName: String;
begin
  Result:= False;
  Ini:= TIniFile.Create(iniPagerOPTINIFN);
  if ASection = ''
  then SectName:= iniTAPSECTION
  else SectName:= ASection;
  with ATerminalPars, Ini do begin
    {          }
    WriteBool(SectName, iniALLOWCONTROLS, fmtpgALLOWCONTROLS in stlFormat);
    if fmtpgBLOCKTRM_ETB in stlFormat
    then L:= 0
    else L:= 1;
    WriteInteger(SectName, iniBLOCKTRM_ETB_US, L);
    WriteBool(SectName, iniALLOWCR, fmtpgALLOWCR in stlFormat);
    WriteBool(SectName, iniNO_CR_AFTER_MSG, fmtpgNO_CR_AFTER_MSG in stlFormat);
    WriteBool(SectName, iniFORCETRUNCLONG, fmtpgFORCETRUNCLONG in stlFormat);
    WriteBool(SectName, iniFORCE1BLOCK, fmtpgFORCE1BLOCK in stlFormat);
    WriteBool(SectName, iniNOTRANSLATION, fmtpgNOTRANSLATION in stlFormat);
    L:= 0;
    if fmtpgRING in stlFormat
    then L:= 1;
    if fmtpgNORING in stlFormat
    then L:= 2;
    WriteInteger(SectName,iniRING, L);
    {   }
    WriteBool(SectName, iniUseNO, numpgNO in stlNumerate);
    {   }
    L:= 0;
//  if numpgNO in ANumerateStyle
//  then L:= 0;
    if numpgALPHANUMERIC in stlNumerate
    then L:= 1;
    if numpgALPHA in stlNumerate
    then L:= 2;
    if numpgHEX in stlNumerate
    then L:= 3;
    WriteInteger(SectName, iniNUMERIC, L);
    WriteBool(SectName, iniALLOWSUBMSG, numpgALLOWSUBMSG in stlNumerate);
    L:= 0;
    if numpgSUBMSGDOTTED in stlNumerate
    then L:= 1;
    if numpgSUBMSG_AS_MSG in stlNumerate
    then L:= 2;
    WriteInteger(SectName, iniSUBMSGNUMERATE, L);
    WriteBool(SectName, iniSUBMSGTOTAL, numpgSUBMSGTOTAL in stlNumerate);

    WriteInteger(SectName, iniTAPBLOCKLEN, tapBlockLen);
    WriteInteger(SectName, iniTAPBLOCKMAX, tapLimitBlocks);
    WriteInteger(SectName, iniFirstMsg, tapFirstMsgNo);

    WriteBool(SectName, iniCRC8Bit, fmtpgCRC8bit in stlFormat);
  end;
  Ini.Free;
  Result:= True;
end;

{   
}
function TAPRuleLoadIni(BannerList, RulesList: TStrings): Boolean;
var
  Ini: TIniFile;
begin
  Result:= False;
  Ini:= TIniFile.Create(iniPagerOPTINIFN);
  with Ini do begin
    ReadSection(iniTAPRULESect, BannerList);
    ReadSectionValues(iniTAPRULESect, RulesList)
  end;
  Ini.Free;
  Result:= True;
end;

function PagLoadIni(const ASection: String; var ATerminalPars: TTerminalPar): Boolean;
var
  Ini: TIniFile;
  L: Integer;
  SectName: String;
begin
  Result:= False;
  Ini:= TIniFile.Create(iniPagerOPTINIFN);
  if ASection = ''
  then SectName:= iniTAPSECTION
  else SectName:= ASection;

  with ATerminalPars, Ini do begin
    stlFormat:= [];
    {          }
    if ReadBool(SectName, iniALLOWCONTROLS, False)
    then Include(stlFormat, fmtpgALLOWCONTROLS);
    L:= ReadInteger(SectName, iniBLOCKTRM_ETB_US, 0);
    case L of
    0: Include(stlFormat, fmtpgBLOCKTRM_ETB);
    1: Include(stlFormat, fmtpgBLOCKTRM_US);
    end;
    if ReadBool(SectName, iniALLOWCR, False)
    then Include(stlFormat, fmtpgALLOWCR );
    if ReadBool(SectName, iniNO_CR_AFTER_MSG, False)
    then Include(stlFormat, fmtpgNO_CR_AFTER_MSG);
    if ReadBool(SectName, iniFORCETRUNCLONG, False)
    then Include(stlFormat, fmtpgFORCETRUNCLONG);
    if ReadBool(SectName, iniFORCE1BLOCK, False)
    then Include(stlFormat, fmtpgFORCE1BLOCK);
    if ReadBool(SectName, iniNOTRANSLATION, False)
    then Include(stlFormat, fmtpgNOTRANSLATION);
    L:= ReadInteger(SectName,iniRING, 0);
    case L of
    0: ;
    1: Include(stlFormat, fmtpgRING);
    2: Include(stlFormat, fmtpgNORING);
    end;
    {   }
    stlNumerate:= [];
    L:= ReadInteger(SectName, iniNUMERIC, 0);
    case L of
    1: Include(stlNumerate, numpgALPHANUMERIC);
    2: Include(stlNumerate, numpgALPHA);
    3: Include(stlNumerate, numpgHEX);
    end;
    {     }
    if ReadBool(SectName, iniUseNO, False)
    then Include(stlNumerate, numpgNO)
    else Exclude(stlNumerate, numpgNO);
    if ReadBool(SectName, iniALLOWSUBMSG, False)
    then Include(stlNumerate, numpgALLOWSUBMSG);
    L:= ReadInteger(SectName, iniSUBMSGNUMERATE, 0);
    case L of
    0: ;
    1: Include(stlNumerate, numpgSUBMSGDOTTED);
    2: Include(stlNumerate, numpgSUBMSG_AS_MSG);
    end;
    if ReadBool(SectName, iniSUBMSGTOTAL, False)
    then Include(stlNumerate, numpgSUBMSGTOTAL);
    ATerminalPars.tapBlockLen:= ReadInteger(SectName, iniTAPBLOCKLEN, DEFBLOCKLIMITMSG);
    ATerminalPars.tapLimitBlocks:= ReadInteger(SectName, iniTAPBLOCKMAX, UNLIMITEDBLOCKS);
    ATerminalPars.tapFirstMsgNo:= ReadInteger(SectName, iniFirstMsg, 1);
    if ReadBool(SectName, iniCRC8Bit, False)
    then  Include(stlFormat, fmtpgCRC8bit);
  end;
  Ini.Free;
  Result:= True;
end;

function  IniTapSectionQty: Integer;
var
  Ini: TIniFile;
begin
  Ini:= TIniFile.Create(iniPagerOPTINIFN);
  Result:= Ini.ReadInteger(iniTAPSECTION, iniTAPSECTQTY, 0);
  Ini.Free;
end;

procedure SetIniTapSectionQty(ANew: Integer);
var
  Ini: TIniFile;
begin
  Ini:= TIniFile.Create(iniPagerOPTINIFN);
  Ini.WriteInteger(iniTAPSECTION, iniTAPSECTQTY, ANew);
  Ini.Free;
end;

procedure TFormPagerOptions.StoreIni;
begin
  {       }
  FillFields(True);
  PagStoreIni('', NewTerminalPars);
end;

procedure TFormPagerOptions.LoadIni;
begin
  PagLoadIni('', NewTerminalPars);
  FillFields(False);
end;

procedure TFormPagerOptions.RGNumerateSubMsgClick(Sender: TObject);
begin
  if CBShowParts.Checked then begin
    if RGNumerateSubMsg.ItemIndex <> 1 then begin
      CBShowParts.Checked:= False;
    end;
  end;
end;

procedure TFormPagerOptions.CBShowPartsClick(Sender: TObject);
begin
  RGNumerateSubMsg.ItemIndex:= 1;
end;

procedure TFormPagerOptions.CBMsgLenKeyPress(Sender: TObject;
  var Key: Char);
begin
  if not (Key in [#0..#31,'0'..'9'])
  then Key:= #9;
end;

{ fill up:
    NewFormatStyle: FormatStyleSet;
    NewNumerateStyle: NumerateStyleSet;
    NewBlockLen: Integer;
    NewBlocksMax: Integer;
    NewFirstMsgNo: Integer;
  if return = true then fill up (return):
    AFormatStyle, ANumerateStyle, ABlockLen, ABlocksMax, AMsgNo
}
function FormPagerOptionsDlg(var ATerminalPars: TTerminalPar): Boolean;
begin
  Result:= False;
  FormPagerOptions:= TFormPagerOptions.Create(Application);
  with FormPagerOptions do begin
    {   }
    NewTerminalPars:= ATerminalPars;
    { FormActivate  controls   New.. }
    if ShowModal = mrOK then begin
      {          }
      ATerminalPars:= NewTerminalPars;
      Result:= True;
    end;
  end;
  FormPagerOptions.Free;
end;

procedure TFormPagerOptions.RBMaxBlockLimitClick(Sender: TObject);
begin
  EBlocksMax.Enabled:= RBMaxBlockLimit.Checked;
  UDBlocksMax.Enabled:= RBMaxBlockLimit.Checked;
end;

procedure TFormPagerOptions.CBNoNumerateClick(Sender: TObject);
var
  AllowNum: Boolean;
begin
  {}
  AllowNum:= not CBNoNumerate.Checked;
  RGNumerateDigits.Enabled:= AllowNum;
  RGNumerateSubMsg.Enabled:= AllowNum;
  CBShowParts.Enabled:= AllowNum;
end;

end.
