{ :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  :: QuickReport 2.0 for Delphi 1.0/2.0/3.0                  ::
  ::                                                         ::
  :: Example reports project                                 ::
  ::                                                         ::
  :: Copyright (c) 1997 QuSoft AS                            ::
  :: All Rights Reserved                                     ::
  ::                                                         ::
  :: web: http://www.qusoft.no   mail: support@qusoft.no     ::
  ::                             fax: +47 22 41 74 91        ::
  ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }

unit Menu;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Quickrpt, List, GrpList, manygrp, MD, ExtCtrls, qrextra,
  ComCtrls, ToolWin, ExtPage;

type
  TMainForm = class(TForm)
    GroupBox1: TGroupBox;
    CompositeReport: TQuickRep;
    QRCompositeReport1: TQRCompositeReport;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    StatusBar1: TStatusBar;
    MDescription: TMemo;
    ExtPageControl1: TExtPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    RGAb: TRadioGroup;
    procedure PreviewClick(Sender: TObject);
    procedure PrintClick(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure QRCompositeReport1AddReports(Sender: TObject);
    procedure ExtPageControl1Change(Sender: TObject);
  private
    FReport : TQuickRep;
    procedure SetReport(Value : TQuickRep);
  public
    property Report : TQuickRep read FReport write SetReport;
  end;

var
  MainForm: TMainForm;

implementation

uses List1;

{$R *.DFM}

procedure TMainForm.SetReport(Value : TQuickRep);
begin
  FReport:=Value;
  MDescription.Lines.Assign(Report.Description);
end;

procedure TMainForm.PreviewClick(Sender: TObject);
begin
  if Report = CompositeReport then
  begin
    QRCompositeReport1.Preview;
  end else
    Report.Preview;
end;

procedure TMainForm.PrintClick(Sender: TObject);
begin
  if Report = CompositeReport then
  begin
    QRCompositeReport1.Print;
  end else
    Report.Print;
end;

procedure TMainForm.ExitClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  if MDescription.Lines.Count = 0
  then Report:=ListForm.QuickRep;
end;

procedure TMainForm.QRCompositeReport1AddReports(Sender: TObject);
begin
  with QRCompositeReport1 do
  begin
    Reports.Add(ListForm.QuickRep);
    Reports.Add(GrpListForm.QuickRep);
    Reports.Add(MDForm.QuickRep);
    Reports.Add(ManyGrpForm.QuickRep);
  end;
end;

procedure TMainForm.ExtPageControl1Change(Sender: TObject);
begin
  case ExtPageControl1.ActivePage.PageIndex of
  0: case RGAb.ItemIndex of
     0: Report:= ListForm.QuickRep;
     1: Report:= ListForm1.QuickRep;
     end;
  1: Report:= GrpListForm.QuickRep;
  2: Report:= MDForm.QuickRep;
  3: Report:= ManyGrpForm.QuickRep;
  4: Report:= CompositeReport;
  end;
end;

end.
