unit CommTest;
(*##*)
(*******************************************************************
*                                                                 *
*   C  O  M  M  T  E  S  T Telocator alphanumeric protocol       *
*                          Test                                   *
*   Copyright (c) 1998, A.Ivanov. All rights reserved.             *
*                                                                 *
*   Conditional defines: MSCOMM                                    *
*   define MSCOMM if wants MSComm component                       *
*   Last Revision: Mar 19 1998                                     *
*   Last fix     : Mar 19 1998                                    *
*   Lines        : 219                                             *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

{--$DEFINE MSCOMM}
{$DEFINE ASYNC}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Mask,
  OleCtrls, ComCtrls,
  conopts, Menus,
{$IFDEF MSCOMM}
  MSCommLib, MSC_TAP,
{$ENDIF}
{$IFDEF ASYNC}
  AP_Tap, AdPort,
{$ENDIF}
  tap;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TSState: TTabSheet;
    TSToTerminal: TTabSheet;
    MState: TMemo;
    MComIn: TMemo;
    MainMenu1: TMainMenu;
    NFile: TMenuItem;
    N1: TMenuItem;
    MFileExit: TMenuItem;
    MHelp: TMenuItem;
    MHelpIndex: TMenuItem;
    MenuView: TMenuItem;
    MViewText: TMenuItem;
    MViewASCII: TMenuItem;
    MViewHex: TMenuItem;
    N3: TMenuItem;
    MViewCkear: TMenuItem;
    MComOut: TMemo;
    Splitter1: TSplitter;
    Panel1: TPanel;
    Panel2: TPanel;
    BProtocol: TButton;
    BSend: TButton;
    BHangup: TButton;
    BConnectOpt: TButton;
    PageControl4: TPageControl;
    TSMessages: TTabSheet;
    MMessages: TMemo;
    TSPreparedMsg: TTabSheet;
    MOutMessages: TMemo;
    TabSheet1: TTabSheet;
    EPagerMsgLen: TEdit;
    UpDown1: TUpDown;
    Label1: TLabel;
    TabSheet2: TTabSheet;
    ETAPFields: TEdit;
    UpDown2: TUpDown;
    Label2: TLabel;
    procedure BSendClick(Sender: TObject);
    procedure BHangupClick(Sender: TObject);
    procedure MComInKeyPress(Sender: TObject; var Key: Char);
    procedure BProtocolClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BConnectOptClick(Sender: TObject);
    procedure MFileExitClick(Sender: TObject);
    procedure APDTriggerStatus(CP: TObject; TriggerHandle: Word);
    procedure APDTriggerAvail(CP: TObject; Count: Word);
    procedure BClearClick(Sender: TObject);
    procedure MViewClick(Sender: TObject);
  private
    { Private declarations }
  public
    TAPs: TTAPTerminals;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
uses
  util1, PagOpts, about;

var
  CurFld: Integer;

{ callback      
      False,      
      True     
    Msg   (WO)-        <CR> 
    MsgNo (WO)-   (     )
                (         )
  TGetMsgProc = function(var MSGNo: Integer; var S: String): Boolean;
 }
function GetMsgCallBack(AWaitSec: Integer; var MsgNo: Integer; var Msg: String;
  var APagerProps: TPagerProps): Boolean; far;
var
  f, flds: Integer;
begin
  // AWaitSec -     
  APagerProps.MsgLen:= StrToIntDef(Form1.EPagerMsgLen.Text, 128);
  flds:= StrToIntDef(Form1.ETAPFields.Text, 2);
  if (CurFld + flds) > Form1.MMessages.Lines.Count then begin
    //  
    Result:= False;
  end else begin
    Msg:= Form1.MMessages.Lines[CurFld];
    for f:= 2 to flds do begin
      //   () 
      Msg:= #13+Msg + Form1.MMessages.Lines[CurFld];
    end;
    Inc(CurFld, flds);
    MsgNo:= CurFld div flds;
    Result:= True;
  end;
end;

procedure MsgSentOrFailedCallBack(No: Integer; Sent: Boolean);
begin
  if Sent
  then Form1.MMessages.Lines[No * 2 - 1]:= Form1.MMessages.Lines[No * 2 - 1] + ' SENT'
  else Form1.MMessages.Lines[No * 2 - 1]:= Form1.MMessages.Lines[No * 2 - 1] + ' FAILED'
end;

{ TStateShowProc
}
procedure StateShow(const S: String); far;
begin
  Form1.MState.Lines.Add(S);
  Application.ProcessMessages;
end;

procedure TForm1.BSendClick(Sender: TObject);
begin
  CurFld:= 0;
  MState.Lines.Clear;
  BSend.Enabled:= False;
  BHangup.Enabled:= True;
  {    }
  with MComOut.Lines do begin
    Clear;
    Add('');
  end;
  {     }
  with MComIn.Lines do begin
    Clear;
  end;
{$IFDEF MSCOMM}
  {    }
  if MSComm1.PortOpen
  then MSComm1.PortOpen:= False;
  if MSC_OpenCommPort(MSComm1, ConnectPars.PortNo1, ConnectPars.PortSetS,
    ConnectPars.HandShakingType, Ord(not (cmASCIITextOnly in ConnectPars.PgConOptSet)))
  then begin
    if MSC_SendLoop(Form1.Handle, MSComm1, ConnectPars, FormatStyle, NumerateStyle,
      TAPBlockLen, MsgLen, BlocksMax, GetMsgCallBack, StateShow) then begin
      ShowMessage('   !');
    end;
  end;
{$ENDIF}
{$IFDEF ASYNC}
  {    }

  if TAPs.ComPorts[0].Open
  then TAPs.ComPorts[0].Open:= False;
  TAPs.ComPorts[0].Open:= True;
  if AP_SendLoop(TAPs.ComPorts[0], TAPs.Params[0],
    GetMsgCallBack, MsgSentOrFailedCallBack, StateShow) then begin
    ShowMessage('   !');
  end;
{$ENDIF}
  BSend.Enabled:= True;
  BHangup.Enabled:= False;
end;

procedure TForm1.BHangupClick(Sender: TObject);
begin
{$IFDEF MSCOMM}
  MSComm1.PortOpen:= False;
{$ENDIF}
{$IFDEF ASYNC}
  TAPs.ComPorts[0].Open:= False;
{$ENDIF}
  BSend.Enabled:= True;
  BHangup.Enabled:= False;
  StateShow(' ');
end;

procedure TForm1.MComInKeyPress(Sender: TObject; var Key: Char);
begin
  {}
{$IFDEF MSCOMM}
  MSComm1.Output:= Key;
{$ENDIF}
{$IFDEF ASYNC}
  TAPs.ComPorts[0].Output:= Key;
{$ENDIF}
end;

procedure TForm1.BProtocolClick(Sender: TObject);
var
  TAPTerminalPar: TTerminalPar;
begin
  TAPTerminalPar:= TAPs.Params[0];
  if FormPagerOptionsDlg(TAPTerminalPar) then begin
    TAPs.Params[0]:= TAPTerminalPar;
    TAPs.StoreToIni;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  TAPs:= TTAPTerminals.Create;
  TAPS.LoadFromIni;
  if TAPS.Count = 0
  then TAPS.Count:= 1;
  TAPs.ComPorts[0].OnTriggerAvail:= APDTriggerAvail;
  TAPs.ComPorts[0].OnTriggerStatus:= APDTriggerStatus;
end;

procedure TForm1.BConnectOptClick(Sender: TObject);
var
  termp: TTerminalPar;
begin
  termp:= TAPs.Params[0];
  FormConOptionsDlg(termp.comPars);
  TAPs.Params[0]:= termp;
  TAPs.StoreToIni;
end;

procedure TForm1.MFileExitClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.APDTriggerStatus(CP: TObject;
  TriggerHandle: Word);
begin
  StateShow('  ');
end;

procedure TForm1.APDTriggerAvail(CP: TObject; Count: Word);
var
  i: Integer;
  ViewNo: Word;
  S: String;
begin
  S:= '';
  for I := 1 to Count
  do S := S + TAPs.ComPorts[0].GetChar;
  ViewNo:= 0;
  if MViewASCII.Checked
  then ViewNo:= 1;
  if MViewHex.Checked
  then ViewNo:= 2;
  MComOut.Text:= MComOut.Text + TranslateView(S, ViewNo);
end;

procedure TForm1.BClearClick(Sender: TObject);
begin
  MComOut.Clear;
end;

procedure TForm1.MViewClick(Sender: TObject);
begin
  (Sender as TMenuItem).Checked:= True;
  MComOut.Clear;
end;

end.
