unit EmulServ;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Dialogs, ComCtrls, Grids, EDdeMan;

type
  TDdeServerConv4= array [0..3] of TEDdeServerConv;
  TDdeServerItem4= array [0..3] of TEDdeServerItem;

  TFormEmulServ = class(TForm)
    BStart: TButton;
    CancelBtn: TButton;
    SG1: TStringGrid;
    HeaderControl1: THeaderControl;
    StatusBar1: TStatusBar;
    BAssign: TButton;
    EService: TEdit;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BStartClick(Sender: TObject);
    procedure BAssignClick(Sender: TObject);
    procedure SG1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EDdeServerConv1ExecuteMacro(Sender: TObject; Msg: TStrings);
    procedure EDdeServerItem1PokeData(Sender: TObject);
    procedure EDdeServerItem2PokeData(Sender: TObject);
    procedure EDdeServerItem3PokeData(Sender: TObject);
    procedure EDdeServerItem4PokeData(Sender: TObject);
    procedure EDdeServerConv2ExecuteMacro(Sender: TObject; Msg: TStrings);
    procedure EDdeServerConv3ExecuteMacro(Sender: TObject; Msg: TStrings);
    procedure EDdeServerConv4ExecuteMacro(Sender: TObject; Msg: TStrings);
  private
    { Private declarations }
    Conv4: TDdeServerConv4;
    Item4: TDdeServerItem4;
  public
    { Public declarations }
    Started: Boolean;
  end;

var
  FormEmulServ: TFormEmulServ;

implementation

uses DatMod;

{$R *.DFM}

procedure TFormEmulServ.FormCreate(Sender: TObject);
begin
  Started:= False;
  with DM do begin
    Conv4[0]:= EDdeServerConv1;
    Conv4[1]:= EDdeServerConv2;
    Conv4[2]:= EDdeServerConv3;
    Conv4[3]:= EDdeServerConv4;
    Item4[0]:= EDdeServerItem1;
    Item4[1]:= EDdeServerItem2;
    Item4[2]:= EDdeServerItem3;
    Item4[3]:= EDdeServerItem4;
  end;  
end;

procedure TFormEmulServ.BStartClick(Sender: TObject);
begin
  if Started then begin
    // 
    Started:= False;
    BStart.Caption:= '&';
  end else begin
    // 
    Started:= True;
    BStart.Caption:= '&';
  end;
end;

procedure TFormEmulServ.BAssignClick(Sender: TObject);
begin
  DDEMgr.AppName:= EService.Text;
  EService.Text:= DDEMgr.AppName;
  if SG1.Cells[0,0] <> '' then begin
    Conv4[0].Topic:= SG1.Cells[0,0];
    Item4[0].Item:= SG1.Cells[1,0];
    Item4[0].Text:= SG1.Cells[2,0];
  end;
  if SG1.Cells[0,1] <> '' then begin
    Conv4[1].Topic:= SG1.Cells[0,1];
    Item4[1].Item:= SG1.Cells[1,1];
    Item4[1].Text:= SG1.Cells[2,1];
  end;
  if SG1.Cells[0,2] <> '' then begin
    Conv4[2].Topic:= SG1.Cells[0,2];
    Item4[2].Item:= SG1.Cells[1,2];
    Item4[2].Text:= SG1.Cells[2,2];
  end;
  if SG1.Cells[0,3] <> '' then begin
    Conv4[3].Topic:= SG1.Cells[0,3];
    Item4[3].Item:= SG1.Cells[1,3];
    Item4[3].Text:= SG1.Cells[2,3];
  end;
end;

procedure TFormEmulServ.SG1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then begin
    if SG1.Cells[0,0] <> '' then begin
      Item4[0].Text:= SG1.Cells[2,0];
    end;
    if SG1.Cells[0,1] <> '' then begin
      Item4[1].Text:= SG1.Cells[2,1];
    end;
    if SG1.Cells[0,2] <> '' then begin
      Item4[2].Text:= SG1.Cells[2,2];
    end;
    if SG1.Cells[0,3] <> '' then begin
      Item4[3].Text:= SG1.Cells[2,3];
    end;
  end;
end;

procedure TFormEmulServ.EDdeServerConv1ExecuteMacro(Sender: TObject;
  Msg: TStrings);
begin
  StatusBar1.Panels[StatusBar1.Panels.Count-1].Text:=
    '1.  :'+Msg.Text;
  ShowMessage('1:'+Msg.Text);
end;

procedure TFormEmulServ.EDdeServerItem1PokeData(Sender: TObject);
begin
  StatusBar1.Panels[StatusBar1.Panels.Count-1].Text:=
    '    1';
end;

procedure TFormEmulServ.EDdeServerItem2PokeData(Sender: TObject);
begin
  StatusBar1.Panels[StatusBar1.Panels.Count-1].Text:=
    '    2';
end;

procedure TFormEmulServ.EDdeServerItem3PokeData(Sender: TObject);
begin
  StatusBar1.Panels[StatusBar1.Panels.Count-1].Text:=
    '    3';
end;

procedure TFormEmulServ.EDdeServerItem4PokeData(Sender: TObject);
begin
  StatusBar1.Panels[StatusBar1.Panels.Count-1].Text:=
    '    4';
end;

procedure TFormEmulServ.EDdeServerConv2ExecuteMacro(Sender: TObject;
  Msg: TStrings);
begin
  StatusBar1.Panels[StatusBar1.Panels.Count-1].Text:=
    '2.  :'+Msg.Text;
  ShowMessage('2:'+Msg.Text);
end;

procedure TFormEmulServ.EDdeServerConv3ExecuteMacro(Sender: TObject;
  Msg: TStrings);
begin
  StatusBar1.Panels[StatusBar1.Panels.Count-1].Text:=
    '3.  :'+Msg.Text;
  ShowMessage('3:'+Msg.Text);
end;

procedure TFormEmulServ.EDdeServerConv4ExecuteMacro(Sender: TObject;
  Msg: TStrings);
begin
  StatusBar1.Panels[StatusBar1.Panels.Count-1].Text:=
    '4.  :'+Msg.Text;
  ShowMessage('4:'+Msg.Text);
end;

end.
