unit MSC_TAP;
(*##*)
(*******************************************************************
*                                                                 *
*   M  S  C  T  A  P         MSComm component TAP implementation   *
*                                                                 *
*   Copyright (c) 1998, A.Ivanov. All rights reserved.             *
*   Delphi 2, 3 only (uses huge strings)                          *
*   Conditional defines: MSCOMM H+                                 *
*   define MSCOMM if wants MSComm component                       *
*   Last Revision: Mar 19 1998                                     *
*   Last fix     : Mar 19 1998                                    *
*   Lines        : 431                                             *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

interface
uses
  Classes, SysUtils, Windows, Forms, util1, TAP, MSCommLib;

type
  TSendProc = function(AMS: TMSComm; const S: String): Boolean;
  TRecvFunc = function(AMS: TMSComm): String;
  {  MSC_SendLoop - callback     }
  TStateShowProc = procedure (const StateString: String);
  {      MSComm
  }
{     SWaitForB         TimeoutB  (  -  )
    SSend               TimeRepeat     
      SWaitForE         TimeoutE  (  -  )
}
function MSC_TTYSend(wnd: HWND; AMSComm: TMSComm; SendProc: TSendProc; RecvFunc: TRecvFunc;
  const SWaitForB, SSend, SWaitForE: String;
  TimeoutB, TimeRepeat, TimeoutE: Integer): Integer;

{    MSComm  
}
function MSC_OpenCommPort(AMSComm: TMSComm; AComPortNo: Integer;
  const AParams: String; AHandShaking, AInputMode: Integer): Boolean;

function MSC_SendLoop(Handle: HWND; AMSComm: TMSComm;
  ConnectPars: TConnectPars; FormatStyle: FormatStyleSet; NumerateStyle: NumerateStyleSet;
  MsgLen, BlocksMax: Integer; AGetMsgProc: TGetMsgProc; StateShow: TStateShowProc): Boolean;

implementation

{     SWaitForB         TimeoutB  (  -  )
    SSend               TimeRepeat      (  -  )
      SWaitForE         TimeoutE  (  -  )
   TimeRepeat = 0    SSend
  - 0- OK     SWaitForE = NIL  
              0,1,.. -     SWaitForE
              -1     - 
  SWaitForE -   ","  
}
function MSC_TTYSend(wnd: HWND; AMSComm: TMSComm; SendProc: TSendProc; RecvFunc: TRecvFunc;
  const SWaitForB, SSend, SWaitForE: String;
  TimeoutB, TimeRepeat, TimeoutE: Integer): Integer;
var
  i: Integer;
  Ok: Boolean;
  S, Tok: String;
begin
  Result:= -1;
  {    }
  TimerFlags:= TimerFlags - [1,2];
  { ----------   ----------- }
  if SWaitForB <> '' then begin
    {   1 }
    SetTimer(wnd, 1, TimeOutB*1000, @SetTimerFlag);
    S:= '';
    {   }
    Ok:= False;
    repeat
      S:= S+RecvFunc(AMSComm);
     { :  - uppercase? }
      if (System.Pos(SWaitForB, S)>0) then begin
        Ok:= True;
        Break;
      end;
      {   -      }
    until 1 in TimerFlags;
    {   }
    KillTimer(wnd, 1);
    Exclude(TimerFlags, 1);
    if not Ok
    then Exit;
  end;
  { --  -- }
  S:= '';
  repeat
    { ----------  (   TimeRepeat > 0)----------- }
    if SSend <> '' then begin
      if not SendProc(AMSComm, SSend) then begin
        Exit;
      end;
    end;
    {   1 }
    SetTimer(wnd, 1, TimeoutE*1000, @SetTimerFlag);
    { ----------   ----------- }
    if SWaitForE > '' then begin
      {   2 }
      if TimeRepeat > 0
      then SetTimer(wnd, 2, TimeRepeat* 1000, @SetTimerFlag)
      else SetTimer(wnd, 2, TimeOutE  * 1000, @SetTimerFlag);
      {   }
      Ok:= False;
      repeat
        S:= S+RecvFunc(AMSComm);
        i:= 1;
        Tok:= GetToken(1, LISTDELIMITER, SWaitForE);
        while Tok > '' do begin
          { :  - uppercase? }
          if (System.Pos(Tok, S) > 0) then begin
            OK:= True;
            {       }
            Result:= i-1;
            Break;
          end;
          Inc(i);
          Tok:= GetToken(i, LISTDELIMITER, SWaitForE);
        end;
        if OK then begin
          Break;
        end;
        {   -      }
      until 2 in TimerFlags;
      {   }
      KillTimer(wnd, 2);
      Exclude(TimerFlags, 2);
    end else begin
      {   , OK = true,   }
      Result:= 0;
      Ok:= True;
    end;
    {  (TimeRepeat>0)  -  }
  until OK or (TimeRepeat <= 0) or (1 in TimerFlags);
  {   }
  KillTimer(wnd, 1);
  Exclude(TimerFlags, 1);
end;

{ prototypes:
  TSendProc = function(const S: String): Boolean;
  TRecvFunc = function: String;
}
function MSC_SSend(AMSComm: TMSComm; const S: String): Boolean; far;
begin
  Result:= False;
  Application.ProcessMessages;
  try
    AMSComm.Output:= S;
    Result:= True;
  except
  end;
  // MComIn.Text:= MComIn.Text + TranslateView(S, RGView.ItemIndex);
end;

function MSC_SRecv(AMSComm: TMSComm): String; far;
var
  S: String;
  dly: Integer;
begin
  Application.ProcessMessages;
  try
    S:= AMSComm.Input;
  except
    S:= '';
  end;
//  if S > ''
//  then MComOut.Text:= MComOut.Text + TranslateView(S, RGView.ItemIndex);
  Result:= S;
end;

{ prototypes:
  MSC_TTYSend(SendProc: TSendProc; RecvFunc: TRecvFunc; const SWaitForB, SSend, SWaitForE: String;
  TimeoutB, TimeRepeat, TimeoutE: Integer): Boolean;
  APrompt -   ","  
}
function MSC_WaitPrompt(Handle: HWnd; AMSComm: TMSComm; ConnectPars: TConnectPars; const ALog, APrompt: String;
  Secs: Integer; Rpt: Integer): Boolean;
begin
  if not (cmWaitPrompt in ConnectPars.PgConOptSet) then begin
    {     }
    Result:= True;
    Exit;
  end;
  Result:= MSC_TTYSend(Handle, AMSComm, MSC_SSend, MSC_SRecv, '', ALog, APrompt,0, Secs div Rpt, Secs) = 0;
end;

{  MSComm
}
function MSC_OpenCommPort(AMSComm: TMSComm; AComPortNo: Integer;
 const AParams: String; AHandShaking, AInputMode: Integer): Boolean;
begin
  with AMSComm do begin
    CommPort:= AComPortNo;
    Settings:= AParams;
    InputMode:= AInputMode;
    HandShaking:= AHandShaking;
    PortOpen:= True;
    Result:= PortOpen;
  end;
end;

function  MSC_CallModem(AMSComm: TMSComm; ConnectPars: TConnectPars;
  StateShow: TStateShowProc): Boolean;
begin
  Result:= False;
  if (cmThruModem in ConnectPars.PgConOptSet) and
    (ConnectPars.Phone > '') then begin
    AMSComm.Output:= WEBStyleAndControlString2ASCII(ConnectPars.Phone);
    StateShow(' Enter   ');
  end;
  Result:= True;
end;

function  MSC_TryLogon(Handle: HWnd; AMSComm: TMSComm; ConnectPars: TConnectPars; Secs: Integer;
  StateShow: TStateShowProc): Boolean;
var
  name_passwd: String;
  R: Integer;
begin
  Result:= False;
  if (cmManualLogin in ConnectPars.PgConOptSet) then begin
      {         }
    name_passwd:= WEBStyleAndControlString2ASCII(ConnectPars.ManualLogStr);
    { }
    StateShow(' -  ACK (NAK|EOT),    " "');
  end else begin
    {    "PG1" }
    name_passwd:= ESC + WEBStyleAndControlString2ASCII(ConnectPars.UserName);
    {        CR  ! }
    if ConnectPars.Passwd > ''
    then name_passwd:= name_passwd +
      WEBStyleAndControlString2ASCII(ConnectPars.Passwd) + CR;
  end;
  if (cmNoWaitAccept in ConnectPars.PgConOptSet) then begin
    {      }
    Secs:= 0;
  end;
  {  ACK-  NAK-   EOT-  }
  { :     }
  R:= MSC_TTYSend(Handle, AMSComm, MSC_SSend, MSC_SRecv,'', name_passwd, ACK+','+NAK+','+EOT, 0, 0, Secs);
// test R:= MSC_TTYSend(Handle, SSendMS, SRecvMS,'', 'AT'#13#10, 'OK'+','+NAK+','+EOT, 0, 0, Secs);
  Result:= R = 0;
end;

function  MSC_WaitReadyTransaction(Handle: HWND; AMSComm: TMSComm; ConnectPars: TConnectPars;
  const AReadyString: String; Secs: Integer): Boolean;
var
  R: Integer;
begin
  Result:= False;
  if (cmNoWaitReady in ConnectPars.PgConOptSet) then begin
   {  ? }
    Result:= True;
  end else begin
    {   }
    Result:= MSC_TTYSend(Handle, AMSComm, MSC_SSend, MSC_SRecv, AReadyString, '', '', Secs, 0, 0) = 0;
  end;
end;

{    
}
function MSC_DisconnectTransaction(Handle: HWND; AMSComm: TMSComm; Secs: Integer): Boolean;
begin
  {  ..  }
  {  ,     }
  Result:= MSC_TTYSend(Handle, AMSComm, MSC_SSend, MSC_SRecv, '', EOT+CR, ESC+EOT+CR+','+RS+CR,0, 0, Secs) = 0;
end;

{ wait carrier detect signal at comm. port in SECS second
}
function MSC_WaitCD(AMSComm: TMSComm; Secs: Integer): Boolean;
var
  TimeOut: TTimeOut;
begin
  Result:= False;
  TimeOut:= TTimeOut.Create(Secs);
  repeat
    Application.ProcessMessages;
  until AMSComm.CDHolding or Timeout.TerminateByEvent;
  Result:= AMSComm.CDHolding;
  TimeOut.Free;
end;

function MSC_SendTAPMessage(Handle: HWnd; AMSComm: TMSComm;
  MsgNo: Integer; const PrepMsg: String;
  FormatStyle: FormatStyleSet; NumerateStyle: NumerateStyleSet;
  MsgLen, BlocksMax: Integer; StateShow: TStateShowProc): Boolean;
label
  fine;
const
  BLOCKSecs = 10; //T4
var
  S, SS: String;
  ACK_EOTReceived: Boolean;
  i, r: Integer;
  MsgList,
  BlockList,
  KindList: TList;
begin
  Result:= False;
  MsgList:= TList.Create;
  BlockList:= TList.Create;
  KindList:= TList.Create;
  S:= PrepMsg;
  TransactionFillMessages(S, FormatStyle, NumerateStyle,MsgLen, BlocksMax, MsgList);
//    TransactionFillBlocks(S, MsgList, BLOCKLIMITMSG, BlockList);
  TransactionFillBlocks(S, MsgList, 4, BlockList, KindList);
  // PrepMsg:= '';
  for i:= 1 to BlockList.Count do begin
    {      NAK }
    repeat
      SS:= GenerateMessageBlock(MsgNo, i-1, S, FormatStyle, NumerateStyle, MsgList, BlockList, KindList);
      // MOutMessages.Text:= MOutMessages.Text + TranslateView(SS, RGView.ItemIndex);
      // PrepMsg:= PrepMsg + SS;
      {  ,    ACK }
      ACK_EOTReceived:= True;
      {  }
      R:= MSC_TTYSend(Handle, AMSComm, MSC_SSend, MSC_SRecv,'', SS, ACK+','+NAK+','+EOT, 0, 0, BLOCKSecs);
      case R of
      0: { ACK } begin
          Result:= True;
          StateShow(' ' + IntToStr(i)+ '  ');
          Break;
        end;
      1: { NAK } begin
          StateShow(' ' + IntToStr(i)+ '    CRC');
          {   }
          ACK_EOTReceived:= False;
          Break;
        end;
      2: { EOT } begin
          StateShow('  ' + IntToStr(i)+ ' -    ');
          {   -    }
          goto fine;
        end;
        else begin
         {   -  }
          StateShow(' ' + IntToStr(i)+ ': -  '+IntToStr(BLOCKSecs)+' ,    ');
          Break;
        end;
      end; { case }
    until ACK_EOTReceived;
  end;
fine:
  MsgList.Free;
  BlockList.Free;
  KindList.Free;
end;

{  ,  RS+CR
   RS CR ESC EOT CR - 
             ESC EOT CR -  
  Secs: 10     
  :
  True-       
  False-    ,  ()    
          :   ,...
}

function MSC_SendLoop(Handle: HWND; AMSComm: TMSComm;
  ConnectPars: TConnectPars; FormatStyle: FormatStyleSet; NumerateStyle: NumerateStyleSet;
  MsgLen, BlocksMax: Integer; AGetMsgProc: TGetMsgProc; StateShow: TStateShowProc): Boolean;
var
  MsgNo: Integer;
  PrepMsg: String;
begin
  StateShow(' ');
  if MSC_CallModem(AMSComm, ConnectPars, StateShow) then begin
    StateShow('  ');
  end else begin
    StateShow('   .');
  end;
  if MSC_WaitCD(AMSComm, ConnectPars.CDWaitSec) then begin
    StateShow(' ,  ');
    if MSC_WaitPrompt(Handle, AMSComm, ConnectPars, #13,
      WEBStyleAndControlString2ASCII(ConnectPars.LoginPrompt), 9, 3) then begin
      StateShow(' , (/<CR>),  .');
      if MSC_TryLogon(Handle, AMSComm, ConnectPars, 2, StateShow) then begin
        StateShow(' ,     .');
        if MSC_WaitReadyTransaction(Handle, AMSComm, ConnectPars, WEBStyleAndControlString2ASCII(
          ConnectPars.ReadyTransactionStr), 10) then begin
          StateShow('    ,  .');
          {     ,.. }
          //    MsgNo    Msg
          while AGetMsgProc(MsgNo, PrepMsg)do begin
            { ..  }
            if (cmNoSendMsg in ConnectPars.PgConOptSet) then begin
              // PrepareMessage;
            end else begin
              {    }
              if MSC_SendTAPMessage(Handle, AMSComm, MsgNo, PrepMsg,
              FormatStyle, NumerateStyle, MsgLen, BlocksMax, StateShow)
              then StateShow(' ')
              else StateShow(' ');
              {   }
              StateShow(' ..');
              if MSC_DisconnectTransaction(Handle, AMSComm, 10) then begin
                StateShow(' ,   ');
              end else begin
                StateShow('     (  ,..)');
              end;
              // Input2Buf(AMSComm, Timer2);
            end;
          end;
        end else begin
          StateShow('      1- .');
        end;
      end else begin
        StateShow('  , - .');
      end;
    end else begin
      AMSComm.DTREnable:= True;
      AMSComm.RTSEnable:= True;
      StateShow(' .');
    end;
  end else begin
    StateShow('   .');
  end;
  // AMSComm.Output:= #13;
end;

end.
