unit tapnull;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, ToolWin, IniFiles,
  PCommon, Menus;

type
  TFormTAPNull = class(TForm)
    CoolBar1: TCoolBar;
    StatusBar1: TStatusBar;
    PanelNavigate: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label4: TLabel;
    Bevel1: TBevel;
    Panel2: TPanel;
    ToolBar1: TToolBar;
    TBConnect: TToolButton;
    TBSetAdvise: TToolButton;
    TBDisconnect: TToolButton;
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    MFile: TMenuItem;
    N1: TMenuItem;
    MFileExit: TMenuItem;
    MOptions: TMenuItem;
    MOptionsSave: TMenuItem;
    MOptionsLoad: TMenuItem;
    TBPasteLink: TToolButton;
    MEdit: TMenuItem;
    MEditLinkDDE: TMenuItem;
    MDDE: TMenuItem;
    MDDEList: TMenuItem;
    MDDEPoke: TMenuItem;
    MDDEExecute: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    MDDEEmulate: TMenuItem;
    Bevel2: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure TBConnectClick(Sender: TObject);
    procedure TBSetAdviseClick(Sender: TObject);
    procedure TBDisconnectClick(Sender: TObject);
    procedure NavigateKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MFileExitClick(Sender: TObject);
    procedure MOptionsSaveClick(Sender: TObject);
    procedure MOptionsLoadClick(Sender: TObject);
    procedure TBPasteLinkClick(Sender: TObject);
    procedure MDDEListClick(Sender: TObject);
    procedure MDDEPokeClick(Sender: TObject);
    procedure MDDEExecuteClick(Sender: TObject);
    procedure MDDEEmulateClick(Sender: TObject);
  private
    { Private declarations }
    procedure DisplayHint(Sender: TObject);
  public
    { Public declarations }
    procedure MkConnect;
    procedure ViewState;
    procedure SyncView(AByLink: Boolean);
    function  LoadIni: Boolean;
    procedure StoreIni;
  end;

var
  FormTAPNull: TFormTAPNull;

implementation

uses DatMod, EDDEMan, DDEml, Macro, EmulServ, DDEPoke;

{$R *.DFM}

procedure TFormTAPNull.MkConnect;
begin
  with DM do begin
    EDdeClientConv1.CloseLink;  //   OpenLink,    
    EDdeClientConv1.ServiceApplication:= Edit1.Text;
    if EDdeClientConv1.SetLink(Edit2.Text, Edit3.Text) then begin
  //  EDdeClientConv1.DataMode:= ddeAutomatic;
      EDDEClientItem1.DDEItem:= Edit4.Text;
      if EDdeClientConv1.ConnectMode = ddeManual
      then EDdeClientConv1.OpenLink;
    end;
  end;
end;

procedure TFormTAPNull.FormCreate(Sender: TObject);
begin
  Application.OnHint:= DisplayHint;
  if LoadIni then begin
    MkConnect;
  end;
end;

procedure TFormTAPNull.ViewState;
begin
  with StatusBar1
  do Panels[0].Text:= FormatDateTime('hh:nn:ss  ', Time);
end;

procedure TFormTAPNull.TBConnectClick(Sender: TObject);
begin
  MkConnect;
end;

procedure TFormTAPNull.TBSetAdviseClick(Sender: TObject);
begin
  with DM do begin
    if EDdeClientConv1.StartAdvise then begin
    end else begin
      ShowMessage('  ');
    end;
  end;
end;

procedure TFormTAPNull.TBDisconnectClick(Sender: TObject);
begin
  with DM do begin
    EDdeClientConv1.CloseLink;
  end;
end;

procedure TFormTAPNull.NavigateKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  R: PChar;
begin
  if Key = VK_RETURN then begin
    // MKConnect;
    {   }
    DM.EDdeClientItem1.DdeItem:= Edit4.Text;
    R:= DM.EDdeClientConv1.RequestData(Edit4.Text);
    if R <> Nil then begin
      Memo1.Lines.Add(StrPas(R));
      StrDispose(R);
    end;
  end;
end;

function TFormTAPNull.LoadIni: Boolean;
var
  IniFile: TIniFile;
begin
  Result:= False;
  IniFile := TIniFile.Create(INI_PAGER_FILE);
  with IniFile do begin
    Font.Name:= ReadString(sectFONT, iniFontName, 'System');
    Edit1.Text:= ReadString(sectTAP_NULL, iniNULLEXE, 'lssql1');
    Edit2.Text:= ReadString(sectTAP_NULL, iniNULLSERV, 'LSSQL1');
    Edit3.Text:= ReadString(sectTAP_NULL, iniNULLTOPIC, 'qInformation');
    Edit4.Text:= ReadString(sectTAP_NULL, iniNULLITEM1, 'qQueryCyr');
//  Edit5.Text:= ReadString(sectTAP_NULL, iniNULLITEM2, Edit4.Text);
  end;
  IniFile.Free;
  Result:= True;
end;

procedure TFormTAPNull.StoreIni;
var
  IniFile: TIniFile;
begin
  IniFile := TIniFile.Create(INI_PAGER_FILE);
  with IniFile do begin
    WriteString(sectTAP_NULL, iniNULLEXE, Edit1.Text);
    WriteString(sectTAP_NULL, iniNULLSERV, Edit2.Text);
    WriteString(sectTAP_NULL, iniNULLTOPIC, Edit3.Text);
    WriteString(sectTAP_NULL, iniNULLITEM1, Edit4.Text );
//  WriteString(sectTAP_NULL, iniNULLITEM2, Edit4.Text);
  end;
  IniFile.Free;
end;

procedure TFormTAPNull.MFileExitClick(Sender: TObject);
begin
  Close;
end;

procedure TFormTAPNull.MOptionsSaveClick(Sender: TObject);
begin
  StoreIni;
end;

procedure TFormTAPNull.MOptionsLoadClick(Sender: TObject);
begin
  LoadIni;
end;

procedure TFormTAPNull.DisplayHint(Sender: TObject);
begin
  with StatusBar1
  do Panels[Panels.Count-1].Text:= Application.Hint;
end;

{ AByLink:
   True -   Text1,..   
   False-  MKConnect
}
procedure TFormTAPNull.SyncView(AByLink: Boolean);
begin
  if AByLink then begin
    Edit1.Text:= DM.EDdeClientConv1.ServiceApplication;
    Edit2.Text:= DM.EDdeClientConv1.DdeService;
    Edit3.Text:= DM.EDdeClientConv1.DdeTopic;
    if DM.EDDEClientItem1.DDEItem = ''
    then Edit4.Text:= '?'+Edit4.Text
    else Edit4.Text:= DM.EDDEClientItem1.DDEItem;
  end else begin
    MKConnect;
  end;
end;

procedure TFormTAPNull.TBPasteLinkClick(Sender: TObject);
begin
  {}
  if DM.EDdeClientConv1.PasteLink then begin
    SyncView(True);
  end else begin
    ShowMessage('     DDE (,       )');
  end;
end;

procedure TFormTAPNull.MDDEListClick(Sender: TObject);
var
  convCount: Integer;
  CurConv: HConv;
  sel_serv, sel_topic: LongInt;
  convinfo: TConvInfo;
  convList: HConvList;
  buf: array[0..127] of Char;
  s: String;
begin
  {}
  Memo1.Clear;
  Memo1.Lines.Add('SvcPartner ServiceReq Topic Item');
  convList:= 0;
  convinfo.cb:= SizeOf(TConvInfo);
  // 2- handle of service name string, 3-handle of topic name string
  // 6- context data
  sel_serv:= 0;
  sel_topic:= 0;
  convList:= DdeConnectList(ddemgr.DdeInstId, sel_serv, sel_topic, 0, Nil);
  // convCount- handles in the conversation list
  convCount:= 0;
  CurConv:= 0;
  repeat
    curConv:= DdeQueryNextServer(convList, curConv);
    if curConv <> 0 then begin
      DdeQueryConvInfo(curConv, QID_SYNC, @convinfo);
      //   
      with convinfo do begin
        DdeKeepStringHandle(ddemgr.DdeInstId, hszSvcPartner);
        DdeKeepStringHandle(ddemgr.DdeInstId, hszServiceReq);
        DdeKeepStringHandle(ddemgr.DdeInstId, hszTopic);
        DdeKeepStringHandle(ddemgr.DdeInstId, hszItem);
        DDEQueryString(ddemgr.DdeInstId, hszSvcPartner, buf, 128, CP_WINANSI);
        S:= StrPas(Buf);
        DDEQueryString(ddemgr.DdeInstId, hszServiceReq, buf, 128, CP_WINANSI);
        S:= S+ ' ' + StrPas(Buf);
        DDEQueryString(ddemgr.DdeInstId, hszTopic, buf, 128, CP_WINANSI);
        S:= S+ ' ' + StrPas(Buf);
        DDEQueryString(ddemgr.DdeInstId, hszItem, buf, 128, CP_WINANSI);
        S:= S+ ' ' + StrPas(Buf);
      end;
      Memo1.Lines.Add(S);
      Inc(convCount);
    end
    else Break;
  until False;
  DdeDisconnectList(convList);
end;

procedure TFormTAPNull.MDDEPokeClick(Sender: TObject);
begin
  {}
  FormPoke:= TFormPoke.Create(Application);
  FormPoke.Edit1.Text:= Edit3.Text;
  FormPoke.Memo1.Text:= Edit4.Text;
  if FormPoke.ShowModal = mrOK then begin
  end;
  FormPoke.Free;
end;

procedure TFormTAPNull.MDDEExecuteClick(Sender: TObject);
begin
  {}
  FormExecMacro:= TFormExecMacro.Create(Application);
  FormExecMacro.Memo1.Text:= '';
  if FormExecMacro.ShowModal = mrOK then begin
  end;
  FormExecMacro.Free;
end;

procedure TFormTAPNull.MDDEEmulateClick(Sender: TObject);
begin
  FormEmulServ:= TFormEmulServ.Create(Application);
  if FormEmulServ.ShowModal = mrOK then begin
  end;
  FormEmulServ.Free;
end;

end.
{
:             MSAccess
:               Pagers;TABLE XQueue Fast
:            FirstRow
10001291	102161	100040091110	ASASASS	10.03.98	17	54
Call ID	        Message ID   Capcode    Message	Date For Trans	Hour For Trans
                                                                        Minute For Trans
float8  long            255             memo    d/t             int2            int2
}

