unit Exscr0;
(*##*)
(*******************************************************************
*                                                                 *
*   E  X  S  C  R  0         Ensen's script-driven TAP interface   *
*                                                                 *
*   Copyright (c) 1998, A.Ivanov. All rights reserved.             *
*   Main unit. Part of EPager                                     *
*   Conditional defines:                                           *
*                                                                 *
*   Last Revision: Apr 22 1998                                     *
*   Last fix     : Apr 22 1998                                    *
*   Lines        : 32                                              *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus, ComCtrls, DdeMan, ExtCtrls, ToolWin,
  ShellAPI,
  AdTerm, AdPort, AdProtcl, AdPStat, AdScript,
  epscript;

type
  TForm1 = class(TForm)
    ApdComPort1: TApdComPort;
    ApdProtocol1: TApdProtocol;
    ApdProtocolStatus1: TApdProtocolStatus;
    TAPScript1: TTAPScript;
    MainMenu1: TMainMenu;
    MFile: TMenuItem;
    MMFileDelimiter1: TMenuItem;
    MFileExit: TMenuItem;
    MOptions: TMenuItem;
    MFileStartStop: TMenuItem;
    MFileStart: TMenuItem;
    MFileStop: TMenuItem;
    MOptionsLocactions: TMenuItem;
    N2: TMenuItem;
    MOptionsLoad: TMenuItem;
    MOptionsStore: TMenuItem;
    MHelp: TMenuItem;
    MHelpIndex: TMenuItem;
    MHelpAbout: TMenuItem;
    StatusBar1: TStatusBar;
    DdeClientConv1: TDdeClientConv;
    DdeClientItem1: TDdeClientItem;
    Panel2: TPanel;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    TBDDEStartStop: TToolButton;
    TBAnswer: TToolButton;
    ListView1: TListView;
    Splitter1: TSplitter;
    PMenuListView: TPopupMenu;
    pmClear: TMenuItem;
    pmStore2File: TMenuItem;
    pmLoadFromFile: TMenuItem;
    pmN1: TMenuItem;
    EFields: TEdit;
    UDFields: TUpDown;
    LFields: TLabel;
    N1: TMenuItem;
    MHelpTest: TMenuItem;
    MEditScript: TMenuItem;
    MEdit: TMenuItem;
    Panel1: TPanel;
    ApdTerminal1: TApdTerminal;
    pmPokeSent: TMenuItem;
    pmPokeFail: TMenuItem;
    procedure ApdScript1ScriptFinish(CP: TObject; Condition: Integer);
    procedure TAPScriptNextBlock(CP: TObject; var Has: Boolean; var NextBlock: String);
    procedure MFileExitClick(Sender: TObject);
    procedure DisplayHint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DdeClientItem1Change(Sender: TObject);
    procedure TBDDEStartStopClick(Sender: TObject);
    procedure pmClearClick(Sender: TObject);
    procedure UDFieldsClick(Sender: TObject; Button: TUDBtnType);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MHelpTestClick(Sender: TObject);
    procedure MEditScriptClick(Sender: TObject);
    procedure MFileStartClick(Sender: TObject);
    procedure MFileStopClick(Sender: TObject);
    procedure TBAnswerClick(Sender: TObject);
    procedure pmPokeSentClick(Sender: TObject);
    procedure pmPokeFailClick(Sender: TObject);
  private
    // DDEItSelf: Boolean; // re-enter flag
    FServerRespond: Boolean;
    FScriptStarted: Boolean;
    FMsgFields: Word;
    FScriptFile: String;
    FDDEServer: String[32];
    FDDETopic: String[32];
    FDDEItem: String[32];
    FDDESent: String[32];
    FDDEFail: String[32];
     { Private declarations }
    procedure SetServerRespond(AServerRespond: Boolean);
    procedure SetScriptStarted(AScriptStarted: Boolean);
    procedure SetMsgFields(AMsgFields: Word);
  public
    { Public declarations }
    CurMsg: TStrings;  //  
    property ServerRespond: Boolean read FServerRespond write SetServerRespond;
    property ScriptStarted: Boolean read FScriptStarted write SetScriptStarted;
    property MsgFields: Word read FMsgFields write SetMsgFields; //    
    procedure PutMsgQ(AMsg: TStrings);              //    
    function  GetMsgQ(var AMsg: TStrings): Boolean; //  False   
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
uses
  util1;

procedure TForm1.SetServerRespond(AServerRespond: Boolean);
begin
  if AServerRespond then begin
    DdeClientConv1.CloseLink;
    DdeClientItem1.DdeConv:= DdeClientConv1;
    DdeClientItem1.DdeItem:= FDDEITEM;
    DdeClientItem1.OnChange:= DdeClientItem1Change;
    FServerRespond:= DdeClientConv1.SetLink(FDDESERVER, FDDETOPIC)
      and DdeClientConv1.OpenLink;
  end else begin
    DdeClientConv1.CloseLink;
    FServerRespond:= False;
  end;
  if FServerRespond
  then TBDDEStartStop.ImageIndex:= 1
  else TBDDEStartStop.ImageIndex:= 0;
  ToolBar1.Repaint;
end;

procedure TForm1.SetScriptStarted(AScriptStarted: Boolean);
begin
  if AScriptStarted then begin
    FScriptStarted:= True;
    TAPScript1.StartScript;
  end else begin
    FScriptStarted:= False;
    TAPScript1.StopScript(0);
  end;
  if FScriptStarted then begin
    TBAnswer.ImageIndex:= 3;
    MFileStart.Checked:= True;
  end else begin
    TBAnswer.ImageIndex:= 2;
    MFileStop.Checked:= True;    
  end;
  ToolBar1.Repaint;
end;

procedure TForm1.SetMsgFields(AMsgFields: Word);
begin
  FMsgFields:= AMsgFields;
  //       ListView1
end;

//    
procedure TForm1.PutMsgQ(AMsg: TStrings);
var
  LI: TListItem;
//  i: Integer;
begin
  LI:= ListView1.Items.Add;
  LI.Caption:= IntToStr(LI.Index);
  LI.SubItems.Assign(AMsg);
  {
  for i:= 0 to AMsg.Count-1 do begin
    // smth else?
    LI.SubItems.Add(AMsg.Strings[i]);
  end;
  }
end;

//     
//  False      
function  TForm1.GetMsgQ(var AMsg: TStrings): Boolean;
var
  LI: TListItem;
begin
  Result:= False;
  //     
  AMsg.Clear;
  if ListView1.Items.Count > 0 then begin
    //      
    //     - FIFO
    LI:= ListView1.Items[0];
    AMsg.Assign(LI.SubItems);
    ListView1.Items.Delete(0);
    Result:= True;
  end;
end;

procedure TForm1.ApdScript1ScriptFinish(CP: TObject; Condition: Integer);
begin
  ScriptStarted:= False;
  ShowMessage('  ');
  ScriptStarted:= True;
end;

procedure TForm1.TAPScriptNextBlock(CP: TObject; var Has: Boolean;
  var NextBlock: String);
begin
  Has:= GetMsgQ(CurMsg);
  NextBlock:= CurMsg.Text;
end;

procedure TForm1.MFileExitClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.DisplayHint(Sender: TObject);
begin
  with StatusBar1
  do Panels[Panels.Count-1].Text:= Application.Hint;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // DDEItSelf:= False;
  FDDEServer:= 'EGate';
  FDDETopic:= 'Scripts';
  FDDEItem:= 'Script1';
  FDDESent:= 'Sent';
  FDDEFail:= 'Fail';
  Application.OnHint:= DisplayHint;
  //    
  ScriptStarted:= False;
  //   
  ServerRespond:= True;
  MsgFields:= 2;
  CurMsg:= TStringList.Create;
  FScriptFile:= 'tap.sc';
  TAPScript1.ScriptFile:= FScriptFile;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CurMsg.Free;
end;

procedure TForm1.MEditScriptClick(Sender: TObject);
begin
  // ExecuteFile    ,     
  util1.EExecuteFile(FScriptFile);
end;

procedure TForm1.DdeClientItem1Change(Sender: TObject);
var
  p: array[0..31] of char;
begin
  if DdeClientItem1.Lines.Count > 0 then begin
    if not ((Pos(FDDESent, DdeClientItem1.Text)=1) or ((Pos(FDDEFail, DdeClientItem1.Text)=1))) then begin
      PutMsgQ(DdeClientItem1.Lines);
      //  
      // DdeClientConv1.PokeData(FDDEItem, StrPCopy(p, FDDESent));
      DdeClientConv1.ExecuteMacro(StrPCopy(p, FDDESent), False);
    end;
  end;
end;

procedure TForm1.TBDDEStartStopClick(Sender: TObject);
begin
  ServerRespond:= not ServerRespond;
end;

procedure TForm1.pmClearClick(Sender: TObject);
begin
  ListView1.Items.Clear;
end;

procedure TForm1.UDFieldsClick(Sender: TObject; Button: TUDBtnType);
begin
  MsgFields:= UDFields.Position;
end;

function MakeTestMsg(AMsgFields: Word): TStrings;
var
  i: Integer;
begin
  with Form1 do begin
    CurMsg.Clear;
    CurMsg.Add('123456789012');
    for i:= 2 to AMsgFields do begin
      CurMsg.Add('Just a test '+IntToStr(i-1));
    end;
    Result:= CurMsg;
  end;
end;

procedure TForm1.MHelpTestClick(Sender: TObject);
begin
  PutMsgQ(MakeTestMsg(MsgFields));
end;

procedure TForm1.MFileStartClick(Sender: TObject);
begin
  ScriptStarted:= True;
end;

procedure TForm1.MFileStopClick(Sender: TObject);
begin
  ScriptStarted:= False;
end;

procedure TForm1.TBAnswerClick(Sender: TObject);
begin
  ScriptStarted:= not ScriptStarted;
end;

procedure TForm1.pmPokeSentClick(Sender: TObject);
var
  p: array[0..31] of char;
begin
  // DdeClientConv1.PokeData(FDDEItem, StrPCopy(p, FDDESent));
  DdeClientConv1.ExecuteMacro(StrPCopy(p, FDDESent), False);
end;

procedure TForm1.pmPokeFailClick(Sender: TObject);
var
  p: array[0..31] of char;
begin
  // DdeClientConv1.PokeData(FDDEItem, StrPCopy(p,FDDEFail));
  DdeClientConv1.ExecuteMacro(StrPCopy(p, FDDEFail), False);
end;

end.

