unit tap;
(*##*)
(*******************************************************************
*                                                                 *
*   T  A  P                Telocator alphanumeric protocol impl. *
*                                                                 *
*   Copyright (c) 1998, A.Ivanov. All rights reserved.             *
*   Delphi 2, 3 only (uses huge strings)                          *
*   Conditional defines:        H+                                 *
*                                                                 *
*   Last Revision: Apr 19 1998                                     *
*   Last fix     : Apr 21 1998                                    *
*   Oct 04 1998,  xlat definitions removed, link to cpcoll unit    *
*                                                                 *
*   Lines        : 1216                                            *
*   History      : see CHANGES.TXT file                           *
*   Printed      : ---                                             *
*                                                                 *
********************************************************************)
(*##*)
{$H+   use String==ANSIString<>ShortString}
interface

uses
  Classes, Windows, dialogs, extctrls,
  forms;

const
  { ini section constants
  }
  iniPagerOPTINIFN   = 'EPager.Ini';
  iniTAPTESTSECTION  = 'TAPTest';
  iniTAPSECTION      = 'TAP';
  iniTAPSECTQTY      = 'TerminalsQty';
  iniDEFAULTRULE     = 'DefaultRule';
  iniCyclesStarted   = 'StartCycles';
  iniExtModuleName   = 'ExtModuleName';

  NUL = #0;  SOH = #1;  STX = #2;  ETX = #3;  EOT = #4;  ENQ = #5;
  ACK = #6;  BEL = #7;  BS  = #8;  HT  = #9;  LF  = #10; VT  = #11;
  FF  = #12; CR  = #13; SO  = #14; SI  = #15; DLE = #16; DC1 = #17;
  DC2 = #18; DC3 = #19; DC4 = #20; NAK = #21; SYN = #22; ETB = #23;
  CAN = #24; EM  = #25; SUB = #26; ESC = #27; FS  = #28; GS  = #29;
  RS  = #30; US  = #32;
  XON = DC1; XOFF= DC3;

  BLOCKLIMIT       = 256;
  DEFBLOCKLIMITMSG = 250;
  UNLIMITEDBLOCKS  = 0;  {  }
  {     }
  MINPAGERMessageLen = 80;
  RECOMMENDED_NUMDIGITS = 3;

  TIMERTICKSPERSEC = 1000;  // TTimer component
  {   }
  blkMSGSTART           = 0;
  blkMSGMIDDLE          = 1;
  blkMSGFINISH          = 2;
  blkMSGALONE           = 3;
  blkMSGNONE            = 4;
  blkLAST               = 4;
  {    }
  fmtpgREGULAR          = 0;  //  
  fmtpgALLOWCONTROLS    = 1;  //      
  fmtpgBLOCKTRM_ETB     = 2;  //       ETB 
  fmtpgBLOCKTRM_US      = 3;  //       US
  fmtpgALLOWCR          = 4;  //   CR   
  fmtpgNO_CR_AFTER_MSG  = 5;  //   CR   
  fmtpgFORCETRUNCLONG   = 6;  //       
  fmtpgFORCE1BLOCK      = 7;  //          
  fmtpgNOTRANSLATION    = 8;  //    
  fmtpgRING             = 9;  //    (  )
  fmtpgNORING           = 10; //     (  )
  fmtpgCRC8bit          = 11; //  8  CRC   7 
  fmtpgLAST             = 11;

  numpgREGULAR          = 0;  //
  numpgNO               = 1;  //      
  numpgNUMERIC          = 2;  // 1,2..
  numpgALPHANUMERIC     = 3;  // 1,2..9,A,B,..a,..z,11,..
  numpgALPHA            = 4;  //    
  numpgHEX              = 5;  // 1,..F,10..FF,..
                              //      -   
  numpgALLOWSUBMSG      = 6;  //    
  numpgSUBMSGDOTTED     = 7;  //     ( ) 
  numpgSUBMSG_AS_MSG    = 8;  //       ( )
                              // (    ,  ,   )
  numpgSUBMSGTOTAL      = 9;  //     (,1/7 -   )
  numpgLAST             = 9;  //       ,
                              //      
  LISTDELIMITER: Char = ',';

type
 { string types for ConOpts unit }
  String32 = String[32];
  String8 = String[8];

  { xlat definitions removed, link to cpcoll unit }

  //     MODELS
  TPagerProps =  record
    PGModel: String[16];
    MsgLen: LongInt;
    Protocol:String[12];
    Speed: LongInt;
    Charset: String[12];
    Price: Real;
  end;

  // callback
  //  TTimeOut
  TProc    = procedure;

  {  -    }
  TMarkMsgProc = procedure(MSGNo: Integer; Sent: Boolean);

  {  callback- ,     SendLoop
         
    
      False,      
      True     
    Msg   (WO)-        <CR> 
    MsgNo (WO)-   (     )
                (         )
  }
  TGetMsgProc = function(AWaitSec: Integer; var MSGNo: Integer; var S: String;
    var APagerProps: TPagerProps): Boolean;

  { types for PagOpts unit }
  FormatStyleType = fmtpgREGULAR..fmtpgLAST;
  FormatStyleSet = set of FormatStyleType;
  NumerateStyleType = numpgREGULAR..numpgLAST;
  NumerateStyleSet = set of NumerateStyleType;
  TBlockKind = blkMSGSTART.. blkLAST;
  TPosInString = record
    case Integer of
    0: (P: Pointer;);
    1: ( Start,
         Finish: Word;
        );
    2: (BlockKind: TBlockKind);
  end;

  TPgConOpts = (cmASCIITextOnly, cmThruModem, cmWaitPrompt, cmManualLogin,
    cmNoWaitReady, cmNoWaitAccept, cmNoSendMsg);
  TPgConOptSet = set of TPgConOpts;

  TConnectPars = record
    {  PortNo = 0      ! }
    PortNo1:  Word;
    PortSetS: String32;
    CDWaitSec: Word;
    HandShakingType: Byte;
    XONChar, XOFFChar: Byte;
    Phone: String32;
    LoginPrompt: String32;
    Passwd: String32;
    UserName: String8;
    ManualLogStr: String32;
    ReadyTransactionStr: String32;
    PgConOptSet: TPgConOptSet;
  end;

  TTerminalPar = record //    
    tapBlockLen: Word;    //  - 250
    tapLimitBlocks: Word; // 0- 
    tapFirstMsgNo: LongInt;
    comPars: TConnectPars;
    stlFormat: FormatStyleSet;
    stlNumerate: NumerateStyleSet;
  end;

  //   
  TTerminalsParsArray = array[0..5] of TTerminalPar; //       [0..0]
  TTAPsPars = class
    private
    FCount: Word;
    FMaxCount: Word;
    FParameters: ^TTerminalsParsArray;
    FSectionPrefix: String[32];
    function  GetSectionPrefix: String;
    procedure SetSectionPrefix(APrefix: String);
    function  GetTerminalPar(AIndex: Word): TTerminalPar;
    protected
    procedure SetCount(ACount: Word); virtual;
    procedure SetTerminalPar(AIndex: Word; AValue: TTerminalPar); virtual;
    public
    constructor Create; virtual;
    destructor Destroy; virtual;
    procedure LoadFromIni; virtual;
    procedure StoreToIni;
    property Count: Word read FCount write SetCount;
    property Params[index: Word]: TTerminalPar read GetTerminalPar write SetTerminalPar;
    property SectionPrefix: String read GetSectionPrefix write SetSectionPrefix;
  end;

  {    XX 
      XX   TerminateByEvent
  }
  TTimeOut = class(TObject)
    TerminateByEvent: Boolean;
    Timer: TTimer;
    constructor Create(Secs: Integer);
    destructor Destroy; override;//virtual;
    procedure WaitCallBack(Sender: TObject);
  end;

const
  // MSComm's Handshake Constants
  comNone	 = 0; //	No handshaking.
  comXonXoff     = 1; //	XOn/XOff handshaking.
  comRTS         = 2; //	Request-to-send/clear-to-send handshaking.
  comRTSXOnXOff  = 3; //Both request-to-send and XOn/XOff handshaking.
  //OnComm Constants
  comEvSend	 = 1; // Send event.
  comEvReceive	 = 2; // Receive event.
  comEvCTS	 = 3; // Change in clear-to-send line.
  comEvDSR	 = 4; // Change in data-set ready line.
  comEvCD	 = 5; // Change in carrier detect line.
  comEvRing      = 6; // Ring detect.
  comEvEOF       = 7; // End of file.
  // Error Constants
  comEventBreak	 = 1001; // Break signal received
  comEventCTSTO	 = 1002; // Clear-to-send timeout
  comEventDSRTO	 = 1003; // Data-set ready timeout
  comEventFrame	 = 1004; // Framing error
  comEventOverrun= 1006; // Port overrun
  comEventCDTO	 = 1007; // Carrier detect timeout
  comEventRxOver = 1008; // Receive buffer overflow
  comEventRxParity=1009; // Parity error
  comEventTxFull = 1010; // Transmit buffer full
  comEventDCB	 = 1011; // Unexpected error retrieving Device Control Block (DCB) for the port
  // InputMode Constants
  comInputModeText  = 0; //(Default) Data is retrieved through the Input property as text.
  comInputModeBinary= 1; // Data is retrieved through the Input property as binary data.

{  CRC  12    S-
     P1    P2. P1     0!
   P1=1  P2=0 ( P2=0,        ), 
   ,  P2 >  
      7 
}
function CRC12bit(S: String; P1, P2: Integer): String;

{  CRC  12    S-
      8 
}
function CRC12bitExtendedASCII(S: String; P1, P2: Integer): String;

{        MSComm
}
function ComStateErrorStr(Code: Word): String;

{   
  Kind:
  0 - #13As text      
  1 - ^MAs  ASCII      
  2 - 0A .. hex     
}
function TranslateView(const S: String; AKind: Integer): String;

{     <SUB> <Char> << 6 + 40h
  KeepCR - True  -  CR   -   
         - False -     
  Style: 0 - 
       +-1 -    0  #31                 ( CR  KeepCR=True)
       +-2 -     TAP
       +-3 -   #7, #9, #10, #12, #13
          <0 -    , >0 -   
}
procedure ValidateControlChar(Style: Integer; KeepCR: Boolean; var S: String);

{ TransactionFillMessages
     
  :
  MSG -   
  FotmatStyle -    
    fmtpgREGULAR           
    fmtpgALLOWCONTROLS         
     fmtpgBLOCKTRM_ETB          ETB 
     fmtpgBLOCKTRM_US           US
    fmtpgALLOWCR            CR   
    fmtpgNO_CR_AFTER_MSG    CR   
    fmtpgFORCETRUNCLONG         
    fmtpgFORCE1BLOCK               
    fmtpgNOTRANSLATION       
     fmtpgRING               (  ) 
     fmtpgNORING              (  )
         -     
  NumerateStyle -   
    numpgREGULAR
    numpgNO                    
     numpgNUMERIC           -   
     numpgALPHANUMERIC    1,2..9,A,B,..a,..z,11,..
     numpgALPHA              
     numpgHEX             1,..F,10..FF,..
    numpgALLOWSUBMSG         
     numpgSUBMSGDOTTED        ( ) 
     numpgSUBMSG_AS_MSG         ( )
                          (  ,   )
     numpgSUBMSGTOTAL         (,1/7 -   )
                                ,
                               
  OneMsgLenLimit -       ( 
          )
  LimitBlocks -        
    (   /      )
     0,  -  
  MessagesList: (WO)             ,
                             TransactionFillBlocks
const FormatStyle: FormatStyleSet; const NumerateStyle: NumerateStyleSet;
TAPBlockLen, TAPLimitBlocks,
}

procedure TransactionFillMessages(var Msg: String;
  ATerminalPars: TTerminalPar; OneMsgLenLimit: Integer; MessagesList: TList);

{   TAP    MessagesList
  :
  MessagesList: (RO)        ,
                       
  :
  BlocksList:   (WO)     
  KindList:     (WO)     
                   (blkMSGSTART,blkMSGMIDDLE,blkMSGFINISH,blkMSGALONE);
}
procedure TransactionFillBlocks(const Msg: String; MessagesList: TList;
  Virtual_BlockLimit: Integer; BlocksList, KindList: TList);

{
  Num         - 0..
  FormatStyle -    
    fmtpgREGULAR           
    fmtpgALLOWCONTROLS         
     fmtpgBLOCKTRM_ETB          ETB 
     fmtpgBLOCKTRM_US           US
    fmtpgALLOWCR            CR   
    fmtpgNO_CR_AFTER_MSG    CR   
    fmtpgFORCETRUNCLONG         
    fmtpgFORCE1BLOCK               
                                
    fmtpgNOTRANSLATION       
     fmtpgRING               (  ) 
     fmtpgNORING              (  )
         -     

  NumerateStyle -   
    numpgREGULAR
    numpgNO                    
     numpgNUMERIC           -   
     numpgALPHANUMERIC    1,2..9,A,B,..a,..z,11,..
     numpgALPHA              
     numpgHEX             1,..F,10..FF,..
    numpgALLOWSUBMSG         
     numpgSUBMSGDOTTED        ( ) 
     numpgSUBMSG_AS_MSG         ( )
                          (  ,   )
     numpgSUBMSGTOTAL         (,1/7 -   )
                                ,
                               
  OneMsgLenLimit -       ( 
          )
  MsgNo          -   (  ),   
                     
}
function GenerateMessageBlock(MsgNo, Num: Integer; const Msgs: String;
  ATerminalPars: TTerminalPar; MsgList, BlockList, KindList: TList): String;

{ :    ,   POSITION  
    .     
}
function BlockIsStartOfMessage(Position: Integer; MList: TList): Boolean;

{ :    NUM   MLIST
    (blkMSGSTART,blkMSGMIDDLE,blkMSGFINISH,blkMSGALONE);
    .     
}
function BlockKind(Num: Integer; MList, BList: TList):TBlockKind;

//          0   1   2   3   4
// return   N   O   E   M   S
function ParityChar(AParity: Byte): Char;

//          0   1   2   3   4
// return  no,odd,even,mark,space
function ParityStr(AParity: Byte): String;

{   - 1..7 }
var
  TimerFlags: set of 0..7;

{        
    HWND  hwnd	  handle of window for timer messages
    UINT  uMsg	  WM_TIMER message
    UINT  idEvent timer identifier
    DWORD  dwTime current system time
}
procedure SetTimerFlag(wnd: HWND; Msg, TimerId, sysTime: LongInt); stdcall;

implementation

uses
  sysutils, util1, pagopts, conopts;

function ComStateErrorStr(Code: Word): String;
var
  S: String;
begin
  case Code of
    0: S:= '';
    { error }
    comEventBreak   : S:= 'A Break was received.';
    comEventCDTO    : S:= 'CD (RLSD) -..';
    comEventCTSTO   : S:= 'CTS -.';
    comEventDSRTO   : S:= 'DSR -.';
    comEventFrame   : S:= 'Framing Error';
    comEventOverrun : S:= ' .';
    comEventRxOver  : S:= '  .';
    comEventRxParity: S:= ' .';
    comEventTxFull  : S:= '  .';
    comEventDCB	    : S:= '   DCB';
    { Events }
    comEvCD	: S:= '   CD.';
    comEvCTS	: S:= '   CTS.';
    comEvDSR	: S:= '   DSR.';
    comEvRing	: S:= '     Ring.';
    comEvReceive: S:= 'Received RThreshold # of chars.';
    comEvSend	: S:= 'There are SThreshold number of characters in the transmit buffer.';
    comEvEof	: S:= '   <EOF>    .';
    else          S:= ' .';
  end;
  Result:= S;
end;

type
  LongAs4Byte = record
  case Integer of
    0: (I4: LongInt);
    1: (C4: array [0..3] of Char);
    2: (B4: array [0..3] of Byte);
  end;

{  CRC  12    S-
     P1    P2. P1     0!
   P1=1  P2=0 ( P2=0,        ), 
   ,  P2 >  
  - Button1.Caption:= tap.CRC12bit(#2#49#50#51#13#65#66#67#13#3, 1, 0);
   - "17;"
}
function CRC12bit(S: String; P1, P2: Integer): String;
var
  i, L: Integer;
  R: LongAs4Byte;
  RS: String[3];
begin
  Result:= '000';
  L:= Length(S);
  {        -     }
  if P2 > L
  then P2:= L;
  if P2 = 0
  then P2:= L;
  if (L = 0) or (P1 > L) or (P1 > P2)
  then Exit;
  R.I4:= 0;
  // 7 bit - mask bit 7
  for i:= P1 to P2
  // overflow- bit sign? Possible causes bug
  do Inc(R.I4, Byte(S[i]) and $7F);
  // R.I4:= R.I4 and $FFF;
  RS[0]:= #3;
  RS[3]:= Char(R.B4[0] and $F + $30);
  RS[2]:= Char((R.B4[0] and $F0) shr 4 + $30);
  RS[1]:= Char(R.B4[1] and $F + $30);
  Result:= RS;
end;

{  CRC  12    S-
      8 
}
function CRC12bitExtendedASCII(S: String; P1, P2: Integer): String;
var
  i, L: Integer;
  R: LongAs4Byte;
  RS: String[3];
begin
  Result:= '000';
  L:= Length(S);
  {        -     }
  if P2 > L
  then P2:= L;
  if P2 = 0
  then P2:= L;
  if (L = 0) or (P1 > L) or (P1 > P2)
  then Exit;
  R.I4:= 0;
  for i:= P1 to P2
  do Inc(R.I4, Byte(S[i]));
  // R.I4:= R.I4 and $FFF;
  RS[0]:= #3;
  RS[3]:= Char(R.B4[0] and $F + $30);
  RS[2]:= Char((R.B4[0] and $F0) shr 4 + $30);
  RS[1]:= Char(R.B4[1] and $F + $30);
  Result:= RS;
end;

function TranslateView(const S: String; AKind: Integer): String;
var
  SS: String;
  i, L: Integer;
begin
  L:= Length(S);
  case AKind of
  0: begin
       SS:= '';
       for i:= 1 to L do begin
         case S[i] of
         #10:;
         #13: SS:= SS + #13#10;
         else SS:= SS + ControlChar(S[i]);
         end;
       end;
       Result:= SS;
     end;
  1: begin
       SS:= '';
       for i:= 1 to L do begin
         case S[i] of
         #10: ;
         #13: SS:= SS + #13#10;
         #0..#8, #11..#12, #14..#31,#128..#191:
           SS:= SS + '#'+IntToStr(Byte(S[i]));
         else SS:= SS + S[i];
         end;
       end;
       Result:= SS;
     end;
  2: begin
       SS:= '';
       for i:= 1 to L do begin
         SS:= SS + IntToHex(Byte(S[i]), 2)+ ' ';
       end;
       Result:= SS;
     end;
  end;
end;

{     <SUB> <Char> << 6 + 40h
  KeepCR - True  -  CR   -   
         - False -     
  Style: 0 - 
       +-1 -    0  #31                 ( CR  KeepCR=True)
       +-2 -     TAP
       +-3 -   #7, #9, #10, #12, #13
          <0 -    , >0 -   
}
procedure ValidateControlChar(Style: Integer; KeepCR: Boolean; var S: String);
var
  i, L: Integer;
  JustDelete: Boolean;
begin
  L:= Length(S);
  JustDelete:= Style < 0;
  Style:= Abs(Style);
  i:= 1;
  case Style of
  1:begin
      if JustDelete then begin
        {     }
        {    0  #31( CR)}
        if KeepCR then begin
          {    CR }
          while i <= L do begin
            if (S[i]<#13) or ((S[i]>#13) and (S[i]<#32)) then begin
              System.Delete(S,i,1);
              Dec(L);
            end else begin
              Inc(i);
            end; { if }
          end; { while }
        end else begin
         {   CR  }
          while i <= L do begin
            if S[i] < #32 then begin
              System.Delete(S,i,1);
              Dec(L);
            end else begin
              Inc(i);
            end; { if }
          end; { while }
        end;
      end else begin
        {    }
        if KeepCR then begin
          while i <= L do begin
            {    CR }
            if (S[i]<#13) or ((S[i]>#13) and (S[i]<#32)) then begin
              {  .  }
              System.Insert(SUB + Char(Byte(S[i])+$40), S, i);
              {   .  }
              System.Delete(S, i+2, 1);
              Inc(L);
              Inc(i, 2);
            end else begin
              Inc(i);
            end; { if }
          end; { while }
        end else begin
         {   CR }
          while i <= L do begin
            if S[i] < #32 then begin
              {  .  }
              System.Insert(SUB + Char(Byte(S[i])+$40), S, i);
              {   .  }
              System.Delete(S, i+2, 1);
              Inc(L);
              Inc(i, 2);
            end else begin
              Inc(i);
            end; { if }
          end; { while }
        end;
      end
    end;
  2:begin
      while i <= L do begin
        if S[i] in [LF, ESC, STX, ETX, US, ETB, EOT, SUB] then begin
          {  .  }
          System.Insert(SUB + Char(Byte(S[i])+$40), S, i);
          {   .  }
          System.Delete(S, i+2, 1);
          Inc(L);
          Inc(i, 2);
        end else begin
          Inc(i);
        end; { if }
      end; { while }
    end;
  3:begin
      while i <= L do begin
        if S[i] in [#1..#6,#7,#8,#11, #14..#31] then begin
          {  .  }
          System.Insert(SUB + Char(Byte(S[i])+$40), S, i);
          {   .  }
          System.Delete(S, i+2, 1);
          Inc(L);
          Inc(i, 2);
        end else begin
          Inc(i);
        end; { if }
      end; { while }
    end;
  end;
end;

{ :
  MSG -   
  FotmatStyle -    
    fmtpgREGULAR           
    fmtpgALLOWCONTROLS         
     fmtpgBLOCKTRM_ETB          ETB 
     fmtpgBLOCKTRM_US           US
    fmtpgALLOWCR            CR   
    fmtpgNO_CR_AFTER_MSG    CR   
    fmtpgFORCETRUNCLONG         
    fmtpgFORCE1BLOCK               
    fmtpgNOTRANSLATION       
     fmtpgRING               (  ) 
     fmtpgNORING              (  )
         -     
  NumerateStyle -   
    numpgREGULAR
    numpgNO                    
     numpgNUMERIC           -   
     numpgALPHANUMERIC    1,2..9,A,B,..a,..z,11,..
     numpgALPHA              
     numpgHEX             1,..F,10..FF,..
    numpgALLOWSUBMSG         
     numpgSUBMSGDOTTED        ( ) 
     numpgSUBMSG_AS_MSG         ( )
                          (  ,   )
     numpgSUBMSGTOTAL         (,1/7 -   )
                                ,
                               
  OneMsgLenLimit -       ( 
          )
  LimitBlocks -        
    (   /      )
     0,  -  
  MessagesList: (WO)        

}
procedure TransactionFillMessages(var Msg: String;
  ATerminalPars: TTerminalPar; OneMsgLenLimit: Integer; MessagesList: TList);
var
  L, SubMsgs: Integer;
  OneMsgLimitWNums: Integer;
  PosInString: TPosInString;
begin
  MessagesList.Clear;
  {      }
  DeleteLeadTerminateDoubledSpaceStr(Msg);
  {     
    CR -    
  }
  if fmtpgALLOWCONTROLS in ATerminalPars.stlFormat
  then ValidateControlChar(1, True, Msg)
  else ValidateControlChar(-1, True, Msg);
  L:= Length(Msg);
  if OneMsgLenLimit < 1 then begin
    // ShowMessage('      1 ');
    // OneMsgLenLimit:= 80; - that's wrong validation
    Exit;
  end;
  if fmtpgNO_CR_AFTER_MSG in ATerminalPars.stlFormat then begin
    {   CR }
    if (L > 0) and (Msg[L] = #13) then begin
      System.Delete(Msg, L, 1);
      Dec(L);
    end;
  end else begin
    {  CR         }
    if Msg[L] <> #13 then begin
      Msg:= Msg+#13;
      {  CR   }
      Inc(L);
    end;
  end;
  {    }
  //....
  {  ,    ? }
  {  ,    }
  OneMsgLimitWNums:= OneMsgLenLimit;
  {       (1,2..).. }
  if ATerminalPars.tapLimitBlocks > 0 then begin
    {        (  ) }
    if OneMsgLimitWNums > ATerminalPars.tapLimitBlocks * ATerminalPars.tapBlockLen then begin
      {  -         }
      OneMsgLimitWNums:= ATerminalPars.tapLimitBlocks * ATerminalPars.tapBlockLen;
    end;
  end;
  if fmtpgFORCE1BLOCK in ATerminalPars.stlFormat then begin
    {              }
    {       250       250}
    if OneMsgLimitWNums > ATerminalPars.tapBlockLen
    then OneMsgLimitWNums:= ATerminalPars.tapBlockLen;
  end;
  if numpgNO in ATerminalPars.stlNumerate then begin //*
    {        }
  end else begin
    { }
    Dec(OneMsgLimitWNums, RECOMMENDED_NUMDIGITS);
    {       }
    if numpgALLOWSUBMSG in ATerminalPars.stlNumerate then begin //*
      if numpgSUBMSGDOTTED in ATerminalPars.stlNumerate then begin //*
        {  No ? - 2  .S }
        Dec(OneMsgLimitWNums, 2);
        {   - ? - 2  /T }
        if numpgSUBMSGTOTAL in ATerminalPars.stlNumerate then begin //*
          Dec(OneMsgLimitWNums, 2);
        end;
      end else begin
        if numpgSUBMSG_AS_MSG in ATerminalPars.stlNumerate then begin //*
          {    -   }
        end;
      end;
    end;
  end;
  {       }
  {   }
  SubMsgs:= L div OneMsgLimitWNums;
  if L mod OneMsgLimitWNums > 0
  then Inc(SubMsgs);
  {    -     }
  case SubMsgs of
  1:begin  { 0 }
      {    1  }
      PosInString.Start:= 1;
      PosInString.Finish:= L;
      MessagesList.Add(PosInString.P);
    end;
  2..MaxInt:begin { 1.. }
    {      }
      if fmtpgFORCETRUNCLONG in ATerminalPars.stlFormat then begin
        {        -    }
        Delete(Msg, OneMsgLimitWNums, L);
        PosInString.Start:= 1;
        PosInString.Finish:= L;
        MessagesList.Add(PosInString.P);
      end else begin
        {       }
        PosInString.Finish:= 0;
        repeat
          {      }
          if LimitQtyWordsPos(Msg, PosInString.Start, PosInString.Finish, OneMsgLimitWNums) then begin
            { Len:= Fin - PosInString.Start + 1; }
            MessagesList.Add(PosInString.P);
          end else begin
            Break;
          end;
        until False;
      end;
    end;
  end; { case }
end;

{ :
  MessagesList: (RO)     -   
                       ,   
  :
  BlocksList:   (WO)     
  KindList:     (WO)     
                   (blkMSGSTART,blkMSGMIDDLE,blkMSGFINISH,blkMSGALONE);
}
procedure TransactionFillBlocks(const Msg: String; MessagesList: TList;
  Virtual_BlockLimit: Integer; BlocksList, KindList: TList);
var
  i: Integer;
  PosInString: TPosInString;
  Kind: TPosInString;
  IsBlockFirst: Boolean;
begin
  BlocksList. Clear;
  KindList. Clear;
  //      .      250
  if Virtual_BlockLimit <= 0
  then Virtual_BlockLimit:= DEFBLOCKLIMITMSG;
  {   .. }
  for i:= 1 to MessagesList.Count do begin
    {     i-1 (0..)   }
    PosInString.Finish:= TPosInString(MessagesList.Items[i-1]).Start-1;
    {   . LimitQtyWordsPos  -    }
    { ,     }
    IsBlockFirst:= True;
    repeat
      {     ,   .. }
      if LimitQtyWordsPos(Msg, PosInString.Start, PosInString.Finish, Virtual_BlockLimit) then begin
        {         .. }
        if PosInString.Finish >= TPosInString(MessagesList.Items[i-1]).Finish then begin
          { ..   :
            -    1 ,
            -     
          }
          { ,       ? }
          if PosInString.Start <= TPosInString(MessagesList.Items[i-1]).Finish then begin
            {      
            }
            PosInString.Finish:= TPosInString(MessagesList.Items[i-1]).Finish;
            { +++   ,     }
            BlocksList.Add(PosInString.P);
            if IsBlockFirst
            then Kind.BlockKind:= blkMSGALONE
            else Kind.BlockKind:= blkMSGFINISH;
            KindList.Add(Kind.P);
            {         -   repeat }
          end;
          {    ,     }
          Break;
        end else begin
          { +++     ,    }
          BlocksList.Add(PosInString.P);
          if IsBlockFirst
          then Kind.BlockKind:= blkMSGSTART
          else Kind.BlockKind:= blkMSGMIDDLE;
          KindList.Add(Kind.P);
          {     1  }
          IsBlockFirst:= False;
        end;
      end else begin
        {   ,     }
        Break;
      end;
      {      repeat  break -      }
      IsBlockFirst:= False;
    until False;
  end;
end;

{ :    ,   POSITION  
    .     
}
function BlockIsStartOfMessage(Position: Integer; MList: TList): Boolean;
var
  i: Integer;
begin
  Result:= False;
  for i:= 1 to MList.Count do begin
    if TPosInString(MList.Items[i-1]).Start = Position then begin
      Result:= True;
      Break;
    end;
  end;
end;

{ :    NUM   MLIST
    (blkMSGSTART,blkMSGMIDDLE,blkMSGFINISH,blkMSGALONE);
    .     
}
function BlockKind(Num: Integer; MList, BList: TList):TBlockKind;
var
  i: Integer;
  Pos0: TPosInString;
  Kind: TBlockKind; { blkMSGSTART.. blkLAST }
begin
  Result:= blkMSGNONE;
  if (Num < 0) or (Num >= BList.Count)
  then Exit;
  Pos0:= TPosInString(BList.Items[Num]);
  {
  if Num > 0
  then Pos_1:= TPosInString(BList.Items[Num-2]);
  if (BList.Count > 0) and (Num < BList.Count-1)
  then Pos1:= TPosInString(BList.Items[Num]);
  }
  {       ,    
  }
  Kind:= blkMSGMIDDLE;
  for i:= 1 to MList.Count do begin
    if TPosInString(MList.Items[i-1]).Start = Pos0.Start then begin
      {   }
      if TPosInString(MList.Items[i-1]).Finish = Pos0.Finish then begin
        {   }
        if TPosInString(MList.Items[i-1]).Finish = Pos0.Finish then begin
          {    -   ( 1 ) }
          Kind:= blkMSGALONE;
        end;
      end else begin
        {     -  }
        Kind:= blkMSGSTART;
      end;
      Break;
    end;
    if TPosInString(MList.Items[i-1]).Finish = Pos0.Finish then begin
      {      }
      Kind:= blkMSGFINISH;
      Break;
    end;
  end;
  Result:= Kind;
end;

{    (0..),     BlockNum
  :
  BlockNum -   (0..)
}
function GetSubMsgNoByBlock(BlockNum: Integer; MsgList, BlockList: TList): Integer;
var
  i, P, m: Integer;
begin
  P:= TPosInString(BlockList.Items[BlockNum]).Start;
  M:= 0;
  for i:= 1 to MsgList.Count do begin
    {    >  .. }
    if P > TPosInString(MsgList.Items[i-1]).Finish then begin
      { ..    
               }
      M:= i-2;
      Break;
    end;
  end;
  {     .. }
  { .. 1-     }
  Result:= M;
end;

{     MsgNo,  SubMsgNo,  BlockNo
       NumerateStyle
       
  NumerateStyle -   
  numpgNO                    
   numpgNUMERIC           -   
   numpgALPHANUMERIC    1,2..9,A,B,..a,..z,11,..
   numpgALPHA              
   numpgHEX             1,..F,10..FF,..
  numpgALLOWSUBMSG         
   numpgSUBMSGDOTTED        ( ) -   
   numpgSUBMSG_AS_MSG         ( )
                        (  ,   )
   numpgSUBMSGTOTAL         (,1/7 -   )
                              ,
                             
}
function MkNum(const NumerateStyle: NumerateStyleSet; MsgNo, SubMsgNo, BlockNo: Integer): String;
var
  S: String;

function NumByStyle(Num, Digits: Integer): String;
begin
  if numpgALPHANUMERIC in NumerateStyle then begin
    {  RECOMMENDED_NUMDIGITS=3  }
    Result:= IntToAplhaNumeric(Num, Digits);
  end else begin
    if numpgALPHA in NumerateStyle then begin
      {  RECOMMENDED_NUMDIGITS=3  }
      Result:= IntToAplha(Num, Digits);
    end else begin
      if numpgHEX in NumerateStyle then begin
        {  RECOMMENDED_NUMDIGITS=3  }
        Result:= IntToHex(Num, Digits);
      end else begin
        {  -     }
        Result:= System.Copy(IntToStr(Num), 1, Digits);
      end;
    end;
  end;
end;

begin
  Result:= '';
  {     -  }
  if numpgNO in NumerateStyle
  then Exit;
  if (numpgALLOWSUBMSG in NumerateStyle) and
    (numpgSUBMSG_AS_MSG in NumerateStyle) then begin
    {   }
    Inc(MsgNo, SubMsgNo);
  end;
  {   '>'  -   }
  S:= NumByStyle(MsgNo, RECOMMENDED_NUMDIGITS-1);
  {   ,   (   ) }
  if (numpgALLOWSUBMSG in NumerateStyle) and (not (numpgSUBMSG_AS_MSG in NumerateStyle))then begin
    {  , numpgSUBMSGDOTTED     
    }
    {    () -   
    if Length(S) > 2
    then Delete(S, 1, 1);
    }
    S:= S+ '.'+ NumByStyle(SubMsgNo, 1);
    if numpgSUBMSGTOTAL in NumerateStyle then begin
      {    }
      { ------------------------   --------------------------------}
      S:= S+ '/X';
    end;
  end;
  Result:= S + '>';
end;

{    
  Num         - 0..
  FormatStyle -    
    fmtpgREGULAR           
    fmtpgALLOWCONTROLS         
     fmtpgBLOCKTRM_ETB          ETB 
     fmtpgBLOCKTRM_US           US
    fmtpgALLOWCR            CR   
    fmtpgNO_CR_AFTER_MSG    CR   
    fmtpgFORCETRUNCLONG         
    fmtpgFORCE1BLOCK               
                                
    fmtpgNOTRANSLATION       
     fmtpgRING               (  ) 
     fmtpgNORING              (  )
         -     

  NumerateStyle -   
    numpgREGULAR
    numpgNO                    
     numpgNUMERIC           -   
     numpgALPHANUMERIC    1,2..9,A,B,..a,..z,11,..
     numpgALPHA              
     numpgHEX             1,..F,10..FF,..
    numpgALLOWSUBMSG         
     numpgSUBMSGDOTTED        ( ) 
     numpgSUBMSG_AS_MSG         ( )
                          (  ,   )
     numpgSUBMSGTOTAL         (,1/7 -   )
                                ,
                               
  OneMsgLenLimit -       ( 
          )
  MsgList  -     
  BlockList-  
  KindList -   
}
function GenerateMessageBlock(MsgNo, Num: Integer; const Msgs: String;
  ATerminalPars: TTerminalPar;
  MsgList, BlockList, KindList: TList): String;
var
  S: String;
  PosInString: TPosInString;
  Kind: TBlockKind; { blkMSGSTART.. blkLAST }
  SubMsgNo: Integer;
begin
  Result:= '';
  {   0      }
  if (Num < 0) or (Num >= BlockList.Count)
  then Exit;
  PosInString:= TPosInString(BlockList.Items[Num]);
  S:= System.Copy(Msgs, PosInString.Start, PosInString.Finish-PosInString.Start+1);
  {       }
  Kind:= TPosInString(KindList.Items[Num]).BlockKind;
  SubMsgNo:= GetSubMsgNoByBlock(Num, MsgList, BlockList);
  System.Insert(MkNum(ATerminalPars.stlNumerate, MsgNo, SubMsgNo, 0), S, 1);
  System.Insert(STX, S, 1);
  case kind of
  blkMSGSTART, blkMSGMIDDLE: begin
    {   }
    if fmtpgBLOCKTRM_US in ATerminalPars.stlFormat
    then S:= S+US
    else S:= S+ETB;
    end;
  blkMSGFINISH, blkMSGALONE : begin
    {   }
    S:= S+ETX;
    end;
  end;
  if fmtpgCRC8bit in ATerminalPars.stlFormat
  then S:= S + CRC12bitExtendedASCII(S, 1, 0)+CR
  else S:= S + CRC12bit(S, 1, 0)+CR;
  Result:= S;
end;

{        
    HWND  hwnd	  handle of window for timer messages
    UINT  uMsg	  WM_TIMER message
    UINT  idEvent timer identifier
    DWORD  dwTime current system time
}
procedure SetTimerFlag(wnd: HWND; Msg, TimerId, sysTime: LongInt); stdcall;
begin
  if TimerId < 8
  then Include(TimerFlags, TimerId)
  else TimerFlags:= [0]; { what for? shit! }
end;
//          0   1   2   3   4
// return   N   O   E   M   S
function ParityChar(AParity: Byte): Char;
var
  Ch: Char;
begin
  case AParity of
  1: Ch:= 'O';
  2: Ch:= 'E';
  3: Ch:= 'M';
  4: Ch:= 'S';
  else Ch:= 'N';
  end;
  Result:= Ch;
end;

//          0   1   2   3   4
// return  no,odd,even,mark,space
function ParityStr(AParity: Byte): String;
begin
  case AParity of
  1: Result:= 'odd';
  2: Result:= 'even';
  3: Result:= 'mark';
  4: Result:= 'space';
  else Result:= 'none';
  end;
end;

{ TTimeOut
}
constructor TTimeOut.Create;
begin
  inherited Create;
  TerminateByEvent:= False;
  Timer:= TTimer.Create(Nil);
  with Timer do begin
    Enabled:= False;
    Interval:= Secs * TIMERTICKSPERSEC;
    OnTimer:= WaitCallBack;
    Enabled:= True;
  end;
end;

destructor TTimeOut.Destroy;
begin
  Timer.Enabled:= False;
  // Timer.Free;
  inherited Destroy;
end;

procedure TTimeOut.WaitCallBack(Sender: TObject);
begin
  TerminateByEvent:= True;
end;

{ :   ,
      SendTAPMessage
        -   SendLoop
  , BlocksMax
}
procedure PrepareMessage(MsgNo: Integer; var PrepMsg: String;
  ATerminalPars: TTerminalPar; MsgLen: Integer);
var
  S, SS: String;
  i: Integer;
  MsgList,
  BlockList,
  KindList: TList;
begin
  // 
  MsgList:= TList.Create;
  BlockList:= TList.Create;
  KindList:= TList.Create;
  S:= PrepMsg;
  //      
  TransactionFillMessages(S, ATerminalPars, MsgLen, MsgList);
  //     (   )
  TransactionFillBlocks(S, MsgList, ATerminalPars.tapBlockLen, BlockList, KindList);
  //  
  PrepMsg:= '';
  for i:= 1 to BlockList.Count do begin
    SS:= GenerateMessageBlock(MsgNo, i-1, S, ATerminalPars, MsgList, BlockList, KindList);
    PrepMsg:= PrepMsg + SS;
  end;
  MsgList.Free;
  BlockList.Free;
  KindList.Free;
end;

//      (Count)   SetCount   
// Count (  FCount)     (      SetCount)
constructor TTAPsPars.Create;
begin
  FCount:= 0;
  FMaxCount:= 128;
  FParameters:= Nil; // ^TTerminalsParsArray;
  FSectionPrefix:= 'TAP';
end;

destructor TTAPsPars.Destroy;
begin
  if (FCount > 0) then begin
    //          
    SetCount(0);
  end;
  inherited Destroy;
end;

procedure TTAPsPars.SetCount(ACount: Word);
begin
  try
    ReAllocMem(FParameters, ACount * SizeOf(TTerminalPar));
  except
  end;
  FCount:= ACount;
end;

function TTAPsPars.GetSectionPrefix: String;
begin
  Result:= FSectionPrefix;
end;

procedure TTAPsPars.SetSectionPrefix(APrefix: String);
begin
  FSectionPrefix:= Copy(APrefix, 1, 16);
end;

function  TTAPsPars.GetTerminalPar(AIndex: Word): TTerminalPar;
begin
  if (AIndex >= FCount) or (FParameters = Nil) then begin
    //  
    raise Exception.Create(' : '+IntToStr(AIndex));
    Exit;
  end;
  Result:= FParameters^[AIndex];
end;

procedure TTAPsPars.SetTerminalPar(AIndex: Word; AValue: TTerminalPar);
begin
  if (AIndex >= FCount) or (FParameters = Nil) then begin
    raise Exception.Create(' : '+IntToStr(AIndex));
    Exit;
  end;
  FParameters^[AIndex]:= AValue;
end;

procedure TTAPsPars.LoadFromIni;
var
  i: Word;
  TermPar: TTerminalPar;
begin
  //    SetCount     
  Count:= IniTapSectionQty;
  for i:= 1 to FCount do begin
    PagLoadIni(FSectionPrefix+IntToStr(i), TermPar);
    ConLoadIni(FSectionPrefix+IntToStr(i), TermPar.comPars);
    Params[i-1]:= TermPar;
  end;
end;

procedure TTAPsPars.StoreToIni;
var
  i: Word;
begin
  SetIniTapSectionQty(FCount);
  for i:= 1 to FCount do begin
    PagStoreIni(FSectionPrefix+IntToStr(i), FParameters^[i-1]);
    ConStoreIni(FSectionPrefix+IntToStr(i), FParameters^[i-1].comPars);
  end;
end;

begin
  TimerFlags:= [];
end.
